/*
 * Chax.h
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#import <Cocoa/Cocoa.h>
#import "MethodSwizzle.h"

#define DONATE_URL [NSURL URLWithString:@"http://www.ksuther.com/chax/donate"]

#define SHOW_TEXT_STATUS_MENU_ITEM 13371
#define LOG_VIEWER_MENU_ITEM 13372
#define ACTIVITY_WINDOW_MENU_ITEM 13373
#define ALWAYS_ON_TOP_MENU_ITEM 13374
#define ALL_CONTACTS_MENU_ITEM 13375
#define MUTE_ALERTS_MENU_ITEM 13376
#define BY_HANDLE_MENU_ITEM 13377
#define SEND_CAMERA_SNAPSHOT_MENU_ITEM 13378

extern NSString *ChaxBundleIdentifier;

static inline NSString * ChaxLocalizedString(NSString *key) {
    return [[NSBundle bundleWithIdentifier:@"com.ksuther.chax"] localizedStringForKey:(key) value:@"" table:nil];
}

@interface Chax : NSObject {

}

+ (void)registerDefaults;
+ (void)addMenuItems;
+ (NSArray *)menuItems;

+ (void)undimScreenAndStopScreenSaver;

+ (BOOL)boolForKey:(NSString *)key;
+ (int)integerForKey:(NSString *)key;
+ (NSData *)dataForKey:(NSString *)key;
+ (NSString *)stringForKey:(NSString *)key;
+ (id)objectForKey:(NSString *)key;
+ (void)setBool:(BOOL)value forKey:(NSString *)key;
+ (void)setInteger:(int)value forKey:(NSString *)key;
+ (void)setObject:(id)value forKey:(NSString *)key;

@end
