/*
 * Chax_FileTransferCenter.m
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#import "Chax_FileTransferCenter.h"
#import "Chax.h"

@implementation FileTransferCenter (Chax)

+ (void)load
{
	MethodSwizzle([self class], @selector(sessionAdded:), @selector(chax_sessionAdded:));
	MethodSwizzle([self class], @selector(acceptTransferContext:withPath:), @selector(chax_acceptTransferContext:withPath:));
}

- (void)chax_sessionAdded:(id)fp8
{
	[self chax_sessionAdded:fp8];
	
	NSDictionary *info = [fp8 userInfo];
	
	if ([[info objectForKey:@"FT:IsIncoming"] boolValue]) {
		FileTransfer *transfer = [self transferForGUID:[info objectForKey:@"GUID"]];
		
		if ([Chax boolForKey:@"AutoAcceptFiles"]) {
			NSArray *autoAcceptContacts = [[Chax objectForKey:@"AutoAccept.Files"] objectForKey:[info objectForKey:@"Account"]];
			
			if ([Chax integerForKey:@"AutoAcceptSelect.Files"] == 0 || [autoAcceptContacts containsObject:@"Chax_AcceptAnyone"] || [autoAcceptContacts containsObject:[[info objectForKey:@"FT:Buddy"] lowercaseString]]) {
				[transfer performSelector:@selector(acceptTransferCommand:) withObject:nil afterDelay:0.0];
			}
		}
	}
}

@end
