/*
 * Chax_PeopleListItem.m
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#import "Chax_PeopleListItem.h"
#import "Chax.h"

@implementation PeopleListItem (Chax)

+ (void)load
{
	MethodSwizzle([self class], @selector(_comparePresentitiesWith:withSortParameters:), @selector(chax_comparePresentitiesWith:withSortParameters:));
}

- (int)chax_comparePresentitiesWith:(id)fp8 withSortParameters:(CDAnonymousStruct7 *)fp12
{
	if (fp12->_field1[0] == 100) {
		return [[[self presentity] ID] caseInsensitiveCompare:[[fp8 presentity] ID]];
	} else if (fp12->_field1[1] == 100) {
		NSComparisonResult result;
		
		if (fp12->_field1[0] == 1) {
			result = [[self presentity] compareFirstNames:[fp8 presentity]];
		} else if (fp12->_field1[0] == 2) {
			result = [[self presentity] compareLastNames:[fp8 presentity]];
		} else if (fp12->_field1[0] == 3) {
			result = [[self presentity] compareStatus:[fp8 presentity]];
		}
		
		return (result == NSOrderedSame) ? [[[self presentity] ID] caseInsensitiveCompare:[[fp8 presentity] ID]] : result;
	}
	
	return [self chax_comparePresentitiesWith:fp8 withSortParameters:fp12];
}

@end
