/*
 * Prefs_Chax.h
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#import <Cocoa/Cocoa.h>
#import "NSPreferences.h"

@class ChaxPrefsView, ChaxDefaults, AutoAcceptPrefsWindowController;

@interface Prefs_Chax : NSPreferencesModule {
	IBOutlet AutoAcceptPrefsWindowController *_autoAcceptPrefs;
	IBOutlet NSTextField *_contactFontTextField;
	IBOutlet NSWindow *_fileTransferOptions;
	IBOutlet NSButton *_setContactFontButton;
	IBOutlet NSButton *_setStatusMessageFontButton;
	IBOutlet NSTextField *_statusMessageFontTextField;
	IBOutlet NSButton *_transferAIMCheckbox;
	IBOutlet NSButton *_transferBonjourCheckbox;
	IBOutlet NSPopUpButton *_transferGroupMenu;
	IBOutlet NSButton *_transferJabberCheckbox;
	IBOutlet NSTextField *_versionTextField;
	IBOutlet ChaxPrefsView *_view;
	
	ChaxDefaults *_defaults;
	
	NSImage *_icon;
	NSFont *_contactFont, *_statusMessageFont;
	int _changingFont;
}

- (IBAction)aboutAction:(id)sender;
- (IBAction)changeContactListSetting:(id)sender;

- (IBAction)showAutoAcceptOptions:(id)sender;

- (void)setContactFont:(NSFont *)font;
- (NSFont *)contactFont;;
@end
