/*
 * VideoConference.h
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 *     Generated by class-dump 3.1.1.
 *
 *     class-dump is Copyright (C) 1997-1998, 2000-2001, 2004-2006 by Steve Nygard.
 */

struct IONotificationPort;

struct OpaqueSecCertificateRef;

struct OpaqueSecIdentityRef;

struct _SDPInfo {
    char _field1[1024];
    char _field2[1024];
};

struct _VCFocusCapability {
    char audioHardwareCapable;
    int maxAudioParticipantsBasedOnHardware;
    char audioNetworkCapable;
    int maxAudioParticipants;
    char canBeAudioMultipointParticipant;
    char videoHardwareCapable;
    int maxVideoParticipantsBasedOnHardware;
    char videoNetworkCapable;
    int maxVideoParticipants;
    char canBeVideoMultipointParticipant;
    int detectedUpstreamKbits;
    int detectedDownstreamKbits;
};

struct __CFData;

struct __CFDictionary;

struct __CVBuffer;

struct __SCDynamicStore;

struct tagCALLBACKDATA {
    int _field1;
    int _field2;
    struct _opaque_pthread_mutex_t _field3;
    struct _opaque_pthread_cond_t _field4;
    char _field5[80];
    char _field6[1024];
    char _field7[1024];
    int _field8;
    char _field9[80];
    void *_field10;
    int _field11;
};

struct tagHANDLE {
    int _field1;
};

struct tagRTPHANDLES {
    struct tagHANDLE *hRTPVideo;
    struct tagHANDLE *hRTPAudio;
};

typedef struct {
    char *_field1;
    int _field2;
    int _field3;
    int _field4;
    int _field5;
    int _field6;
    int _field7;
} CDAnonymousStruct1_;

@class VideoConferenceController, VCMicrophone, VCChannelModel, VCRulesCPUList, VCRulesImageSizeList;

/*
 * File: /System/Library/PrivateFrameworks/VideoConference.framework/Versions/A/VideoConference
 * Arch: PowerPC 7400 (ppc7400)
 *       Current version: 2.0.0, Compatibility version: 2.0.0
 */

@protocol VCRenderDelegateProtocol
- (int)processCVPixelBuffer:(struct __CVBuffer *)fp8 intoCVPixelBuffer:(struct __CVBuffer *)fp12 withHint:(id)fp16;
- (int)resizeRemoteVideoForUserID:(id)fp8 outBuffer:(struct __CVBuffer *)fp12;
@end

@protocol VideoConferenceDelegateProtocol
- (void)vcc:(id)fp8 initiateConferenceStartedForParty:(id)fp12;
- (void)vcc:(id)fp8 initiateConferenceCompletedForParty:(id)fp12 partyInfo:(id)fp16;
- (void)vcc:(id)fp8 partyConnected:(id)fp12;
- (void)vcc:(id)fp8 partyHungUp:(id)fp12;
- (void)vcc:(id)fp8 party:(id)fp12 didMute:(BOOL)fp16;
- (void)vcc:(id)fp8 party:(id)fp12 didPause:(BOOL)fp16;
- (void)vcc:(id)fp8 partyCancelled:(id)fp12;
- (void)vcc:(id)fp8 conferenceAttempted:(id)fp12;
- (void)vccInsufficientBandwidth:(id)fp8 forParty:(id)fp12 partyInfo:(id)fp16;
- (void)vccNetworkTimeout:(id)fp8;
- (void)vccLocalVideoError:(id)fp8;
- (void)vcc:(id)fp8 noPacketsFromParty:(id)fp12 partyInfo:(id)fp16;
- (void)vcc:(id)fp8 party:(id)fp12 didStall:(BOOL)fp16;
- (BOOL)shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8 callbackInfo:(id)fp12;
- (BOOL)shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8;
- (BOOL)vcc:(id)fp8 isRemoteCertificateValid:(struct OpaqueSecCertificateRef *)fp12 forUser:(id)fp16;
- (void)vcc:(id)fp8 securityChangedForUser:(id)fp12;
- (void)vccLocalCertNotAccepted:(id)fp8;
- (void)vccRemoteCertNotAccepted:(id)fp8 forParty:(id)fp12;
- (BOOL)vcc:(id)fp8 userRequestedAuxiliaryInput:(id)fp12;
- (void)vcc:(id)fp8 user:(id)fp12 approvedAuxiliaryInput:(BOOL)fp16;
@end

@interface AudioDeviceMonitor : NSObject
{
    unsigned int _inputDeviceCount;
    BOOL _needsRecount;
    unsigned int _deviceID;
}

+ (id)sharedMonitor;
- (id)init;
- (void)dealloc;
- (void)postMessage:(id)fp8;
- (BOOL)hasMicrophone;
- (unsigned int)inputDeviceCount;
- (void)monitorDevice:(unsigned long)fp8;
- (void)monitorCurrentDevice;
- (void)countInputDevices;
- (BOOL)isOutputMuted;
- (void)setOutputMute:(BOOL)fp8;

@end

@interface DotMacConfiguration : NSObject
{
    NSConditionLock *_condLock;
    NSMutableArray *_ipAndPortDataArray;
    NSString *_userDefaultsConfigurationURLKey;
    NSString *_dotMacConfigurationURL;
}

- (id)init;
- (void)dealloc;
- (void)connect;
- (id)ipAndPortArray;
- (void)getConfigurationProc:(id)fp8;

@end

@interface BWDConfiguration : DotMacConfiguration
{
}

- (id)init;
- (void)dealloc;
- (void)getConfigurationProc:(id)fp8;

@end

@interface CallBackData : NSObject
{
    struct tagCALLBACKDATA *_pcbd;
}

- (struct tagCALLBACKDATA *)callBackData;
- (id)initWithCallBackData:(struct tagCALLBACKDATA *)fp8;
- (id)init;
- (id)resetData;

@end

@interface CommNATConfiguration : DotMacConfiguration
{
    _Bool _gotServerInfo;
    unsigned int _mainIP;
    unsigned short _mainPort0;
    unsigned short _mainPort1;
    unsigned int _cohortIP;
    unsigned short _cohortPort;
}

- (id)init;
- (void)dealloc;
- (void)getConfigurationProc:(id)fp8;
- (int)getServerInfo:(unsigned int *)fp8 pMainPort0:(unsigned short *)fp12 pMainPort1:(unsigned short *)fp16 pCohortIP:(unsigned int *)fp20 pCohortPort:(unsigned short *)fp24;

@end

@interface HardwareCapsChangeNotifier : NSObject
{
    struct IONotificationPort *_notificationPort;
    NSMutableDictionary *_notifierMap;
    NSMutableArray *_cameraCallbackObjs;
    NSMutableArray *_iterators;
    BOOL _hasQ8;
    BOOL _hasDV;
}

+ (id)hardwareCapsChangeNotifier;
- (id)_init;
- (void)dealloc;
- (void)registerForHardwareNotification;
- (void)unregisterForHardwareNotification;
- (void)initIOKitNotifications;
- (void)createNotification:(struct __CFDictionary *)fp8 callback:(void *)fp12;
- (id)notifierMap;
- (struct IONotificationPort *)notificationPort;
- (void)audioHardwareChanged:(id)fp8;
- (unsigned int)cameraCallbackFindParent:(unsigned int)fp8 parentClass:(const char *)fp12;
- (unsigned int)cameraCallbackCreateNotifier:(unsigned int)fp8 withIterator:(unsigned int)fp12;
- (BOOL)_isGUIDUnique:(id)fp8;
- (void)_broadcastHardwareCaps;
- (id)vcHardwareCaps;

@end

@interface NATTraversal : NSObject
{
    int _NATTraversalType;
    NSString *_externalIPAddress;
    NSString *_SNATMAPIPAddress;
    unsigned short _SNATMAPPort;
    NSString *_configurationServerIPAddress;
    unsigned long _ipUPnPRouter;
    BOOL _checked;
    NSData *_snatmapData;
    NSConditionLock *_condLock;
    unsigned long _ipSNATMAP;
}

+ (id)NATTraversal;
- (id)init;
- (void)dealloc;
- (void)acquireSNATMAPConfiguration;
- (void)refreshUPnPViaSIPProc:(id)fp8;
- (void)acquireSNATMAPConfigurationProc:(id)fp8;
- (BOOL)isReady;
- (int)NATTraversalType;
- (int)getIPAndPortMappingForSocket:(int)fp8 ip:(char *)fp12 port:(unsigned short *)fp16 internalPort:(unsigned short)fp20;
- (int)releasePortMapping:(unsigned short)fp8;
- (void)heartBeat:(int)fp8;
- (void)setNATTraversalType:(int)fp8;
- (id)conditionLock;
- (void)setSNATMAPData:(id)fp8;
- (unsigned long)ipSNATMAP;

@end

@interface NSNotificationCenter (MainThreadPostAdditions)
- (void)postNotificationOnMainThreadName:(id)fp8 object:(id)fp12 userInfo:(id)fp16;
- (void)postNotificationOnMainThreadName:(id)fp8 object:(id)fp12;
@end

@interface SDPAnalyzer : NSObject
{
    NSMutableDictionary *_dict;
}

- (id)init;
- (id)initWithViceroyDefaultsUsingZeroes:(BOOL)fp8 forAudioOnly:(BOOL)fp12 withUserCount:(int)fp16;
- (id)initWithViceroyDefaultsUsingZeroes:(BOOL)fp8 forAudioOnly:(BOOL)fp12;
- (id)initWithViceroyDefaultsUsingZeroes:(BOOL)fp8;
- (id)initWithString:(id)fp8;
- (void)dealloc;
- (void)setSDP:(id)fp8;
- (void)resetSDP;
- (id)sessionString;
- (id)audioStringForVersion:(unsigned int)fp8;
- (id)videoStringForVersion:(unsigned int)fp8;
- (id)dataStringForVersion:(unsigned int)fp8;
- (id)toString;
- (id)toStringForVersion:(unsigned int)fp8;
- (void)setOriginWithArray:(id)fp8;
- (id)origin;
- (void)setConnectionWithArray:(id)fp8;
- (id)connection;
- (void)setBandwidthWithString:(id)fp8;
- (id)bandwidth;
- (void)setMediaWithArrayHelper:(id)fp8 mediaArray:(id)fp12 attributesArray:(id)fp16;
- (void)setAudioMediaWithArray:(id)fp8 andAttributesWithArray:(id)fp12;
- (id)audioMedia;
- (void)setVideoMediaWithArray:(id)fp8 andAttributesWithArray:(id)fp12;
- (id)videoMedia;
- (void)setDataMediaWithArray:(id)fp8 andAttributesWithArray:(id)fp12;
- (id)dataMedia;
- (id)audioMediaAttributes;
- (id)videoMediaAttributes;
- (id)dataMediaAttributes;
- (id)audioMediaConnection;
- (id)videoMediaConnection;
- (id)sessionAttributes;
- (id)sessionName;
- (int)addressTypeForConnection:(id)fp8;
- (int)addressType;
- (int)addressTypeVideo;
- (int)addressTypeAudio;
- (void)appendAudioAttribute:(id)fp8;
- (void)appendVideoAttribute:(id)fp8;
- (void)updateVideoAttributePrefix:(id)fp8 withAppendedValue:(id)fp12;
- (void)appendSessionAttribute:(id)fp8;
- (void)setSessionName:(id)fp8;
- (BOOL)hasAudioCodec:(int)fp8;
- (BOOL)hasVideoCodec:(int)fp8;

@end

@interface SDPAnalyzer (helper)
- (id)defaultAudioPayloads;
- (id)defaultAudioPayloads:(BOOL)fp8;
- (id)defaultAudioPayloads:(BOOL)fp8 withUserCount:(int)fp12;
- (id)SDPUsername;
@end

@interface SDPAnalyzer (viceroy)
- (int)portForMediaHelper:(id)fp8;
- (int)videoPort;
- (int)audioPort;
- (int)dataPort;
- (int)videoRTCPPort;
- (int)audioRTCPPort;
- (int)dataRTCPPort;
- (const char *)userName;
- (const char *)ipFromConnection:(id)fp8;
- (const char *)ip;
- (const char *)ipVideo;
- (const char *)ipAudio;
- (int)maxImagesize;
- (int)maxBandwidth;
- (int)maxFramerate;
- (int)rulesFramerate:(int)fp8;
- (void)rulesImageSize:(int)fp8 pWidth:(int *)fp12 pHeight:(int *)fp16;
- (void)rulesPeerImageSize:(int)fp8 pWidth:(int *)fp12 pHeight:(int *)fp16;
- (char *)srtpKey;
- (char *)srtpSalt;
- (void)setMaxImageSize:(int)fp8 forPayloadType:(int)fp12;
- (void)setMaxBandwidth:(int)fp8;
- (void)setMaxFramerate:(int)fp8;
- (void)setAutoDetectBandwidth:(BOOL)fp8;
- (BOOL)autoDetectBandwidth;
- (void)setUseIChatEncryption:(BOOL)fp8;
- (BOOL)useIChatEncryption;
- (void)setAudioRTPID:(unsigned long)fp8;
- (unsigned long)audioRTPID;
- (void)setVideoRTPID:(unsigned long)fp8;
- (unsigned long)videoRTPID;
- (BOOL)hasPureVoice;
- (BOOL)hasViceroyCompatibleAudioCodec;
- (BOOL)hasViceroyCompatibleVideoCodec;
- (BOOL)hasH263;
- (BOOL)irisOpen;
- (id)generateVideoMediaArray:(BOOL)fp8;
- (id)generateVideoMediaAttributesArray:(BOOL)fp8;
- (void)setMultiPointFlagWithCount:(int)fp8;
- (BOOL)hasMultiPointFlag:(int *)fp8;
- (void)setHardwareInfo:(id)fp8;
- (id)hardwareInfo;
- (void)buildRTPMap;
- (id)RTPMapString:(int)fp8 isAudio:(BOOL)fp12;
- (int)payload:(int)fp8 isAudio:(BOOL)fp12;
- (id)payloadString:(int)fp8 isAudio:(BOOL)fp12;
- (BOOL)hasAudioCodec:(int)fp8 withPeerSDP:(id)fp12;
- (BOOL)hasVideoCodec:(int)fp8 withPeerSDP:(id)fp12;
@end

@interface SIPManager : NSObject
{
    unsigned short _localSIPPort[8];
    unsigned long _localIPAddress[8];
    unsigned short _extSIPPort[8];
    unsigned long _extIPAddress[8];
    int _SIPInfoCount;
    struct tagHANDLE *_hSIP;
    int _transportProtocol;
    NSLock *_lock;
    NSString *_remoteUserAgent;
    NSString *_remoteDisplayName;
}

+ (id)SIPManager;
- (id)initWithTransportProtocol:(int)fp8;
- (id)init;
- (void)dealloc;
- (unsigned short)localSIPPortAtIndex:(int)fp8;
- (unsigned long)localIPAddressAtIndex:(int)fp8;
- (unsigned short)externalSIPPortAtIndex:(int)fp8;
- (unsigned long)externalIPAddressAtIndex:(int)fp8;
- (int)createHandle;
- (int)listen:(BOOL)fp8;
- (int)connectUsingData:(id)fp8 fromName:(id)fp12 to:(id)fp16 SDPInfo:(struct _SDPInfo *)fp20 callID:(int)fp24 rtpHandles:(struct tagRTPHANDLES *)fp28 forConfIndex:(int)fp32;
- (int)connect:(id)fp8 to:(id)fp12 ip:(id)fp16 SIPPort:(unsigned short)fp20 SDPInfo:(struct _SDPInfo *)fp24 callID:(int)fp28 rtpInfo:(struct tagRTPHANDLES *)fp32;
- (int)keyExchange:(int)fp8 toCert:(struct OpaqueSecCertificateRef *)fp12 returnKey:(const struct __CFData **)fp16 forConfIndex:(int)fp20;
- (BOOL)setDoKeyExchange:(BOOL)fp8 identity:(struct OpaqueSecIdentityRef *)fp12;
- (int)hangup:(int)fp8;
- (int)cancelConnect:(int)fp8;
- (int)connectIncoming:(char *)fp8;
- (int)sendMessage:(id)fp8 toCallID:(int)fp12;
- (int)sendMessage:(id)fp8 toAllExceptCallID:(int)fp12;
- (int)closeCall:(int)fp8;
- (id)remoteUserAgentForCallID:(int)fp8;
- (void)getRemoteInfo:(int)fp8;
- (id)getRemoteUserAgent;
- (id)getRemoteDisplayName;
- (BOOL)remoteUserAgentIsWindowsClient;
- (id)localUserAgent;
- (BOOL)setIsFocus:(BOOL)fp8;
- (BOOL)setSIPPing:(BOOL)fp8 forCallID:(int)fp12;
- (BOOL)isCurrentFocus;
- (BOOL)isRemoteFocus:(int)fp8;
- (void)updateInterfaceList;
- (id)getConnectionDataForCallID:(int)fp8;
- (id)getConnectionDataForCallID:(int)fp8 shouldFindExternalIP:(BOOL)fp12;
- (BOOL)generateCallID:(int *)fp8;
- (long)startConnectionCheck:(int)fp8 withConnectionData:(id)fp12;
- (int)connectWithCallID:(int)fp8 fromName:(id)fp12 to:(id)fp16 SDPInfo:(struct _SDPInfo *)fp20 rtpHandles:(struct tagRTPHANDLES *)fp24 forConfIndex:(int)fp28;
- (int)getCallIDForConnectionData:(id)fp8;
- (id)getIPInfoWithRemoteIPInfo:(void *)fp8 remoteIPInfoSize:(int)fp12;
- (id)getIPInfoWithRemoteIPInfo:(void *)fp8 remoteIPInfoSize:(int)fp12 shouldFindExternalIP:(BOOL)fp16;

@end

@interface SNATMAPConfiguration : DotMacConfiguration
{
    _Bool hasConnected;
}

+ (id)SNATMAPConfiguration;
- (id)init;
- (void)dealloc;
- (void)connect;
- (void)getConfigurationProc:(id)fp8;

@end

@interface STUNConfiguration : DotMacConfiguration
{
}

- (id)init;
- (void)dealloc;
- (void)getConfigurationProc:(id)fp8;

@end

@interface VCCallMgr : NSObject
{
    NSLock *lock;
    NSMutableDictionary *dictIncomingCalls;
    NSMutableDictionary *dictOutgoingCalls;
    NSMutableDictionary *_globalAttributesDictionary;
    NSMutableDictionary *dictHangupCalls;
    NSMutableDictionary *_confStatusMap;
    NSMutableDictionary *mapUserIDToCallID;
    NSMutableDictionary *participantUserIDToConfIndex;
    NSMutableDictionary *mapUserIDToSecurityInfo;
    NSLock *_SecurityInfoLock;
    BOOL fSecurityInfoPaused;
    BOOL fSecurityEnabledValue;
    BOOL fSecurityValidValue;
    NSMutableArray *participantUpdateQueue;
    SDPAnalyzer *_callerSDP;
    SDPAnalyzer *_calleeSDP;
    int _curCallID;
    int _callIDIter;
    int _microphoneDevice;
    unsigned int _speakerDevice;
    NSDate *_callStartTime;
    double _lastCallDuration;
    struct tagRTPHANDLES _localRTPHandles;
    NSString *_localUserName;
    NSLock *_initiateLock;
    NSLock *_confStatusLock;
    NSLock *_determineFocusCapabilityLock;
    NSLock *_BWDThreadLock;
    NSLock *_deferVideoFormatLock;
    NSLock *_delegateLock;
    NSLock *_participantUserIDToConfIndexLock;
    NSLock *_userIDToCallIDMapLock;
    NSLock *_vcCameraLock;
    BOOL _didStartTransmitForNonFocus;
    BOOL _multiPartyConference;
    BOOL _isTransmitting;
    BOOL _BWDThreadRunning;
    BOOL _confStatusConnected;
    BOOL _startedAuxiliaryInput;
    VideoConferenceController *_vcControllerInstance;
    id _vcDelegate;
    id _vcRenderDelegate;
    BOOL _vcDelegateConformsToDelegateProtocol;
    int _confUpstream;
    int _confDownstream;
    struct _VCFocusCapability _focusCapability;
    unsigned long long _lastCameraGUID;
    BOOL _usePCMUWideband;
    BOOL _useSpeex;
    BOOL _useSpeex32K;
    int _auxVideoInputMode;
}

+ (id)defaultCallMgr;
- (id)init;
- (void)dealloc;
- (void)addCall:(int)fp8 withData:(id)fp12;
- (id)getCallData:(int)fp8;
- (BOOL)existCallID:(int)fp8;
- (BOOL)acceptCallID:(int)fp8;
- (BOOL)cancelCallID:(int)fp8;
- (int)size;
- (void)addOutgoingCall:(int)fp8;
- (BOOL)existOutgoingCallID:(int)fp8 andRemove:(BOOL)fp12;
- (BOOL)hangupCall:(int)fp8;
- (void)finishedCallHangup:(int)fp8;
- (void)setCurCallID:(int)fp8;
- (int)curCallID;
- (int)getIncrementedCallIDIter;
- (int)callIDIter;
- (id)globalAttributesDictionary;
- (int)microphoneDevice;
- (int)speakerDevice;
- (void)setSpeakerDevice:(unsigned long)fp8;
- (void)setRTPHandles:(struct tagRTPHANDLES *)fp8;
- (struct tagRTPHANDLES *)RTPHandles;
- (void)startCallTimer;
- (id)callStartTime;
- (void)endCallTimer;
- (double)lastCallDuration;
- (BOOL)BWDThreadRunning;
- (void)setBWDThreadRunning:(BOOL)fp8;
- (void)setCallerSDP:(id)fp8;
- (void)setCalleeSDP:(id)fp8;
- (id)callerSDP;
- (id)calleeSDP;
- (void)setLocalUserName:(id)fp8;
- (id)localUserName;
- (id)userIDToCallIDMap;
- (int)confIndexFromMapForUserID:(id)fp8;
- (int)callIDFromMapForUserID:(id)fp8;
- (void)setPeerToPeerInfoInMapForUserID:(id)fp8 payload:(int)fp12 transmitWidth:(int)fp16 transmitHeight:(int)fp20 transmitBitrate:(int)fp24 transmitFramerate:(int)fp28;
- (void)peerToPeerInfoFromMapForUserID:(id)fp8 payload:(int *)fp12 transmitWidth:(int *)fp16 transmitHeight:(int *)fp20 transmitBitrate:(int *)fp24 transmitFramerate:(int *)fp28;
- (void)smallestNonfocusBitrate:(int *)fp8 framerate:(int *)fp12;
- (id)hardwareInfoArrayFromMap;
- (id)userIDForCallID:(unsigned int)fp8;
- (id)userIDForConfIndex:(unsigned int)fp8;
- (id)getParticipantUpdateQueue;
- (id)vcControllerInstance;
- (id)vcDelegate;
- (void)setVCControllerInstance:(id)fp8;
- (void)setVCDelegate:(id)fp8;
- (BOOL)vcDelegateConformsToDelegateProtocol;
- (void)setVCRenderDelegate:(id)fp8;
- (id)vcRenderDelegate;
- (void)setConfIndex:(int)fp8 forUserID:(id)fp12;
- (int)confIndexForUserID:(id)fp8;
- (void)clearConfIndexForUserID;
- (id)initiateLock;
- (id)confStatusLock;
- (id)userIDToCallIDMapLock;
- (id)determineFocusCapabilityLock;
- (id)deferVideoFormatLock;
- (id)vcCameraLock;
- (BOOL)didStartTransmitForNonFocus;
- (void)setDidStartTransmitForNonFocus:(BOOL)fp8;
- (BOOL)isMultiPartyConference;
- (void)setMultiPartyConference:(BOOL)fp8;
- (BOOL)isTransmitting;
- (void)setIsTransmitting:(BOOL)fp8;
- (int)BWDUpstreamKbits;
- (int)BWDDownstreamKbits;
- (void)setFocusCapability:(struct _VCFocusCapability *)fp8;
- (void)getFocusCapability:(struct _VCFocusCapability *)fp8;
- (void)confStatusMapRemoveAll;
- (void)addConfStatusForUserID:(id)fp8 status:(int)fp12 confIndex:(int)fp16 userInfo:(id)fp20;
- (void)removeConfStatus:(id)fp8;
- (void)sendConfStatusUpdateToiChat;
- (void)setConfStatusConnected:(BOOL)fp8;
- (void)setSecurityInfoCertificate:(struct OpaqueSecCertificateRef *)fp8 forUser:(id)fp12;
- (void)setSecurityInfoEnabled:(BOOL)fp8 forUser:(id)fp12;
- (void)setSecurityInfoValid:(BOOL)fp8 forUser:(id)fp12;
- (BOOL)isSecurityEnabledForUser:(id)fp8;
- (BOOL)isSecurityValidForUser:(id)fp8;
- (struct OpaqueSecCertificateRef *)getRemoteCertificateForUser:(id)fp8;
- (void)clearSecurityInfo;
- (void)setSecurityInfoPaused:(BOOL)fp8;
- (void)setLastCameraGUID:(unsigned long long)fp8;
- (unsigned long long)lastCameraGUID;
- (BOOL)startedAuxiliaryInput;
- (void)setStartedAuxiliaryInput:(BOOL)fp8;
- (BOOL)usePCMUWideband;
- (void)setUsePCMUWideband:(BOOL)fp8;
- (BOOL)useSpeex;
- (void)setUseSpeex:(BOOL)fp8;
- (BOOL)useSpeex32K;
- (void)setUseSpeex32K:(BOOL)fp8;
- (int)auxiliaryVideoInputMode;
- (void)setAuxiliaryVideoInputMode:(int)fp8;

@end

@interface VCCamera : NSObject
{
    NSString *_displayName;
    NSString *_driverName;
    NSString *_inputName;
    NSNumber *_GUID;
    VCMicrophone *_associatedMicrophone;
    int _type;
    BOOL _visible;
    BOOL _irisOpen;
}

- (id)init;
- (void)dealloc;
- (id)displayName;
- (id)GUID;
- (id)associatedMicrophone;
- (int)type;
- (BOOL)visible;
- (BOOL)irisOpen;

@end

@interface VCCamera (internal)
- (id)initWithDisplayName:(id)fp8 driverName:(id)fp12 inputName:(id)fp16 GUID:(id)fp20 associatedMicrophone:(id)fp24;
- (void)setType:(int)fp8;
- (void)setVisible:(BOOL)fp8;
- (void)setIrisOpen:(BOOL)fp8;
@end

@interface VCChannel : NSObject
{
    VCChannelModel *_model;
}

+ (id)OpenNewChannelWithOptions:(id)fp8;
- (id)init;
- (id)initWithOptions:(id)fp8;
- (void)dealloc;
- (id)connectionData;
- (id)connectionData:(BOOL)fp8;
- (void)prepareConnectionWithRemoteConnectionData:(id)fp8;
- (int)socket;
- (id)remoteIPPort;
- (void)close;

@end

@interface VCChannel (private)
- (void)setSavedConnectionData:(id)fp8;
- (id)getSavedConnectionData;
@end

@interface VCChannelExtra : NSObject
{
    VCChannelModel *_model;
}

- (id)init;
- (id)initWithHandle:(int)fp8;
- (void)dealloc;
- (int)currentHandle;
- (void)closeHandle;
- (id)connectionDataWithOptions:(id)fp8;
- (id)connectionDataWithOptions:(id)fp8 shouldFindExternalIP:(BOOL)fp12;
- (void)prepareExtraConnectionWithRemoteConnectionData:(id)fp8 withLocalConnectionData:(id)fp12;
- (void)sockets:(int *)fp8 size:(int)fp12;
- (id)remoteIPPorts:(int)fp8;

@end

@interface VCChannelModel : NSObject
{
    struct tagHANDLE *_hVCChannel;
    NSData *_localConnectionData;
    NSDictionary *_optionsDictionary;
}

- (id)init;
- (void)dealloc;
- (struct tagHANDLE *)hVCChannel;
- (id)localConnectionData;
- (id)optionsDictionary;
- (void)sethVCChannel:(struct tagHANDLE *)fp8;
- (void)setLocalConnectionData:(id)fp8;
- (void)setOptionsDictionary:(id)fp8;

@end

@interface VCSoundDevice : NSObject
{
    NSString *_displayName;
    NSString *_deviceName;
    NSString *_sourceName;
    unsigned int _deviceID;
    unsigned int _sourceID;
    unsigned int _transportType;
    BOOL _isBluetooth;
}

- (id)init;
- (void)dealloc;
- (id)deviceName;
- (id)sourceName;
- (id)displayName;
- (unsigned long)deviceID;
- (unsigned long)sourceID;
- (unsigned int)transportType;
- (BOOL)isBluetooth;

@end

@interface VCMicrophone : VCSoundDevice
{
}

- (id)init;
- (unsigned int)transportType;

@end

@interface VCMicrophone (internal)
- (id)initWithDisplayName:(id)fp8 deviceName:(id)fp12 sourceName:(id)fp16 deviceID:(unsigned long)fp20 sourceID:(unsigned long)fp24 isBluetooth:(BOOL)fp28;
@end

@interface VCNotificationGateway : NSObject
{
    BOOL _ignoreNoRemotePackets;
    NSNotificationQueue *_notificationQueue;
}

- (id)init;
- (void)dealloc;
- (id)startMonitor;
- (id)endMonitor;
- (void)setIgnoreNoRemotePackets:(BOOL)fp8;
- (BOOL)ignoreNoRemotePackets;

@end

@interface VCRules : NSObject
{
    VCRulesCPUList *_VCRulesCPUList;
    NSMutableArray *_arrayHardwareRules;
    NSMutableArray *_arrayHardwareRulesH264;
    NSMutableArray *_arrayDowngradeRulesH264;
    NSMutableArray *_arrayDowngradeRules;
}

+ (id)VCRulesSingleton;
+ (unsigned int)QuickTimeBandwidth;
+ (void)parametersForRules:(id)fp8 pFramerate:(int *)fp12 pWidth:(int *)fp16 pHeight:(int *)fp20;
+ (BOOL)canSupportH264Encode;
+ (BOOL)canSupportH264Decode;
+ (BOOL)isHardwareSuitableForFilters;
+ (void)updateImageSize:(int *)fp8 forBandwidth:(int)fp12;
+ (unsigned int)minAudioBandwidth;
+ (unsigned int)minVideoBandwidth;
+ (unsigned short)cutoff15FPS;
+ (unsigned int)magicRTCBandwidth;
+ (unsigned int)minCPUSpeedForH264;
+ (struct _NSSize)applyImageSizeDowngradeRuleForPayload:(int)fp8 currentSize:(struct _NSSize)fp12 bitrate:(int)fp20 pFramerate:(int *)fp24 inMultiway:(BOOL)fp28;
+ (id)generateHardwareInfoForSDP;
+ (void)parseSDPHardwareInfo:(id)fp8 forMachineType:(int *)fp12 forCPUCount:(int *)fp16 forCPUSpeed:(int *)fp20;
+ (void)getMultipointInfoForPayload:(int)fp8 imageWidth:(int *)fp12 imageHeight:(int *)fp16 framerate:(int *)fp20;
+ (BOOL)canSupportSpeexPayload:(int)fp8 audioOnly:(BOOL)fp12;
+ (BOOL)canSupportPCMUWideband:(BOOL)fp8;
+ (BOOL)canSupportAACLD:(int)fp8 audioOnly:(BOOL)fp12;
- (void)addAllRules;
- (void)addT1RulesForMhrtz:(int)fp8 cpuCount:(int)fp12;
- (void)addG5RulesForMhrtz:(int)fp8 cpuCount:(int)fp12;
- (void)addG4RulesForMhrtz:(int)fp8 cpuCount:(int)fp12;
- (void)addG3RulesForMhrtz:(int)fp8 cpuCount:(int)fp12;
- (id)init;
- (void)dealloc;
- (id)arrayHardwareRules;
- (id)arrayHardwareRulesH264;
- (id)arrayDowngradeRulesH264;
- (id)arrayDowngradeRules;
- (void)loadOtherRules;
- (id)cpuTypeStringForMachineType:(int)fp8;
- (BOOL)determineLocalRulesForBandwidthAndSize:(unsigned int)fp8 currentWidth:(int)fp12 currentHeight:(int)fp16 participants:(int)fp20 conferenceType:(int)fp24 width:(int *)fp28 height:(int *)fp32 framerate:(int *)fp36;
- (BOOL)localRulesForBandwidth:(unsigned int)fp8 participants:(int)fp12 conferenceType:(int)fp16 width:(int *)fp20 height:(int *)fp24 framerate:(int *)fp28;
- (int)bestFramerateForConferenceType:(int)fp8 imageWidth:(int)fp12 imageHeight:(int)fp16;
- (void)bestH263Settings:(int *)fp8 framerate:(int *)fp12;
- (void)bestH263SettingsForBandwidth:(int)fp8 width:(int *)fp12 height:(int *)fp16 framerate:(int *)fp20;
- (void)bestH264SettingsFramerate:(int *)fp8 width:(int *)fp12 height:(int *)fp16;
- (void)bestH264MultipointSettingsForTotalBandwidthAndUserCount:(int)fp8 userCount:(int)fp12 width:(int *)fp16 height:(int *)fp20 framerate:(int *)fp24;

@end

@interface VCRulesBandwidth : NSObject
{
    int _bandwidth;
    int _bandwidthLowerThreshold;
    int _bandwidthUpperThreshold;
    VCRulesImageSizeList *_H264Focus;
    VCRulesImageSizeList *_H264NonFocus;
    VCRulesImageSizeList *_H263;
}

- (id)initWithBandwidthLowerThreshold:(int)fp8 upperThreshold:(int)fp12;
- (void)dealloc;
- (id)description;
- (void)addRuleWithNParticipants:(int)fp8 width:(int)fp12 height:(int)fp16 fps:(int)fp20 conferenceType:(int)fp24;
- (id)imageSizeForNParticipants:(int)fp8 conferenceType:(int)fp12;
- (void)addRuleWithNParticipants:(int)fp8 width:(int)fp12 height:(int)fp16 fps:(int)fp20 type:(id)fp24;
- (id)imageSizeForNParticipants:(int)fp8 type:(id)fp12;
- (int)bandwidth;
- (void)setBandwidth:(int)fp8;
- (int)bandwidthLowerThreshold;
- (void)setBandwidthLowerThreshold:(int)fp8;
- (int)bandwidthUpperThreshold;
- (void)setBandwidthUpperThreshold:(int)fp8;
- (id)H264Focus;
- (void)setH264Focus:(id)fp8;
- (id)H264NonFocus;
- (void)setH264NonFocus:(id)fp8;
- (id)H263;
- (void)setH263:(id)fp8;

@end

@interface VCRulesBandwidthList : NSObject
{
    NSMutableArray *_bandwidthList;
}

- (id)init;
- (void)dealloc;
- (id)addBandwidthLowerThreshold:(int)fp8 upperThreshold:(int)fp12;
- (id)bandwidthWithLowerThreshold:(int)fp8 upperThreshold:(int)fp12;
- (void)addRuleWithBandwidthLowerThreshold:(int)fp8 upperThreshold:(int)fp12 nParticipants:(int)fp16 width:(int)fp20 height:(int)fp24 fps:(int)fp28 type:(id)fp32;
- (id)imageSizeForBandwidth:(int)fp8 nParticipants:(int)fp12 type:(id)fp16;
- (void)addRuleWithBandwidthLowerThreshold:(int)fp8 upperThreshold:(int)fp12 nParticipants:(int)fp16 width:(int)fp20 height:(int)fp24 fps:(int)fp28 conferenceType:(int)fp32;
- (id)imageSizeForBandwidth:(int)fp8 nParticipants:(int)fp12 conferenceType:(int)fp16;
- (id)description;
- (id)bandwidthList;
- (void)setBandwidthList:(id)fp8;

@end

@interface VCRulesCPU : NSObject
{
    NSString *_cpuType;
    int _nProcessors;
    int _frequency;
    VCRulesBandwidthList *_bandwidthList;
}

- (id)initWithCPUType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16;
- (void)dealloc;
- (id)description;
- (void)addRuleWithBandwidthLowerThreshold:(int)fp8 upperThreshold:(int)fp12 nParticipants:(int)fp16 width:(int)fp20 height:(int)fp24 fps:(int)fp28 type:(id)fp32;
- (id)imageSizeForBandwidth:(int)fp8 nParticipants:(int)fp12 type:(id)fp16;
- (void)addRuleWithBandwidthLowerThreshold:(int)fp8 upperThreshold:(int)fp12 nParticipants:(int)fp16 width:(int)fp20 height:(int)fp24 fps:(int)fp28 conferenceType:(int)fp32;
- (id)imageSizeForBandwidth:(int)fp8 nParticipants:(int)fp12 conferenceType:(int)fp16;
- (int)compareCPU:(id)fp8;
- (id)cpuType;
- (void)setCPUType:(id)fp8;
- (int)nProcessors;
- (void)setNProcessors:(int)fp8;
- (int)frequency;
- (void)setFrequency:(int)fp8;
- (id)bandwidthList;
- (void)setBandwidthList:(id)fp8;

@end

@interface VCRulesCPUList : NSObject
{
    NSMutableArray *_cpuList;
}

- (id)init;
- (void)dealloc;
- (id)description;
- (id)addCPUwithType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16;
- (id)cpuWithType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16;
- (void)addRuleForCPUWithType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16 lowerThreshold:(int)fp20 upperThreshold:(int)fp24 nParticipants:(int)fp28 width:(int)fp32 height:(int)fp36 fps:(int)fp40 type:(id)fp44;
- (id)imageSizeForCPUWithType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16 bandwidth:(int)fp20 nParticipants:(int)fp24 type:(id)fp28;
- (void)addRuleForCPUWithType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16 lowerThreshold:(int)fp20 upperThreshold:(int)fp24 nParticipants:(int)fp28 width:(int)fp32 height:(int)fp36 fps:(int)fp40 conferenceType:(int)fp44;
- (id)imageSizeForCPUWithType:(id)fp8 nProcessors:(int)fp12 frequency:(int)fp16 bandwidth:(int)fp20 nParticipants:(int)fp24 conferenceType:(int)fp28;
- (id)cpuList;
- (void)setCPUList:(id)fp8;

@end

@interface VCRulesImageSize : NSObject
{
    int _nParticipants;
    int _width;
    int _height;
    int _fps;
}

- (id)initWithNParticipants:(int)fp8 width:(int)fp12 height:(int)fp16 fps:(int)fp20;
- (id)description;
- (int)nParticipants;
- (void)setNParticipants:(int)fp8;
- (int)width;
- (void)setWidth:(int)fp8;
- (int)height;
- (void)setHeight:(int)fp8;
- (int)fps;
- (void)setFps:(int)fp8;

@end

@interface VCRulesImageSizeList : NSObject
{
    NSMutableArray *_imageSizeList;
    NSString *_type;
}

- (id)init;
- (id)initWithType:(id)fp8;
- (void)dealloc;
- (void)addImageSizeWithNParticipants:(int)fp8 width:(int)fp12 height:(int)fp16 fps:(int)fp20;
- (id)imageSizeForNParticipants:(int)fp8;
- (id)description;
- (id)imageSizeList;
- (void)setImageSizeList:(id)fp8;
- (id)type;
- (void)setType:(id)fp8;

@end

@interface VCSNATMAPData : NSObject
{
    unsigned char _dataVersion;
    unsigned int _iChatAVVersion;
    unsigned int _OSVersion;
    unsigned int _ViceroyVersion;
    unsigned short _mediaType;
    unsigned int _sessionID;
}

- (id)init;
- (void)dealloc;
- (void)setiChatAVVersion:(unsigned int)fp8;
- (void)setViceroyVersion:(unsigned int)fp8;
- (void)setMediaType:(unsigned short)fp8;
- (void)setSessionID:(unsigned int)fp8;
- (id)snatmapData;

@end

@interface VCSleepWakeMonitor : NSObject
{
    unsigned int root_port;
    unsigned int notifierObject;
    struct IONotificationPort *notifyPortRef;
}

+ (id)VCSleepWakeMonitorSingleton;
- (BOOL)startMonitor;
- (void)endMonitor;
- (unsigned int)rootPort;

@end

@interface VCSpeaker : VCSoundDevice
{
}

- (id)init;
- (unsigned int)transportType;

@end

@interface VCSpeaker (internal)
- (id)initWithDisplayName:(id)fp8 deviceName:(id)fp12 sourceName:(id)fp16 deviceID:(unsigned long)fp20 sourceID:(unsigned long)fp24 isBluetooth:(BOOL)fp28;
@end

@interface VCStateMgr : NSObject <NSLocking>
{
    NSLock *lock;
    int _videoConferenceState;
    NSDictionary *_hardwareCaps;
}

+ (id)defaultStateMgr;
- (id)init;
- (void)dealloc;
- (char *)stateName:(int)fp8;
- (BOOL)setStateAndLock:(int)fp8 from:(int)fp12;
- (void)setStateUnlock;
- (int)state;
- (void)lock;
- (void)unlock;
- (void)setHardwareCaps:(id)fp8;
- (id)hardwareCaps;

@end

@interface VideoConferenceController : NSObject
{
    NSString *_localIPAddress;
    NSString *_userName;
    BOOL _allowsVideoRecv;
    BOOL _allowsAudioRecv;
    BOOL _allowsVideoSend;
    BOOL _allowsAudioSend;
    BOOL _enableEchoCancellation;
    BOOL _enableOldAudioProcessing;
    BOOL _enableNewAudioProcessing;
    unsigned int _bitrate;
    unsigned int _framerate;
    unsigned int _keyrate;
    unsigned int _maxBitrate;
    unsigned int _maxFramerate;
    int _optimalImageSize;
    BOOL _doNotDisturb;
    BOOL _preFilter;
    BOOL _postFilter;
    int _lightingProfile;
    int _defaultPayload;
    int _defaultWidth;
    int _defaultHeight;
    NSString *_remoteUserName;
    int _audioQuality;
    BOOL _useEncryption;
    struct OpaqueSecIdentityRef *_localSecIdentityRef;
    BOOL _autoDetectBandwidth;
    NSMutableDictionary *_statsDictionary;
    VCNotificationGateway *_notificationGateway;
    NATTraversal *_NATTraversal;
    struct __SCDynamicStore *_dynamicStore;
    NSMutableDictionary *_connectionDataAndCallIDDictionary;
    BOOL _oneWayOnly;
    NSString *_cameraName;
    NSNumber *_cameraGUID;
}

+ (void)initialize;
+ (id)newcameraList;
+ (id)cameraList;
+ (id)microphoneList;
+ (id)micList;
+ (id)speakerList;
+ (id)soundOutputDeviceList;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (void)setRenderDelegate:(id)fp8;
- (id)renderDelegate;
- (void)resetVars;
- (void)freeVars;
- (id)init;
- (id)initWithRectTexture:(int)fp8;
- (void)setRectTexture:(int)fp8;
- (void)setCPUResize:(int)fp8;
- (id)initWithLocalIPAddress:(id)fp8;
- (void)setLocalIPAddress:(id)fp8;
- (id)localIPAddress;
- (void)setUserName:(id)fp8;
- (id)userName;
- (void)setAllowsVideo:(BOOL)fp8;
- (BOOL)allowsVideo;
- (void)setAllowsAudio:(BOOL)fp8;
- (BOOL)allowsAudio;
- (void)setAllowsVideoSend:(BOOL)fp8;
- (BOOL)allowsVideoSend;
- (void)setAllowsAudioSend:(BOOL)fp8;
- (BOOL)allowsAudioSend;
- (void)setAllowsVideoRecv:(BOOL)fp8;
- (BOOL)allowsVideoRecv;
- (void)setAllowsAudioRecv:(BOOL)fp8;
- (BOOL)allowsAudioRecv;
- (void)setBitrate:(unsigned int)fp8;
- (unsigned int)bitrate;
- (void)setFramerate:(unsigned int)fp8;
- (unsigned int)framerate;
- (void)setKeyrate:(unsigned int)fp8;
- (unsigned int)keyrate;
- (void)setOptimalImageSize:(int)fp8;
- (int)optimalImageSize;
- (void)setMaxBitrate:(unsigned int)fp8;
- (unsigned int)maxBitrate;
- (void)setMaxFramerate:(unsigned int)fp8;
- (unsigned int)maxFramerate;
- (void)setEnableEchoCancellation:(BOOL)fp8;
- (BOOL)enableEchoCancellation;
- (void)setEnableNoiseReduction:(BOOL)fp8;
- (BOOL)enableNoiseReduction;
- (void)setIgnoreNoRemotePackets:(BOOL)fp8;
- (BOOL)ignoreNoRemotePackets;
- (unsigned int)localSIPPort;
- (unsigned int)externalSIPPort;
- (id)externalIPAddress;
- (void)dealloc;
- (void)setRemoteUserName:(id)fp8;
- (id)remoteUserName;
- (BOOL)canStartPreview;
- (int)startPreview;
- (BOOL)fixCameraProperties:(BOOL)fp8;
- (BOOL)fixCameraFeature:(int)fp8 isFixed:(BOOL)fp12;
- (void)setAudioQuality:(int)fp8;
- (int)audioQuality;
- (void)setAutoDetectBandwidth:(BOOL)fp8;
- (BOOL)autoDetectBandwidth;
- (void)setDoNotDisturb:(BOOL)fp8;
- (BOOL)doNotDisturb;
- (int)cancelInitiatedConferenceCallWithRemoteIPAddress:(id)fp8 remoteSIPPort:(unsigned short)fp12;
- (int)DoVCIncomingConference:(void *)fp8;
- (void)muteParty:(int)fp8 shouldMute:(BOOL)fp12;
- (BOOL)isPartyMuted:(int)fp8;
- (void)pauseParty:(int)fp8 shouldPause:(BOOL)fp12;
- (BOOL)isPartyPaused:(int)fp8;
- (void)lockVideoForParty:(int)fp8 shouldLock:(BOOL)fp12;
- (int)setAudioVolume:(float)fp8;
- (float)audioVolume;
- (void)VCSendMessageProc:(id)fp8;
- (void)handleFrameworkNotification:(id)fp8;
- (void)handleDistributedNotification:(id)fp8;
- (int)cancelPreview;
- (int)setMicrophoneGain:(float)fp8;
- (float)microphoneGain;
- (float)microphoneLevel;
- (float)speakerLevel;
- (int)upstreamBandwidthToUserID:(id)fp8;
- (int)upstreamAudioBandwidthToUserID:(id)fp8;
- (BOOL)openCamera;
- (BOOL)closeCamera;
- (BOOL)selectCameraByGUID:(id)fp8;
- (id)selectedCamera;
- (BOOL)selectCamera:(id)fp8;
- (id)cameraName;
- (BOOL)selectMicrophone:(id)fp8;
- (id)selectedMicrophone;
- (id)findMovieMic;
- (BOOL)selectMovieMic;
- (BOOL)selectMic:(id)fp8;
- (id)micName;
- (BOOL)selectSpeaker:(id)fp8;
- (id)selectedSpeaker;
- (BOOL)selectSoundOutputDevice:(id)fp8;
- (id)soundOutputDeviceName;
- (BOOL)setColor:(float)fp8;
- (float)color;
- (BOOL)setBrightness:(float)fp8;
- (float)brightness;
- (BOOL)setContrast:(float)fp8;
- (float)contrast;
- (BOOL)setFocus:(float)fp8;
- (float)focus;
- (BOOL)setSharpness:(float)fp8;
- (float)sharpness;
- (void)setLightingProfile:(int)fp8;
- (int)lightingProfile;
- (void)iChatWillFileTransfer;
- (void)iChatDidFileTransfer;
- (id)snatmapDataObj;
- (void)setSNATMAPData:(id)fp8;
- (int)properConfIndexForUser:(id)fp8;
- (id)getErrorReport;
- (void)shutdownAV;

@end

@interface VideoConferenceController (UserIDMapProtocol)
- (BOOL)addUserIDToMap:(id)fp8 withInfo:(id)fp12;
- (BOOL)removeUserIDFromMap:(id)fp8;
- (int)userIDMapCount;
- (void)clearUserIDToCallIDMap;
- (void)invalidateCallIDForUserID:(id)fp8;
- (BOOL)existUserIDInUserIDMap:(id)fp8;
- (void)updateDictionaryForUserID:(id)fp8 withSubKey:(id)fp12 andValue:(id)fp16;
- (id)dictionaryForUserID:(id)fp8;
- (id)dictionaryForPeer;
@end

@interface VideoConferenceController (VCSideShow)
- (BOOL)enableReplacementVideoInputWithName:(id)fp8;
- (void)disableReplacementInput;
- (void)requestAuxiliaryVideoInput;
- (void)setAuxiliaryVideoInputMode:(int)fp8;
- (void)auxiliaryInputReady;
- (void)disableAuxiliaryVideoInput;
- (id)audioReflectorGUID;
- (int)audioReflectorChannel;
- (id)audioReflectorChannels:(int)fp8;
- (BOOL)requestReflectorChannels:(id)fp8;
- (int)startAuxiliaryReflector;
- (void)stopAuxiliaryReflector;
- (void)muteAuxiliaryAudio:(BOOL)fp8;
- (void)muteAuxiliaryAudioLocalPlayback:(BOOL)fp8;
- (struct _NSSize)auxVideoBufferSizeForParty:(id)fp8 replacementOnly:(BOOL)fp12;
@end

@interface VideoConferenceController (VCSideShow_Private)
- (BOOL)enableU2Input;
- (void)disableU2Input;
- (void)sendHardwareCapsChange:(BOOL)fp8;
@end

@interface VideoConferenceController (otherapi)
- (void)hangupThreadProc:(id)fp8;
- (void)launchHangupThread:(int)fp8;
- (void)allowGSM:(BOOL)fp8;
- (void)allowG711:(BOOL)fp8;
- (void)allowPureVoice:(BOOL)fp8;
- (int)cameraFeatureID:(id)fp8;
- (int)setCameraFeature:(int)fp8 enabled:(int)fp12 value:(float)fp16 automatic:(int)fp20;
- (int)getCameraFeature:(int)fp8 enabled:(int *)fp12 value:(float *)fp16 automatic:(int *)fp20;
- (int)getCameraFeatureDefaults:(int)fp8 enabled:(int *)fp12 value:(float *)fp16 automatic:(int *)fp20;
- (int)getCameraFeatureRange:(int)fp8 minValue:(float *)fp12 maxValue:(float *)fp16 hasManual:(int *)fp20 hasAuto:(int *)fp24;
- (int)setCameraFocusPoint:(float)fp8 y:(float)fp12;
- (int)getCameraFocusPoint:(float *)fp8 y:(float *)fp12;
- (int)getCameraFocusPointDefaults:(float *)fp8 y:(float *)fp12;
- (int)setCameraAreaOfInterest:(float)fp8 y:(float)fp12 width:(float)fp16 height:(float)fp20;
- (int)getCameraAreaOfInterest:(float *)fp8 y:(float *)fp12 width:(float *)fp16 height:(float *)fp20;
- (int)getCameraAreaOfInterestDefaults:(float *)fp8 y:(float *)fp12 width:(float *)fp16 height:(float *)fp20;
- (void)setEncryption:(BOOL)fp8;
- (BOOL)encryption;
- (void)setEchoCancellation:(BOOL)fp8;
- (BOOL)echoCancellation;
- (void)setAGC:(BOOL)fp8;
- (BOOL)AGC;
- (void)setOldAudioProcessing:(BOOL)fp8;
- (BOOL)oldAudioProcessing;
- (void)setNewAudioProcessing:(BOOL)fp8;
- (BOOL)newAudioProcessing;
- (void)setPreFilter:(int)fp8 enabled:(BOOL)fp12;
- (BOOL)preFilter:(int)fp8;
- (void)setPostFilter:(BOOL)fp8;
- (BOOL)postFilter;
- (id)get_seqg;
- (id)get_ch_video;
- (id)cameraSettingsData;
- (BOOL)setCameraSettingsData:(id)fp8;
- (BOOL)enableFocus:(BOOL)fp8;
- (int)sendChatMessage:(id)fp8;
- (id)bandwidthDictionaryForUserID:(id)fp8;
@end

@interface VideoConferenceController (private_methods)
- (void)UPnPSetupProc:(id)fp8;
- (BOOL)setAudioAndVideoPayload:(id)fp8 forConferenceIndex:(int)fp12 forUserAgent:(id)fp16;
- (BOOL)setAudioAndVideoPayload:(id)fp8 forConferenceIndex:(int)fp12 forUserAgent:(id)fp16 forPeerSDP:(id)fp20;
- (id)getSIPDataAndIPListFromRemoteIPAndPortData:(id)fp8 ipList:(id)fp12;
- (BOOL)hasCamera;
- (BOOL)_openCamera;
- (BOOL)_closeCamera;
- (BOOL)_selectCameraByGUID:(id)fp8;
- (id)_selectedCamera;
- (void)setConferenceBitrate:(int)fp8;
- (id)currentCameraName;
- (void)setCurrentCameraName:(id)fp8;
- (id)currentCameraGUID;
- (void)setCurrentCameraGUID:(id)fp8;
- (int)processCVPixelBuffer:(void *)fp8 intoCVPixelBuffer:(void *)fp12 withHint:(id)fp16;
- (void)setInternalSamplingRateFromDefaults;
@end

@interface VideoConferenceMultiController : VideoConferenceController
{
}

+ (id)makeIPAndPortDataFromIP:(id)fp8 port:(unsigned short)fp12;
- (id)init;
- (id)initWithRectTexture:(int)fp8;
- (void)dealloc;
- (void)setValidatedIdentity:(struct OpaqueSecIdentityRef *)fp8;
- (struct OpaqueSecIdentityRef *)getValidatedIdentity;
- (BOOL)isSecurityEnabledForUser:(id)fp8;
- (BOOL)isSecurityValidForUser:(id)fp8;
- (BOOL)isSecurityEnabled;
- (BOOL)isSecurityValid;
- (struct OpaqueSecCertificateRef *)getRemoteCertificateForUser:(id)fp8;
- (id)IPAndPortDataWithCallerIPAndPortData:(id)fp8;
- (id)IPAndPortDataWithCallerIPAndPortData:(id)fp8 shouldFindExternalIP:(BOOL)fp12;
- (int)initiateConferenceToUser:(id)fp8 withIPAndPortData:(id)fp12 oneWayOnly:(BOOL)fp16 withValidatedCert:(struct OpaqueSecCertificateRef *)fp20;
- (int)initiateConferenceToUser:(id)fp8 withIPAndPortData:(id)fp12 oneWayOnly:(BOOL)fp16 withValidatedCert:(struct OpaqueSecCertificateRef *)fp20 shouldFindExternalIP:(BOOL)fp24;
- (int)initiateConferenceToUser:(id)fp8 withIPAndPortData:(id)fp12 oneWayOnly:(BOOL)fp16;
- (int)initiateConferenceToUser:(id)fp8 withIPAndPortData:(id)fp12 oneWayOnly:(BOOL)fp16 shouldFindExternalIP:(BOOL)fp20;
- (int)addParticipantToConference:(id)fp8 withIPAndPortData:(id)fp12 oneWayOnly:(BOOL)fp16;
- (int)endConference;
- (int)endConferenceForUserID:(id)fp8;
- (BOOL)startReflector;
- (BOOL)stopReflector;
- (int)reflectorChannelForUserID:(id)fp8;
- (void)setReflectorIconForUserID:(id)fp8 icon:(struct __CFData *)fp12;
- (unsigned long)vcCapabilities;
- (unsigned long)vcCapabilitiesOfCPU;
- (unsigned long)vcCapabilitiesOfNetwork;
- (BOOL)isFocus;
- (BOOL)startConferenceWithUserID:(id)fp8;
- (int)DoVCIncomingConference:(void *)fp8;
- (BOOL)startConferenceWithIndex:(int)fp8 userAtIndexIsCaller:(BOOL)fp12 userIDAtIndex:(id)fp16;
- (id)statistics;
- (double)conferenceUptime;
- (id)audioLevelForUserID:(id)fp8;
- (BOOL)getLocalVideoTextureBuffer:(CDAnonymousStruct1_ *)fp8;
- (BOOL)isLocalVideoChanged;
- (BOOL)isRemoteVideoChangedForUser:(id)fp8;
- (BOOL)lockVideoBufferForUser:(id)fp8;
- (BOOL)unlockVideoBufferForUser:(id)fp8;
- (BOOL)lockVideoBufferForUser:(id)fp8 lockID:(int *)fp12;
- (BOOL)unlockVideoBufferForUser:(id)fp8 lockID:(int)fp12;
- (BOOL)getRemoteVideoTextureBuffer:(CDAnonymousStruct1_ *)fp8 forUser:(id)fp12;
- (BOOL)getRemoteVideoTextureBuffer:(CDAnonymousStruct1_ *)fp8 forUser:(id)fp12 freezeFlag:(BOOL)fp16;
- (unsigned int)localSIPPort;
- (unsigned int)externalSIPPort;
- (id)externalIPAddress;
- (id)IPAndPortDataWithCallerIP:(id)fp8 callerSIPPort:(unsigned int)fp12;
- (id)IPAndPortDataWithCallerIP:(id)fp8 callerSIPPort:(unsigned int)fp12 shouldFindExternalIP:(BOOL)fp16;

@end

@interface VideoConferenceMultiController (NSThreadProcs)
- (void)VCIncomingConferenceProc:(id)fp8;
- (void)VCSendNotificationProc:(id)fp8;
- (void)VCCancelProc:(id)fp8;
- (void)VCReferredInvitationProc:(id)fp8;
- (void)VCInternalUpdateParticipantsProc:(id)fp8;
- (void)VCCheckRemoteCertProc:(id)fp8;
- (void)VCSecurityChangedProc:(id)fp8;
- (void)VCProcessRequestAuxInputProc:(id)fp8;
- (void)VCSIPHangupProc:(id)fp8;
- (void)VCProcessEndingAuxInputProc:(id)fp8;
- (void)VCSendRequestAuxiliaryVideoInputProc:(id)fp8;
- (void)VCSendMessageEndingAuxInputProc:(id)fp8;
@end

@interface VideoConferenceMultiController (VCInitiateConference)
- (id)VCConnectionDataWithExtraChannels:(id)fp8 shouldFindExternalIP:(BOOL)fp12;
- (id)VCConnectionDataWithExtraChannels:(id)fp8;
- (id)VCConnectionData;
- (id)VCConnectionData:(BOOL)fp8;
- (void)prepareConnectionWithRemoteConnectionData:(id)fp8 localConnectionData:(id)fp12;
- (void)cancelPreparingConnection:(id)fp8;
- (int)initiateConferenceToUser:(id)fp8 withRemoteVCConnectionData:(id)fp12 withLocalVCConnectionData:(id)fp16 conferenceSettings:(id)fp20;
- (int)initiateConferenceToUser:(id)fp8 withRemoteVCConnectionData:(id)fp12 withLocalVCConnectionData:(id)fp16 conferenceSettings:(id)fp20 shouldFindExternalIP:(BOOL)fp24;
- (id)extraChannelsForVCConnectionData:(id)fp8;
@end

@interface VideoConferenceMultiController (VCInitiateConference_Private)
- (int)callIDForVCConnectionData:(id)fp8;
- (id)connectionDataForIPAndPortData:(id)fp8;
- (id)bandwidthDictionary;
- (id)VCChannelExtraDictionary:(id)fp8 withHandle:(struct tagHANDLE *)fp12;
- (id)SIPICEDataForCallID:(int)fp8 shouldFindExternalIP:(BOOL)fp12;
- (id)generateVCConnectionDataWithVersion:(int)fp8 SIPICEData:(id)fp12 bandwidthDictionary:(id)fp16 connectionHelper:(id)fp20 VCChannelExtra:(id)fp24;
- (id)IPAndPortDataForConnectionData:(id)fp8;
- (id)extractObjectFromVCConnectionData:(id)fp8 byKey:(id)fp12;
- (id)extractConnectionDataFromVCConnectionData:(id)fp8;
- (id)extractIPAndPortDataFromVCConnectionData:(id)fp8;
- (id)extractVersionFromVCConnectionData:(id)fp8;
- (id)extractBandwidthInfoFromVCConnectionData:(id)fp8;
- (id)extractVCChannelExtraFromVCConnectionData:(id)fp8;
- (BOOL)hasVCChannelExtraInVCConnectionData:(id)fp8;
- (struct tagHANDLE *)extractVCChannelHandleFromVCConnectionData:(id)fp8;
- (int)initiateConferenceCallUsingConnectionDataWithErrorInfoToUser:(id)fp8 withRemoteVCConnectionData:(id)fp12 withLocalVCConnectionData:(id)fp16 oneWayOnly:(BOOL)fp20 errorInfo:(id *)fp24 shouldFindExternalIP:(BOOL)fp28;
- (void)initiateConferenceToUserWithVCConnectionDataProc:(id)fp8;
- (void)cacheConnectionData:(id)fp8 andCallID:(int)fp12;
- (void)VCChannelExtraPreparationProc:(id)fp8;
@end

@interface VideoConferenceMultiController (VCNetworkMonitor)
- (void)openNetworkMonitor;
- (void)closeNetworkMonitor;
- (void)registerForNetworkChanges;
- (id)localIPs;
@end

@interface VideoConferenceMultiController (helper)
- (void)updateFocusTransmitParameters;
- (void)updateFocusCapabilityForBandwidth:(struct _VCFocusCapability *)fp8 upstreamKbits:(int)fp12 downstreamKbits:(int)fp16;
- (void)determineFocusCapability:(struct _VCFocusCapability *)fp8 isVideoHardwareCapable:(char *)fp12;
- (void)determineFocusCapabilityOfCPU:(struct _VCFocusCapability *)fp8;
- (void)determineFocusCapabilityOfNetwork:(struct _VCFocusCapability *)fp8;
- (void)handleCleanupForUser:(id)fp8 endTransmit:(BOOL)fp12 andSendSIPHangupToCallID:(int)fp16;
- (void)setAudioHalfRate:(BOOL)fp8 forConfIndex:(int)fp12;
- (void)printCapabilities:(unsigned long)fp8;
- (int)doPeerToPeerBandwidthDetectionForIndex:(int)fp8 pUpstreamKbits:(int *)fp12 pDownstreamKbits:(int *)fp16 withSNATMAPIP:(unsigned long)fp20 withCallID:(int)fp24 withUserID:(id)fp28;
@end

@interface VideoConferenceMultiController (procs)
- (void)determineFocusCapabilityProc:(id)fp8;
- (void)checkNATCapabilityProc:(id)fp8;
@end

