/*
 * iChatCommonGUI.h
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 *     Generated by class-dump 3.1.1.
 *
 *     class-dump is Copyright (C) 1997-1998, 2000-2001, 2004-2006 by Steve Nygard.
 */

/*
 * File: /System/Library/PrivateFrameworks/iChatCommonGUI.framework/iChatCommonGUI
 * Arch: PowerPC 7400 (ppc7400)
 *       Current version: 601.0.0, Compatibility version: 1.0.0
 */

@class TranscriptStyleManager, SimplifiedFont, FileTransfer, FileTransferFragmentManager, FileTransferFragmentProvider;

@protocol PresentityProtocol <NSObject>
- (id)ID;
- (id)name;
- (id)nameAndID;
- (BOOL)isMyLogin;
- (id)balloonColor;
- (id)guid;
- (BOOL)isBuddy;
- (BOOL)canBeSecure;
- (id)uniqueName;
- (id)pictureKey;
- (id)mappedPresentity;
@end

@protocol FZSecureObject <NSObject>
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
@end

@protocol InstantMessageReadOnlyProtocol <NSObject>
- (id)sender;
- (id)subject;
- (BOOL)fromMe;
- (id)time;
- (id)text;
- (id)originalText;
- (id)summaryString;
- (id)incomingFile;
- (id)outgoingFile;
- (id)senderName;
- (id)baseFont;
- (BOOL)isEmpty;
- (BOOL)finished;
- (BOOL)isEmote;
- (BOOL)isRTL;
- (BOOL)isAlert;
- (BOOL)isDelayed;
- (BOOL)isAutoReply;
- (BOOL)isAddressedToMe;
- (id)backgroundColor;
- (id)error;
- (id)guid;
- (BOOL)isHeader;
- (BOOL)isTimestamp;
- (BOOL)isStatusChangeMessage;
- (BOOL)isSystemMessage;
- (BOOL)isAnnouncementMessage;
- (BOOL)isInvitationMessage;
- (id)inlineFiles;
@end

@interface AbstractRichTextGenerator : NSObject
{
    NSAttributedString *_text;
    NSColor *_fgColor;
    NSColor *_bgColor;
    NSFont *_baseFont;
    NSMutableArray *_tagStack;
    NSMutableArray *_tagValueStack;
    NSMutableString *_out;
}

+ (id)richTextFromAttributedString:(id)fp8 baseFont:(id)fp12 defaultBGColor:(id)fp16;
+ (id)plainTextFromAttributedString:(id)fp8;
+ (id)hrefTextForURL:(id)fp8;
+ (id)_bgColorForHTML:(id)fp8;
+ (id)parseHTML:(id)fp8 resultingBGColor:(id *)fp12 resultingFontColor:(id *)fp16 defaultFont:(id)fp20;
+ (id)_generatorString;
- (id)initWithAttributedString:(id)fp8;
- (void)dealloc;
- (void)setDefaultForegroundColor:(id)fp8;
- (void)setDefaultBackgroundColor:(id)fp8;
- (void)setBaseFont:(id)fp8;
- (id)_valueOfTag:(id)fp8;
- (void)_appendTagAttributeWithAttribute:(id)fp8 value:(id)fp12;
- (void)_pushPopSingletonTag:(id)fp8 attributesAndValues:(id)fp12;
- (void)_pushTag:(id)fp8 tagValue:(id)fp12 attributesAndValues:(id)fp16;
- (void)_pushTag:(id)fp8 tagValue:(id)fp12 attribute:(id)fp16 value:(id)fp20;
- (void)_popTag;
- (void)_popAllTags;
- (void)_popTag:(id)fp8 ifValueNot:(id)fp12;
- (void)_generateImageTagWithTextAttachment:(id)fp8 fileName:(id)fp12 ID:(id)fp16 width:(id)fp20 height:(id)fp24 fileSize:(id)fp28;
- (void)_generateHTMLForString:(id)fp8 attributes:(id)fp12;
- (id)generateRichText;
- (id)generatePlainText;
- (id)_currentColor;
- (id)_currentFont;
- (BOOL)_isXHTML;
- (id)_brTag;
- (void)_pushHTMLTag;
- (void)_pushBodyTagWithForegroundColor:(id)fp8 backgroundColor:(id)fp12 isRTL:(BOOL)fp16;
- (void)_generateTagsWithBold:(id)fp8 italic:(id)fp12 link:(id)fp16 font:(id)fp20 color:(id)fp24 bgColor:(id)fp28 underline:(id)fp32 myName:(id)fp36;

@end

@interface TranscriptFragmentProvider : NSObject
{
    TranscriptStyleManager *_styleManager;
}

- (id)role;
- (id)fragmentIdForMessage:(id)fp8;
- (id)initWithTranscriptStyleManager:(id)fp8;
- (void)dealloc;
- (void)transcriptWillLoad;
- (void)transcriptDidLoad;
- (void)nameDisplayChanged:(id)fp8;
- (id)fragmentForMessage:(id)fp8;
- (id)appendFragmentForMessage:(id)fp8 toNode:(id)fp12;
- (void)removeFragmentForMessage:(id)fp8;
- (void)addFragmentIdPropertiesToElement:(id)fp8 forMessage:(id)fp12;

@end

@interface SystemMessageFragmentProvider : TranscriptFragmentProvider
{
    NSMutableDictionary *_persons;
    DOMCSSPageRule *_systemMessageRule;
}

- (id)initWithTranscriptStyleManager:(id)fp8;
- (id)role;
- (void)transcriptWillLoad;
- (void)dealloc;
- (void)makeVisible;
- (void)makeInvisible;
- (id)setupMutableArrayForPresentity:(id)fp8;
- (void)nameDisplayChanged:(id)fp8;
- (id)fragmentForMessage:(id)fp8;

@end

@interface AnnouncementFragmentProvider : SystemMessageFragmentProvider
{
}

@end

@interface BuddyIconFragment : NSObject
{
    DOMDocumentFragment *_fragment;
    NSString *_personGuid;
    DOMElement *_container;
    DOMElement *_standardRepresentationElement;
    BOOL _usingStandardRepresentation;
    BuddyIconFragment *_nextFragment;
    BuddyIconFragment *_previousFragment;
    id <InstantMessageReadOnlyProtocol> _instantMessage;
}

- (id)initWithMessage:(id)fp8 size:(unsigned int)fp12 inChat:(id)fp16;
- (void)useAlternateRepresentation:(id)fp8;
- (void)useStandardRepresentation;
- (void)dealloc;
- (id)fragment;
- (id)instantMessage;
- (id)previousFragment;
- (void)setPreviousFragment:(id)fp8;
- (id)nextFragment;
- (void)setNextFragment:(id)fp8;

@end

@interface BuddyIconFragmentProvider : TranscriptFragmentProvider
{
    unsigned int _iconSize;
    DOMCSSPageRule *_iconContainerRule;
    DOMCSSPageRule *_personIconRule;
    DOMCSSPageRule *_personIconPluginRule;
    NSMutableDictionary *_presentityActiveIcons;
    NSMutableDictionary *_presentityStaticIcons;
    NSMutableDictionary *_presentityPersonIcons;
    NSMutableDictionary *_iconsInTranscript;
    BuddyIconFragment *_lastIcon;
    DOMElement *_pluginElement;
}

- (id)role;
- (id)fragmentIdForMessage:(id)fp8;
- (id)initWithTranscriptStyleManager:(id)fp8;
- (unsigned int)iconSize;
- (void)setIconSize:(unsigned int)fp8;
- (void)transcriptWillLoad;
- (void)_updateIconContainerRule;
- (void)_updatePersonIconRule;
- (void)dealloc;
- (id)_personiconUrlForKey:(id)fp8;
- (void)createRulesForPresentity:(id)fp8;
- (void)updateRulesForPresentity:(id)fp8;
- (id)_buildPluginElement;
- (void)_updatePluginElement:(id)fp8 forPresentity:(id)fp12;
- (id)fragmentForMessage:(id)fp8;
- (void)removeFragmentForMessage:(id)fp8;

@end

@interface DOMDocument (FezWebUtil)
- (id)createDivElement;
- (id)createSpanElement;
@end

@interface DOMElement (FezWebUtil)
- (struct _NSRect)boundsRectForElement;
- (struct _NSRect)minimumDisplayRectForElement;
- (id)parentElementWithAttribute:(id)fp8 havingValue:(id)fp12;
@end

@interface DateFragmentProvider : TranscriptFragmentProvider
{
    NSMutableArray *_dateFragments;
}

- (id)initWithTranscriptStyleManager:(id)fp8;
- (void)dealloc;
- (void)transcriptWillLoad;
- (id)fragmentForDate:(id)fp8 showDate:(BOOL)fp12 showTime:(BOOL)fp16 showSeconds:(BOOL)fp20;
- (id)fragmentForDate:(id)fp8;
- (void)adjustDateFragmentsForTimeChange;
- (void)updateDateFormats;
- (void)dateFormatDidChange;
- (id)preciseStringForDate:(id)fp8;
- (id)formatDate:(id)fp8 roundInterval:(int)fp12 showDate:(BOOL)fp16 showTime:(BOOL)fp20 showSeconds:(BOOL)fp24;

@end

@interface TimestampFragmentProvider : SystemMessageFragmentProvider
{
    DOMCSSPageRule *_timestampRule;
}

- (void)transcriptWillLoad;
- (void)dealloc;
- (id)fragmentIdForMessage:(id)fp8;
- (id)_displayableDateFragmentForDate:(id)fp8;
- (id)fragmentForMessage:(id)fp8;
- (void)hideTimestamps;
- (void)showTimestamps;
- (void)makeTimestampsInvisible;
- (void)makeTimestampsVisible;

@end

@interface DatestampFragmentProvider : TimestampFragmentProvider
{
}

- (id)fragmentIdForMessage:(id)fp8;
- (id)_displayableDateFragmentForDate:(id)fp8;

@end

@interface DocumentFragmentProvider : TranscriptFragmentProvider
{
    unsigned int _documentBackgroundRuleIndex;
    DOMCSSPageRule *_bodyRule;
    DOMElement *_baseAppendPoint;
}

+ (id)baseBodyRule;
+ (id)baseDocumentString;
- (void)dealloc;
- (void)showNames;
- (void)hideNames;
- (void)showPictures;
- (void)hidePictures;
- (void)hideMessageContent;
- (void)showMessageContent;
- (void)hideScrollbars;
- (void)showScrollbars;
- (void)hideBackground;
- (void)showBackground;
- (void)makeNotSelectable;
- (void)makeSelectable;
- (void)transcriptWillLoad;
- (void)transcriptDidLoad;
- (id)backgroundRuleForPath:(id)fp8;
- (void)setBackgroundImage:(id)fp8;
- (id)baseAppendPoint;

@end

@interface EmoteFragmentProvider : TranscriptFragmentProvider
{
    DOMCSSPageRule *_emoteRule;
}

- (id)role;
- (void)transcriptWillLoad;
- (void)dealloc;
- (id)fragmentForMessage:(id)fp8;

@end

@interface EmoticonFragmentProvider : TranscriptFragmentProvider
{
    DOMCSSPageRule *_imageRule;
    DOMCSSPageRule *_textRule;
}

+ (id)emoticonForRawText:(id)fp8 usingImageVariantAtPath:(id)fp12 inChat:(id)fp16;
- (void)dealloc;
- (void)transcriptWillLoad;
- (void)updateCSSRulesShowingImageVariants:(BOOL)fp8;
- (void)showImageVariants;
- (void)showTextVariants;

@end

@interface ErrorFragmentProvider : SystemMessageFragmentProvider
{
}

@end

@interface FZImageResourceURLProtocol : NSURLProtocol
{
}

+ (id)customProtocolScheme;
+ (BOOL)canInitWithRequest:(id)fp8;
+ (id)canonicalRequestForRequest:(id)fp8;
+ (void)registerCustomProtocolInBundle:(id)fp8;
- (void)loadOnMainThreadCreatingDataAt:(id)fp8;
- (void)startLoading;
- (void)stopLoading;

@end

@interface FZPair : NSObject <NSCopying>
{
    id _first;
    id _second;
}

+ (id)pairWithFirst:(id)fp8 second:(id)fp12;
- (id)initWithFirst:(id)fp8 second:(id)fp12;
- (id)first;
- (id)second;
- (void)dealloc;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (unsigned int)hash;
- (BOOL)isEqual:(id)fp8;

@end

@interface FezNSTextAttachment : NSTextAttachment
{
    NSImage *_image;
}

- (id)initWithImage:(id)fp8;
- (void)dealloc;
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;
- (void)setFileWrapper:(id)fp8;
- (id)fileWrapper;
- (id)attachmentCell;
- (id)description;

@end

@interface TimestampResolver : NSObject
{
    NSDate *_lastTimestamp;
}

- (void)setLastTimestamp:(id)fp8;
- (id)lastTimestamp;
- (BOOL)messageShouldHaveTimestamp:(id)fp8 afterMessage:(id)fp12;
- (BOOL)shouldAddTimestampBeforeMessage:(id)fp8 afterMessage:(id)fp12;

@end

@interface FixedIntervalTimestampResolver : TimestampResolver
{
    double _timeIntervalSeconds;
}

- (id)init;
- (double)timeIntervalSeconds;
- (void)setTimeIntervalSeconds:(double)fp8;
- (BOOL)messageShouldHaveTimestamp:(id)fp8 afterMessage:(id)fp12;
- (BOOL)shouldAddTimestampBeforeMessage:(id)fp8 afterMessage:(id)fp12;

@end

@interface FontAndColor : NSObject
{
    SimplifiedFont *_font;
    NSColor *_color;
    NSColor *_bgColor;
}

- (id)initWithFont:(id)fp8 color:(id)fp12 bgColor:(id)fp16;
- (void)dealloc;
- (id)color;
- (id)bgColor;
- (id)simplifiedFont;
- (BOOL)isEqualTo:(id)fp8;

@end

@interface HFSFileManager : NSFileManager
{
}

+ (id)defaultManager;
+ (id)defaultHFSFileManager;
- (BOOL)existingPath:(id)fp8 toFSRef:(void *)fp12;
- (BOOL)existingPath:(id)fp8 toFSSpec:(void *)fp12;
- (BOOL)path:(id)fp8 toParentFSRef:(void *)fp12 andFileName:(id *)fp16;
- (id)fileAttributesAtPath:(id)fp8 traverseLink:(BOOL)fp12;
- (BOOL)changeFileAttributes:(id)fp8 atPath:(id)fp12;
- (id)kindStringForFile:(id)fp8;
- (id)MIMETypeOfFile:(id)fp8;
- (id)MIMETypeOfFileWithName:(id)fp8 hfsType:(unsigned long)fp12 hfsCreator:(unsigned long)fp16;
- (id)displayNameOfFileWithName:(id)fp8 hfsFlags:(unsigned short)fp12;
- (long long)fileSizeAtPath:(id)fp8;
- (long long)totalSizeAtPath:(id)fp8 fileCount:(int *)fp12;
- (BOOL)isNonPublicAttrs:(unsigned long)fp8 forDir:(BOOL)fp12;
- (BOOL)isNonPublicFileAtPath:(id)fp8 traverseLink:(BOOL)fp12;

@end

@interface HeaderFragmentProvider : SystemMessageFragmentProvider
{
    DOMCSSPageRule *_headerRule;
}

- (id)role;
- (void)transcriptWillLoad;
- (void)dealloc;
- (void)makeVisible;
- (void)makeInvisible;
- (id)fragmentForMessage:(id)fp8;

@end

@interface InlineImageFragment : NSObject <DOMEventListener>
{
    DOMDocumentFragment *_fragment;
    NSString *_filename;
    TranscriptStyleManager *_style;
    BOOL _usesTileAppearance;
}

- (id)fragment;
- (id)initWithImagePath:(id)fp8 inChat:(id)fp12;
- (void)dealloc;
- (void)handleEvent:(id)fp8;

@end

@interface InlineImageFragmentProvider : TranscriptFragmentProvider
{
}

- (id)role;
- (void)transcriptWillLoad;
- (id)fragmentForImageAtPath:(id)fp8;

@end

@interface InstantMessage : NSObject <NSCoding, FZSecureObject, InstantMessageReadOnlyProtocol>
{
    id <PresentityProtocol> _sender;
    id <PresentityProtocol> _subject;
    NSDate *_time;
    NSAttributedString *_text;
    NSColor *_bgColor;
    int _flags;
    NSError *_error;
    FileTransfer *_file;
    NSString *_guid;
    BOOL _isInvitationMessage;
    NSString *_originalString;
    NSArray *_inlineFiles;
}

+ (id)fromMePresentity:(id)fp8 withText:(id)fp12 originalText:(id)fp16 outgoingFile:(id)fp20 flags:(int)fp24;
- (id)initWithSender:(id)fp8 time:(id)fp12 text:(id)fp16 originalText:(id)fp20 incomingFile:(id)fp24 flags:(int)fp28 error:(id)fp32 guid:(id)fp36 subject:(id)fp40;
- (id)initWithSender:(id)fp8 time:(id)fp12 string:(id)fp16 incomingFile:(id)fp20 flags:(int)fp24 error:(id)fp28;
- (id)initWithSender:(id)fp8 time:(id)fp12 string:(id)fp16 incomingFile:(id)fp20 flags:(int)fp24 error:(id)fp28 subject:(id)fp32;
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;
- (void)dealloc;
- (id)description;
- (id)sender;
- (id)subject;
- (BOOL)isDelayed;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (BOOL)isHeader;
- (BOOL)isTimestamp;
- (BOOL)isStatusChangeMessage;
- (BOOL)isSystemMessage;
- (BOOL)isAnnouncementMessage;
- (BOOL)fromMe;
- (id)time;
- (id)originalText;
- (id)text;
- (BOOL)isInteresting;
- (id)summaryString;
- (void)setText:(id)fp8;
- (id)backgroundColor;
- (void)setBackgroundColor:(id)fp8;
- (id)incomingFile;
- (id)outgoingFile;
- (int)flags;
- (void)setFlags:(int)fp8;
- (BOOL)finished;
- (BOOL)isEmpty;
- (BOOL)isAlert;
- (BOOL)hasInlineImage;
- (void)setInlineFiles:(id)fp8;
- (id)inlineFiles;
- (void)cleanupTemporaryInlineFiles;
- (void)setIsInvitationMessage:(BOOL)fp8;
- (BOOL)isInvitationMessage;
- (void)setIsAddressedToMe:(BOOL)fp8;
- (BOOL)isAutoReply;
- (BOOL)isEmote;
- (id)senderName;
- (BOOL)isRTL;
- (BOOL)isAddressedToMe;
- (id)error;
- (void)setError:(id)fp8;
- (id)guid;
- (id)baseFont;

@end

@interface InstantMessageFragmentProvider : TranscriptFragmentProvider
{
    BOOL _incomingContentHidden;
    unsigned int _containerIndex;
    DOMDocumentFragment *_lastMessageContainer;
    NSMutableArray *_timestamps;
}

- (id)fragmentIdForMessage:(id)fp8;
- (id)initWithTranscriptStyleManager:(id)fp8;
- (void)dealloc;
- (id)providerForMessage:(id)fp8;
- (id)appendFragmentForMessage:(id)fp8 toNode:(id)fp12;
- (void)removeFragmentForMessage:(id)fp8;
- (void)makeIncomingContentVisible;
- (void)makeIncomingContentHidden;
- (struct _NSRect)rectOfMessage:(id)fp8;
- (struct _NSRect)boundsOfMessage:(id)fp8;

@end

@interface KnockKnockFragmentProvider : TranscriptFragmentProvider
{
    DOMCSSPageRule *_kkRule;
    NSString *_knockKnockReplacementMessage;
    unsigned int _messageCount;
}

- (void)transcriptWillLoad;
- (void)setKnockKnockReplacementMessage:(id)fp8;
- (id)knockKnockReplacementMessage;
- (void)hideMessageContent;
- (void)showMessageContent;
- (void)dealloc;
- (id)fragmentForMessage:(id)fp8;
- (struct _NSRect)messagePreviewBounds;

@end

@interface LullTimestampResolver : FixedIntervalTimestampResolver
{
}

- (id)init;
- (BOOL)shouldAddTimestampBeforeMessage:(id)fp8 afterMessage:(id)fp12;

@end

@interface MessageBodyFragmentProvider : TranscriptFragmentProvider
{
    DOMCSSPageRule *_meRule;
    DOMCSSPageRule *_systemRule;
    DOMCSSPageRule *_remoteRule;
    DOMCSSPageRule *_remoteSpanRule;
    DOMCSSPageRule *_remoteStrongRule;
    DOMCSSPageRule *_remoteEmRule;
    DOMCSSPageRule *_remoteURule;
    DOMCSSPageRule *_watchMessageAddressingRule;
    DOMCSSPageRule *_rtlRule;
    DOMCSSPageRule *_messageSpanRule;
    NSColor *_localFontColor;
    NSFont *_localFont;
    NSColor *_remoteFontColor;
    NSFont *_remoteFont;
    BOOL _watchMessageAddressing;
    BOOL _remoteUserOverrideFormatting;
}

- (id)fragmentIdForMessage:(id)fp8;
- (void)setWatchMessageAddressing:(BOOL)fp8;
- (void)setRemoteUserOverrideFormatting:(BOOL)fp8;
- (void)setLocalFontColor:(id)fp8;
- (void)setRemoteFontColor:(id)fp8;
- (void)setLocalFont:(id)fp8;
- (void)setRemoteFont:(id)fp8;
- (void)_updateMeRule;
- (void)_updateRemoteRule;
- (void)_updateWatchMessageAddressingRule;
- (void)transcriptWillLoad;
- (id)ruleNameForContainerLink;
- (id)ruleNameForContainerAddressing;
- (id)ruleNameForEmoteLink;
- (id)ruleNameForEmoteAddressing;
- (id)ruleNameForEmoteBody;
- (void)dealloc;
- (void)_pruneTag:(id)fp8 fromTopOfNode:(id)fp12;
- (id)createMessage:(id)fp8 withRange:(struct _NSRange)fp12;
- (id)fragmentForMessage:(id)fp8;
- (void)provideContrastOverridesForColor:(id)fp8 containerLinkRule:(id)fp12 containerAddressingRule:(id)fp16 emoteLinkRule:(id)fp20 emoteAddressingRule:(id)fp24 emoteBodyRule:(id)fp28;

@end

@interface MessageContainerFragmentProvider : TranscriptFragmentProvider
{
    unsigned int _containerIndex;
    DOMCSSPageRule *_showPictureRule;
    DOMCSSPageRule *_showNameRule;
    BOOL _remoteUserOverrideFormatting;
    BOOL _usePresentityColor;
    NSArray *_localSenderRules;
    NSArray *_remoteSenderRules;
    NSMutableDictionary *_presentitySenderRules;
    NSMutableDictionary *_backgroundColorStyleRules;
    NSMutableArray *_presentities;
    NSMutableArray *_colorsWithRulesGenerated;
    NSMutableArray *_presentitiesWithRulesGenerated;
}

- (BOOL)needsToUpdateRulesForColor:(id)fp8;
- (void)didUpdateRulesForColor:(id)fp8;
- (void)didClearRulesForColor:(id)fp8;
- (BOOL)needsToUpdateRulesForPresentity:(id)fp8;
- (void)didUpdateRulesForPresentity:(id)fp8;
- (void)didClearRulesForPresentity:(id)fp8;
- (id)role;
- (id)fragmentIdForMessage:(id)fp8;
- (void)removeFragmentForMessage:(id)fp8;
- (id)backgroundColorForMessage:(id)fp8;
- (void)setRemoteUserOverrideFormatting:(BOOL)fp8;
- (void)setLocalBackgroundColor:(id)fp8;
- (void)setRemoteBackgroundColor:(id)fp8;
- (void)setWatchMessageAddressing:(BOOL)fp8;
- (void)forceUpdateDisplayRules;
- (void)forceUpdatePresentityRules;
- (void)forceUpdateColorRules;
- (id)initWithTranscriptStyleManager:(id)fp8;
- (void)dealloc;
- (void)transcriptWillLoad;
- (void)showNames;
- (void)hideNames;
- (void)showPictures;
- (void)hidePictures;
- (id)fragmentForMessage:(id)fp8;
- (void)prepareForSystemMessage;
- (void)processDisplayRulesForMessage:(id)fp8;
- (void)processDisplayRulesForColor:(id)fp8;
- (id)standardRuleBodyForColor:(id)fp8 isFromMe:(BOOL)fp12 isImportant:(BOOL)fp16;
- (void)processDisplayRulesForPresentity:(id)fp8;
- (id)createRulesForCriterion:(id)fp8;
- (id)createRulesForRemotePresentity;
- (id)createRulesForLocalPresentity;
- (id)createRulesForPresentity:(id)fp8;
- (id)createRulesForColor:(id)fp8;
- (void)updateRules:(id)fp8 forColor:(id)fp12;
- (void)updateRules:(id)fp8 forColor:(id)fp12 displayColor:(id)fp16 isFromMe:(BOOL)fp20 isImportant:(BOOL)fp24;
- (void)updateRules:(id)fp8 forPresentity:(id)fp12;
- (void)prepareForInstantMessage:(id)fp8;
- (struct _NSRect)messagePreviewBounds;
- (struct _NSRect)boundsOfMessage:(id)fp8;
- (id)colorForPresentity:(id)fp8;

@end

@interface MinuteChangedTimestampResolver : TimestampResolver
{
}

- (BOOL)shouldAddTimestampBeforeMessage:(id)fp8 afterMessage:(id)fp12;
- (BOOL)messageShouldHaveTimestamp:(id)fp8 afterMessage:(id)fp12;

@end

@interface NSAlert (iChatAlertAdditions)
+ (void)beginAlertSheetWithMessage:(id)fp8 text:(id)fp12 defaultButton:(id)fp16 alternateButton:(id)fp20 otherButton:(id)fp24 helpAnchor:(id)fp28 audibleAlert:(BOOL)fp32 documentWindow:(id)fp36 alertStyle:(unsigned int)fp40 delegate:(id)fp44 didEndSelector:(SEL)fp48 didDismissSelector:(SEL)fp52 contextInfo:(void *)fp56;
+ (void)beginAlertSheetWithMessage:(id)fp8 text:(id)fp12 helpAnchor:(id)fp16;
+ (void)beginAlertSheetWithMessage:(id)fp8 text:(id)fp12;
+ (int)runAlertSheetWithMessage:(id)fp8 text:(id)fp12 defaultButton:(id)fp16 alternateButton:(id)fp20 otherButton:(id)fp24 helpAnchor:(id)fp28 audibleAlert:(BOOL)fp32 alertStyle:(unsigned int)fp36;
+ (int)runAlertSheetWithMessage:(id)fp8 text:(id)fp12 helpAnchor:(id)fp16;
+ (int)runAlertSheetWithMessage:(id)fp8 text:(id)fp12;
@end

@interface NSApplication (BadgeAdditions)
- (void)setApplicationBadgeUnreadCount:(int)fp8;
- (void)clearApplicationBadge;
@end

@interface NSArray (FezAdditions)
- (BOOL)containsObjectIdenticalTo:(id)fp8;
- (unsigned int)indexOfObject:(id)fp8 matchingComparison:(SEL)fp12;
- (BOOL)containsObject:(id)fp8 matchingComparison:(SEL)fp12;
- (id)arrayByApplyingSelector:(SEL)fp8;
- (id)arrayByApplyingSelector:(SEL)fp8 withObject:(id)fp12;
- (id)arrayByFilteringOutBySelector:(SEL)fp8 withObject:(id)fp12;
- (id)componentsJoinedIntoListWithMaxItems:(int)fp8;
@end

@interface NSAttributedString (AttributeSearching)
- (id)nextAttribute:(id)fp8 fromLocation:(unsigned int)fp12 effectiveRange:(struct _NSRange *)fp16;
@end

@interface NSAttributedString (FezAdditions)
- (BOOL)attribute:(id)fp8 existsInRange:(struct _NSRange)fp12;
@end

@interface NSAttributedString (TruncationExtensions)
- (struct _NSRange)adjustRange:(struct _NSRange)fp8;
- (int)actualWritingDirection;
@end

@interface NSBezierPath (RoundedRectangle)
+ (id)bezierPathWithRoundRectInRect:(struct _NSRect)fp8 radius:(float)fp24;
+ (id)bezierPathWithRoundTopRightRectInRect:(struct _NSRect)fp8 radius:(float)fp24;
+ (id)bezierPathWithRoundTopRectInRect:(struct _NSRect)fp8 radius:(float)fp24;
+ (id)openBezierPathWithRoundTopRectInRect:(struct _NSRect)fp8 radius:(float)fp24;
+ (id)openBezierPathWithRoundBottomRectInRect:(struct _NSRect)fp8 radius:(float)fp24;
+ (id)bezierPathWithRoundBottomRectInRect:(struct _NSRect)fp8 radius:(float)fp24;
+ (id)openBezierPathWithRect:(struct _NSRect)fp8 hasTop:(BOOL)fp24 hasBottom:(BOOL)fp28;
+ (id)bezierPathWithPieChart:(float)fp8 inRect:(struct _NSRect)fp12 startAngle:(float)fp28;
@end

@interface NSBitmapImageRep (RawDataAdditions)
- (id)JPEGDataWithCompression:(float)fp8;
@end

@interface NSButton (ImageSizingAdditions)
- (id)_templateImageFrom:(id)fp8 ofSize:(struct _NSSize)fp12;
- (void)setTemplateImageSize:(struct _NSSize)fp8;
@end

@interface NSCalendarDate (FezAdditions)
- (int)daysAgo;
@end

@interface NSColor (FezColorUtilAdditions)
+ (id)cannedColorPlist;
+ (id)cannedColorWithTag:(int)fp8;
+ (id)randomizedCannedColors;
+ (id)colorWithWebIntValue:(int)fp8;
- (BOOL)isEqualToColor:(id)fp8;
- (int)webIntValue;
@end

@interface NSColor (FezWebUtil)
- (float)grayness;
- (id)rgbaColor;
- (id)hexColor;
- (id)safeLinkColor;
- (id)htmlString;
- (id)cssValue;
- (id)bgCssValue;
@end

@interface NSData (FezAdditions)
+ (id)dataWithHexString:(id)fp8;
+ (id)dataWithRandomBytes:(unsigned int)fp8;
- (id)hexStringOfBytes:(char *)fp8 withLength:(int)fp12;
- (id)hexString;
- (BOOL)hasJPEGPrefix;
- (BOOL)hasGIFPrefix;
@end

@interface NSData (ImageTypeChecking)
- (id)imageFileExtension;
- (BOOL)isGIF;
- (BOOL)isJPEG;
@end

@interface NSDataRetainingImage : NSImage
{
    NSData *_originalDataBlob;
    NSString *_fileExtension;
}

+ (BOOL)canInitWithPasteboard:(id)fp8;
- (id)initWithData:(id)fp8;
- (id)initWithContentsOfFile:(id)fp8;
- (id)initWithPath:(id)fp8;
- (id)initWithPasteboard:(id)fp8 sender:(id)fp12;
- (id)initWithPasteboard:(id)fp8;
- (void)setOriginalData:(id)fp8;
- (id)originalData;
- (id)fileExtension;
- (id)writeToPath:(id)fp8 withName:(id)fp12 unique:(BOOL)fp16 atomically:(BOOL)fp20;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (void)dealloc;
- (id)imageWithMaxSize:(int)fp8;
- (id)imageWithMaxSize:(int)fp8 withLeftPad:(int)fp12;

@end

@interface NSDate (FezAdditions)
- (int)daysAgo;
@end

@interface NSDictionary (FezAdditions)
+ (id)_dictionaryWithData:(id)fp8 isPlist:(BOOL)fp12 allowedClasses:(id)fp16;
+ (id)dictionaryWithPlistData:(id)fp8;
+ (id)dictionaryWithArchiveData:(id)fp8 allowedClasses:(id)fp12;
+ (id)dictionaryWithArchiveData:(id)fp8;
- (id)plistData;
- (id)archiveData;
- (id)dictionaryFromChanges:(id)fp8;
@end

@interface NSDictionary (HFSFileAttributes)
- (id)fileCreationDate;
- (unsigned long)fileHFSType;
- (unsigned long)fileHFSCreator;
- (unsigned short)fileHFSFlags;
- (unsigned long long)fileHFSResourceForkSize;
@end

@interface NSFileManager (FezAdditions)
- (id)baseDirectoryContentsAtPath:(id)fp8;
- (BOOL)makeDirectoriesInPath:(id)fp8 mode:(int)fp12;
- (id)uniqueFilename:(id)fp8 atPath:(id)fp12 ofType:(id)fp16;
@end

@interface NSFont (FezWebUtil)
- (id)fontDeltaName;
- (id)cheapCSSValue;
- (id)cssValue;
- (id)cssValueIsImportant:(BOOL)fp8;
- (id)aimFontSize;
- (BOOL)hasBoldAttribute;
- (BOOL)hasItalicAttribute;
@end

@interface NSImage (ImageEffects)
+ (id)imageNamed:(id)fp8 rollover:(BOOL)fp12 pressed:(BOOL)fp16 inactive:(BOOL)fp20 disabled:(BOOL)fp24 clearSelected:(BOOL)fp28 selected:(BOOL)fp32 active:(BOOL)fp36;
+ (id)clearSelectedImageNamed:(id)fp8;
+ (id)selectedImageNamed:(id)fp8;
+ (id)rolloverImageNamed:(id)fp8;
+ (id)inactiveImageNamed:(id)fp8;
+ (id)disabledImageNamed:(id)fp8;
+ (id)pressedImageNamed:(id)fp8;
+ (id)activeImageNamed:(id)fp8;
@end

@interface NSImage (ImageRelativeSizing)
- (void)sizeImageToFitInSize:(struct _NSSize)fp8;
@end

@interface NSImage (NSDataRetainingWarnings)
- (id)originalData;
@end

@interface NSImage (SimpleImageEffects)
- (id)imageByApplyingShadow:(id)fp8;
@end

@interface NSImage (TintedImageAdditions)
- (id)tintedImageWithColor:(id)fp8;
@end

@interface NSImage (iChatAdditions)
+ (id)imageNamed:(id)fp8 inBundle:(id)fp12;
- (struct CGImage *)CGImage;
- (BOOL)imageIsWithinMaxSize:(struct _NSSize)fp8 andMinSize:(struct _NSSize)fp16;
- (struct _NSSize)sizeForDetailedDisplayInWindow:(id)fp8;
- (id)GIFDataFromRepWithMaxSize:(struct _NSSize)fp8 maxLength:(int)fp16 minSize:(struct _NSSize)fp20;
- (id)rawGIFData;
- (struct _NSSize)largestRepSize;
- (struct _NSSize)largestRepPixelSize;
- (void)drawNicelyScaledInRect:(struct _NSRect)fp8 operation:(unsigned int)fp24 fraction:(float)fp28;
- (void)drawNicelyScaledInRect:(struct _NSRect)fp8 inView:(id)fp24 operation:(unsigned int)fp28 fraction:(float)fp32;
- (void)drawStretchedInFrame:(struct _NSRect)fp8 inView:(id)fp24 capWidth:(float)fp28 alpha:(float)fp32;
- (id)_imageWithFrame:(struct _NSRect)fp8 inSize:(struct _NSSize)fp24;
- (id)imageWithMaxSize:(int)fp8;
- (id)imageWithMaxSize:(int)fp8 withLeftPad:(int)fp12;
- (id)imageWithSize:(struct _NSSize)fp8;
- (id)JPEGDataWithMaxSize:(float)fp8 minSize:(float)fp12 compression:(float)fp16;
- (BOOL)writeJPEGDataWithCompression:(float)fp8 toFile:(id)fp12;
- (id)temporaryJPEGFileWithCompression:(float)fp8;
- (id)bitmapImageRep;
- (id)bitmapImageRepWithPadding:(float)fp8;
@end

@interface NSImageRep (GIFDetectionAdditions)
- (BOOL)hasExpectedGIFAttributes;
- (BOOL)isGIF;
@end

@interface NSMutableArray (FezAdditions)
+ (id)nonRetainingArray;
- (void)applySelector:(SEL)fp8;
- (void)applySelector:(SEL)fp8 withObject:(id)fp12;
@end

@interface NSMutableAttributedString (FezAdditions)
- (void)trimWhitespace;
- (void)replaceNewlinesWithSpaces;
- (void)removeNewlines;
- (void)replaceAttribute:(id)fp8 value:(id)fp12 withValue:(id)fp16;
- (void)removeCharactersWithAttribute:(id)fp8;
@end

@interface NSMutableAttributedString (FezExtensions)
+ (id)attributedStringWithHTML:(id)fp8 defaultFont:(id)fp12 documentAttributes:(id *)fp16;
- (void)addAttribute:(id)fp8 value:(id)fp12 range:(struct _NSRange)fp16 notOnAttribute:(id)fp24;
- (void)addLinkTooltipAttibutes;
- (void)setAlignment:(unsigned int)fp8;
@end

@interface NSMutableSet (FezAdditions)
+ (id)nonRetainingSet;
@end

@interface NSMutableString (FezAdditions)
- (void)replaceNewlinesWithSpaces;
- (void)removeNewlines;
- (void)replaceSubstring:(id)fp8 with:(id)fp12;
@end

@interface NSObject (DelayedPerformADditions)
- (void)performSelector:(SEL)fp8 withObject:(id)fp12 afterDelay:(double)fp16 ignoreMenuTracking:(BOOL)fp24;
@end

@interface NSObject (FezAdditions)
- (BOOL)isNull;
@end

@interface NSPasteboard (FezUtilAdditions)
- (BOOL)hasFilesnamesOrImage;
- (id)filenamesForImage;
@end

@interface NSScreen (FezExtensions)
+ (id)screenForRect:(struct _NSRect)fp8;
- (unsigned int)directDisplayID;
@end

@interface NSString (FezAdditions)
+ (id)stringGUID;
- (BOOL)isEqualToIgnoringCase:(id)fp8;
- (BOOL)isDirectory;
- (unsigned int)hexValue;
- (unsigned int)unsignedIntValue;
- (BOOL)localizedHasPrefix:(id)fp8 caseSensitive:(BOOL)fp12;
- (id)trimmedString;
- (id)stringByRemovingURLEscapes;
- (id)stringByAddingURLEscapes;
- (id)stringByReplacing:(id)fp8 with:(id)fp12;
- (id)stringWithDefaultServerIfNeeded:(id)fp8;
- (id)stripDotMacSuffixIfPresent;
- (BOOL)isPhone;
- (BOOL)isICQ;
- (BOOL)isICQorPhone;
- (id)stringByResolvingAndStandardizingPath;
- (id)commaSeparatedComponents;
- (struct _NSRange)rangeOfNewlineInRange:(struct _NSRange)fp8;
- (id)stringByRemovingWhitespace;
- (id)plaintextSubstituteForHTML;
- (id)uniqueSavePath;
- (id)stringByStrippingControlCharacters;
- (id)stringByRemovingCharactersFromSet:(id)fp8;
- (BOOL)createDirectoryWithMode:(int)fp8;
@end

@interface NSString (FezWebUtil)
+ (id)stringWithNonBreakingSpace;
+ (id)stringWithHorizontalEllipsis;
- (id)valueForHTMLAttribute:(id)fp8;
- (id)replaceFontTagWithSpanTag;
@end

@interface NSString (FileTransferAdditions)
- (BOOL)checkSavePathPostingErrorToWindow:(id)fp8;
@end

@interface NSTextField (iChatAdditions)
- (float)autosizeWithStringValue:(id)fp8 resizeWindow:(BOOL)fp12 expandOnly:(BOOL)fp16;
- (BOOL)textIsNonEmpty;
- (id)rawAttributedStringValue;
@end

@interface NSTextView (FezUtilAdditions)
- (BOOL)writeAttributedStringSelectionToPasteboard:(id)fp8;
- (BOOL)_pasteAttributedStringWithAttachments:(id)fp8 plainString:(id)fp12;
- (BOOL)_pasteAttributedString:(id)fp8 plainString:(id)fp12;
- (BOOL)pasteStringFromPasteboard:(id)fp8 withAttributes:(id)fp12;
- (BOOL)pasteRtfdFromPasteboard:(id)fp8;
- (BOOL)pasteRtfFromPasteboard:(id)fp8;
- (BOOL)pasteAttributedStringFromPasteboard:(id)fp8;
@end

@interface NSURL (FezAdditions)
- (id)URLByAppendingPathComponent:(id)fp8;
@end

@interface NSView (FezUtilAdditions)
- (BOOL)flipContextIfNecessary;
- (void)unflipContext:(BOOL)fp8;
- (struct _NSPoint)mouseLocationInView;
- (BOOL)mouseInRect:(struct _NSRect)fp8;
- (BOOL)mouseInView;
- (void)_reposition:(int)fp8;
- (void)bringToFront;
- (void)sendToBack;
- (void)setMaxX:(float)fp8;
- (void)setFocusRingNeedsDisplay;
- (struct _NSPoint)mouseLocationOutsideOfEventStream;
- (BOOL)isOrContainsFirstResponder;
- (struct _NSSize)constrainWindowSize:(struct _NSSize)fp8 minSize:(struct _NSSize)fp16 maxSize:(struct _NSSize)fp24 aspectRatio:(struct _NSSize)fp32 outset:(BOOL)fp40;
- (id)snapshotOfRect:(struct _NSRect)fp8;
- (id)snapshotOfRect:(struct _NSRect)fp8 forceFullDraw:(BOOL)fp24;
@end

@interface NSWindow (iChatWindowLocation)
+ (id)windowsWithOrigin:(struct _NSPoint)fp8 screen:(id)fp16 withDelegateClass:(Class)fp20;
@end

@interface PersonNameFragmentProvider : TranscriptFragmentProvider
{
    NSMutableDictionary *_persons;
}

- (id)initWithTranscriptStyleManager:(id)fp8;
- (void)dealloc;
- (void)transcriptWillLoad;
- (void)nameDisplayChanged:(id)fp8;
- (id)setupMutableArrayForPresentity:(id)fp8;
- (id)fragmentForMessage:(id)fp8;

@end

@interface SimplifiedFont : NSObject
{
    NSFont *_font;
}

- (id)initWithFont:(id)fp8;
- (void)dealloc;
- (id)font;
- (BOOL)isEqualTo:(id)fp8;
- (id)cssValue;
- (id)cssValueIsImportant:(BOOL)fp8;
- (id)cheapCSSValue;

@end

@interface StatusChangeFragmentProvider : SystemMessageFragmentProvider
{
}

@end

@interface TranscriptStyleManager : NSObject
{
    WebView *_webView;
    DOMDocument *_theDom;
    DOMHTMLElement *_head;
    DOMHTMLElement *_body;
    DOMCSSStyleSheet *_style;
    NSColor *_backgroundColor;
    NSURL *_backgroundImage;
    NSMutableDictionary *_rules;
    NSMutableArray *_fragments;
    int _inBatchViewChangeCount;
    BOOL _batchChangeRequiresRebuild;
    TimestampResolver *_timestampResolver;
    DocumentFragmentProvider *_documentFragmentProvider;
    KnockKnockFragmentProvider *_knockKnockFragmentProvider;
    InstantMessageFragmentProvider *_instantMessageFragmentProvider;
    MessageContainerFragmentProvider *_messageContainerFragmentProvider;
    MessageBodyFragmentProvider *_messageBodyFragmentProvider;
    BuddyIconFragmentProvider *_buddyIconFragmentProvider;
    EmoticonFragmentProvider *_emoticonFragmentProvider;
    InlineImageFragmentProvider *_inlineImageFragmentProvider;
    FileTransferFragmentProvider *_fileTransferFragmentProvider;
    PersonNameFragmentProvider *_personNameFragmentProvider;
    DateFragmentProvider *_dateFragmentProvider;
    EmoteFragmentProvider *_emoteFragmentProvider;
    SystemMessageFragmentProvider *_systemMessageFragmentProvider;
    TimestampFragmentProvider *_timestampFragmentProvider;
    DatestampFragmentProvider *_datestampFragmentProvider;
    ErrorFragmentProvider *_errorFragmentProvider;
    HeaderFragmentProvider *_headerFragmentProvider;
    StatusChangeFragmentProvider *_statusChangeFragmentProvider;
    AnnouncementFragmentProvider *_announcementFragmentProvider;
    BOOL _allowsPlugins;
    BOOL _remoteUserOverrideFormatting;
    BOOL _watchMessageAddressing;
    BOOL _messageContentIsHidden;
    BOOL _shouldCacheUncommittedMessages;
    BOOL _isRebuildingUncommittedMessages;
    NSMutableArray *_uncommittedMessages;
    id <InstantMessageReadOnlyProtocol> _lastCommittedMessage;
}

+ (id)localizedMenuTitle;
+ (id)localizedName;
+ (Class)documentFragmentProviderClass;
+ (Class)instantMessageFragmentProviderClass;
+ (Class)messageContainerFragmentProviderClass;
+ (Class)messageBodyFragmentProviderClass;
+ (Class)emoticonFragmentProviderClass;
+ (Class)emoteFragmentProviderClass;
+ (Class)inlineImageFragmentProviderClass;
+ (Class)fileTransferFragmentProviderClass;
+ (Class)datestampFragmentProviderClass;
+ (Class)timestampFragmentProviderClass;
+ (Class)errorFragmentProviderClass;
+ (Class)systemMessageFragmentProviderClass;
+ (Class)headerFragmentProviderClass;
+ (Class)statusChangeFragmentProviderClass;
+ (Class)announcementFragmentProviderClass;
+ (Class)personNameFragmentProviderClass;
+ (Class)buddyIconFragmentProviderClass;
+ (Class)dateFragmentProviderClass;
+ (Class)knockKnockFragmentProviderClass;
+ (Class)timestampResolverClass;
- (id)documentFragmentProvider;
- (id)instantMessageFragmentProvider;
- (id)messageContainerFragmentProvider;
- (id)messageBodyFragmentProvider;
- (id)emoticonFragmentProvider;
- (id)emoteFragmentProvider;
- (id)inlineImageFragmentProvider;
- (id)fileTransferFragmentProvider;
- (id)datestampFragmentProvider;
- (id)timestampFragmentProvider;
- (id)errorFragmentProvider;
- (id)systemMessageFragmentProvider;
- (id)headerFragmentProvider;
- (id)statusChangeFragmentProvider;
- (id)announcementFragmentProvider;
- (id)personNameFragmentProvider;
- (id)buddyIconFragmentProvider;
- (id)dateFragmentProvider;
- (id)knockKnockFragmentProvider;
- (id)timestampResolver;
- (id)initWithWebView:(id)fp8;
- (id)window;
- (void)transcriptDidLoad;
- (void)dealloc;
- (id)insertCSSWithURL:(id)fp8;
- (id)ruleForIndex:(unsigned int)fp8;
- (id)ruleFromName:(id)fp8;
- (id)insertRule:(id)fp8 withName:(id)fp12;
- (id)insertRule:(id)fp8;
- (void)cacheURL:(id)fp8;
- (void)_setNeedsRebuild;
- (void)beginBatchViewChange;
- (BOOL)endBatchViewChange;
- (void)makeSystemMessagesVisible;
- (void)makeSystemMessagesInvisible;
- (void)hideTimestamps;
- (void)showTimestamps;
- (void)hideMessageContent;
- (void)showMessageContent;
- (void)makeTimestampsInvisible;
- (void)makeTimestampsVisible;
- (void)hideScrollbars;
- (void)showScrollbars;
- (void)showSmileys;
- (void)hideSmileys;
- (void)showPictures;
- (void)hidePictures;
- (void)showNames;
- (void)hideNames;
- (void)hideBackground;
- (void)showBackground;
- (void)makeNotSelectable;
- (void)makeSelectable;
- (void)setBackgroundColor:(id)fp8;
- (void)setBackgroundImage:(id)fp8;
- (void)setLastTimestamp:(id)fp8;
- (void)appendInstantMessage:(id)fp8;
- (void)removeInstantMessage:(id)fp8;
- (void)replaceInstantMessage:(id)fp8 withMessage:(id)fp12;
- (struct _NSRect)previousMessageRect;
- (struct _NSRect)messagePreviewBounds;
- (struct _NSRect)rectOfMessage:(id)fp8;
- (struct _NSRect)boundsOfMessage:(id)fp8;
- (id)lastMessage;
- (id)DOM;
- (id)body;
- (id)head;
- (id)style;
- (void)emptyBody;
- (void)removeNodeAndChildren:(id)fp8;
- (void)removeChildren:(id)fp8;
- (void)bodyFinishLayout;
- (void)setWatchMessageAddressing:(BOOL)fp8;
- (void)setRemoteUserOverrideFormatting:(BOOL)fp8;
- (void)setAllowsPlugins:(BOOL)fp8;
- (BOOL)allowsPlugins;
- (void)localUserSetBackgroundColor:(id)fp8;
- (void)localUserSetFontColor:(id)fp8;
- (void)localUserSetFont:(id)fp8;
- (void)remoteUserSetBackgroundColor:(id)fp8;
- (void)remoteUserSetFontColor:(id)fp8;
- (void)remoteUserSetFont:(id)fp8;
- (void)personInfoChanged:(id)fp8;
- (void)personPictureChanged:(id)fp8;
- (void)retainFragment:(id)fp8;
- (void)adjustDateFragmentsForTimeChange;
- (void)dateFormatDidChange;
- (void)setLastCommittedMessage:(id)fp8;
- (id)lastCommittedMessage;
- (void)deferRuleChangeForURL:(id)fp8 rule:(id)fp12 body:(id)fp16;

@end

@interface XHTMLGenerator : AbstractRichTextGenerator
{
}

+ (id)_generatorString;
- (void)_pushHTMLTag;
- (void)_generateImageTagWithTextAttachment:(id)fp8 fileName:(id)fp12 ID:(id)fp16 width:(id)fp20 height:(id)fp24 fileSize:(id)fp28;
- (void)_pushBodyTagWithForegroundColor:(id)fp8 backgroundColor:(id)fp12 isRTL:(BOOL)fp16;
- (id)_currentColor;
- (id)_currentBgColor;
- (id)_currentFont;
- (void)_generateTagsWithBold:(id)fp8 italic:(id)fp12 link:(id)fp16 font:(id)fp20 color:(id)fp24 bgColor:(id)fp28 underline:(id)fp32 myName:(id)fp36;
- (id)_brTag;
- (BOOL)_isXHTML;

@end

@interface WebKitFragmentGenerator : XHTMLGenerator
{
}

@end

@interface WebView (FezWebUtil)
- (void)_handleClickedURLS:(id)fp8 decidePolicyForNavigationAction:(id)fp12 request:(id)fp16 frame:(id)fp20 decisionListener:(id)fp24;
- (void)fzWebView:(id)fp8 decidePolicyForNavigationAction:(id)fp12 request:(id)fp16 frame:(id)fp20 decisionListener:(id)fp24;
- (void)fzWebView:(id)fp8 decidePolicyForNewWindowAction:(id)fp12 request:(id)fp16 newFrameName:(id)fp20 decisionListener:(id)fp24;
@end

@interface XHTMLEncoder : NSObject
{
}

+ (void)initialize;
+ (BOOL)_isValidXMLCharacter:(unsigned short)fp8;
+ (void)encodeText:(id)fp8 asXHTML:(BOOL)fp12 into:(id)fp16 charsToEncode:(id)fp20;
+ (void)encodeText:(id)fp8 asXHTML:(BOOL)fp12 into:(id)fp16;
+ (id)encodeText:(id)fp8 asXHTML:(BOOL)fp12;
+ (id)encodeNonAsciiCharsIn:(id)fp8 asXHTML:(BOOL)fp12;
+ (id)_stringFromEscapeSequence:(id)fp8;
+ (id)stripTagsFromHTML:(id)fp8;

@end

