/*
 * iChat4.h
 *
 * Copyright (c) 2007-2009 Kent Sutherland
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 * Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 *     Generated by class-dump 3.1.1.
 *
 *     class-dump is Copyright (C) 1997-1998, 2000-2001, 2004-2006 by Steve Nygard.
 */

#import <InstantMessage/IMService.h>
#import <AddressBook/AddressBook.h>
#import <WebKit/WebKit.h>
#import <Quartz/Quartz.h>
#import "NSPreferences.h"
#import "iChatCommonGUI.h"
#import "VideoConference.h"

struct AudioBuffer {
    unsigned int mNumberChannels;
    unsigned int mDataByteSize;
    void *mData;
};

struct AudioBufferList {
    unsigned int _field1;
    struct AudioBuffer _field2[1];
};

struct AudioStreamBasicDescription {
    double mSampleRate;
    unsigned int mFormatID;
    unsigned int mFormatFlags;
    unsigned int mBytesPerPacket;
    unsigned int mFramesPerPacket;
    unsigned int mBytesPerFrame;
    unsigned int mChannelsPerFrame;
    unsigned int mBitsPerChannel;
    unsigned int mReserved;
};

struct CGContext;

struct CGImage;

struct MediaType;

struct MovieType;

struct OpaqueAudioFileID;

struct OpaqueEventHotKeyRef;

struct OpaqueEventRef;

struct OpaqueICMCompressionSession;

struct OpaqueQTVisualContext;

struct OpaqueSecCertificateRef;

struct OpaqueSecIdentityRef;

struct OpaqueSecKeyRef;

struct SoundDescription;

struct TrackType;

struct _CGLPrivateObject;

struct _FZChatRoomValidity {
    int _field1;
    unsigned short _field2;
};

struct _RectPosition {
    int horiz;
    int vert;
};

struct __CFArray;

struct __CFRunLoopSource;

struct __CVBuffer;

struct __CVOpenGLBufferPool;

struct __CVOpenGLTextureCache;

struct __CVPixelBufferPool;

struct __GLIContextRec;

struct __GLIFunctionDispatchRec {
    void *accum;
    void *alpha_func;
    void *are_textures_resident;
    void *array_element;
    void *begin;
    void *bind_texture;
    void *bitmap;
    void *blend_func;
    void *call_list;
    void *call_lists;
    void *clear;
    void *clear_accum;
    void *clear_color;
    void *clear_depth;
    void *clear_index;
    void *clear_stencil;
    void *clip_plane;
    void *color3b;
    void *color3bv;
    void *color3d;
    void *color3dv;
    void *color3f;
    void *color3fv;
    void *color3i;
    void *color3iv;
    void *color3s;
    void *color3sv;
    void *color3ub;
    void *color3ubv;
    void *color3ui;
    void *color3uiv;
    void *color3us;
    void *color3usv;
    void *color4b;
    void *color4bv;
    void *color4d;
    void *color4dv;
    void *color4f;
    void *color4fv;
    void *color4i;
    void *color4iv;
    void *color4s;
    void *color4sv;
    void *color4ub;
    void *color4ubv;
    void *color4ui;
    void *color4uiv;
    void *color4us;
    void *color4usv;
    void *color_mask;
    void *color_material;
    void *color_pointer;
    void *copy_pixels;
    void *copy_tex_image1D;
    void *copy_tex_image2D;
    void *copy_tex_sub_image1D;
    void *copy_tex_sub_image2D;
    void *cull_face;
    void *delete_lists;
    void *delete_textures;
    void *depth_func;
    void *depth_mask;
    void *depth_range;
    void *disable;
    void *disable_client_state;
    void *draw_arrays;
    void *draw_buffer;
    void *draw_elements;
    void *draw_pixels;
    void *edge_flag;
    void *edge_flag_pointer;
    void *edge_flagv;
    void *enable;
    void *enable_client_state;
    void *end;
    void *end_list;
    void *eval_coord1d;
    void *eval_coord1dv;
    void *eval_coord1f;
    void *eval_coord1fv;
    void *eval_coord2d;
    void *eval_coord2dv;
    void *eval_coord2f;
    void *eval_coord2fv;
    void *eval_mesh1;
    void *eval_mesh2;
    void *eval_point1;
    void *eval_point2;
    void *feedback_buffer;
    void *finish;
    void *flush;
    void *fogf;
    void *fogfv;
    void *fogi;
    void *fogiv;
    void *front_face;
    void *frustum;
    void *gen_lists;
    void *gen_textures;
    void *get_booleanv;
    void *get_clip_plane;
    void *get_doublev;
    void *get_error;
    void *get_floatv;
    void *get_integerv;
    void *get_lightfv;
    void *get_lightiv;
    void *get_mapdv;
    void *get_mapfv;
    void *get_mapiv;
    void *get_materialfv;
    void *get_materialiv;
    void *get_pixel_mapfv;
    void *get_pixel_mapuiv;
    void *get_pixel_mapusv;
    void *get_pointerv;
    void *get_polygon_stipple;
    void *get_string;
    void *get_tex_envfv;
    void *get_tex_enviv;
    void *get_tex_gendv;
    void *get_tex_genfv;
    void *get_tex_geniv;
    void *get_tex_image;
    void *get_tex_level_parameterfv;
    void *get_tex_level_parameteriv;
    void *get_tex_parameterfv;
    void *get_tex_parameteriv;
    void *hint;
    void *index_mask;
    void *index_pointer;
    void *indexd;
    void *indexdv;
    void *indexf;
    void *indexfv;
    void *indexi;
    void *indexiv;
    void *indexs;
    void *indexsv;
    void *indexub;
    void *indexubv;
    void *init_names;
    void *interleaved_arrays;
    void *is_enabled;
    void *is_list;
    void *is_texture;
    void *light_modelf;
    void *light_modelfv;
    void *light_modeli;
    void *light_modeliv;
    void *lightf;
    void *lightfv;
    void *lighti;
    void *lightiv;
    void *line_stipple;
    void *line_width;
    void *list_base;
    void *load_identity;
    void *load_matrixd;
    void *load_matrixf;
    void *load_name;
    void *logic_op;
    void *map1d;
    void *map1f;
    void *map2d;
    void *map2f;
    void *map_grid1d;
    void *map_grid1f;
    void *map_grid2d;
    void *map_grid2f;
    void *materialf;
    void *materialfv;
    void *materiali;
    void *materialiv;
    void *matrix_mode;
    void *mult_matrixd;
    void *mult_matrixf;
    void *new_list;
    void *normal3b;
    void *normal3bv;
    void *normal3d;
    void *normal3dv;
    void *normal3f;
    void *normal3fv;
    void *normal3i;
    void *normal3iv;
    void *normal3s;
    void *normal3sv;
    void *normal_pointer;
    void *ortho;
    void *pass_through;
    void *pixel_mapfv;
    void *pixel_mapuiv;
    void *pixel_mapusv;
    void *pixel_storef;
    void *pixel_storei;
    void *pixel_transferf;
    void *pixel_transferi;
    void *pixel_zoom;
    void *point_size;
    void *polygon_mode;
    void *polygon_offset;
    void *polygon_stipple;
    void *pop_attrib;
    void *pop_client_attrib;
    void *pop_matrix;
    void *pop_name;
    void *prioritize_textures;
    void *push_attrib;
    void *push_client_attrib;
    void *push_matrix;
    void *push_name;
    void *raster_pos2d;
    void *raster_pos2dv;
    void *raster_pos2f;
    void *raster_pos2fv;
    void *raster_pos2i;
    void *raster_pos2iv;
    void *raster_pos2s;
    void *raster_pos2sv;
    void *raster_pos3d;
    void *raster_pos3dv;
    void *raster_pos3f;
    void *raster_pos3fv;
    void *raster_pos3i;
    void *raster_pos3iv;
    void *raster_pos3s;
    void *raster_pos3sv;
    void *raster_pos4d;
    void *raster_pos4dv;
    void *raster_pos4f;
    void *raster_pos4fv;
    void *raster_pos4i;
    void *raster_pos4iv;
    void *raster_pos4s;
    void *raster_pos4sv;
    void *read_buffer;
    void *read_pixels;
    void *rectd;
    void *rectdv;
    void *rectf;
    void *rectfv;
    void *recti;
    void *rectiv;
    void *rects;
    void *rectsv;
    void *render_mode;
    void *rotated;
    void *rotatef;
    void *scaled;
    void *scalef;
    void *scissor;
    void *select_buffer;
    void *shade_model;
    void *stencil_func;
    void *stencil_mask;
    void *stencil_op;
    void *tex_coord1d;
    void *tex_coord1dv;
    void *tex_coord1f;
    void *tex_coord1fv;
    void *tex_coord1i;
    void *tex_coord1iv;
    void *tex_coord1s;
    void *tex_coord1sv;
    void *tex_coord2d;
    void *tex_coord2dv;
    void *tex_coord2f;
    void *tex_coord2fv;
    void *tex_coord2i;
    void *tex_coord2iv;
    void *tex_coord2s;
    void *tex_coord2sv;
    void *tex_coord3d;
    void *tex_coord3dv;
    void *tex_coord3f;
    void *tex_coord3fv;
    void *tex_coord3i;
    void *tex_coord3iv;
    void *tex_coord3s;
    void *tex_coord3sv;
    void *tex_coord4d;
    void *tex_coord4dv;
    void *tex_coord4f;
    void *tex_coord4fv;
    void *tex_coord4i;
    void *tex_coord4iv;
    void *tex_coord4s;
    void *tex_coord4sv;
    void *tex_coord_pointer;
    void *tex_envf;
    void *tex_envfv;
    void *tex_envi;
    void *tex_enviv;
    void *tex_gend;
    void *tex_gendv;
    void *tex_genf;
    void *tex_genfv;
    void *tex_geni;
    void *tex_geniv;
    void *tex_image1D;
    void *tex_image2D;
    void *tex_parameterf;
    void *tex_parameterfv;
    void *tex_parameteri;
    void *tex_parameteriv;
    void *tex_sub_image1D;
    void *tex_sub_image2D;
    void *translated;
    void *translatef;
    void *vertex2d;
    void *vertex2dv;
    void *vertex2f;
    void *vertex2fv;
    void *vertex2i;
    void *vertex2iv;
    void *vertex2s;
    void *vertex2sv;
    void *vertex3d;
    void *vertex3dv;
    void *vertex3f;
    void *vertex3fv;
    void *vertex3i;
    void *vertex3iv;
    void *vertex3s;
    void *vertex3sv;
    void *vertex4d;
    void *vertex4dv;
    void *vertex4f;
    void *vertex4fv;
    void *vertex4i;
    void *vertex4iv;
    void *vertex4s;
    void *vertex4sv;
    void *vertex_pointer;
    void *viewport;
    void *blend_func_separate;
    void *blend_color;
    void *blend_equation;
    void *lock_arrays_EXT;
    void *unlock_arrays_EXT;
    void *client_active_texture;
    void *active_texture;
    void *multi_tex_coord1d;
    void *multi_tex_coord1dv;
    void *multi_tex_coord1f;
    void *multi_tex_coord1fv;
    void *multi_tex_coord1i;
    void *multi_tex_coord1iv;
    void *multi_tex_coord1s;
    void *multi_tex_coord1sv;
    void *multi_tex_coord2d;
    void *multi_tex_coord2dv;
    void *multi_tex_coord2f;
    void *multi_tex_coord2fv;
    void *multi_tex_coord2i;
    void *multi_tex_coord2iv;
    void *multi_tex_coord2s;
    void *multi_tex_coord2sv;
    void *multi_tex_coord3d;
    void *multi_tex_coord3dv;
    void *multi_tex_coord3f;
    void *multi_tex_coord3fv;
    void *multi_tex_coord3i;
    void *multi_tex_coord3iv;
    void *multi_tex_coord3s;
    void *multi_tex_coord3sv;
    void *multi_tex_coord4d;
    void *multi_tex_coord4dv;
    void *multi_tex_coord4f;
    void *multi_tex_coord4fv;
    void *multi_tex_coord4i;
    void *multi_tex_coord4iv;
    void *multi_tex_coord4s;
    void *multi_tex_coord4sv;
    void *load_transpose_matrixd;
    void *load_transpose_matrixf;
    void *mult_transpose_matrixd;
    void *mult_transpose_matrixf;
    void *compressed_tex_image3D;
    void *compressed_tex_image2D;
    void *compressed_tex_image1D;
    void *compressed_tex_sub_image3D;
    void *compressed_tex_sub_image2D;
    void *compressed_tex_sub_image1D;
    void *get_compressed_tex_image;
    void *secondary_color3b;
    void *secondary_color3bv;
    void *secondary_color3d;
    void *secondary_color3dv;
    void *secondary_color3f;
    void *secondary_color3fv;
    void *secondary_color3i;
    void *secondary_color3iv;
    void *secondary_color3s;
    void *secondary_color3sv;
    void *secondary_color3ub;
    void *secondary_color3ubv;
    void *secondary_color3ui;
    void *secondary_color3uiv;
    void *secondary_color3us;
    void *secondary_color3usv;
    void *secondary_color_pointer;
    void *vertex_array_range_EXT;
    void *flush_vertex_array_range_EXT;
    void *draw_range_elements;
    void *color_table;
    void *color_table_parameterfv;
    void *color_table_parameteriv;
    void *copy_color_table;
    void *get_color_table;
    void *get_color_table_parameterfv;
    void *get_color_table_parameteriv;
    void *color_sub_table;
    void *copy_color_sub_table;
    void *convolution_filter1D;
    void *convolution_filter2D;
    void *convolution_parameterf;
    void *convolution_parameterfv;
    void *convolution_parameteri;
    void *convolution_parameteriv;
    void *copy_convolution_filter1D;
    void *copy_convolution_filter2D;
    void *get_convolution_filter;
    void *get_convolution_parameterfv;
    void *get_convolution_parameteriv;
    void *get_separable_filter;
    void *separable_filter2D;
    void *get_histogram;
    void *get_histogram_parameterfv;
    void *get_histogram_parameteriv;
    void *get_minmax;
    void *get_minmax_parameterfv;
    void *get_minmax_parameteriv;
    void *histogram;
    void *minmax;
    void *reset_histogram;
    void *reset_minmax;
    void *tex_image3D;
    void *tex_sub_image3D;
    void *copy_tex_sub_image3D;
    void *combiner_parameterfv_NV;
    void *combiner_parameterf_NV;
    void *combiner_parameteriv_NV;
    void *combiner_parameteri_NV;
    void *combiner_input_NV;
    void *combiner_output_NV;
    void *final_combiner_input_NV;
    void *get_combiner_input_parameterfv_NV;
    void *get_combiner_input_parameteriv_NV;
    void *get_combiner_output_parameterfv_NV;
    void *get_combiner_output_parameteriv_NV;
    void *get_final_combiner_input_parameterfv_NV;
    void *get_final_combiner_input_parameteriv_NV;
    void *combiner_stage_parameterfv_NV;
    void *get_combiner_stage_parameterfv_NV;
    void *texture_range_APPLE;
    void *get_tex_parameter_pointerv_APPLE;
    void *blend_equation_separate_EXT;
    void *sample_coverage;
    void *sample_pass;
    void *pn_trianglesi_ATI;
    void *pn_trianglesf_ATI;
    void *gen_fences_APPLE;
    void *delete_fences_APPLE;
    void *set_fence_APPLE;
    void *is_fence_APPLE;
    void *test_fence_APPLE;
    void *finish_fence_APPLE;
    void *test_object_APPLE;
    void *finish_object_APPLE;
    void *bind_program_ARB;
    void *delete_programs_ARB;
    void *gen_programs_ARB;
    void *is_program_ARB;
    void *vertex_attrib1s_ARB;
    void *vertex_attrib1f_ARB;
    void *vertex_attrib1d_ARB;
    void *vertex_attrib2s_ARB;
    void *vertex_attrib2f_ARB;
    void *vertex_attrib2d_ARB;
    void *vertex_attrib3s_ARB;
    void *vertex_attrib3f_ARB;
    void *vertex_attrib3d_ARB;
    void *vertex_attrib4s_ARB;
    void *vertex_attrib4f_ARB;
    void *vertex_attrib4d_ARB;
    void *vertex_attrib4Nub_ARB;
    void *vertex_attrib1sv_ARB;
    void *vertex_attrib1fv_ARB;
    void *vertex_attrib1dv_ARB;
    void *vertex_attrib2sv_ARB;
    void *vertex_attrib2fv_ARB;
    void *vertex_attrib2dv_ARB;
    void *vertex_attrib3sv_ARB;
    void *vertex_attrib3fv_ARB;
    void *vertex_attrib3dv_ARB;
    void *vertex_attrib4bv_ARB;
    void *vertex_attrib4sv_ARB;
    void *vertex_attrib4iv_ARB;
    void *vertex_attrib4ubv_ARB;
    void *vertex_attrib4usv_ARB;
    void *vertex_attrib4uiv_ARB;
    void *vertex_attrib4fv_ARB;
    void *vertex_attrib4dv_ARB;
    void *vertex_attrib4Nbv_ARB;
    void *vertex_attrib4Nsv_ARB;
    void *vertex_attrib4Niv_ARB;
    void *vertex_attrib4Nubv_ARB;
    void *vertex_attrib4Nusv_ARB;
    void *vertex_attrib4Nuiv_ARB;
    void *vertex_attrib_pointer_ARB;
    void *enable_vertex_attrib_array_ARB;
    void *disable_vertex_attrib_array_ARB;
    void *get_vertex_attribdv_ARB;
    void *get_vertex_attribfv_ARB;
    void *get_vertex_attribiv_ARB;
    void *get_vertex_attrib_pointerv_ARB;
    void *program_env_parameter4d_ARB;
    void *program_env_parameter4dv_ARB;
    void *program_env_parameter4f_ARB;
    void *program_env_parameter4fv_ARB;
    void *program_local_parameter4d_ARB;
    void *program_local_parameter4dv_ARB;
    void *program_local_parameter4f_ARB;
    void *program_local_parameter4fv_ARB;
    void *get_program_env_parameterdv_ARB;
    void *get_program_env_parameterfv_ARB;
    void *get_program_local_parameterdv_ARB;
    void *get_program_local_parameterfv_ARB;
    void *program_string_ARB;
    void *get_program_string_ARB;
    void *get_programiv_ARB;
    void *enable_vertex_attrib_ARB;
    void *disable_vertex_attrib_ARB;
    void *is_vertex_attrib_enabled_ARB;
    void *map_vertex_attrib1d_ARB;
    void *map_vertex_attrib1f_ARB;
    void *map_vertex_attrib2d_ARB;
    void *map_vertex_attrib2f_ARB;
    void *point_parameterf;
    void *point_parameterfv;
    void *point_parameteri;
    void *point_parameteriv;
    void *fog_coordf;
    void *fog_coordfv;
    void *fog_coordd;
    void *fog_coorddv;
    void *fog_coord_pointer;
    void *vertex_array_parameteri_EXT;
    void *bind_vertex_array_EXT;
    void *delete_vertex_arrays_EXT;
    void *gen_vertex_arrays_EXT;
    void *is_vertex_array_EXT;
    void *element_pointer_APPLE;
    void *draw_element_array_APPLE;
    void *draw_range_element_array_APPLE;
    void *weightbv_ARB;
    void *weightsv_ARB;
    void *weightiv_ARB;
    void *weightfv_ARB;
    void *weightdv_ARB;
    void *weightubv_ARB;
    void *weightusv_ARB;
    void *weightuiv_ARB;
    void *weight_pointer_ARB;
    void *vertex_blend_ARB;
    void *multi_draw_arrays;
    void *multi_draw_elements;
    void *window_pos2d;
    void *window_pos2dv;
    void *window_pos2f;
    void *window_pos2fv;
    void *window_pos2i;
    void *window_pos2iv;
    void *window_pos2s;
    void *window_pos2sv;
    void *window_pos3d;
    void *window_pos3dv;
    void *window_pos3f;
    void *window_pos3fv;
    void *window_pos3i;
    void *window_pos3iv;
    void *window_pos3s;
    void *window_pos3sv;
    void *active_stencil_face_EXT;
    void *stencil_op_separate_ATI;
    void *stencil_func_separate_ATI;
    void *flush_render_APPLE;
    void *finish_render_APPLE;
    void *swap_APPLE;
    void *delete_object_ARB;
    void *get_handle_ARB;
    void *detach_object_ARB;
    void *create_shader_object_ARB;
    void *shader_source_ARB;
    void *compile_shader_ARB;
    void *create_program_object_ARB;
    void *attach_object_ARB;
    void *link_program_ARB;
    void *use_program_object_ARB;
    void *validate_program_ARB;
    void *uniform1f_ARB;
    void *uniform2f_ARB;
    void *uniform3f_ARB;
    void *uniform4f_ARB;
    void *uniform1i_ARB;
    void *uniform2i_ARB;
    void *uniform3i_ARB;
    void *uniform4i_ARB;
    void *uniform1fv_ARB;
    void *uniform2fv_ARB;
    void *uniform3fv_ARB;
    void *uniform4fv_ARB;
    void *uniform1iv_ARB;
    void *uniform2iv_ARB;
    void *uniform3iv_ARB;
    void *uniform4iv_ARB;
    void *uniform_matrix2fv_ARB;
    void *uniform_matrix3fv_ARB;
    void *uniform_matrix4fv_ARB;
    void *get_object_parameterfv_ARB;
    void *get_object_parameteriv_ARB;
    void *get_info_log_ARB;
    void *get_attached_objects_ARB;
    void *get_uniform_location_ARB;
    void *get_active_uniform_ARB;
    void *get_uniformfv_ARB;
    void *get_uniformiv_ARB;
    void *get_shader_source_ARB;
    void *bind_attrib_location_ARB;
    void *get_active_attrib_ARB;
    void *get_attrib_location_ARB;
    void *pad;
    void *gen_queries;
    void *delete_queries;
    void *is_query;
    void *begin_query;
    void *end_query;
    void *get_queryiv;
    void *get_query_objectiv;
    void *get_query_objectuiv;
    void *bind_buffer;
    void *delete_buffers;
    void *gen_buffers;
    void *is_buffer;
    void *buffer_data;
    void *buffer_sub_data;
    void *get_buffer_sub_data;
    void *map_buffer;
    void *unmap_buffer;
    void *get_buffer_parameteriv;
    void *get_buffer_pointerv;
    void *depth_bounds_EXT;
    void *draw_buffers_ARB;
    void *is_shader;
    void *is_program;
    void *get_shaderiv;
    void *get_programiv;
    void *get_shader_info_log;
    void *get_program_info_log;
    void *stencil_func_separate;
    void *stencil_mask_separate;
    void *multi_draw_element_array_APPLE;
    void *multi_draw_range_element_array_APPLE;
    void *is_renderbuffer_EXT;
    void *bind_renderbuffer_EXT;
    void *delete_renderbuffers_EXT;
    void *gen_renderbuffers_EXT;
    void *renderbuffer_storage_EXT;
    void *get_renderbuffer_parameteriv_EXT;
    void *is_framebuffer_EXT;
    void *bind_framebuffer_EXT;
    void *delete_framebuffers_EXT;
    void *gen_framebuffers_EXT;
    void *check_framebuffer_status_EXT;
    void *framebuffer_texture1D_EXT;
    void *framebuffer_texture2D_EXT;
    void *framebuffer_texture3D_EXT;
    void *framebuffer_renderbuffer_EXT;
    void *get_framebuffer_attachment_parameteriv_EXT;
    void *generate_mipmap_EXT;
    void *buffer_parameteri_APPLE;
    void *flush_mapped_buffer_range_APPLE;
    void *program_env_parameters4fv_EXT;
    void *program_local_parameters4fv_EXT;
    void *object_purgeable_APPLE;
    void *object_unpurgeable_APPLE;
    void *get_object_parameteriv_APPLE;
    void *program_parameteri_EXT;
    void *framebuffer_texture_EXT;
    void *framebuffer_texture_layer_EXT;
    void *framebuffer_texture_face_EXT;
    void *bind_buffer_range_EXT;
    void *bind_buffer_offset_EXT;
    void *bind_buffer_base_EXT;
    void *begin_transform_feedback_EXT;
    void *end_transform_feedback_EXT;
    void *transform_feedback_varyings_EXT;
    void *get_transform_feedback_varying_EXT;
    void *get_integer_indexedv_EXT;
    void *get_boolean_indexedv_EXT;
    void *uniform_buffer_EXT;
    void *get_uniform_buffer_size_EXT;
    void *get_uniform_buffer_offset_EXT;
    void *clear_colorIi_EXT;
    void *clear_colorIui_EXT;
    void *tex_parameterIiv_EXT;
    void *tex_parameterIuiv_EXT;
    void *get_tex_parameterIiv_EXT;
    void *get_tex_parameterIiuv_EXT;
    void *vertex_attribI1i_EXT;
    void *vertex_attribI2i_EXT;
    void *vertex_attribI3i_EXT;
    void *vertex_attribI4i_EXT;
    void *vertex_attribI1ui_EXT;
    void *vertex_attribI2ui_EXT;
    void *vertex_attribI3ui_EXT;
    void *vertex_attribI4ui_EXT;
    void *vertex_attribI1iv_EXT;
    void *vertex_attribI2iv_EXT;
    void *vertex_attribI3iv_EXT;
    void *vertex_attribI4iv_EXT;
    void *vertex_attribI1uiv_EXT;
    void *vertex_attribI2uiv_EXT;
    void *vertex_attribI3uiv_EXT;
    void *vertex_attribI4uiv_EXT;
    void *vertex_attribI4bv_EXT;
    void *vertex_attribI4sv_EXT;
    void *vertex_attribI4ubv_EXT;
    void *vertex_attribI4usv_EXT;
    void *vertex_attribI_pointer_EXT;
    void *get_vertex_attribIiv_EXT;
    void *get_vertex_attribIuiv_EXT;
    void *uniform1ui_EXT;
    void *uniform2ui_EXT;
    void *uniform3ui_EXT;
    void *uniform4ui_EXT;
    void *uniform1uiv_EXT;
    void *uniform2uiv_EXT;
    void *uniform3uiv_EXT;
    void *uniform4uiv_EXT;
    void *get_uniformuiv_EXT;
    void *bind_frag_data_location_EXT;
    void *get_frag_data_location_EXT;
    void *shader_binary_OES;
    void *get_shader_precision_format_OES;
    void *release_shader_compiler_OES;
    void *get_renderbuffer_storage_formatsiv_OES;
    void *uniform_matrix2x3fv;
    void *uniform_matrix3x2fv;
    void *uniform_matrix2x4fv;
    void *uniform_matrix4x2fv;
    void *uniform_matrix3x4fv;
    void *uniform_matrix4x3fv;
    void *blit_framebuffer_EXT;
    void *renderbuffer_storage_multisample_EXT;
    void *depth_rangef;
    void *clear_depthf;
};

struct _CGLContextObject {
    struct __GLIContextRec *_field1;
    struct __GLIFunctionDispatchRec _field2;
    struct _CGLPrivateObject *_field3;
    void *_field4;
};

struct __SCDynamicStore;

struct __darwin_pthread_handler_rec;

typedef struct {
    id _field1;
    id _field2;
    int _field3;
    int _field4;
    int _field5;
} CDAnonymousStruct2;

typedef struct {
    unsigned short _field1;
    unsigned short _field2;
    unsigned short _field3;
    unsigned short _field4;
    struct {
    } *_field5;
} CDAnonymousStruct3;

typedef struct {
    float left;
    float right;
    float leftBottom;
    float rightBottom;
    float leftTop;
    float rightTop;
} CDAnonymousStruct6;

typedef struct {
    struct {
        float _field1[6];
        float _field2;
        float _field3;
    } _field1;
    int _field2;
    struct {
        float _field1;
        float _field2;
        float _field3;
        float _field4;
    } _field3[3];
    struct _NSSize _field4;
} CDAnonymousStruct4;

typedef struct {
    float frustum[6];
    float cameraHeight;
    float cameraDistance;
} CDAnonymousStruct5;

typedef struct {
    int _field1[3];
    int _field2;
    char _field3;
} CDAnonymousStruct7;

typedef struct {
    float _field1;
    float _field2;
    float _field3;
    float _field4;
} CDAnonymousStruct8;

typedef struct {
    char *_field1;
    int _field2;
    int _field3;
    int _field4;
    int _field5;
    int _field6;
    int _field7;
} CDAnonymousStruct9;

typedef struct {
    char *_field1;
    char _field2;
    char _field3;
    char _field4;
    char _field5;
    void *_field6;
} CDAnonymousStruct1;

typedef struct {
    int contourType;
    int intParam1;
    int intParam2;
    float floatParam1;
    float floatParam2;
} CDAnonymousStruct10;

/*
 * File: iChat
 * Arch: PowerPC 7400 (ppc7400)
 */
 
@class ABLargeTypeView, ABPhoneFormatter, People, Presentity, SFCertificateTrustPanel, DotMacCaps, AVChatWindow;
@class StretchyImageView, VCNotifier, ActiveChat, VCChannelNegotiation, AVRecorder, RFBImageView, FullScreenWindow;
@class AbbreviatingTextField, GradientView, AudioConferenceView, ARDHUDPanel, AnimatingTabView, AVChat;
@class ShadowView, ARDPIPButton, SecureWindowTitleCell, NSExtendedBox, AVChatParticipant, FZVideoConferenceController;
@class FetchICEDataOp, VCChannel, VolumeIndicator, AVParticipantView, LockButton, AVSegmentedControl, Animator, FileTransfer;
@class MultiBuddyImageView, ProgressSpinner, OpenGLLayerView, FrameReader, NSSoundPopUpButton, ChatWindowController, ServicePopUp;
@class ExtendedComboBox, CollapseView, ABPeoplePickerView, Service, EffectView, SimpleArray, FezCellTipWindow, Tooltip, SimpleArray;
@class CustomWindow, QTMovie, PeoplePicker, IMLocalObject, VideoProcessor, Prefs_Accounts, NSDataRetainingImage, PeopleList;
@class OpenGLLayerModel, OpenGLVideoConferenceLayer, ValidationObject, URLFetcher, SFCertificateView, ExtendedSplitViewGrabber;
@class MyNameControl, ChatInputLine, IMRemoteObject, IMSharedPixelBufferPool, ChatDOMView, ChooseBuddyButton, ExtendedTextField;
@class ChatFieldEditor, ChatNotifier, ChatPluginLoader, TranscriptStyleManager, ChatScrollerAnimation, ChatMiniwindowController, ExtendedSplitView;
@class LinkSheetController, MenuButton, QCCompositionPickerPanel, VCCamera, StatusController, FileTransferRequest, DOMDocumentFragment, DOMNode;
@class ViewTable, GLFBO, QCView, PeopleListController, Texture, GLSLProgram, Prefs_MsgCompose, PeopleListItem, VideoConferenceLayerView;
@class VideoChatController, OpenGLNSViewLayer, OpenGLNSViewLayerWindow, PresenceTooltip, ABUIController, VCInfoTable, ILMediaBrowserView;
@class QCImage, QCPatchController, _GetVCChannelOp, _GetCertificateOp;

@class InstantMessage;

@protocol AbstractAccountBuddyListProtocol
- (void)beginChanges;
- (void)endChanges;
- (BOOL)makingChanges;
- (unsigned int)sortOrderForPresentity:(id)fp8 inGroup:(id)fp12;
- (void)renameGroup:(id)fp8 to:(id)fp12;
- (id)buddyList;
- (void)setBuddyProperties:(id)fp8 buddyPictures:(id)fp12;
- (void)reorderGroups:(id)fp8;
- (void)reorderGroup:(id)fp8 order:(id)fp12;
- (BOOL)removePresentity:(id)fp8 fromGroups:(id)fp12;
- (BOOL)addPresentity:(id)fp8 toGroups:(id)fp12 atLocation:(int)fp16;
- (BOOL)removePeople:(id)fp8 fromGroups:(id)fp12;
- (BOOL)addPeople:(id)fp8 toGroups:(id)fp12 atLocation:(int)fp16;
- (void)changeBuddyList:(id)fp8 add:(BOOL)fp12 groups:(id)fp16 atLocation:(int)fp20;
- (void)addBuddyToBuddyList:(id)fp8;
@end

@protocol AbstractAccountChatProtocol
- (id)visibleChatToHookUpWithID:(id)fp8;
- (id)chatWithID:(id)fp8;
- (void)setPresentity:(id)fp8 isIgnored:(BOOL)fp12 inChat:(id)fp16;
- (void)leaveChatRoom:(id)fp8;
- (int)sendMessage:(id)fp8 toChat:(id)fp12;
- (void)respond:(BOOL)fp8 toInvitationToChat:(id)fp12;
- (void)invitePresentity:(id)fp8 toChat:(id)fp12 withMessage:(id)fp16;
- (id)goToChatNamed:(id)fp8 useRoomName:(BOOL)fp12 forceDisplay:(BOOL)fp16;
- (id)goToChatNamed:(id)fp8 useRoomName:(BOOL)fp12;
- (struct _FZChatRoomValidity)validityOfChatRoomName:(id)fp8;
- (BOOL)validateChatRoomName:(id)fp8 reason:(id *)fp12;
- (id)defaultChatSuffix;
- (id)chatIDForRoomName:(id)fp8;
- (void)rememberChat:(id)fp8;
- (void)reconnectChat:(id)fp8;
- (void)forgetChat:(id)fp8;
- (void)refreshChatRegistration:(id)fp8;
- (id)createChatRoomName;
- (void)forgetAllChats;
@end

@protocol AbstractAccountPresentityProtocol
+ (id)allBuddyListPresentities;
+ (id)arrayOfAllPresentities;
+ (id)presentityWithID:(id)fp8;
- (void)registerPresentity:(id)fp8;
- (void)unregisterPresentity:(id)fp8;
- (void)registerSpecialPresentity:(id)fp8;
- (void)unregisterSpecialPresentity:(id)fp8;
- (BOOL)equalID:(id)fp8 andID:(id)fp12;
- (id)abPersonSibsForPresentity:(id)fp8;
- (id)abPersonForPresentity:(id)fp8;
- (id)arrayOfAllPresentities;
- (id)presentityWithID:(id)fp8;
- (id)existingPresentityWithID:(id)fp8;
- (id)presentityForGuid:(id)fp8;
- (BOOL)addPresentity:(id)fp8 toABPerson:(id)fp12;
- (BOOL)removePresentity:(id)fp8 fromABPerson:(id)fp12;
- (id)presentitiesForABPerson:(id)fp8;
- (void)forgetAllWatches;
- (void)startWatchingPresentity:(id)fp8;
- (void)stopWatchingPresentity:(id)fp8;
- (void)requestPresenceStatusFromPresentity:(id)fp8;
- (void)setPresenceStatus:(BOOL)fp8 forPresentity:(id)fp12 requestID:(id)fp16;
- (void)setValue:(id)fp8 ofExtraProperty:(id)fp12 ofPresentity:(id)fp16;
- (void)requestProperty:(id)fp8 ofPresentity:(id)fp12;
- (void)disableCertificatesForPresentity:(id)fp8;
- (void)handleSubscriptionRequestFrom:(id)fp8;
@end

@protocol AbstractAccountPrivacyProtocol
- (void)blockMessages:(BOOL)fp8 fromID:(id)fp12;
- (void)setBlockList:(id)fp8;
- (id)blockList;
- (void)setAllowList:(id)fp8;
- (id)allowList;
- (void)setBlockingMode:(unsigned int)fp8;
- (unsigned int)blockingMode;
- (BOOL)blockIdleStatus;
- (void)setBlockIdleStatus:(BOOL)fp8;
- (BOOL)blockOtherAddresses;
- (void)setBlockOtherAddresses:(BOOL)fp8;
@end

@protocol AbstractAccountSessionProtocol
- (void)setAccountLoginStatus:(int)fp8;
- (void)setAccountLoginStatus:(int)fp8 errorMessage:(id)fp12;
- (void)setAccountLoginStatus:(int)fp8 errorMessage:(id)fp12 reason:(unsigned int)fp16;
- (void)requestGroups;
- (void)hookupToDaemon;
- (void)chat:(id)fp8 statusChanged:(int)fp12;
- (void)chat:(id)fp8 showError:(id)fp12;
- (void)chat:(id)fp8 member:(id)fp12 statusChanged:(int)fp16;
- (void)handleChat:(id)fp8 messageReceived:(id)fp12;
- (void)groupsChanged:(id)fp8 error:(id)fp12;
- (void)updateCapabilities:(unsigned long long)fp8;
- (void)buddyPictureChanged:(id)fp8 imageData:(id)fp12 imageHash:(id)fp16;
- (void)buddyPropertiesChanged:(id)fp8;
- (void)loginStatusChanged:(unsigned int)fp8 message:(id)fp12 reason:(unsigned int)fp16 properties:(id)fp20;
- (void)directIMRequestFrom:(id)fp8 invitation:(id)fp12;
- (void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (void)holdBuddyUpdates;
- (void)resumeBuddyUpdates;
@end

@protocol AbstractAccountVideoConferenceProtocol
- (void)requestVCWithBuddy:(id)fp8 properties:(id)fp12;
- (void)respondToVCRequestWithBuddy:(id)fp8 properties:(id)fp12;
- (void)declineVCRequestWithBuddy:(id)fp8 response:(int)fp12 vcProps:(id)fp16;
- (void)cancelVCRequestWithBuddy:(id)fp8;
- (void)sendVCCounterProposalToBuddy:(id)fp8 properties:(id)fp12;
- (void)sendVCUpdate:(id)fp8 toBuddy:(id)fp12;
- (void)sendAVMessageToBuddy:(id)fp8 sessionID:(unsigned int)fp12 type:(unsigned int)fp16 userInfo:(id)fp20;
@end

@protocol ChatPluginProtocol
+ (id)localizedMenuTitle;
+ (id)localizedName;
+ (BOOL)initializeClass:(id)fp8;
+ (void)terminateClass;
@end

@protocol ChatViewer
- (void)displayChat:(id)fp8;
- (id)displayChatForPresentity:(id)fp8 style:(int)fp12;
- (id)createUIForChat:(id)fp8;
- (id)createChatUIWithPresentities:(id)fp8 style:(int)fp12;
- (id)createChatWindowWithPresentities:(id)fp8 style:(int)fp12;
- (id)visibleChatWithID:(id)fp8;
- (id)visibleChatToHookUpWithPresentity:(id)fp8;
- (void)doAddBuddyCommandForPresentity:(id)fp8 withWindow:(id)fp12;
- (void)showInfoForPresentity:(id)fp8;
- (void)showProfileForPresentity:(id)fp8;
- (id)chooserWindow;
- (id)windowForSheet;
@end

@protocol DirectlyObservableObjectObserver
- (void)objectDidPostDirectNotification:(id)fp8;
@end

@protocol FZDaemon <NSObject>
- (oneway void)autoLoginActiveAccountsIfNecessary;
- (oneway void)loginAllAccounts;
- (oneway void)logoutAllAccounts;
- (oneway void)terminate;
- (oneway void)changeMyStatus:(id)fp8;
- (oneway void)setValue:(id)fp8 ofPersistentProperty:(id)fp12;
- (oneway void)setVCCapabilities:(unsigned long long)fp8;
- (oneway void)requestCurrentAVChatInfoForListenerID:(id)fp8 responseID:(id)fp12;
- (oneway void)requestAudioReflector:(BOOL)fp8 forListenerID:(id)fp12 responseID:(id)fp16;
- (oneway void)requestVideoStillForPerson:(id)fp8 forListenerID:(id)fp12 responseID:(id)fp16;
- (oneway void)provideCurrentAVChatInfo:(id)fp8 result:(unsigned int)fp12 transactionID:(unsigned int)fp16;
- (oneway void)provideVideoStill:(id)fp8 forPerson:(id)fp12 result:(unsigned int)fp16 transactionID:(unsigned int)fp20;
- (oneway void)setAVManagerClient:(id)fp8 URLToShare:(id)fp12;
- (oneway void)contextRequest:(id)fp8 withProperties:(id)fp12 forGUID:(id)fp16;
- (oneway void)syncContexts;
- (oneway void)displayStatusText:(id)fp8;
- (oneway void)service:(id)fp8 writeServiceDefaults:(id)fp12;
- (oneway void)service:(id)fp8 setActiveAccounts:(id)fp12;
- (oneway void)service:(id)fp8 writeAccount:(id)fp12 defaults:(id)fp16;
- (oneway void)service:(id)fp8 holdBuddyUpdatesForAccount:(id)fp12;
- (oneway void)service:(id)fp8 resumeBuddyUpdatesForAccount:(id)fp12;
- (oneway void)service:(id)fp8 autoLoginWithAccount:(id)fp12;
- (oneway void)service:(id)fp8 loginWithAccount:(id)fp12;
- (oneway void)service:(id)fp8 logoutOfAccount:(id)fp12;
- (oneway void)service:(id)fp8 sessionCertificatesChangedForAccount:(id)fp12;
- (oneway void)service:(id)fp8 enableSecureIM:(BOOL)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 disableCertificatesForPerson:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 requestBuddyPicturesAndPropertiesForAccount:(id)fp12;
- (oneway void)service:(id)fp8 requestProperty:(id)fp12 ofPerson:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 setValue:(id)fp12 ofProperty:(id)fp16 ofPerson:(id)fp20 forAccount:(id)fp24;
- (oneway void)service:(id)fp8 requestGroupsForAccount:(id)fp12;
- (oneway void)service:(id)fp8 changeGroups:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 changeGroup:(id)fp12 changes:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 renameGroup:(id)fp12 to:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 createChatForIMsWith:(id)fp12 isDirect:(BOOL)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 createChatWith:(id)fp12 invitation:(id)fp16 named:(id)fp20 forAccount:(id)fp24;
- (oneway void)service:(id)fp8 goToChatNamed:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 invitePerson:(id)fp12 toChat:(id)fp16 withMessage:(id)fp20;
- (oneway void)service:(id)fp8 respond:(BOOL)fp12 toInvitationToChat:(id)fp16;
- (oneway void)service:(id)fp8 sendMessage:(id)fp12 toChat:(id)fp16;
- (oneway void)service:(id)fp8 leaveChat:(id)fp12;
- (oneway void)service:(id)fp8 setPerson:(id)fp12 isIgnored:(BOOL)fp16 inChat:(id)fp20;
- (oneway void)service:(id)fp8 requestVCWithPerson:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 cancelVCRequestWithPerson:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 respondToVCInvitationWithPerson:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 sendCounterProposalToPerson:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 sendVCUpdate:(id)fp12 toPerson:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 sendAVMessageToPerson:(id)fp12 sessionID:(unsigned int)fp16 type:(unsigned int)fp20 userInfo:(id)fp24 forAccount:(id)fp28;
- (oneway void)service:(id)fp8 setBlockList:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 setAllowList:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 setBlockingMode:(unsigned int)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 setBlockIdleStatus:(BOOL)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 acceptSubscriptionRequest:(BOOL)fp12 from:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 requestSubscriptionTo:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 startWatchingBuddy:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 stopWatchingBuddy:(id)fp12 forAccount:(id)fp16;
- (oneway void)addListener:(id)fp8 withListenerID:(id)fp12 forKey:(id)fp16 capabilities:(unsigned int)fp20;
- (oneway void)removeListener:(id)fp8;
@end

@protocol FZDaemonListener <NSObject>
- (oneway void)services:(id)fp8 myStatus:(id)fp12 persistentProperties:(id)fp16;
- (oneway void)service:(id)fp8 properties:(id)fp12 defaults:(id)fp16 defaultAccountSettings:(id)fp20 allAccounts:(id)fp24 activeAccounts:(id)fp28;
- (oneway void)vcCapabilitiesChanged:(unsigned long long)fp8;
- (oneway void)setupComplete;
- (oneway void)defaultsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)activeAccountsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)account:(id)fp8 defaultsChanged:(id)fp12;
- (oneway void)account:(id)fp8 blockListChanged:(id)fp12;
- (oneway void)account:(id)fp8 allowListChanged:(id)fp12;
- (oneway void)account:(id)fp8 blockingModeChanged:(unsigned int)fp12;
- (oneway void)account:(id)fp8 blockIdleStatusChanged:(BOOL)fp12;
- (oneway void)account:(id)fp8 capabilities:(unsigned long long)fp12 serviceLoginStatus:(unsigned int)fp20 loginStatusMessage:(id)fp24;
- (oneway void)account:(id)fp8 loginStatusChanged:(unsigned int)fp12 message:(id)fp16 reason:(unsigned int)fp20 properties:(id)fp24;
- (oneway void)account:(id)fp8 capabilitiesChanged:(unsigned long long)fp12;
- (oneway void)account:(id)fp8 buddyPropertiesChanged:(id)fp12;
- (oneway void)shutdownAVForAccount:(id)fp8;
- (oneway void)account:(id)fp8 buddyPictureChanged:(id)fp12 imageData:(id)fp16 imageHash:(id)fp20;
- (oneway void)account:(id)fp8 groupsChanged:(id)fp12 error:(id)fp16;
- (oneway void)account:(id)fp8 buddyProperties:(id)fp12 buddyPictures:(id)fp16;
- (oneway void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (oneway void)account:(id)fp8 directIMRequestFrom:(id)fp12 invitation:(id)fp16;
- (oneway void)chat:(id)fp8 statusChanged:(int)fp12;
- (oneway void)chat:(id)fp8 messageReceived:(id)fp12;
- (oneway void)chat:(id)fp8 showError:(id)fp12;
- (oneway void)chat:(id)fp8 member:(id)fp12 statusChanged:(int)fp16;
- (oneway void)account:(id)fp8 invitedToVC:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 responseToVCRequest:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 cancelVCInviteFrom:(id)fp12;
- (oneway void)account:(id)fp8 counterProposalFrom:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 updateVCFrom:(id)fp12 data:(id)fp16;
- (oneway void)account:(id)fp8 handleAVMessage:(id)fp12 sessionID:(unsigned int)fp16 type:(unsigned int)fp20 userInfo:(id)fp24;
- (oneway void)account:(id)fp8 handleSubscriptionRequestFrom:(id)fp12;
- (oneway void)showInvalidCertNotificationForAccount:(id)fp8;
- (oneway void)showForgotPasswordNotificationForAccount:(id)fp8;
- (oneway void)myStatusChanged:(id)fp8;
- (oneway void)daemonPersistentProperty:(id)fp8 changedTo:(id)fp12;
- (oneway void)currentAVChatInfoRequestedWithTransactionID:(unsigned int)fp8;
- (oneway void)audioReflectorRequested:(BOOL)fp8 transactionID:(unsigned int)fp12;
- (oneway void)videoStillForPersonRequested:(id)fp8 withTransactionID:(unsigned int)fp12;
- (oneway void)currentAVChatInfoProvided:(id)fp8 result:(unsigned int)fp12 responseID:(id)fp16;
- (oneway void)videoStill:(id)fp8 providedForPerson:(id)fp12 result:(unsigned int)fp16 responseID:(id)fp20;
- (oneway void)setAVManagerRequested:(BOOL)fp8 URLToShare:(id)fp12;
- (oneway void)contextUpdate:(id)fp8;
- (oneway void)contextEndedForGUID:(id)fp8;
- (oneway void)displayStatusText:(id)fp8;
@end

@protocol FileDragOutViewDelegate <NSObject>
- (BOOL)fileDragOutView:(id)fp8 shouldDragFile:(id)fp12;
- (void)fileDragOutView:(id)fp8 file:(id)fp12 draggedTo:(id)fp16 isDuplicate:(BOOL)fp20;
- (void)fileDragOutView:(id)fp8 fileDoubleClicked:(id)fp12;
@end

@protocol FrameListener <NSObject>
- (void)frameNotifier:(id)fp8 postedNewFrame:(id)fp12 fromSource:(id)fp16;
@end

@protocol HotKeyHandler
- (void)handleHotKey:(unsigned long)fp8 pressed:(BOOL)fp12;
@end

@protocol IKPictureTakerVideoProvider
- (void)startGrabbingForReceiver:(id)fp8;
- (void)stopGrabbing;
- (BOOL)canStartGrabbing;
@end

@protocol IMAuxVideoProvider
- (oneway void)provideFrameAtFramerate:(double)fp8;
- (oneway void)setBufferPoolDescription:(id)fp8 audioDeviceUID:(id)fp12 channels:(id)fp16;
- (oneway void)disconnectAndActivate:(BOOL)fp8;
@end

@protocol IMAuxVideoReceiver
- (oneway void)provider:(id)fp8 bundleID:(id)fp12 connectWithPixelFormat:(unsigned long)fp16 videoStills:(BOOL)fp20 replacement:(BOOL)fp24 audioChannels:(int)fp28;
- (oneway void)provider:(id)fp8 sentBuffer:(int)fp12 withAttachments:(id)fp16;
@end

@protocol NetworkChangeNotificationListener
- (void)systemNetworkDidChange;
- (void)systemWillSleep;
- (void)systemDidWake;
@end

@protocol Node <NSObject>
- (id)createChild:(id)fp8;
- (void)addText:(id)fp8;
- (void)childFinished:(id)fp8;
- (void)finished;
@end

@protocol PeopleListDelegate
- (id)peopleList:(id)fp8 alternateStatusTextForPresentity:(id)fp12;
- (id)peopleList:(id)fp8 alternateNameTextForPresentity:(id)fp12;
- (float)peopleList:(id)fp8 alphaForStatus:(unsigned int)fp12;
- (id)peopleList:(id)fp8 addablePeople:(id)fp12;
- (BOOL)peopleList:(id)fp8 canRemoveRows:(id)fp12;
- (void)peopleList:(id)fp8 deleteGroup:(id)fp12;
- (id)peopleList:(id)fp8 filterPresentityFromPasteboard:(id)fp12;
- (void)peopleList:(id)fp8 setGroupsSortOrder:(id)fp12;
- (BOOL)peopleList:(id)fp8 addPersonWithoutID:(id)fp12;
- (id)peopleList:(id)fp8 siblingsForPresentity:(id)fp12;
- (BOOL)peopleList:(id)fp8 people:(id)fp12 draggedFromGroups:(id)fp16 toGroup:(id)fp20 atLocation:(int)fp24 copying:(BOOL)fp28;
- (BOOL)peopleList:(id)fp8 pastePeople:(id)fp12 intoGroup:(id)fp16;
- (BOOL)peopleList:(id)fp8 deletePeople:(id)fp12;
- (id)peopleList:(id)fp8 menuForGroup:(id)fp12;
- (void)peopleListSelectedItemInfoChanged:(id)fp8;
- (id)propertiesForGroup:(id)fp8;
@end

//Declared in iChatCommonGUI.h
/*@protocol PresentityProtocol <NSObject>
- (id)ID;
- (id)name;
- (id)nameAndID;
- (BOOL)isMyLogin;
- (id)balloonColor;
- (id)guid;
- (BOOL)isBuddy;
- (BOOL)canBeSecure;
- (id)uniqueName;
- (id)pictureKey;
- (id)mappedPresentity;
@end*/

@protocol ScreenSaverMonitorListener
- (void)screenSaverDidStart;
- (void)screenSaverDidStop;
@end

@protocol ShowMessagesDelegate
- (void)chatView:(id)fp8 canShowMessages:(BOOL)fp12;
@end

//Declared in VideoConference.h
/*@protocol VCRenderDelegateProtocol
- (int)processCVPixelBuffer:(struct __CVBuffer *)fp8 intoCVPixelBuffer:(struct __CVBuffer *)fp12 withHint:(id)fp16;
- (int)resizeRemoteVideoForUserID:(id)fp8 outBuffer:(struct __CVBuffer *)fp12;
@end*/

//Declared in VideoConference.h
/*@protocol VideoConferenceDelegateProtocol
- (void)vcc:(id)fp8 initiateConferenceStartedForParty:(id)fp12;
- (void)vcc:(id)fp8 initiateConferenceCompletedForParty:(id)fp12 partyInfo:(id)fp16;
- (void)vcc:(id)fp8 partyConnected:(id)fp12;
- (void)vcc:(id)fp8 partyHungUp:(id)fp12;
- (void)vcc:(id)fp8 party:(id)fp12 didMute:(BOOL)fp16;
- (void)vcc:(id)fp8 party:(id)fp12 didPause:(BOOL)fp16;
- (void)vcc:(id)fp8 partyCancelled:(id)fp12;
- (void)vcc:(id)fp8 conferenceAttempted:(id)fp12;
- (void)vccInsufficientBandwidth:(id)fp8 forParty:(id)fp12 partyInfo:(id)fp16;
- (void)vccNetworkTimeout:(id)fp8;
- (void)vccLocalVideoError:(id)fp8;
- (void)vcc:(id)fp8 noPacketsFromParty:(id)fp12 partyInfo:(id)fp16;
- (void)vcc:(id)fp8 party:(id)fp12 didStall:(BOOL)fp16;
- (BOOL)shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8 callbackInfo:(id)fp12;
- (BOOL)shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8;
- (BOOL)vcc:(id)fp8 isRemoteCertificateValid:(struct OpaqueSecCertificateRef *)fp12 forUser:(id)fp16;
- (void)vcc:(id)fp8 securityChangedForUser:(id)fp12;
- (void)vccLocalCertNotAccepted:(id)fp8;
- (void)vccRemoteCertNotAccepted:(id)fp8 forParty:(id)fp12;
- (BOOL)vcc:(id)fp8 userRequestedAuxiliaryInput:(id)fp12;
- (void)vcc:(id)fp8 user:(id)fp12 approvedAuxiliaryInput:(BOOL)fp16;
@end*/

@interface ABAddressBook (Fez)
- (id)existingABPersonWithFirstName:(id)fp8 lastName:(id)fp12;
- (id)existingABPersonWithFirstName:(id)fp8 andLastName:(id)fp12 orEmail:(id)fp16;
- (id)existingABPersonForPerson:(id)fp8;
@end

@interface ABBezelWindow : NSPanel
{
}

- (id)initWithContentRect:(struct _NSRect)fp8 styleMask:(unsigned int)fp24 backing:(unsigned int)fp28 defer:(BOOL)fp32;
- (BOOL)canBecomeKeyWindow;
- (BOOL)canBecomeMainWindow;
- (void)resignMainWindow;

@end

@interface ABLargeTypeController : NSWindowController
{
    ABLargeTypeView *largeTypeView;
    NSString *_phoneString;
    BOOL _closing;
    BOOL _fadeIn;
    id _delegate;
}

+ (id)displayString:(id)fp8 forTime:(double)fp12 delegate:(id)fp20;
- (id)initWithString:(id)fp8 delegate:(id)fp12;
- (void)unsetDelegate:(id)fp8;
- (void)dealloc;
- (void)awakeFromNib;
- (void)windowDidLoad;
- (void)stupidKitWorkaround;
- (id)windowNibName;
- (void)animationDidStop:(id)fp8;
- (void)animationDidEnd:(id)fp8;
- (void)_fadeInTimer:(id)fp8;
- (void)_startTimer;
- (void)fadeIn:(id)fp8;
- (void)fadeOut:(id)fp8;
- (void)showWindow:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)close;

@end

@interface ABLargeTypeView : NSView
{
    NSString *_phoneString;
    NSDictionary *_attributes;
    ABPhoneFormatter *_formatter;
}

- (struct _NSRect)contentRectForString;
- (void)setPhoneString:(id)fp8;
- (void)setAttributes:(id)fp8;
- (void)dealloc;
- (void)finalize;
- (void)drawRect:(struct _NSRect)fp8;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (void)mouseDown:(id)fp8;

@end

@interface ABMonitorBrightnessController : NSObject
{
    NSMutableDictionary *_previousMonitorBrightness;
}

+ (id)defaultController;
- (id)init;
- (void)dealloc;
- (void)setMaximumBrightnessOnAllDisplays;
- (void)revertBrightness;

@end

@interface ABPerson (Fez)
+ (id)cardFromPasteboardContent:(id)fp8;
+ (id)cardFromVCardData:(id)fp8;
+ (id)cardWithFirstName:(id)fp8 lastName:(id)fp12;
- (BOOL)mergeVCardWithABPerson:(id)fp8;
- (id)mergedAddressBookMatch;
- (void)setFirstName:(id)fp8 lastName:(id)fp12;
- (BOOL)containsHandle:(id)fp8 forServiceProperty:(id)fp12;
- (BOOL)isCompany;
- (id)companyName;
- (id)fullName;
- (id)nickname;
- (id)firstName;
- (void)setFirstName:(id)fp8;
- (id)lastName;
- (void)setLastName:(id)fp8;
- (void)save;
- (id)valuesForProperty:(id)fp8;
- (id)emails;
- (void)setValues:(id)fp8 forProperty:(id)fp12;
- (void)setEmails:(id)fp8;
- (BOOL)isInAddressBook;
- (void)setID:(id)fp8 forProperty:(id)fp12 withLabel:(id)fp16;
- (id)allHandlesForProperty:(id)fp8;
- (id)_allJabberHandles;
- (id)mobileNumbers;
- (id)allAIMHandles;
- (id)macDotComEmails;
- (id)macDotComEmail;
- (id)gmailHandles;
- (id)jabberHandles;
- (id)aimHandles;
- (void)appendID:(id)fp8 toProperty:(id)fp12 withLabel:(id)fp16;
- (BOOL)openInAddressBookAndEdit:(BOOL)fp8;
- (BOOL)blockingPresentityPictures;
- (void)setBlockingPresentityPictures:(BOOL)fp8;
@end

@interface ABPictureControl : NSImageView
{
    NSImage *_placeholderImage;
    struct _NSPoint _lastMouseDownLocation;
    NSArray *_buddyPictures;
    NSString *_baseFilename;
    BOOL _allowsDrag;
    SEL _doubleAction;
}

- (void)dealloc;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)awakeFromNib;
- (void)setPlaceholderImage:(id)fp8;
- (void)_buddyPictureNeedsDrawFromAnimate:(id)fp8;
- (id)imagePreservingOriginalImage;
- (id)buddyPicture;
- (id)buddyPictures;
- (void)setBuddyPictures:(id)fp8;
- (void)setBuddyPicture:(id)fp8;
- (id)placeholderImage;
- (id)image;
- (void)setBaseFilename:(id)fp8;
- (id)baseFilename;
- (void)_sendAction:(SEL)fp8;
- (void)_sendAction;
- (void)_sendDoubleAction;
- (void)_setImageAndNotifyTarget:(id)fp8;
- (BOOL)acceptsFirstResponder;
- (struct _NSRect)frameForImage;
- (void)_drawFocusRing;
- (void)drawRect:(struct _NSRect)fp8;
- (void)openPanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)openMyPictureFilePanel:(id)fp8;
- (id)_dragImageOfSize:(struct _NSSize)fp8;
- (id)namesOfPromisedFilesDroppedAtDestination:(id)fp8;
- (void)mouseDragged:(id)fp8;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)fp8;
- (void)mouseDown:(id)fp8;
- (void)performClick:(id)fp8;
- (void)keyDown:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (BOOL)copy:(id)fp8;
- (void)cut:(id)fp8;
- (void)paste:(id)fp8;
- (void)delete:(id)fp8;
- (unsigned int)draggingEntered:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (void)setAllowsDrag:(BOOL)fp8;
- (BOOL)allowsDrag;
- (void)setDoubleAction:(SEL)fp8;
- (SEL)doubleAction;

@end

@interface ABPictureControl (ABPictureControlAccessibility)
- (id)accessibilityFocusedUIElement;
- (id)accessibilityHitTest:(struct _NSPoint)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityActionNames;
- (id)accessibilityActionDescription:(id)fp8;
- (void)accessibilityPerformAction:(id)fp8;
- (id)accessibilityRoleAttribute;
- (id)accessibilityDescriptionAttribute;
@end

@interface AbstractAccount : NSObject <AbstractAccountSessionProtocol, AbstractAccountBuddyListProtocol, AbstractAccountVideoConferenceProtocol, AbstractAccountChatProtocol, AbstractAccountPresentityProtocol, AbstractAccountPrivacyProtocol>
{
    NSMutableDictionary *_data;
    NSString *_uniqueID;
    People *_buddyList;
    NSArray *_groups;
    NSMutableDictionary *_sortOrders;
    NSDictionary *_members;
    int _coalesceCount;
    NSMutableDictionary *_coalescedChanges;
    NSArray *_targetGroupState;
    NSArray *_lastReceivedGroupState;
    int _cachedBlockingMode;
    NSArray *_cachedAllowList;
    NSArray *_cachedBlockList;
    BOOL _blockIdleStatus;
    BOOL _blockOtherAddresses;
    unsigned long long _capabilities;
    int _loginStatus;
    BOOL _justLoggedIn;
    NSMutableDictionary *_presentities;
    NSMutableSet *_specialPresentities;
    BOOL _dontPostNotifications;
    Presentity *_loginPresentity;
    BOOL _needToCheckForWatchedPresentities;
    int _numHolding;
    BOOL _needToFlushBuddyList;
    BOOL _syncedWithRemoteBuddyList;
    BOOL _hasReceivedSync;
    NSMutableDictionary *_inlineTransfers;
    NSImage *_smallImage;
    BOOL _asleep;
    NSMutableDictionary *_accountPreferences;
    SFCertificateTrustPanel *_trustPanel;
}

+ (id)defaults;
+ (id)service;
+ (BOOL)supportsMultipleConnections;
+ (BOOL)isPersistent;
+ (id)defaultBuddylistDescription;
+ (BOOL)isValidAccount:(id)fp8;
+ (id)passwordForAccount:(id)fp8 forServiceName:(id)fp12;
+ (void)setPassword:(id)fp8 forAccount:(id)fp12 forServiceName:(id)fp16;
+ (void)removePasswordForAccount:(id)fp8 forServiceName:(id)fp12;
+ (id)nameOfLoginStatus:(int)fp8;
+ (id)arrayOfAllPresentities;
+ (id)allBuddyListPresentities;
+ (id)presentityWithID:(id)fp8;
+ (id)canonicalFormOfID:(id)fp8;
- (void)loadFromDictionary:(id)fp8;
- (id)dictionary;
- (void)_clearServiceCaches;
- (id)initWithUniqueID:(id)fp8;
- (id)init;
- (void)dealloc;
- (id)service;
- (id)uniqueID;
- (void)setUniqueID:(id)fp8;
- (id)objectForKey:(id)fp8;
- (void)setObject:(id)fp8 forKey:(id)fp12;
- (void)removeObjectForKey:(id)fp8;
- (void)setDictionaryData:(id)fp8 forKey:(id)fp12;
- (id)dictionaryDataForKey:(id)fp8;
- (id)stringForKey:(id)fp8;
- (void)setString:(id)fp8 forKey:(id)fp12;
- (BOOL)boolForKey:(id)fp8;
- (void)setBool:(BOOL)fp8 forKey:(id)fp12;
- (int)integerForKey:(id)fp8;
- (void)setInteger:(int)fp8 forKey:(id)fp12;
- (id)objectForPreferenceKey:(id)fp8;
- (void)setObject:(id)fp8 forPreferenceKey:(id)fp12;
- (void)removeObjectForPreferenceKey:(id)fp8;
- (void)setDictionaryData:(id)fp8 forPreferenceKey:(id)fp12;
- (id)dictionaryDataForPreferenceKey:(id)fp8;
- (id)stringForPreferenceKey:(id)fp8 defaultValue:(id)fp12;
- (void)setString:(id)fp8 forPreferenceKey:(id)fp12;
- (BOOL)boolForPreferenceKey:(id)fp8 defaultValue:(BOOL)fp12;
- (void)setBool:(BOOL)fp8 forPreferenceKey:(id)fp12;
- (int)integerForPreferenceKey:(id)fp8 defaultValue:(int)fp12;
- (void)setInteger:(int)fp8 forPreferenceKey:(id)fp12;
- (BOOL)canActivate;
- (BOOL)isManaged;
- (unsigned long long)capabilities;
- (BOOL)hasCapability:(unsigned long long)fp8;
- (id)image;
- (id)accountImageForPresentity:(id)fp8;
- (id)smallImage;
- (BOOL)connecting;
- (BOOL)connected;
- (BOOL)enabled;
- (void)setEnabled:(BOOL)fp8;
- (void)writeSettings;
- (void)resetToDefaults;
- (void)disconnect;
- (void)connect;
- (BOOL)hasCustomDescription;
- (id)buddyListDescription;
- (id)speechDescription;
- (id)menuItemDescription;
- (id)description;
- (void)setDescription:(id)fp8;
- (void)setCollapsedGroups:(id)fp8;
- (id)collapsedGroups;
- (BOOL)autoLogin;
- (void)setAutoLogin:(BOOL)fp8;
- (BOOL)isInvisible;
- (void)setInvisible:(BOOL)fp8;
- (BOOL)goIdle;
- (void)setGoIdle:(BOOL)fp8;
- (int)invalidSettings;
- (void)setSigning:(struct OpaqueSecCertificateRef *)fp8 encryption:(struct OpaqueSecCertificateRef *)fp12;
- (void)enableSecureIM:(BOOL)fp8;
- (void)disableCertificatesForPresentity:(id)fp8;
- (BOOL)canBeSecure;
- (void)setSecureImEnabled:(BOOL)fp8;
- (BOOL)secureImEnabled;
- (void)showFailedCertificateDialog;
- (void)_loginWithAutoLogin:(BOOL)fp8;
- (void)autoLoginAccount;
- (void)loginAccount;
- (void)logoutAccount;
- (id)_login;
- (id)login;
- (void)setLogin:(id)fp8;
- (id)loginPresentity;
- (id)password;
- (void)setPassword:(id)fp8;
- (void)removePassword;
- (void)askAboutEncryptionIfNecessary;
- (void)showForgotPasswordDialog;
- (void)didWakeNotification:(id)fp8;
- (void)willSleepNotification:(id)fp8;
- (void)_disconnectAllPresentities;
- (BOOL)loggedIn;
- (BOOL)justLoggedIn;
- (void)_notJustLoggedIn;
- (id)accountLoginStatusMessage;
- (void)setAccountLoginStatus:(int)fp8;
- (int)accountLoginStatus;
- (void)_setTimersForNotJustLoggedIn;
- (void)setAccountLoginStatus:(int)fp8 errorMessage:(id)fp12;
- (void)setAccountLoginStatus:(int)fp8 errorMessage:(id)fp12 reason:(unsigned int)fp16;
- (void)joinBookmarkedChatRooms;
- (void)nowLoggedIn;
- (void)nowLoggedOut;
- (void)_watchBuddiesIfNecessary;
- (void)watchBuddiesIfNecessary;
- (void)startWatchingPresentity:(id)fp8;
- (void)stopWatchingPresentity:(id)fp8;
- (void)forgetAllWatches;
- (void)registerPresentity:(id)fp8;
- (void)unregisterPresentity:(id)fp8;
- (void)registerSpecialPresentity:(id)fp8;
- (void)unregisterSpecialPresentity:(id)fp8;
- (id)arrayOfAllPresentities;
- (id)existingPresentityWithID:(id)fp8;
- (id)presentityWithID:(id)fp8;
- (id)presentityForGuid:(id)fp8;
- (BOOL)equalID:(id)fp8 andID:(id)fp12;
- (id)canonicalFormOfID:(id)fp8;
- (void)setPresenceStatus:(BOOL)fp8 forPresentity:(id)fp12 requestID:(id)fp16;
- (void)requestPresenceStatusFromPresentity:(id)fp8;
- (void)setValue:(id)fp8 ofExtraProperty:(id)fp12 ofPresentity:(id)fp16;
- (BOOL)emailAddressIsID:(id)fp8;
- (id)abPersonSibsForPresentity:(id)fp8;
- (id)abPersonForPresentity:(id)fp8;
- (unsigned int)sortOrderForPresentity:(id)fp8 inGroup:(id)fp12;
- (void)requestGroups;
- (id)buddyList;
- (void)_ensureGroupsExists:(id)fp8;
- (BOOL)addPeople:(id)fp8 toGroups:(id)fp12 atLocation:(int)fp16;
- (BOOL)removePeople:(id)fp8 fromGroups:(id)fp12;
- (BOOL)addPresentity:(id)fp8 toGroups:(id)fp12 atLocation:(int)fp16;
- (BOOL)removePresentity:(id)fp8 fromGroups:(id)fp12;
- (void)requestProperty:(id)fp8 ofPresentity:(id)fp12;
- (void)addBuddyToBuddyList:(id)fp8;
- (void)beginChanges;
- (void)endChanges;
- (BOOL)makingChanges;
- (void)changeBuddyList:(id)fp8 add:(BOOL)fp12 groups:(id)fp16 atLocation:(int)fp20;
- (void)renameGroup:(id)fp8 to:(id)fp12;
- (void)reorderGroup:(id)fp8 order:(id)fp12;
- (void)reorderGroups:(id)fp8;
- (void)holdBuddyUpdates;
- (void)_resumeBuddyUpdatesNow;
- (void)resumeBuddyUpdates;
- (id)propertiesForGroup:(id)fp8;
- (id)groupMembers:(id)fp8;
- (id)groupList;
- (id)memberGroups:(id)fp8;
- (void)presentity:(id)fp8 buddyStatusChanged:(BOOL)fp12;
- (void)requestVCWithBuddy:(id)fp8 properties:(id)fp12;
- (void)respondToVCRequestWithBuddy:(id)fp8 properties:(id)fp12;
- (void)declineVCRequestWithBuddy:(id)fp8 response:(int)fp12 vcProps:(id)fp16;
- (void)cancelVCRequestWithBuddy:(id)fp8;
- (void)sendVCCounterProposalToBuddy:(id)fp8 properties:(id)fp12;
- (void)sendVCUpdate:(id)fp8 toBuddy:(id)fp12;
- (void)sendAVMessageToBuddy:(id)fp8 sessionID:(unsigned int)fp12 type:(unsigned int)fp16 userInfo:(id)fp20;
- (void)_reconnectChat:(id)fp8 toIncomingID:(id)fp12;
- (id)_createBaseInstantMessage:(id)fp8 chatID:(id)fp12;
- (id)_createInstantMessage:(id)fp8 chatID:(id)fp12;
- (id)_createFZMessage:(id)fp8;
- (id)_createChatWithID:(id)fp8 message:(id)fp12 style:(int)fp16 isInvitationMessage:(BOOL)fp20;
- (void)forgetAllChats;
- (id)createChatRoomName;
- (void)refreshChatRegistration:(id)fp8;
- (id)visibleChatToHookUpWithID:(id)fp8;
- (void)rememberChat:(id)fp8;
- (void)forgetChat:(id)fp8;
- (void)reconnectChat:(id)fp8;
- (id)chatWithID:(id)fp8;
- (id)chatIDForRoomName:(id)fp8;
- (id)defaultChatSuffix;
- (struct _FZChatRoomValidity)validityOfChatRoomName:(id)fp8;
- (BOOL)validateChatRoomName:(id)fp8 reason:(id *)fp12;
- (BOOL)_registerChat:(id)fp8 withMessage:(id)fp12;
- (id)goToChatNamed:(id)fp8 useRoomName:(BOOL)fp12;
- (id)goToChatNamed:(id)fp8 useRoomName:(BOOL)fp12 forceDisplay:(BOOL)fp16;
- (void)invitePresentity:(id)fp8 toChat:(id)fp12 withMessage:(id)fp16;
- (void)respond:(BOOL)fp8 toInvitationToChat:(id)fp12;
- (int)sendMessage:(id)fp8 toChat:(id)fp12;
- (void)leaveChatRoom:(id)fp8;
- (void)setPresentity:(id)fp8 isIgnored:(BOOL)fp12 inChat:(id)fp16;
- (void)_inlineXferUpdate:(id)fp8;
- (id)_convertInlineGUIDsToInlineFiles:(id)fp8;
- (void)_listenForInlineTransferUpdates:(id)fp8 forMessage:(id)fp12 withFZMessage:(id)fp16 withChatID:(id)fp20;
- (id)_attachURL:(id)fp8 andSubject:(id)fp12 toAttributedString:(id)fp16;
- (id)_attachInlineFiles:(id)fp8 toAttributedString:(id)fp12;
- (unsigned int)acceptableFormats;
- (id)addressBookProperty;
- (id)emailDomains;
- (id)icon;
- (id)defaultImageForPresentity:(id)fp8;
- (id)defaultImageForID:(id)fp8;
- (id)defaultBuddyIconForPresentity:(id)fp8;
- (id)defaultBuddyIconForID:(id)fp8;
- (id)serviceName;
- (id)shortName;
- (id)internalName;
- (int)compareNames:(id)fp8;
- (BOOL)handlesChatInvites;
- (void)setCachedAllowList:(id)fp8;
- (void)setCachedBlockList:(id)fp8;
- (void)setCachedBlockingMode:(unsigned int)fp8;
- (void)setCachedBlockIdleStatus:(BOOL)fp8;
- (void)blockMessages:(BOOL)fp8 fromID:(id)fp12;
- (void)setBlockList:(id)fp8;
- (id)blockList;
- (void)setAllowList:(id)fp8;
- (id)allowList;
- (void)setBlockingMode:(unsigned int)fp8;
- (unsigned int)blockingMode;
- (BOOL)blockIdleStatus;
- (void)setBlockIdleStatus:(BOOL)fp8;
- (BOOL)blockOtherAddresses;
- (BOOL)blockOtherAddressesForAccount:(id)fp8;
- (void)setBlockOtherAddresses:(BOOL)fp8;
- (void)_clearTargetState;
- (BOOL)_isAwaitingTargetGroupState;
- (BOOL)_hasTargetGroupStateBeenMet;
- (void)_targetGroupStateTimeout;
- (void)_setWaitForTargetState;
- (void)_updateWithTargetGroups;
- (void)_setTargetGroupsState:(id)fp8;
- (void)_applyChangesToTemporaryCache:(id)fp8;
- (void)_handleChat:(id)fp8 messageReceived:(id)fp12;
- (void)groupsChanged:(id)fp8 error:(id)fp12;
- (void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (void)updateCapabilities:(unsigned long long)fp8;
- (void)certificateTrustSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)loginStatusChanged:(unsigned int)fp8 message:(id)fp12 reason:(unsigned int)fp16 properties:(id)fp20;
- (void)buddyPropertiesChanged:(id)fp8;
- (void)buddyPictureChanged:(id)fp8 imageData:(id)fp12 imageHash:(id)fp16;
- (void)directIMRequestFrom:(id)fp8 invitation:(id)fp12;
- (void)handleChat:(id)fp8 messageReceived:(id)fp12;
- (void)chat:(id)fp8 member:(id)fp12 statusChanged:(int)fp16;
- (void)handleSubscriptionRequestFrom:(id)fp8;
- (void)chat:(id)fp8 showError:(id)fp12;
- (void)chat:(id)fp8 statusChanged:(int)fp12;
- (id)presentitiesForABPerson:(id)fp8;
- (BOOL)addPresentity:(id)fp8 toABPerson:(id)fp12;
- (BOOL)removePresentity:(id)fp8 fromABPerson:(id)fp12;
- (void)_connectAllPresentities;
- (void)setBuddyProperties:(id)fp8 buddyPictures:(id)fp12;
- (void)_syncWithRemoteBuddies;
- (void)_refreshLoginPresentity;
- (void)hookupToDaemon;
- (void)_serviceDidConnect:(id)fp8;
- (void)_serviceDidReconnect:(id)fp8;
- (void)_serviceDidDisconnect:(id)fp8;

@end

@interface AIMAccount : AbstractAccount
{
    int _dotMacCertifiability;
    DotMacCaps *_dotMacCaps;
}

+ (id)iToolsName;
+ (id)iToolsAccount;
+ (id)defaultBuddylistDescription;
+ (BOOL)nameAppearsToBeDotMac:(id)fp8;
+ (id)service;
+ (BOOL)supportsMultipleConnections;
+ (BOOL)isValidAccount:(id)fp8;
- (void)dealloc;
- (BOOL)isiToolsAccount;
- (BOOL)appearsToBeDotMac;
- (id)proxyPassword;
- (void)setProxyPassword:(id)fp8;
- (id)proxyUser;
- (void)setProxyUser:(id)fp8;
- (id)proxyHost;
- (void)setProxyHost:(id)fp8;
- (int)proxyType;
- (void)setProxyType:(int)fp8;
- (int)proxyPort;
- (void)setProxyPort:(int)fp8;
- (BOOL)hasAskedToEncrypt;
- (void)setHasAskedToEncrypt:(BOOL)fp8;
- (BOOL)showRecentBuddies;
- (void)setShowRecentBuddies:(BOOL)fp8;
- (BOOL)useSystemProxy;
- (void)setUseSystemProxy:(BOOL)fp8;
- (BOOL)useProxy;
- (void)setUseProxy:(BOOL)fp8;
- (int)multiSession;
- (void)setMultiSession:(int)fp8;
- (int)port;
- (void)setPort:(int)fp8;
- (id)server;
- (void)setServer:(id)fp8;
- (void)setPassword:(id)fp8;
- (void)setLogin:(id)fp8;
- (id)description;
- (void)setPendingCertRequest:(BOOL)fp8;
- (BOOL)pendingCertRequest;
- (void)setBackupPassword:(id)fp8;
- (id)backupPassword;
- (int)dotMacCertifiability;
- (void)clearDotMacCaps;
- (void)determineDotMacCertifiability;
- (void)_finishedGettingDotMacCaps:(id)fp8;
- (id)dotMacCaps;
- (BOOL)useSSL;
- (void)setUseSSL:(BOOL)fp8;
- (id)accountImageForPresentity:(id)fp8;
- (id)image;
- (int)invalidSettings;
- (BOOL)canActivate;
- (void)_dotMacCertifiabilityDetermined:(id)fp8;
- (void)askAboutEncryptionIfNecessary;
- (void)_notJustLoggedIn;
- (struct _FZChatRoomValidity)validityOfChatRoomName:(id)fp8;
- (void)showFailedCertificateDialog;
- (void)showForgotPasswordDialog;

@end

@interface AbstractRichTextGenerator (ConcreteAdditions)
+ (Class)generatorClassForAccount:(id)fp8;
@end

@interface AIMLGenerator : AbstractRichTextGenerator
{
}

+ (id)parseHTML:(id)fp8 resultingBGColor:(id *)fp12 resultingFontColor:(id *)fp16 defaultFont:(id)fp20;
+ (id)_generatorString;
+ (id)_bgColorForHTML:(id)fp8;
- (void)_pushHTMLTag;
- (void)_pushBodyTagWithForegroundColor:(id)fp8 backgroundColor:(id)fp12 isRTL:(BOOL)fp16;
- (id)_currentColor;
- (id)_currentBgColor;
- (id)_currentFont;
- (void)_generateTagsWithBold:(id)fp8 italic:(id)fp12 link:(id)fp16 font:(id)fp20 color:(id)fp24 bgColor:(id)fp28 underline:(id)fp32 myName:(id)fp36;
- (id)_brTag;
- (BOOL)_isXHTML;
- (void)_appendTagAttributeWithAttribute:(id)fp8 value:(id)fp12;

@end

@interface AIMLStandardGenerator : AIMLGenerator
{
}

- (void)_pushBodyTagWithForegroundColor:(id)fp8 backgroundColor:(id)fp12 isRTL:(BOOL)fp16;

@end

@interface ARDFileTransferButton : NSButton
{
    id _dragDelegate;
    Presentity *_targetPresentity;
    BOOL _remote;
    BOOL _dropDestination;
}

- (void)_updateImage;
- (void)awakeFromNib;
- (void)dealloc;
- (void)setRemote:(BOOL)fp8;
- (BOOL)isRemote;
- (void)_setDropDestination:(BOOL)fp8;
- (void)setTargetPresentity:(id)fp8;
- (id)targetPresentity;
- (void)_doBlink:(BOOL)fp8;
- (void)_blink:(int)fp8;
- (void)_springLoad;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (void)draggingExited:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (BOOL)wantsPeriodicDraggingUpdates;

@end

@interface ARDButton : ARDFileTransferButton
{
    float _progress;
    NSBezierPath *_arrowPath;
    NSDate *_animationStart;
    NSTimer *_animationTimer;
    float _animationBase;
}

- (void)_updateImage;
- (void)awakeFromNib;
- (void)dealloc;
- (void)_stopAnimation;
- (void)_setNeedsDisplay;
- (float)_animatedProgress;
- (void)_updateAnimation;
- (void)_drawButton;
- (void)_drawArrow;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setProgress:(float)fp8;

@end

@interface AVChatController : NSWindowController
{
    AVChatWindow *_avWindow;
    AnimatingTabView *_phaseTab;
    VolumeIndicator *_volumeIndicator;
    AVSegmentedControl *_chatControls;
    NSSlider *_volumeSlider;
    StretchyImageView *_volumeDownIcon;
    StretchyImageView *_volumeUpIcon;
    NSButton *_textReplyButton;
    VCNotifier *_notifier;
    AVChat *_avChat;
    BOOL _handledAVShutdown;
    BOOL _windowIsClosing;
    ActiveChat *_textReply;
    NSMutableString *_errorReporterLog;
    int _errorCount;
    NSString *_lastError;
    BOOL _displayingPreview;
    VCChannelNegotiation *_ardUpgradeNegotiation;
    BOOL _showedMenuExtra;
    AVRecorder *_recorder;
    NSMutableArray *_recordingFileNames;
    NSMutableArray *_recordingNegotiationQueue;
    NSTimer *_recordingIndicatorTimer;
    BOOL _recordingIndicatorOn;
    NSTabView *_invitedPhaseTabView;
    NSTabView *_sourceTabView;
    NSView *_liveSourceView;
    NSTabViewItem *_liveSourceTabViewItem;
    BOOL _isSilent;
    ABLargeTypeController *_largeTypeController;
}

+ (BOOL)isVideoController;
+ (id)_controllerForChatInitiatedBy:(id)fp8;
+ (id)_warnTitleVideo:(BOOL)fp8 ARD:(BOOL)fp12;
+ (void)_warnWithReason:(id)fp8 video:(BOOL)fp12 ARD:(BOOL)fp16;
+ (void)_warnMaxVideo:(BOOL)fp8;
+ (void)_warnMultiway:(BOOL)fp8 allPeople:(id)fp12 offenders:(id)fp16 offerText:(BOOL)fp20;
+ (id)_controllerWithAVChat:(id)fp8 ardRequest:(id)fp12 notifier:(id)fp16;
+ (id)initiateInvitationTo:(id)fp8 isVideo:(BOOL)fp12 withARDRole:(unsigned int)fp16;
+ (void)_showVideoChatErrorAlert:(id)fp8;
+ (id)buildPersistentInvitationFrom:(id)fp8 isVideo:(BOOL)fp12 notifier:(id)fp16;
+ (id)receiveInvitationFrom:(id)fp8 isVideo:(BOOL)fp12 notifier:(id)fp16;
+ (id)showARDUpgradeRequest:(id)fp8 notifier:(id)fp12;
- (id)description;
- (id)chatControls;
- (void)largeTypeControllerClosing:(id)fp8;
- (void)displayFullScreenString:(id)fp8 forTime:(double)fp12;
- (id)_initWithAVChat:(id)fp8 ardRequest:(id)fp12 notifier:(id)fp16;
- (unsigned int)effectiveARDRole;
- (void)_vcCapsChanged;
- (void)windowDidLoad;
- (void)sendToItunes:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)dealloc;
- (void)windowDidBecomeKeyWindow;
- (void)windowDidResignKeyWindow;
- (id)avChat;
- (id)avWindow;
- (BOOL)isVideo;
- (id)notifier;
- (id)recordingFileNames;
- (id)ardUpgradeNegotiation;
- (void)showSelectedBuddyInfo:(id)fp8;
- (void)showSelectedBuddyProfile:(id)fp8;
- (void)showInAddressBook:(id)fp8;
- (void)addABuddy:(id)fp8;
- (void)startChat:(id)fp8;
- (void)sendMessage:(id)fp8;
- (void)sendDirectMessage:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)sendFile:(id)fp8;
- (id)_buildTextReply;
- (void)textReplyVC:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)acceptAndClearVCNotifier;
- (void)acceptVC:(id)fp8;
- (void)declineVC:(id)fp8;
- (id)textReply;
- (void)_setTextReply:(id)fp8;
- (void)endConference:(id)fp8;
- (void)updatePhaseTabWithState:(unsigned int)fp8;
- (void)endPreview;
- (void)_scheduleToggleRecordingIndicator:(BOOL)fp8;
- (void)_timerToggleRecordingIndicator;
- (void)showRecordingIndicator:(BOOL)fp8;
- (void)_showRecordingIndicatorOn:(BOOL)fp8;
- (void)_updateLocalUI;
- (void)toggleMute:(id)fp8;
- (void)togglePause:(id)fp8;
- (void)volumeChanged:(id)fp8;
- (void)toggleFullScreen:(id)fp8;
- (id)_remotePresentities;
- (void)toggleRecording:(id)fp8;
- (id)layerView;
- (BOOL)isFullScreen;
- (void)_inviteAlertDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)invitePresentities:(id)fp8;
- (void)addParticipant:(id)fp8;
- (id)extraMenuItemsForAVSegmentedControl:(id)fp8;
- (id)extraMenuItemsForChooseBuddyButton:(id)fp8;
- (void)avSegmentedControl:(id)fp8 addPresentity:(id)fp12;
- (id)_filterPresentitiesForAddButton:(id)fp8;
- (id)avSegmentedControl:(id)fp8 filterPresentities:(id)fp12;
- (id)chooseBuddyButton:(id)fp8 filterPresentities:(id)fp12;
- (void)updateAddBuddyButton;
- (void)removeParticipantWithID:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)restoreMenuExtraState;
- (void)postARDNotificationToMenuExtra;
- (void)observeValueForKeyPath:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)ARDUpgradeRequestChangedState;
- (void)finishARDUpgrade;
- (id)shortWindowTitle;
- (id)longWindowTitle;
- (void)_updateWindowTitle;
- (void)windowDidResize:(id)fp8;
- (struct _NSRect)_textReplyWindowFrame;
- (void)positionARDUpgradeRequestWindow;
- (void)tabView:(id)fp8 willSwitchFromTab:(int)fp12 toTab:(int)fp16 effect:(int *)fp20 direction:(int *)fp24;
- (void)_updateAddBuddyButtonState;
- (id)_dragTypes;
- (BOOL)_getInvitablePeople:(id *)fp8 fromPasteboard:(id)fp12;
- (unsigned int)_operationForDrag:(id)fp8 onPartyID:(id)fp12 isFiles:(char *)fp16;
- (BOOL)_performDragOperation:(id)fp8 onPartyID:(id)fp12 confirmFileSend:(BOOL)fp16;
- (id)_errorLogForNoPackets:(id)fp8 isAudio:(BOOL)fp12;
- (id)_errorLogForDict:(id)fp8;
- (id)_sanitizedErrorLogForDict:(id)fp8;
- (void)_addToErrorReporterLog:(id)fp8;
- (void)_membershipChanged;
- (void)avChat:(id)fp8 addedParticipant:(id)fp12;
- (void)avChat:(id)fp8 removedParticipant:(id)fp12;
- (void)avChatParticipantOrderFinalized:(id)fp8;
- (void)logError:(id)fp8 forParticipant:(id)fp12;
- (void)avChat:(id)fp8 participant:(id)fp12 changedFromState:(unsigned int)fp16 toState:(unsigned int)fp20;
- (BOOL)avChat:(id)fp8 startARDClientToParticipant:(id)fp12;
- (void)avChatIrisStateChanged:(id)fp8;
- (void)avChat:(id)fp8 blockedByFileTransfer:(BOOL)fp12;
- (void)avChat:(id)fp8 remoteParticipantMuteOrPausedChanged:(id)fp12;
- (void)avChat:(id)fp8 remoteParticipantNetworkStallChanged:(id)fp12;
- (void)avChatLocalNetworkStallChanged:(id)fp8;
- (void)_securityAlertDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_endChatWithSecurityError;
- (void)avChat:(id)fp8 securityChangedFromLevel:(int)fp12 toLevel:(int)fp16;
- (id)avChat:(id)fp8 bitmapDataForParticipant:(id)fp12;
- (void)avChat:(id)fp8 participantBeganAuxiliaryInput:(id)fp12;
- (void)avChat:(id)fp8 participantEndedAuxiliaryInput:(id)fp12;
- (void)avChat:(id)fp8 participantBeganAuxiliaryReplacement:(id)fp12;
- (void)avChat:(id)fp8 participantEndedAuxiliaryReplacement:(id)fp12;
- (id)errorString;
- (id)errorReporterLog;
- (id)vcErrorReport;
- (void)showErrorReportAndCloseWindowIfNecessaryForChat:(id)fp8;
- (id)_windowForSecurityAlert:(id)fp8;
- (id)secureWindowCertificates:(id)fp8;
- (void)handleShutdownAVConference:(id)fp8;
- (void)_showErrorReporterThenInvoke:(id)fp8;
- (id)defaultSaveName;
- (void)selectPhaseTabWithIdentifier:(id)fp8;
- (void)_recordAudioForAllCurrentParticipants;
- (BOOL)startAVRecorder;
- (void)_requestRecordingPermissionForParticipant:(id)fp8;
- (void)_recordRequestDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)avChat:(id)fp8 participantRequestedRecording:(id)fp12;
- (void)avChat:(id)fp8 participantGrantedRecording:(id)fp12;
- (void)avChat:(id)fp8 participantDeniedRecording:(id)fp12;
- (void)_recordingFailed;
- (void)avChat:(id)fp8 participantBeginRecording:(id)fp12;
- (void)avChat:(id)fp8 participantFinishedRecording:(id)fp12;
- (void)requestRecording;
- (void)stopRecording;
- (void)clearRecordingFileNames;
- (void)setIsSilent:(BOOL)fp8;

@end

@interface ARDClientController : AVChatController
{
    RFBImageView *_clientView;
    ShadowView *_shadowView;
    AVParticipantView *_bannerView;
    NSImageView *_freezeFrame;
    FullScreenWindow *_fullScreenWindow;
}

- (id)windowNibName;
- (void)_prepareBannerIn:(id)fp8;
- (void)_darkenClientView;
- (float)_setARDContentBorder;
- (void)windowDidLoad;
- (void)dealloc;
- (BOOL)isClientConnected;
- (void)_connectClientTo:(id)fp8;
- (void)_disconnectClient;
- (BOOL)avChat:(id)fp8 startARDClientToParticipant:(id)fp12;
- (struct _NSSize)_displaySize;
- (struct _NSSize)_windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12 outset:(BOOL)fp20;
- (struct _NSSize)windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12;
- (struct _NSRect)_windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (void)windowDidResize:(id)fp8;
- (void)_adjustFullScreenClientView;
- (void)_enterFullScreen;
- (BOOL)_endFullScreen;
- (void)toggleFullScreen:(id)fp8;
- (BOOL)shadowView:(id)fp8 mouseDown:(id)fp12;
- (BOOL)validateMenuItem:(id)fp8;
- (void)avChat:(id)fp8 participant:(id)fp12 changedFromState:(unsigned int)fp16 toState:(unsigned int)fp20;
- (void)windowDidBecomeKey;
- (void)windowDidResignKey;
- (void)authenticationSucceededForView:(id)fp8;
- (void)authenticationFailedForView:(id)fp8;
- (void)connectionFailedForView:(id)fp8 error:(const id)fp12;
- (void)viewDidChangeFrame:(id)fp8;
- (void)resolutionDidChangeForView:(id)fp8;
- (void)communicationInterruptedForView:(id)fp8;
- (void)userPictureDidChangeForView:(id)fp8;
- (void)displayInfoDidChangeForView:(id)fp8;
- (void)curtainedStateDidChangeForView:(id)fp8;
- (void)fileTransmitRequestForView:(id)fp8;
- (void)fileReceiveRequestForView:(id)fp8;

@end

@interface AudioChatController : AVChatController <HotKeyHandler>
{
    NSView *_contentContainer;
    NSButton *_recordingButton;
    AbbreviatingTextField *_messageField;
    AbbreviatingTextField *_statusField;
    NSProgressIndicator *_progressIndicator;
    NSView *_ARDWarningView;
    GradientView *_ARDWarningBackground;
    NSImageView *_ARDWarningIconView;
    NSTextField *_ARDWarningField;
    NSBox *_box;
    AudioConferenceView *_conferenceView;
    BOOL _referToConnectionDoctor;
    BOOL _recordingUnderNegotiation;
    BOOL _recordingNegotiationStatusInConferenceView;
    ARDHUDPanel *_hudPanel;
    ARDPIPButton *_hudPIPButton;
}

- (void)awakeFromNib;
- (id)windowNibName;
- (void)_setupARDWarning:(id)fp8;
- (void)_fixGradient;
- (void)_setupTabForARDChat:(id)fp8;
- (void)_removeContentView;
- (void)windowDidLoad;
- (struct _NSRect)window:(id)fp8 willPositionSheet:(id)fp12 usingRect:(struct _NSRect)fp16;
- (void)windowWillClose:(id)fp8;
- (float)_heightForTab:(id)fp8;
- (void)_setupAutoresizingForTabView:(BOOL)fp8;
- (void)_fitPhaseTab;
- (void)_addParticipantsToConferenceView:(id)fp8;
- (void)selectPhaseTabWithIdentifier:(id)fp8;
- (id)_stringForLocalState:(unsigned int)fp8 reason:(unsigned int)fp12;
- (id)longWindowTitle;
- (struct _NSRect)_textReplyWindowFrame;
- (void)showRecordingIndicator:(BOOL)fp8;
- (void)_showRecordingIndicatorOn:(BOOL)fp8;
- (void)_setMessage:(id)fp8;
- (void)showARDWarningHelp:(id)fp8;
- (void)removeParticipantWithID:(id)fp8;
- (void)_ARDServerSessionDidBegin:(BOOL)fp8;
- (void)ARDUpgradeRequestChangedState;
- (void)finishARDUpgrade;
- (void)handleHotKey:(unsigned long)fp8 pressed:(BOOL)fp12;
- (void)dealloc;
- (void)switchView:(id)fp8;
- (void)logError:(id)fp8 forParticipant:(id)fp12;
- (void)avChat:(id)fp8 addedParticipant:(id)fp12;
- (void)avChat:(id)fp8 participant:(id)fp12 changedFromState:(unsigned int)fp16 toState:(unsigned int)fp20;
- (void)avChatIrisStateChanged:(id)fp8;
- (void)_clearMessage;
- (void)_informUserRecordingNegotiationBeginning;
- (void)requestRecording;
- (void)avChat:(id)fp8 participantGrantedRecording:(id)fp12;
- (void)avChat:(id)fp8 participantDeniedRecording:(id)fp12;
- (void)stopRecording;
- (void)avChat:(id)fp8 participantBeginRecording:(id)fp12;
- (void)avChat:(id)fp8 participantFinishedRecording:(id)fp12;

@end

@interface ARDFullScreenClientController : AudioChatController
{
    RFBImageView *_clientView;
    ShadowView *_shadowView;
    NSScrollView *_scrollView;
    BOOL _endConferenceWhenDone;
    BOOL _inTransition;
    BOOL _closeWindowAfterTransition;
    NSWindow *_mainWindow;
    NSImageView *_freezeFrame;
    FullScreenWindow *_fullScreenWindow;
    struct _RectPosition _HUDPosition;
    float _HUDTitleMargin;
    struct _NSRect _cachedLocalVisibleRect;
    struct CGImage *_lastLocalScreenshot;
}

- (void)windowDidLoad;
- (void)dealloc;
- (BOOL)isClientConnected;
- (void)_connectClientTo:(id)fp8;
- (void)_disconnectClient;
- (BOOL)avChat:(id)fp8 startARDClientToParticipant:(id)fp12;
- (BOOL)isShowingRemoteScreen;
- (void)_captureControlForARD;
- (void)_releaseControlFromARD;
- (void)_syncHUDPositionRead:(BOOL)fp8 reflected:(BOOL)fp12;
- (void)_makeARDViewKey;
- (void)transitionDidFinish:(id)fp8;
- (struct _NSRect)_currentHUDContentFrame;
- (struct _NSRect)_HUDContentFrameWithImageSize:(struct _NSSize)fp8 relativeTo:(struct _NSRect)fp16;
- (void)_setHUDContentFrame:(struct _NSRect)fp8 animate:(BOOL)fp24;
- (void)_snapHUDPanel;
- (struct _NSRect)_clientViewFrame;
- (void)_transitionToRemote:(BOOL)fp8 swap:(BOOL)fp12;
- (void)_transitionComplete:(id)fp8;
- (void)_mainWindowDidResignKey:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)_updateControllerState;
- (id)_windowTitleForRemote:(BOOL)fp8;
- (void)_updateControllerStateForRemote:(BOOL)fp8;
- (void)finishARDUpgrade;
- (void)_showControllerAndPrepare;
- (void)_centerRemoteViewInFullScreen;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)transferFile:(id)fp8;
- (void)switchView:(id)fp8;
- (void)showRemoteScreen:(id)fp8;
- (void)showLocalScreen:(id)fp8;
- (void)avChat:(id)fp8 participant:(id)fp12 changedFromState:(unsigned int)fp16 toState:(unsigned int)fp20;
- (void)endConference:(id)fp8;
- (void)_hudPanelWillClose:(id)fp8;
- (void)_hudPanelDidMove:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)tabView:(id)fp8 willSwitchFromTab:(int)fp12 toTab:(int)fp16 effect:(int *)fp20 direction:(int *)fp24;
- (void)_authorizeFileTransferFrom:(id)fp8 to:(id)fp12 toServer:(BOOL)fp16;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)windowDidBecomeKey;
- (void)windowDidResignKey;
- (void)authenticationSucceededForView:(id)fp8;
- (void)authenticationFailedForView:(id)fp8;
- (void)connectionFailedForView:(id)fp8 error:(const id)fp12;
- (void)screenDrawProgressDidUpdateForView:(id)fp8;
- (void)viewDidChangeFrame:(id)fp8;
- (void)resolutionDidChangeForView:(id)fp8;
- (void)communicationInterruptedForView:(id)fp8;
- (void)userPictureDidChangeForView:(id)fp8;
- (void)displayInfoDidChangeForView:(id)fp8;
- (void)curtainedStateDidChangeForView:(id)fp8;
- (void)fileTransmitRequestForView:(id)fp8 localFilePaths:(id)fp12 remoteFilePath:(id)fp16;
- (void)fileReceiveRequestForView:(id)fp8 remoteFilePaths:(id)fp12 localFilePath:(id)fp16;

@end

@interface ARDHUDPanel : NSPanel
{
    BOOL _mouseIsDown;
    BOOL _didPerformMove;
}

- (BOOL)canBecomeKeyWindow;
- (BOOL)canBecomeMainWindow;
- (double)animationResizeTime:(struct _NSRect)fp8;
- (void)_finishWindowDrag;
- (void)sendEvent:(id)fp8;

@end

@interface ARDOverlayContentView : NSView
{
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface CustomFrameSavingWindow : NSWindow
{
    id _frameSaveDelegate;
    NSString *_autosaveFrameName;
    BOOL _restoringWindowFrame;
    BOOL _registered;
}

+ (struct _NSRect)autosavedRectForFrameName:(id)fp8;
+ (void)saveRect:(struct _NSRect)fp8 forFrameName:(id)fp24;
- (void)_restoreFrameFromAutosaveName;
- (struct _NSRect)savedFrameForName:(id)fp8;
- (struct _NSRect)savedFrame;
- (id)targetedFrameAutosaveName;
- (void)dealloc;
- (void)setTargetedFrameAutosaveName:(id)fp8;
- (id)frameSaveDelegate;
- (void)setFrameSaveDelegate:(id)fp8;
- (id)targetView;
- (struct _NSRect)rectToSave;
- (void)saveFrameIfNecessary;
- (void)_customWindowDidMoveNotification:(id)fp8;
- (void)_customWindowDidResizeNotification:(id)fp8;

@end

@interface SecureWindow : CustomFrameSavingWindow
{
    AbbreviatingTextField *_titleView;
    SecureWindowTitleCell *_titleCell;
    LockButton *_lockButton;
    Animator *_animator;
    float _expandPhase;
    BOOL _expanded;
    BOOL _animates;
    id _certDelegate;
}

- (id)initWithContentRect:(struct _NSRect)fp8 styleMask:(unsigned int)fp24 backing:(unsigned int)fp28 defer:(BOOL)fp32;
- (void)awakeFromNib;
- (void)dealloc;
- (float)_minXCoord;
- (float)_collapsedBoundry;
- (float)_expandedBoundry;
- (float)_expandPhase;
- (struct _NSRect)_lockButtonFrame;
- (void)_adjustLockButtonFrame;
- (void)_setupLockButton;
- (BOOL)_isTitleHidden;
- (id)_customTitleCell;
- (struct _NSRect)_realTitleFrame;
- (struct _NSRect)_customTitleFrame;
- (void)_adjustTitleCellFrame;
- (void)_setupTitleView;
- (void)_adjustTitleBarViews;
- (void)setAnimates:(BOOL)fp8;
- (BOOL)animates;
- (void)_lockClicked:(id)fp8;
- (void)animator:(id)fp8 doStep:(float)fp12 lastStep:(BOOL)fp16;
- (void)windowDidResize:(id)fp8;
- (BOOL)isLockExpanded;
- (void)expandLock:(BOOL)fp8;
- (BOOL)isLockVisible;
- (void)showLock:(BOOL)fp8;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (void)setUsesWhiteLockButton:(BOOL)fp8;
- (BOOL)usesWhiteLockButton;
- (void)setLockTitle:(id)fp8;
- (id)lockTitle;
- (id)lockButton;
- (void)setCertificateDelegate:(id)fp8;
- (id)certificateDelegate;
- (id)_certificates;
- (id)_trustPolicies;
- (void)_updateLockUI;
- (void)showCertificates;
- (void)certificatesChanged;
- (void)certificateSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (id)_secureWindowMenuTitle:(id)fp8;

@end

@interface AVChatWindow : SecureWindow
{
    double _resizeTime;
}

- (id)initWithContentRect:(struct _NSRect)fp8 styleMask:(unsigned int)fp24 backing:(unsigned int)fp28 defer:(BOOL)fp32;
- (void)setConstantAnimationResizeTime:(double)fp8;
- (double)animationResizeTime:(struct _NSRect)fp8;
- (void)becomeKeyWindow;
- (void)resignKeyWindow;
- (void)setAlphaValue:(float)fp8;

@end

@interface ARDOverlayWindow : AVChatWindow
{
}

- (id)initWithContentRect:(struct _NSRect)fp8 styleMask:(unsigned int)fp24 backing:(unsigned int)fp28 defer:(BOOL)fp32;
- (BOOL)canBecomeKeyWindow;
- (BOOL)canBecomeMainWindow;
- (void)setTitle:(id)fp8;
- (void)configureContentView;

@end

@interface ARDPIPButton : NSButton
{
    id _dragDelegate;
    BOOL _remote;
    BOOL _dropDestination;
    NSString *_remoteName;
    NSTrackingArea *_trackingArea;
    NSExtendedBox *_labelBox;
    AbbreviatingTextField *_label;
}

- (void)awakeFromNib;
- (void)dealloc;
- (id)hitTest:(struct _NSPoint)fp8;
- (void)setFrameSize:(struct _NSSize)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (void)_updateTracking;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)_setLabelText:(id)fp8;
- (void)_setDropDestination:(BOOL)fp8;
- (void)setRemote:(BOOL)fp8;
- (BOOL)isRemote;
- (void)setRemoteName:(id)fp8;
- (id)remoteName;
- (void)_doBlink:(BOOL)fp8;
- (void)_blink:(int)fp8;
- (void)_springLoad;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (void)draggingExited:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (BOOL)wantsPeriodicDraggingUpdates;

@end

@interface AVChat : NSObject <VideoConferenceDelegateProtocol, FrameListener>
{
    BOOL _suppressBeginChat;
    NSMutableArray *_participants;
    Presentity *_initiator;
    AVChatParticipant *_localParticipant;
    unsigned int _localState;
    AVChatController *_owner;
    AVChatController *_ardUpgradeController;
    BOOL _isCaller;
    unsigned int _sessionID;
    BOOL _isVideo;
    BOOL _dataOut;
    BOOL _dataIn;
    BOOL _didRemoteMute;
    BOOL _didRemotePause;
    BOOL _localNetworkStall;
    BOOL _remoteNetworkStall;
    BOOL _participantOrderFinal;
    int _addableParticipants;
    int _addStatus;
    int _errorCode;
    NSDictionary *_errorDict;
    NSDate *_dateCreated;
    NSDate *_dateEnded;
    NSString *_participantNames;
    FZVideoConferenceController *_vcc;
    NSData *_connectData;
    NSDictionary *_callerProperties;
    NSMutableDictionary *_unknownPartyStates;
    int _securityLevel;
    BOOL _securityExpectedByInitiator;
    BOOL _isListening;
    BOOL _isCounterProposalConnect;
    BOOL _hasPendingAccept;
    BOOL _hasPendingInit;
    BOOL _isTerminating;
    BOOL _iTunesStateChanged;
    BOOL _needToSendEndConferenceNotification;
    BOOL _Q8IrisOpen;
    int _fileTransferState;
    NSTimer *_screenSaverBlockingTimer;
    BOOL _usingCoercedIDs;
    NSString *_GUID;
    BOOL _silentConference;
    BOOL _recordingRequested;
    NSMutableDictionary *_recordingNegotiations;
    unsigned int _lastRecordingNegotiationID;
    NSMutableDictionary *_vcPartyIDToRecordingNegotiationID;
    unsigned int _oldAVManagerState;
    BOOL _auxVideoRunningOrUnderNegotiation;
    BOOL _auxInputAllowed;
    BOOL _watchingForFirstAuxFrame;
}

+ (int)maxRemoteParticipantsVideo:(BOOL)fp8;
+ (id)allowedClassesForArchives;
+ (void)_updateActiveConference;
+ (id)chatWithSessionID:(unsigned int)fp8;
+ (id)chatList;
+ (id)connectedChat;
+ (id)activeChat;
+ (BOOL)activeChatPreventsTheater;
+ (BOOL)_anyOfTheseParticipants:(id)fp8 matchAnyOfThesePresentities:(id)fp12;
+ (BOOL)isPresentityInActiveConference:(id)fp8;
+ (id)avChatInvitedByPresentity:(id)fp8;
+ (id)avChatWaitingForReplyFromPresentity:(id)fp8;
+ (void)endAllChats;
+ (void)_blockConnectedConferenceByFileTransfer:(BOOL)fp8;
+ (void)fileTransferDidStart;
+ (void)fileTransferDidEnd;
+ (void)_doSendUpdate;
+ (void)_sendUpdate;
+ (id)currentAVChatInfo;
+ (void)getVideoStillForPresentity:(id)fp8 data:(id *)fp12 result:(unsigned int *)fp16;
+ (BOOL)isStateFinal:(unsigned int)fp8;
+ (BOOL)isStateActive:(unsigned int)fp8;
+ (id)vcResponseInfoWithSessionID:(unsigned int)fp8 ICEData:(id)fp12 ardChannelInfo:(id)fp16 forParticipant:(id)fp20;
+ (id)vcResponseInfoWithSessionID:(unsigned int)fp8 ICEData:(id)fp12 ardChannelInfo:(id)fp16;
+ (id)vcResponseInfoWithSessionID:(unsigned int)fp8;
- (void)_updatePresentityInBuddyList:(id)fp8;
- (void)_noteStatusChangesForParticipant:(id)fp8;
- (void)_insertRemoteParticipant:(id)fp8 atIndex:(unsigned int)fp12;
- (void)_removeRemoteParticipant:(id)fp8;
- (BOOL)_moveVCPartyID:(id)fp8 toIndex:(unsigned int)fp12 inCount:(unsigned int)fp16;
- (void)_finalizeParticipantOrder:(id)fp8 andNotify:(BOOL)fp12;
- (id)_processNuggets:(id)fp8 filterEndedState:(BOOL)fp12 convertFromDict:(BOOL)fp16;
- (void)_removeParticipantsNotInNuggets:(id)fp8;
- (void)_updateParticipantsWithData:(id)fp8;
- (BOOL)_presentitiesRequireCoercedIDs:(id)fp8;
- (void)_initParticipantsWithPresentities:(id)fp8 ARDRole:(unsigned int)fp12;
- (void)_initParticipantsWithNuggets:(id)fp8;
- (BOOL)_participantsCheckOut;
- (id)initPersistentAVChatWith:(id)fp8 invitedBy:(id)fp12 ARDRole:(unsigned int)fp16 sessionID:(unsigned int)fp20 video:(BOOL)fp24;
- (id)_initWith:(id)fp8 invitedBy:(id)fp12 ARDRole:(unsigned int)fp16 sessionID:(unsigned int)fp20 video:(BOOL)fp24 extraProperties:(id)fp28;
- (void)_setCallerProperties:(id)fp8;
- (id)initIncomingFrom:(id)fp8 isVideo:(BOOL)fp12 callerProperties:(id)fp16;
- (id)initOutgoingTo:(id)fp8 isVideo:(BOOL)fp12 ARDRole:(unsigned int)fp16;
- (void)_participantBeginRecording:(id)fp8 withID:(unsigned int)fp12;
- (void)_participantFinishedRecording:(id)fp8 withID:(unsigned int)fp12;
- (BOOL)recordingRequested;
- (void)_requestRecordingOnBehalfOf:(id)fp8 withID:(unsigned int)fp12;
- (void)requestRecording;
- (void)respondToRecordingRequestFromParticipant:(id)fp8 canRecord:(BOOL)fp12;
- (void)_participantRequestedRecording:(id)fp8 withID:(unsigned int)fp12;
- (void)_participantDeniedRecording:(id)fp8 forParticipant:(id)fp12 withID:(unsigned int)fp16;
- (void)_broadcastRecordingBeginForParticipant:(id)fp8 withID:(unsigned int)fp12;
- (void)_participantGrantedRecording:(id)fp8 forParticipant:(id)fp12 withID:(unsigned int)fp16;
- (void)recordingFinished;
- (void)_sendRecordingMessageToParticipant:(id)fp8 type:(unsigned int)fp12 forParticipant:(id)fp16 onBehalfOf:(id)fp20 withID:(unsigned int)fp24;
- (void)_handleRecordingMessageFromParticipant:(id)fp8 type:(unsigned int)fp12 userInfo:(id)fp16;
- (void)_prepareConnectionForParticipant:(id)fp8;
- (void)handleGenericAVMessageFromParticipant:(id)fp8 type:(unsigned int)fp12 userInfo:(id)fp16;
- (void)_destroyTimer:(id *)fp8;
- (void)dealloc;
- (id)description;
- (void)setOwner:(id)fp8;
- (void)unsetOwner:(id)fp8;
- (void)setARDUpgradeController:(id)fp8;
- (void)_blockByFileTransfer:(BOOL)fp8;
- (BOOL)isBlockedByFileTransfer;
- (id)owner;
- (id)ARDUpgradeController;
- (id)presentity;
- (unsigned int)sessionID;
- (void)setGUID:(id)fp8;
- (id)GUID;
- (id)callerProperties;
- (id)otherPresentity;
- (id)account;
- (id)initiatorPresentity;
- (id)initiatorParticipant;
- (id)localParticipant;
- (id)participants;
- (id)remoteParticipants;
- (int)numActiveParticipants;
- (BOOL)_allParticipantsUsingICE;
- (void)_refreshAddableParticipants;
- (int)addableParticipants;
- (int)addStatus;
- (id)stringForAddStatus:(int)fp8;
- (id)stringForAddStatus;
- (int)addStatusForPresentity:(id)fp8 asVideo:(BOOL)fp12 ardRole:(unsigned int)fp16;
- (BOOL)canAddPresentity:(id)fp8;
- (id)participantMatchingPresentity:(id)fp8;
- (id)_participantMatchingVCPartyID:(id)fp8;
- (id)vcPartyIDForPresentity:(id)fp8;
- (id)participantWithID:(id)fp8;
- (void)removeParticipantWithID:(id)fp8;
- (id)orderedRemotePartyIDs;
- (void)finalizeOrderWithVideoFrom:(id)fp8;
- (void)setConferenceSilent:(BOOL)fp8;
- (BOOL)isConferenceSilent;
- (BOOL)isCaller;
- (BOOL)isVideo;
- (BOOL)isAOLInterop;
- (int)securityLevel;
- (int)_theoreticalSecurityLevel;
- (int)_currentSecurityLevel;
- (void)_updateSecurity;
- (void)_setupIdentity;
- (void)_serviceCapsChanged:(id)fp8;
- (id)_currentAVChatInfo;
- (void)startARDClientToParticipant:(id)fp8;
- (void)sendARDFileTransferAuthorization:(id)fp8 to:(id)fp12;
- (BOOL)isStateFinal;
- (BOOL)isActive;
- (unsigned int)localState;
- (void)_setCreationDate;
- (void)setDateCreated:(id)fp8;
- (id)dateCreated;
- (void)setDateEnded:(id)fp8;
- (id)dateEnded;
- (void)_blockScreenSaver:(id)fp8;
- (void)_subscribeToVCNotifications;
- (void)beginChat;
- (void)endChat;
- (void)endChatWithReason:(unsigned int)fp8;
- (void)endChatWithError:(int)fp8;
- (void)_endChatWithReason:(unsigned int)fp8 andError:(int)fp12;
- (void)_setStateDisconnected;
- (BOOL)dataOut;
- (BOOL)dataIn;
- (unsigned int)ardRole;
- (void)participant:(id)fp8 changedFromState:(unsigned int)fp12 toState:(unsigned int)fp16;
- (id)inviteesInfoAsPlist:(BOOL)fp8;
- (void)inviteAll;
- (void)cancelInvitation;
- (void)_sendVCUpdateTo:(id)fp8 skipConnected:(BOOL)fp12;
- (void)invite:(id)fp8;
- (void)acceptInvitation:(BOOL)fp8;
- (BOOL)connectDataIsProbablyNAT;
- (void)_connectTo:(id)fp8 withData:(id)fp12;
- (void)startVCOnMainThread:(id)fp8;
- (void)_reportError:(id)fp8;
- (void)_counterPropose:(id)fp8;
- (void)_configureVCCRecv;
- (void)_configureVCC;
- (void)connectProc:(id)fp8;
- (int)errorCode;
- (id)errorDictionary;
- (void)_setErrorDictionary:(id)fp8;
- (void)_setActiveConference;
- (unsigned int)sessionId;
- (id)vcErrorReport;
- (void)setMute:(BOOL)fp8;
- (BOOL)isMute;
- (void)toggleMute;
- (void)setPaused:(BOOL)fp8;
- (BOOL)isPaused;
- (void)togglePaused;
- (BOOL)isQ8IrisOpen;
- (void)setRemoteMute:(BOOL)fp8;
- (BOOL)isRemoteMute;
- (void)toggleRemoteMute;
- (void)setRemotePaused:(BOOL)fp8;
- (BOOL)isRemotePaused;
- (void)toggleRemotePaused;
- (BOOL)isChatMute;
- (void)toggleChatMute;
- (BOOL)isChatPaused;
- (void)toggleChatPaused;
- (BOOL)didRemoteMute;
- (BOOL)didRemotePause;
- (BOOL)isLocalNetworkStalled;
- (BOOL)isRemoteNetworkStalled;
- (float)audioVolume;
- (void)setAudioVolume:(float)fp8;
- (BOOL)notifySystemVC:(BOOL)fp8;
- (void)_presentityStatusChanged:(id)fp8;
- (void)_initiatorInfoChanged:(id)fp8;
- (void)_inviteeInfoChanged:(id)fp8;
- (BOOL)_checkVCResponseDict:(id)fp8;
- (void)_mainThreadFinishPrepareConnectionForInvitedParty:(id)fp8;
- (void)_threadedPrepareConnectionForInvitedParty:(id)fp8;
- (void)handleVideoConferenceNotification:(id)fp8;
- (void)_unknownParty:(id)fp8 didConnect:(BOOL)fp12;
- (void)_unknownParty:(id)fp8 muteOrPause:(unsigned int)fp12 didChange:(BOOL)fp16;
- (void)_vccInitDidFinish;
- (void)vcc:(id)fp8 initiateConferenceStartedForParty:(id)fp12;
- (void)_vccInitiateConferenceCompleted:(id)fp8;
- (void)vcc:(id)fp8 initiateConferenceCompletedForParty:(id)fp12 partyInfo:(id)fp16;
- (void)_partyConnected:(id)fp8;
- (void)vcc:(id)fp8 partyConnected:(id)fp12;
- (void)_partyHungUp:(id)fp8;
- (void)vcc:(id)fp8 partyHungUp:(id)fp12;
- (void)_partyDidMute:(id)fp8;
- (void)vcc:(id)fp8 party:(id)fp12 didMute:(BOOL)fp16;
- (void)_partyDidPause:(id)fp8;
- (void)vcc:(id)fp8 party:(id)fp12 didPause:(BOOL)fp16;
- (void)_partyCancelled:(id)fp8;
- (void)vcc:(id)fp8 partyCancelled:(id)fp12;
- (void)vcc:(id)fp8 conferenceAttempted:(id)fp12;
- (void)_insufficientBandwidth:(id)fp8;
- (void)vccInsufficientBandwidth:(id)fp8 forParty:(id)fp12 partyInfo:(id)fp16;
- (void)_networkTimeout:(id)fp8;
- (void)vccNetworkTimeout:(id)fp8;
- (void)_localVideoError:(id)fp8;
- (void)vccLocalVideoError:(id)fp8;
- (void)_noPackets:(id)fp8;
- (void)vcc:(id)fp8 noPacketsFromParty:(id)fp12 partyInfo:(id)fp16;
- (void)_networkStall:(id)fp8;
- (void)vcc:(id)fp8 party:(id)fp12 didStall:(BOOL)fp16;
- (void)_getLocalVCConnectionData:(id)fp8;
- (id)getLocalVCConnectionDataForRemoteUserID:(id)fp8;
- (id)_shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8;
- (BOOL)shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8 callbackInfo:(id)fp12;
- (BOOL)shouldAcceptIncomingVideoConferenceRequestFromUser:(id)fp8;
- (void)_networkValidateCertificateDataForUser:(id)fp8;
- (BOOL)vcc:(id)fp8 isRemoteCertificateValid:(struct OpaqueSecCertificateRef *)fp12 forUser:(id)fp16;
- (BOOL)vcc:(id)fp8 isUserLikelyAIM59OrBelow:(id)fp12;
- (void)_networkSecurityChangedForUser:(id)fp8;
- (void)vcc:(id)fp8 securityChangedForUser:(id)fp12;
- (void)vccLocalCertNotAccepted:(id)fp8;
- (void)_partyHasInvalidCert:(id)fp8;
- (void)vccRemoteCertNotAccepted:(id)fp8 forParty:(id)fp12;
- (BOOL)isAuxVideoRunningOrUnderNegotiation;
- (void)setAuxVideoRunningOrUnderNegotiation:(BOOL)fp8;
- (BOOL)_shouldAllowAuxVideoIncoming:(BOOL)fp8;
- (void)_userRequestedAuxiliaryInput:(id)fp8;
- (BOOL)vcc:(id)fp8 userRequestedAuxiliaryInput:(id)fp12;
- (void)_user:(id)fp8 approvedAuxiliaryInput:(BOOL)fp12;
- (void)_userApprovedAuxiliaryInput:(id)fp8;
- (void)_userDeclinedAuxiliaryInput:(id)fp8;
- (void)vcc:(id)fp8 user:(id)fp12 approvedAuxiliaryInput:(BOOL)fp16;
- (void)_userEndedAuxiliaryInput:(id)fp8;
- (void)_userBeganAuxiliaryInput:(id)fp8;
- (void)vcc:(id)fp8 userBeganAuxiliaryInput:(id)fp12;
- (void)vcc:(id)fp8 userEndedAuxiliaryInput:(id)fp12;
- (void)readyForSideshow;
- (void)_startSideshow;
- (void)_setupAuxVideo;
- (void)_watchForFirstAuxFrame:(BOOL)fp8;
- (void)frameNotifier:(id)fp8 postedNewFrame:(id)fp12 fromSource:(id)fp16;
- (void)_endAuxInput;
- (void)_auxVideoReceiverChangedState:(id)fp8;
- (void)_auxVideoReceiverChangedReplacementMode:(id)fp8;
- (void)invalidateParticipantNames;
- (id)participantNames;

@end

@interface AVChat (Scripting)
- (id)scriptID;
- (id)scriptService;
- (id)scriptAVType;
- (id)scriptScreenSharingRole;
- (id)scriptParticipants;
- (id)scriptShowFullScreen;
- (void)setScriptShowFullScreen:(id)fp8;
- (id)scriptShowLocalVideo;
- (void)setScriptShowLocalVideo:(id)fp8;
- (id)scriptPaused;
- (void)setScriptPaused:(id)fp8;
- (id)scriptMuted;
- (void)setScriptMuted:(id)fp8;
- (id)scriptStarted;
- (id)scriptUpdated;
- (id)scriptInvitation;
- (id)scriptSecure;
- (id)scriptActive;
- (id)scriptAVConnectionState;
- (id)objectSpecifier;
- (void)stopChatScriptCommand:(id)fp8;
- (void)requestRecordingScriptCommand:(id)fp8;
- (void)stopRecordingScriptCommand:(id)fp8;
- (void)acceptInvitationScriptCommand:(id)fp8;
- (void)declineInvitationScriptCommand:(id)fp8;
- (void)takeVideoSnapshotScriptCommand:(id)fp8;
@end

@interface ExtendedOperation : NSOperation
{
    NSThread *_operationThread;
    NSString *_operationName;
    unsigned int _operationState;
    double _operationTimeout;
    NSMutableSet *_childOperations;
}

- (void)dealloc;
- (void)_setState:(unsigned int)fp8;
- (unsigned int)_maxChildOperationState;
- (unsigned int)_minChildOperationState;
- (void)_startThread;
- (void)start;
- (void)_threadedMain;
- (void)observeValueForKeyPath:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)addChildOperation:(id)fp8;
- (void)createChildOperations;
- (void)didFinish;
- (void)setName:(id)fp8;
- (id)name;
- (void)setTimeout:(double)fp8;
- (double)timeout;
- (void)_stopWithState:(unsigned int)fp8;
- (void)_timeout;
- (void)fail;
- (void)cancel;
- (unsigned int)state;
- (BOOL)isConcurrent;
- (BOOL)isExecuting;
- (BOOL)isFinished;

@end

@interface AVChatCancelInvitationOp : ExtendedOperation
{
    Presentity *_presentity;
}

- (id)initWithPresentity:(id)fp8;
- (void)dealloc;
- (void)didFinish;

@end

@interface AVChatController (Scripting)
- (void)acceptInvitationScriptCommand:(id)fp8;
- (void)declineInvitationScriptCommand:(id)fp8;
@end

@interface AVChatNegotiationOp : ExtendedOperation
{
    AVChatParticipant *_participant;
    BOOL _useICE;
    FetchICEDataOp *_fetchICEDataOp;
    ExtendedOperation *_ardChannelOp;
    NSDictionary *_result;
}

- (id)initWithParticipant:(id)fp8;
- (void)dealloc;
- (void)createChildOperations;

@end

@interface AVChatResponseOp : AVChatNegotiationOp
{
    int _response;
    NSDictionary *_callerProperties;
    unsigned int _sessionID;
}

- (void)dealloc;
- (id)initWithParticipant:(id)fp8 response:(int)fp12;
- (void)createChildOperations;
- (void)_sendMessageToBuddy:(id)fp8 result:(id)fp12;
- (void)didFinish;
- (void)main;

@end

@interface AVChatCounterProposalOp : AVChatResponseOp
{
}

- (void)_sendMessageToBuddy:(id)fp8 result:(id)fp12;

@end

@interface AVChatInvitationOp : AVChatNegotiationOp
{
    NSMutableDictionary *_inviteesInfo;
    BOOL _audioOnly;
}

- (id)initWithParticipant:(id)fp8;
- (void)dealloc;
- (void)createChildOperations;
- (void)didFinish;
- (void)main;

@end

@interface AVChatParticipant : NSObject
{
    Presentity *_presentity;
    Presentity *_inviter;
    AVChat *_avChat;
    BOOL _sendingAudio;
    BOOL _sendingVideo;
    BOOL _sendingAuxVideo;
    unsigned int _ardRole;
    BOOL _audioMuted;
    BOOL _videoPaused;
    BOOL _networkStalled;
    unsigned int _state;
    unsigned int _chatEndedReason;
    int _chatError;
    NSString *_rawErrorString;
    NSString *_errorString;
    NSData *_localICEData;
    NSData *_remoteICEData;
    VCChannel *_ARDChannel;
    BOOL _usingICE;
    VCChannelNegotiation *_ARDChannelNegotiation;
    NSData *_ARDEncryptionKey;
    BOOL _ARDAuthorized;
    NSMutableDictionary *_incomingVCChannelNegotiations;
    NSMutableDictionary *_outgoingVCChannelNegotiations;
    NSOperationQueue *_messagingQueue;
    NSTimer *_connectTimeoutTimer;
    BOOL _isInitiator;
    BOOL _isAOLInterop;
    BOOL _isRecording;
    NSString *_vcPartyID;
    struct OpaqueSecCertificateRef *_savedCertificate;
    unsigned int _ARDFileTransferIndex;
    NSMutableIndexSet *_ARDFileTransferUsedIndexes;
    struct {
        int thing1;
        int thing2[2];
    } *_RFBConnectionResult;
}

- (id)description;
- (id)init;
- (id)_initAs:(id)fp8 invitedBy:(id)fp12 sendingAudio:(BOOL)fp16 sendingVideo:(BOOL)fp20 usingICE:(BOOL)fp24 ARDRole:(unsigned int)fp28 toChat:(id)fp32 inState:(unsigned int)fp36 withError:(int)fp40 andReason:(unsigned int)fp44 andVCPartyID:(id)fp48;
- (id)initAs:(id)fp8 invitedBy:(id)fp12 ARDRole:(unsigned int)fp16 toChat:(id)fp20;
- (id)initWithStatusNugget:(id)fp8 andChat:(id)fp12;
- (void)_cleanupARDResult;
- (void)disconnectFromAVChat;
- (void)dealloc;
- (id)presentity;
- (id)invitedBy;
- (id)avChat;
- (id)name;
- (BOOL)isInitiator;
- (BOOL)isLocalParticipant;
- (unsigned int)reasonChatEnded;
- (int)error;
- (id)remoteErrorParticipant;
- (void)_getErrorString:(id *)fp8 rawString:(id *)fp12 forError:(int)fp16;
- (void)_generateErrorStrings;
- (id)rawErrorString;
- (id)errorString;
- (id)errorStringFor:(int)fp8;
- (void)_setError:(int)fp8;
- (void)_enqueueOperation:(id)fp8;
- (void)sendInvitation;
- (void)cancelInvitation;
- (void)sendVCUpdate;
- (void)sendResponse:(int)fp8;
- (void)sendCounterProposal;
- (void)setWaitingToConnect:(BOOL)fp8;
- (void)_connectTimeout:(id)fp8;
- (id)outgoingARDUpgradeRequest;
- (void)requestARDUpgrade:(unsigned int)fp8;
- (void)ARDChannelDidConnect:(id)fp8;
- (void)setARDRole:(unsigned int)fp8;
- (BOOL)createVCChannelRequestWithInfo:(id)fp8 isUpgrade:(BOOL)fp12;
- (void)handleVCChannelMessage:(unsigned int)fp8 userInfo:(id)fp12;
- (void)setRemoteICEData:(id)fp8;
- (id)remoteICEData;
- (id)getLocalICEData;
- (BOOL)isUsingICE;
- (CDAnonymousStruct3 *)_newConnectionAuthorization;
- (void)_authorizeARDClientIfPossible;
- (void)_connectClientIfPossible;
- (void)authorizeARDClient;
- (void)setARDAuthorized;
- (id)ARDChannelNegotiation;
- (void)observeValueForKeyPath:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)closeARDChannel;
- (BOOL)isSendingAudio;
- (BOOL)isSendingVideo;
- (BOOL)isSendingAuxVideo;
- (void)setSendingAuxVideo:(BOOL)fp8;
- (unsigned int)ardRole;
- (BOOL)isAudioMuted;
- (void)setAudioMuted:(BOOL)fp8;
- (BOOL)isVideoPaused;
- (void)setVideoPaused:(BOOL)fp8;
- (BOOL)isNetworkStalled;
- (void)setNetworkStalled:(BOOL)fp8;
- (BOOL)isAOLInterop;
- (void)setAOLInterop:(BOOL)fp8;
- (BOOL)isRecording;
- (void)setRecording:(BOOL)fp8;
- (id)vcPartyID;
- (void)setVCPartyID:(id)fp8;
- (id)statusNugget;
- (struct OpaqueSecCertificateRef *)certificate;
- (void)setSavedCertificate:(struct OpaqueSecCertificateRef *)fp8;
- (void)requestIconIfNecessary;
- (void)_doARDFileTransferSource:(id)fp8 destination:(id)fp12 send:(BOOL)fp16;
- (void)sendARDFileTransferAuthorizationSource:(id)fp8 destination:(id)fp12 toServer:(BOOL)fp16;
- (BOOL)_checkARDFileTransferIndex:(unsigned int)fp8;
- (void)authorizeARDFileTransfer:(id)fp8;
- (id)connectedUDPSocket;
- (id)encryptionKey;
- (id)remoteIPPort;
- (unsigned int)state;
- (void)setState:(unsigned int)fp8;
- (void)setStateToEndedWithReason:(unsigned int)fp8 andError:(int)fp12;
- (void)_setState:(unsigned int)fp8 withReason:(unsigned int)fp12 andError:(int)fp16;

@end

@interface AVChatParticipantStatusNugget : NSObject <NSCoding>
{
    NSString *_presentityName;
    NSString *_presentityID;
    NSString *_invitedBy;
    NSString *_vcPartyID;
    BOOL _sendingAudio;
    BOOL _sendingVideo;
    BOOL _usingICE;
    unsigned int _ardRole;
    unsigned int _state;
    int _error;
    unsigned int _reason;
}

+ (id)nuggetWithDictionaryDescription:(id)fp8;
- (id)initWithParticipant:(id)fp8;
- (void)_configureWithDictionaryDescription:(id)fp8;
- (id)dictionaryDescription;
- (void)dealloc;
- (id)name;
- (id)ID;
- (id)invitedBy;
- (id)vcPartyID;
- (BOOL)sendingAudio;
- (BOOL)sendingVideo;
- (BOOL)isUsingICE;
- (unsigned int)ardRole;
- (unsigned int)state;
- (int)error;
- (unsigned int)reason;
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;

@end

@interface AVChatUpdateOp : ExtendedOperation
{
    Presentity *_presentity;
    NSData *_updateData;
}

- (id)initWithPresentity:(id)fp8 data:(id)fp12;
- (void)dealloc;
- (void)didFinish;

@end

@interface AVCloseButton : NSButton
{
    BOOL _small;
}

- (void)_configureImages;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)setSmall:(BOOL)fp8;
- (void)setMouseOver:(BOOL)fp8;
- (void)setMouseOver:(BOOL)fp8 down:(BOOL)fp12;
- (void)mouseDown:(id)fp8;

@end

@interface AVParticipantView : NSView
{
    AVChatParticipant *_participant;
    BOOL _isLocalParticipant;
    BOOL _invitedByMe;
    BOOL _isNotifier;
    Presentity *_jabberPresentity;
    FileTransfer *_fileTransfer;
    VCChannelNegotiation *_ardUpgradeNegotiation;
    BOOL _hasDropHighlight;
    BOOL _whiteText;
    int _stage;
    int _previousStage;
    int _recordingStage;
    NSTimer *_recordingMessageTimer;
    Animator *_animator;
    float _animationDistance;
    int _configurationAt;
    int _configurationTo;
    int _configurationNext;
    int _viewTag;
    int _buttonTag;
    NSView *_invitedContainer;
    NSExtendedBox *_invitedBGView;
    AbbreviatingTextField *_invitedNameField;
    AbbreviatingTextField *_invitedStatusField;
    NSView *_connectedContainer;
    NSTabView *_connectedTabView;
    AbbreviatingTextField *_connectedNameField;
    AVCloseButton *_connectedCloseButton;
    VolumeIndicator *_vuMeter;
    NSTextField *_connectedARDField;
    MultiBuddyImageView *_connectedIconView;
    ShadowView *_shadowView;
    NSView *_statusContainer;
    NSExtendedBox *_statusBGView;
    MultiBuddyImageView *_statusIconView;
    AbbreviatingTextField *_statusLine1;
    AbbreviatingTextField *_statusLine2;
    ProgressSpinner *_spinner;
    AVCloseButton *_closeButton;
    Animator *_spinnerAnimator;
    float _statusTextDwForSpinner;
    StretchyImageView *_notifierGreenBGView;
    StretchyImageView *_notifierMediumView;
    NSTextField *_notifierNumberField;
    Animator *_notifierAnimator;
    BOOL _hasShownTimestamp;
}

+ (id)centeredImageFromBaseImageName:(id)fp8 overlayColor:(id)fp12 inRect:(struct _NSRect)fp16 maxSize:(struct _NSSize)fp32 inView:(id)fp40;
- (void)_removeInvitedContainer;
- (void)_removeConnectedContainer;
- (void)willBeRemoved;
- (id)_notificationString:(id)fp8;
- (void)_setupInvitedContainer;
- (void)_startVUMeter;
- (void)_arrangeAudioOnlyUI;
- (void)_showBuddyPictureShadow:(BOOL)fp8;
- (void)_setupAudioOnlyUI;
- (void)resizeSubviewsWithOldSize:(struct _NSSize)fp8;
- (void)_pictureChanged:(id)fp8;
- (void)_setupConnectedContainer;
- (void)_setStatusTextColor:(id)fp8;
- (void)_setStatusTextAlpha:(float)fp8;
- (void)setStatusText:(id)fp8;
- (void)_insetView:(id)fp8 left:(float)fp12 right:(float)fp16;
- (id)_remoteParticipantNames;
- (void)showTimeField;
- (void)_getEffectiveEndedReason:(unsigned int *)fp8 error:(int *)fp12;
- (id)_callerParticipant;
- (void)_setupStatusContainer;
- (id)_initWithParticipant:(id)fp8 jabberPresentity:(id)fp12 fileTransfer:(id)fp16 isNotifier:(BOOL)fp20 ardUpgrade:(id)fp24 saveNib:(BOOL)fp28;
- (id)initWithParticipant:(id)fp8 isNotifier:(BOOL)fp12 ardUpgrade:(id)fp16 saveNib:(BOOL)fp20;
- (id)initAsJabberAuth:(id)fp8 isNotifier:(BOOL)fp12;
- (id)initAsFileTransfer:(id)fp8 isNotifier:(BOOL)fp12;
- (void)awakeFromNib;
- (void)dealloc;
- (id)participant;
- (id)jabberPresentity;
- (void)_stopNotifierThrob;
- (void)_setupNumberFieldInBGFrame:(struct _NSRect)fp8;
- (void)_setupNotifierUIWithNumber:(BOOL)fp8;
- (void)startMultiwayThrob;
- (float)dxToFitText;
- (void)updateNotifierUI;
- (float)bannerHeight;
- (void)setUsesWhiteText:(BOOL)fp8;
- (BOOL)usesWhiteText;
- (void)setHasDropHighlight:(BOOL)fp8;
- (BOOL)hasDropHighlight;
- (void)drawRect:(struct _NSRect)fp8;
- (void)_updateStatusLineWidths;
- (void)_startSpinner;
- (void)_stopSpinner;
- (void)showCloseButtonOver:(BOOL)fp8 down:(BOOL)fp12;
- (void)hideCloseButton;
- (struct _NSRect)closeButtonFrame;
- (void)_clearTrackingRects;
- (BOOL)updateMouseTracking:(BOOL)fp8 checkingMouse:(BOOL)fp12 atWindowCoordinates:(struct _NSPoint)fp16;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)viewWillMoveToWindow:(id)fp8;
- (float)animator:(id)fp8 contourForProgress:(float)fp12;
- (void)_updateNotifierProgress:(float)fp8;
- (void)animator:(id)fp8 doStep:(float)fp12 lastStep:(BOOL)fp16;
- (BOOL)isInvited;
- (void)startConnecting;
- (void)_animateTo:(int)fp8;
- (void)_updateConnectedUIConfiguration;
- (void)connect;
- (void)_timedSetRecordingStage:(id)fp8;
- (void)_setRecordingStage:(int)fp8;
- (void)recordingPermissionRequested;
- (void)recordingPermissionGranted;
- (void)recordingPermissionDenied;
- (void)recordingPermissionForgotten;
- (void)finishARDUpgrade;
- (BOOL)isConnected;
- (void)disconnect;
- (BOOL)isDisconnected;
- (void)_mouseUpOutsideCloseButton:(id)fp8;
- (void)closeParticipant:(id)fp8;

@end

@interface AVRecorder : NSObject
{
    int _width;
    int _height;
    BOOL _shouldRecordVideo;
    BOOL _alwaysRecordToMovieContainer;
    OpenGLLayerView *_layerView;
    NSOpenGLContext *_context;
    NSOpenGLPixelBuffer *_nsPixelBuffer;
    FrameReader *_frameReader;
    BOOL _recording;
    NSString *_fileName;
    struct ComponentInstanceRecord *_dataHandler;
    struct MovieType **_movie;
    struct TrackType **_videoTrack;
    struct MediaType **_videoMedia;
    struct OpaqueICMCompressionSession *_videoCompressionSession;
    unsigned int _videoCodecType;
    int _averageVideoDataRate;
    unsigned long long _videoStartTime;
    struct __CFArray *_bufferedCompressedVideoFrames;
    BOOL _recordingRemoteAudio;
    unsigned int _incomingDeviceID;
    struct AudioBufferList *_inputAudioRingBuffer;
    unsigned int _inputAudioRingBufferPacketLength;
    unsigned int _inputAudioRingBufferLengthInPackets;
    unsigned int _inputAudioRingBufferStartPosition;
    unsigned int _inputAudioRingBufferEndPosition;
    struct ComponentInstanceRecord *_stdAudioCompressionComponent;
    struct SoundDescription **_compressedSoundDescription;
    struct AudioStreamBasicDescription _incomingStreamDescription;
    struct AudioStreamBasicDescription _compressedStreamDescription;
    unsigned int _compressedMaxBytesPerPacket;
    BOOL _requiresPacketDescriptions;
    struct TrackType **_soundTrack;
    struct MediaType **_soundMedia;
    struct FSRef _audioFileRef;
    struct OpaqueAudioFileID *_audioFile;
    unsigned long long _audioStartTime;
    double _audioStartSampleTime;
    int _audioDrift;
    unsigned int _packetsWritten;
    BOOL _compressingVideo;
    BOOL _compressingAudio;
    struct _opaque_pthread_t *_videoCompressionThread;
    struct _opaque_pthread_t *_audioCompressionThread;
    struct _opaque_pthread_cond_t _inputAudioReadyCondition;
    struct _opaque_pthread_mutex_t _inputAudioReadyMutex;
    struct _opaque_pthread_cond_t _inputVideoReadyCondition;
    struct _opaque_pthread_mutex_t _inputVideoReadyMutex;
    struct _opaque_pthread_mutex_t _addToMovieMutex;
    BOOL _videoFrameWanted;
    char *_channelsInUse;
    int _channelsInUseCount;
    NSMutableDictionary *_userIDsToChannels;
}

- (id)initWithWidth:(int)fp8 height:(int)fp12 layerView:(id)fp16 sharedContext:(id)fp20;
- (void)dealloc;
- (BOOL)_setupAudioTrack;
- (BOOL)_closeAudioTrack;
- (void *)_audioCompressionThreadMethod;
- (BOOL)_startRemoteAudioRecording;
- (BOOL)_stopRemoteAudioRecording;
- (BOOL)removeAudioForParticipant:(id)fp8;
- (BOOL)addAudioForParticipant:(id)fp8;
- (void)setAlwaysRecordToMovieContainer:(BOOL)fp8;
- (BOOL)setShouldRecordAudio:(BOOL)fp8 forChannel:(int)fp12;
- (BOOL)setShouldRecordAudio:(BOOL)fp8 forParticipant:(id)fp12;
- (long)_flushBufferedVideo;
- (BOOL)startRecording;
- (id)stopRecording;
- (BOOL)isRecording;
- (void)askForFrame;
- (void)newVideoFrameAvailable;
- (void *)_videoCompressionThreadMethod;

@end

@interface AVSegmentedControl : NSSegmentedControl
{
    id _avSegmentedControlTarget;
    NSMenu *_addBuddyMenu;
    BOOL _menuIsValid;
    BOOL _registered;
    AbstractAccount *_account;
    BOOL _muted;
    BOOL _paused;
    BOOL _muteAllowed;
    BOOL _pauseAllowed;
    BOOL _showingPause;
    BOOL _shouldShowPause;
}

+ (Class)cellClass;
- (int)segmentForTag:(int)fp8;
- (void)_configureButtons;
- (void)dealloc;
- (void)awakeFromNib;
- (void)_flagsChanged:(id)fp8;
- (void)setFullScreenEnabled:(BOOL)fp8;
- (void)setAddTooltip:(id)fp8;
- (void)setAddEnabled:(BOOL)fp8;
- (BOOL)isAddEnabled;
- (void)setMuted:(BOOL)fp8;
- (BOOL)isMuted;
- (void)setMuteAllowed:(BOOL)fp8;
- (BOOL)isMuteAllowed;
- (void)setPauseAllowed:(BOOL)fp8;
- (BOOL)isPauseAllowed;
- (void)setPaused:(BOOL)fp8;
- (BOOL)isPaused;
- (void)_showPauseUI;
- (void)_showMuteUI;
- (void)setActionTarget:(id)fp8;
- (void)_sendActionForSegmentType:(int)fp8;
- (void)selfAction:(id)fp8;
- (void)_personSelected:(id)fp8;
- (void)_addItemForAccount:(id)fp8 atIndex:(int *)fp12;
- (void)_addItemForPresentity:(id)fp8 toMenu:(id)fp12 atIndex:(int)fp16 showingDetails:(BOOL)fp20;
- (void)_addItemForEmptyList;
- (void)_registerForNotifications;
- (void)_rebuildMenuIfNecessary;
- (void)menuWillOpen:(id)fp8;
- (void)invalidateAddMenu;
- (void)setAccount:(id)fp8;
- (BOOL)performKeyEquivalent:(id)fp8;

@end

@interface AbbreviatingTextField : NSTextField
{
    BOOL _verticallyCentered;
    NSShadow *_shadow;
    BOOL _sendsActionOnClick;
    NSString *_axDescriptionAttribute;
}

- (void)dealloc;
- (void)setShadow:(id)fp8;
- (id)shadow;
- (void)_setColor:(id)fp8 offset:(float)fp12 blurRadius:(float)fp16;
- (void)setNoShadow;
- (void)setWhiteBevel;
- (void)setFaintBlackShadow;
- (void)setStrongBlackShadow;
- (void)setVerticallyCentered:(BOOL)fp8;
- (BOOL)isVerticallyCentered;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setSendsActionOnClick:(BOOL)fp8;
- (BOOL)sendsActionOnClick;
- (void)_sendAction;
- (void)mouseDown:(id)fp8;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (void)performClick:(id)fp8;
- (id)accessibilityFocusedUIElement;
- (id)accessibilityHitTest:(struct _NSPoint)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityTitleAttribute;
- (id)accessibilityDescriptionAttribute;
- (void)setLocalizedAccessibilityDescriptionAttribute:(id)fp8;

@end

@interface AbstractAccount (AccountControllerCallbacks)
- (void)accountDidBecomeActive;
- (void)accountDidDeactivate;
@end

@interface AbstractAccount (AccountTypeLookups)
- (BOOL)isAccountOfClass:(Class)fp8;
- (BOOL)isAIMAccount;
- (BOOL)isJabberAccount;
- (BOOL)isRendezvousAccount;
@end

@interface AbstractAccount (Scripting)
- (void)loginScriptCommand:(id)fp8;
- (void)logoutScriptCommand:(id)fp8;
- (void)sendScriptCommand:(id)fp8;
- (id)objectSpecifier;
- (void)setScriptName:(id)fp8;
- (id)scriptName;
- (void)setScriptImage:(id)fp8;
- (id)scriptImage;
- (void)setScriptEnabled:(BOOL)fp8;
- (BOOL)scriptEnabled;
- (id)scriptServiceType;
- (id)scriptConnectionStatus;
- (id)buddies;
- (id)valueInBuddiesWithName:(id)fp8;
- (id)valueInBuddiesWithUniqueID:(id)fp8;
- (id)scriptChats;
- (id)valueInScriptChatsWithUniqueID:(id)fp8;
- (id)valueInScriptChatsWithName:(id)fp8;
- (id)scriptTextChats;
- (id)objectInScriptTextChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptTextChatsWithUniqueID:(id)fp8;
- (id)valueInScriptTextChatsWithName:(id)fp8;
- (id)scriptAVChats;
- (id)objectInScriptAVChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptAVChatsWithUniqueID:(id)fp8;
- (id)scriptAudioChats;
- (id)objectInScriptAudioChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptAudioChatsWithUniqueID:(id)fp8;
- (id)scriptVideoChats;
- (id)objectInScriptVideoChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptVideoChatsWithUniqueID:(id)fp8;
@end

@interface AccessibilityIgnoredButton : NSButton
{
}

- (BOOL)accessibilityIsIgnored;
- (id)accessibilityAttributeNames;
- (id)accessibilityParameterizedAttributeNames;
- (id)accessibilityAttributeValue:(id)fp8;

@end

@interface AccountController : NSObject
{
    NSMutableArray *_accounts;
    NSMutableSet *_registeredAccountTypes;
    BOOL _isReadOnly;
}

+ (id)sharedInstance;
- (oneway void)release;
- (unsigned int)retainCount;
- (void)autoLogin;
- (id)init;
- (void)dealloc;
- (void)registerAccountClass:(Class)fp8;
- (id)accountForUniqueID:(id)fp8;
- (id)accountAtIndex:(int)fp8;
- (int)numberOfAccounts;
- (int)numberOfAccountsOfClass:(Class)fp8;
- (id)accountsOfClass:(Class)fp8;
- (int)numberOfActiveAccountsOfClass:(Class)fp8;
- (id)activeAccountsOfClass:(Class)fp8;
- (int)numberOfConnectedAccountsNotOfClass:(Class)fp8;
- (id)connectedAccountsNotOfClass:(Class)fp8;
- (int)numberOfConnectedAccountsOfClass:(Class)fp8;
- (id)connectedAccountsOfClass:(Class)fp8;
- (BOOL)hasAccount:(id)fp8;
- (BOOL)canDeleteAccount:(id)fp8;
- (BOOL)accountActive:(id)fp8;
- (void)disableService:(id)fp8;
- (BOOL)serviceEnabled:(id)fp8;
- (BOOL)readOnly;
- (void)setReadOnly:(BOOL)fp8;
- (BOOL)addAccount:(id)fp8;
- (BOOL)addAccount:(id)fp8 atIndex:(int)fp12;
- (BOOL)deleteAccount:(id)fp8;
- (BOOL)deactivateAccount:(id)fp8;
- (BOOL)deactivateAccount:(id)fp8 withDisable:(BOOL)fp12;
- (BOOL)activateAccount:(id)fp8;
- (BOOL)activateAccount:(id)fp8 force:(BOOL)fp12;
- (BOOL)activateAndHandleReconnectAccount:(id)fp8;
- (BOOL)connectAccount:(id)fp8;
- (BOOL)disconnectAccount:(id)fp8;
- (BOOL)accountConnecting:(id)fp8;
- (BOOL)accountConnected:(id)fp8;
- (BOOL)canActivateAccount:(id)fp8;
- (void)uniquelyRenameAccount:(id)fp8;
- (id)uniqueNameForAccount:(id)fp8 withName:(id)fp12;

@end

@interface AccountController (AccountCleanup)
- (void)removePreferencesForAccount:(id)fp8;
@end

@interface AccountController (BuddyListDisplayAdditions)
- (void)_activeAccountChanged:(id)fp8;
- (BOOL)isBuddyListLoadedForAccount:(id)fp8;
- (id)loadBuddyListForAccount:(id)fp8;
- (id)loadBuddyListForAccount:(id)fp8 dontShowWindow:(BOOL)fp12;
- (void)unloadBuddylistForAccount:(id)fp8;
@end

@interface AccountController (LoadSaveAdditions)
+ (id)supportedAccountClasses;
- (void)_saveSortedAccounts;
- (BOOL)save;
- (BOOL)_importLegacyiChatPrefsIfNecessary;
- (void)_enableLegacyAccountsIfNecessary;
- (BOOL)_importRecentAccountsIfNecessary;
- (void)_sortAccounts;
- (void)_ensureBonjourAccountExists;
- (BOOL)load;
@end

@interface AccountController (MenuDelegate)
- (int)numberOfItemsInMenu:(id)fp8;
- (BOOL)menu:(id)fp8 updateItem:(id)fp12 atIndex:(int)fp16 shouldCancel:(BOOL)fp20;
- (void)toggleAccountConnection:(id)fp8;
@end

@interface AccountController (NSTableViewDataSourceMethods)
- (BOOL)tableView:(id)fp8 writeRows:(id)fp12 toPasteboard:(id)fp16;
- (unsigned int)tableView:(id)fp8 validateDrop:(id)fp12 proposedRow:(int)fp16 proposedDropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 acceptDrop:(id)fp12 row:(int)fp16 dropOperation:(unsigned int)fp20;
- (int)numberOfRowsInTableView:(id)fp8;
- (void)tableView:(id)fp8 willDisplayCell:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
@end

@interface AccountController (NSTableViewDelegateMethods)
- (BOOL)tableView:(id)fp8 shouldShowCellExpansionForTableColumn:(id)fp12 row:(int)fp16;
- (id)tableView:(id)fp8 toolTipForCell:(id)fp12 rect:(struct _NSRect *)fp16 tableColumn:(id)fp20 row:(int)fp24 mouseLocation:(struct _NSPoint)fp28;
@end

@interface AccountController (QuickAccountAccess)
- (id)anyAccountOfClass:(Class)fp8 withLogin:(id)fp12;
- (id)anyActiveAccountOfClass:(Class)fp8 withLogin:(id)fp12;
- (id)anyConnectedAccountOfClass:(Class)fp8 withLogin:(id)fp12;
- (id)anyAccountOfClass:(Class)fp8;
- (id)anyActiveAccountOfClass:(Class)fp8;
- (id)anyConnectedAccountOfClass:(Class)fp8;
@end

@interface AccountController (QuickAccountTypeAccess)
- (id)mostLoggedInAccount;
- (id)aimAccount;
- (id)rendezvousAccount;
- (id)jabberAccount;
- (id)allConnectedAccounts;
- (id)allActiveAccounts;
- (id)allAccounts;
@end

@interface AccountController (Scripting)
- (id)scriptingAccounts;
- (id)accountForDescription:(id)fp8;
@end

@interface AccountController (SwitchToMenuDelegate)
- (int)_numberOfRealItems;
- (int)numberOfItemsInMenu:(id)fp8;
- (BOOL)menu:(id)fp8 updateItem:(id)fp12 atIndex:(int)fp16 shouldCancel:(BOOL)fp20;
- (void)_switchToOtherAIMAccount:(id)fp8;
- (void)_switchToOtherJabberAccount:(id)fp8;
- (void)_loginOtherJabber;
- (void)_switchToAccountFromMenuItem:(id)fp8;
@end

@interface AccountPreferencesTableCell : NSTextFieldCell
{
}

- (id)copyWithZone:(struct _NSZone *)fp8;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface AccountPreferencesTableCell (AccountPreferencesTableCellAccessibility)
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityAttributeValue:(id)fp8;
- (id)accessibilityValueAttribute;
@end

@interface ActionsController : NSObject
{
    NSPopUpButton *_eventsPopUp;
    NSButton *_playSoundCheckbox;
    NSButton *_repeatSoundCheckbox;
    NSButton *_speakCheckbox;
    NSButton *_bounceDockCheckbox;
    NSButton *_repeatBounceCheckbox;
    NSButton *_runAppleScriptCheckbox;
    NSButton *_oneShotCheckbox;
    NSPopUpButton *_appleScriptPopup;
    NSTextField *_oneShotLineTwo;
    NSSoundPopUpButton *_soundsPopUp;
    NSSlider *_volumeSlider;
    Presentity *_buddy;
    NSMutableDictionary *_actionSet;
    int _eventNumber;
    BOOL _eventActionsChanged;
    BOOL _actionsChanged;
    id _delegate;
    NSArray *_availableScripts;
}

+ (id)localizedTitleForFezEvent:(int)fp8;
+ (void)willSleepNotification:(id)fp8;
+ (void)didWakeNotification:(id)fp8;
+ (void)initialize;
+ (id)_prefsKey:(id)fp8;
+ (id)fullPathOfSoundInActions:(id)fp8;
+ (BOOL)continuousVCRingEnabled;
+ (void)setContinuousVCRingEnabled:(BOOL)fp8;
+ (void)_rebounce:(id)fp8;
+ (void)cancelRebounces;
+ (void)_appDidBecomeActive:(id)fp8;
+ (void)_repeatSound:(id)fp8;
+ (void)_playSoundFromFile:(id)fp8 repeat:(BOOL)fp12;
+ (void)_stopRepeatingSoundFromFile:(id)fp8;
+ (id)_actionsForEvent:(int)fp8 withPresentity:(id)fp12;
+ (void)_setActions:(id)fp8 forEvent:(int)fp12 withPresentity:(id)fp16;
+ (void)_announceEvent:(int)fp8 withPresentity:(id)fp12 withMessage:(id)fp16 forChat:(id)fp20;
+ (BOOL)_shouldBeSilentForPresentity:(id)fp8;
+ (BOOL)executeAppleScriptHandlersForEvent:(int)fp8 withPresentity:(id)fp12 withObject:(id)fp16;
+ (BOOL)executeAppleScriptHandlersForEvent:(int)fp8 withPresentity:(id)fp12 withObject:(id)fp16 withChat:(id)fp20;
+ (id)performActionsForEvent:(int)fp8 withPresentity:(id)fp12;
+ (id)performActionsForEvent:(int)fp8 withPresentity:(id)fp12 withMessage:(id)fp16;
+ (id)performActionsForEvent:(int)fp8 withPresentity:(id)fp12 withMessage:(id)fp16 silent:(BOOL)fp20;
+ (id)performActionsForEvent:(int)fp8 withPresentity:(id)fp12 withObject:(id)fp16 silent:(BOOL)fp20;
+ (id)performActionsForEvent:(int)fp8 withPresentity:(id)fp12 withObject:(id)fp16 withChat:(id)fp20 silent:(BOOL)fp24;
+ (void)_executeAppleScriptHandlersForEventDictionary:(id)fp8;
+ (void)stopEventActions:(id)fp8;
+ (void)failedEventHandlerAlertDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)setDelegate:(id)fp8;
- (void)awakeFromNib;
- (void)dealloc;
- (BOOL)hasChangesPending;
- (void)_rememberEventChanges;
- (void)complete;
- (void)saveChanges;
- (void)loadFromDefaults;
- (void)setBuddy:(id)fp8;
- (void)_actionsDidChange:(id)fp8;
- (id)buddy;
- (void)_updateEventsPopUpIcons;
- (void)_addItemWithTag:(int)fp8;
- (void)_fillEventsPopUpWith:(int)fp8;
- (void)_fillEventsPopUp:(BOOL)fp8;
- (void)menuNeedsUpdate:(id)fp8;
- (void)_addScriptsToPopUpFromPath:(id)fp8;
- (void)_fillAppleScriptPopup;
- (void)_enableOneShot:(BOOL)fp8;
- (id)_actionsForEvent:(int)fp8;
- (void)_updateActions;
- (void)eventSelected:(id)fp8;
- (BOOL)_anyActionsChecked;
- (void)_actionsChanged;
- (void)actionChecked:(id)fp8;
- (void)soundSelected:(id)fp8;
- (void)controlTextDidChange:(id)fp8;
- (void)volumeChanged:(id)fp8;
- (void)appleScriptSelected:(id)fp8;
- (void)noAvailableScripts:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (id)titleForSoundFile:(id)fp8;
- (void)_createiChatScriptDirectoryIfNecessary;
- (void)_selectScriptWithFilename:(id)fp8;
- (void)_displayAlertForCouldNotCopyScript:(id)fp8;
- (void)_overwriteScriptAlertDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_selectAppleScriptPathDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)findScriptFile:(id)fp8;
- (void)revealAppleScriptDirectory:(id)fp8;
- (BOOL)fileManager:(id)fp8 shouldProceedAfterError:(id)fp12;
- (void)fileManager:(id)fp8 willProcessPath:(id)fp12;

@end

@interface Chat : NSObject <FZSecureObject>
{
    BOOL _isInNotifier;
    BOOL _isMessageContainer;
    int _buildCount;
    AbstractAccount *_account;
    int _style;
    int _unreadMessages;
    NSString *_subject;
    NSMutableArray *_messages;
    NSMutableArray *_allPeople;
    ChatWindowController *_chatWindowController;
    NSString *_transcript;
    NSString *_address;
    NSString *_cachedDisplayAddress;
    NSMutableDictionary *_properties;
    int _securityLevel;
    NSMutableArray *_queuedMessages;
    BOOL _useRoomName;
    int _startingIndex;
    Presentity *_myHandle;
    BOOL _verifiedToParticipant;
    unsigned int _displayStartIndex;
    NSArray *_displayMesageArray;
    int _msgQueueIndex;
    NSDocument *_chatDoc;
    NSString *_GUID;
    unsigned int _overallChatStatus;
    NSArray *_myAddressableNames;
}

+ (id)chatList;
+ (void)setViewer:(id)fp8;
+ (id)viewer;
- (id)initWithAccount:(id)fp8 style:(int)fp12;
- (void)setTranscript:(id)fp8;
- (id)transcript;
- (void)_declineAndCleanupFileTransfers;
- (void)dealloc;
- (void)addToChatList;
- (void)_removeFromChatList;
- (void)beginBuildMode;
- (void)endBuildMode;
- (BOOL)isInBuildMode;
- (BOOL)verifiedToParticipant;
- (void)setVerifiedToParticipant:(BOOL)fp8;
- (BOOL)isComposing;
- (BOOL)isMessageContainer;
- (BOOL)isActive;
- (BOOL)isChat;
- (int)style;
- (void)setStyle:(int)fp8;
- (void)_notifyStatusChanged;
- (int)numberOfUnreadMessages;
- (BOOL)hasUnreadMessages;
- (void)setUnreadMessages:(BOOL)fp8;
- (id)account;
- (id)otherPresentity;
- (id)_otherPresentityOrChatroom;
- (id)otherPeople;
- (BOOL)fromMe;
- (id)subject;
- (id)displayAddress;
- (id)address;
- (unsigned int)displayStartIndex;
- (void)setDisplayStartIndex:(unsigned int)fp8;
- (id)messagesToDisplay;
- (id)messagesToSave;
- (id)messages;
- (unsigned int)realMessageCount;
- (id)allPeople;
- (id)visibleParticipants;
- (id)peopleDeciding;
- (id)myHandle;
- (id)dateCreated;
- (id)dateModified;
- (id)description;
- (id)valueOfProperty:(id)fp8;
- (void)setValue:(id)fp8 ofProperty:(id)fp12;
- (BOOL)isInNotifier;
- (void)setIsInNotifier:(BOOL)fp8;
- (id)firstInterestingMessage;
- (id)lastMessage;
- (id)lastInterestingMessage;
- (void)setGUID:(id)fp8;
- (id)GUID;
- (id)myAddressableNames;
- (void)setMyAddressableNames:(id)fp8;
- (BOOL)hasUIRepresentation;
- (id)chatController;
- (id)chatWindowController;
- (void)setChatWindowController:(id)fp8;
- (id)chatDoc;
- (void)setChatDoc:(id)fp8;
- (BOOL)isOpenInWindow;
- (void)notifyOpenedByChatController:(id)fp8;
- (id)window;
- (void)display;
- (void)removePermanently;
- (BOOL)useRoomName;
- (void)setUseRoomName:(BOOL)fp8;
- (id)prefKey;
- (id)savedPrefKey;
- (id)metadataDictionary;
- (id)dataRepresentation;
- (id)defaultSaveName;
- (BOOL)writeToFile:(id)fp8;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (BOOL)canBeSecure;
- (unsigned int)overallChatStatus;

@end

@interface ActiveChat : Chat
{
    NSString *_previousTranscriptPath;
    BOOL _active;
    int _joinState;
    BOOL _displayOnJoin;
    BOOL _finishedByMe;
    BOOL _announcePeople;
    BOOL _silent;
    NSMutableArray *_curPeople;
    NSMutableSet *_peopleDeciding;
    NSMutableSet *_ignoredPeople;
    NSString *_ID;
    NSTimer *_autosaveTimer;
    NSDate *_lastSaveDate;
    NSMutableSet *_associatedPeople;
    NSMutableDictionary *_peopleMappings;
    NSTimer *_autoreplyTimer;
    BOOL _alreadyReplied;
    AVChatController *_pendingVCDecline;
    BOOL _canAutoReply;
    BOOL _needsToSendAutoReply;
    BOOL _iDisabledEncryption;
    NSMutableArray *_orderedChatters;
}

+ (id)_unjoinedChatWithPresentity:(id)fp8;
- (void)setOtherPresentity:(id)fp8 verified:(BOOL)fp12;
- (void)setOtherPresentity:(id)fp8;
- (void)_setAutoReplied:(BOOL)fp8;
- (void)_clearAutorepliedFlagTimer:(id)fp8;
- (void)_autoreplyToMsg:(id)fp8 whenMyStatusIs:(unsigned int)fp12;
- (id)initAsContainerForMessage:(id)fp8;
- (id)initWithAccount:(id)fp8 style:(int)fp12;
- (id)initWithMessage:(id)fp8 style:(int)fp12;
- (void)loadAccountPreferences;
- (void)dealloc;
- (void)resetAssociatedPresentities;
- (id)associatedPresentities;
- (BOOL)isPresentityAssociatedWithChat:(id)fp8;
- (void)_watchPresentity:(id)fp8;
- (void)unassociatePresentityWithChat:(id)fp8;
- (void)associatePresentityWithChat:(id)fp8;
- (id)ID;
- (void)setID:(id)fp8;
- (BOOL)isComposing;
- (void)setAccount:(id)fp8;
- (id)visibleParticipants;
- (id)orderedRecentChatters;
- (id)orderedRecentChatters:(int)fp8;
- (void)setPeople:(id)fp8;
- (BOOL)isActive;
- (void)setDisplayOnJoin:(BOOL)fp8;
- (int)joinState;
- (void)setJoining;
- (void)nowAnnouncePeople;
- (void)setHasJoined:(BOOL)fp8;
- (id)curPeople;
- (id)otherPeople;
- (id)peopleDeciding;
- (void)setSubject:(id)fp8;
- (void)setMyHandle:(id)fp8;
- (void)setAddress:(id)fp8;
- (BOOL)_changesSinceSave;
- (BOOL)autoSave;
- (void)_startAutosaveTimer;
- (void)_autosaveTimerFired;
- (void)_destroyTimer:(id *)fp8;
- (void)notifyUser;
- (void)notifyUserAndBeSilent:(BOOL)fp8;
- (BOOL)respondToInvitation:(BOOL)fp8;
- (void)finish;
- (void)_finishedWithMessage:(id)fp8;
- (BOOL)wasFinishedByMe;
- (id)_silentPrefKey;
- (void)setSilent:(BOOL)fp8;
- (BOOL)isSilent;
- (void)_postNotificationName:(id)fp8 key:(id)fp12 object:(id)fp16 key:(id)fp20 object:(id)fp24 key:(id)fp28 object:(id)fp32;
- (void)_postMemberChange:(id)fp8 status:(int)fp12;
- (void)showError:(id)fp8;
- (void)_doPendingVCDecline;
- (void)setPendingVCDecline:(id)fp8;
- (BOOL)canBeSecure;
- (void)setSecurityLevel:(int)fp8;
- (void)_showSecurityChangedWhileComposingSheet;
- (void)_showEncryptedDisabledSheet;
- (void)_showEncryptedChatFailedSheet;
- (void)_showUnexpectedPlaintextSheet;
- (id)_processMessageForActionsIfNeccessary:(id)fp8;
- (void)addMessage:(id)fp8 atEnd:(BOOL)fp12 replacingMessageAtIndex:(int)fp16 isSystemMessage:(BOOL)fp20;
- (void)_unreadMessageDisplayed:(id)fp8;
- (void)addMessage:(id)fp8 atEnd:(BOOL)fp12 replacingMessageAtIndex:(int)fp16;
- (int)indexOfMessage:(id)fp8;
- (int)_findUnfinishedMessageFrom:(id)fp8;
- (void)addMessage:(id)fp8 isSystemMessage:(BOOL)fp12;
- (void)addMessage:(id)fp8;
- (void)addInitialComposeMessage;
- (void)addStatusChangeString:(id)fp8 subject:(id)fp12;
- (void)addAnnouncementString:(id)fp8;
- (void)addAnnouncementString:(id)fp8 subject:(id)fp12;
- (void)notifyMessageAdded:(id)fp8;
- (void)rejoin;
- (BOOL)sendMessage:(id)fp8;
- (void)setAnnouncePeople:(BOOL)fp8;
- (void)_removeDeciding:(id)fp8;
- (void)addPresentity:(id)fp8;
- (void)removePresentity:(id)fp8;
- (void)invitePresentity:(id)fp8 withMessage:(id)fp12;
- (void)invitePeople:(id)fp8 withMessage:(id)fp12;
- (void)_deferredNotifyPresentityInfoChanged:(id)fp8;
- (void)notifyPresentityInfoChanged:(id)fp8;
- (void)_presentityChatroomAssociationChanged:(id)fp8;
- (void)_setOverallChatStatus:(unsigned int)fp8;
- (BOOL)_recomputeOverallChatStatusQuietly:(BOOL)fp8;
- (void)_presentityStatusChanged:(id)fp8;
- (void)setPresentity:(id)fp8 isIgnored:(BOOL)fp12;
- (BOOL)presentityIsIgnored:(id)fp8;
- (void)_quietlyRemovePresentity:(id)fp8;
- (void)_member:(id)fp8 statusChanged:(int)fp12;

@end

@interface ActiveChat (Chat_GroupchatAdditions)
- (id)associatedGroupchatPresentitiesForPresentity:(id)fp8;
- (id)unassociateGroupchatPresentity:(id)fp8;
- (void)associateGroupchatPresentity:(id)fp8 withMappedPresentity:(id)fp12;
- (id)filteredGroupchatPresentity:(id)fp8;
- (id)alternateGroupchatTitleForPresentity:(id)fp8;
@end

@interface ActiveChat (PersistentChatAdditions)
+ (id)resurrectChatFromInfoDictionary:(id)fp8;
- (id)imNameFromThread:(id)fp8;
- (id)chatNameFromThread:(id)fp8;
- (id)threadFromIMName:(id)fp8;
- (id)threadFromChatName:(id)fp8;
- (void)_setPreviousTranscriptPath:(id)fp8;
- (void)_setStartingIndex:(int)fp8;
- (void)clearMessages:(id)fp8;
- (id)persistedDataRepresentation;
- (id)persistedChatInfoWithData:(BOOL)fp8;
@end

@interface AddBuddy : NSObject
{
    BOOL _lockAccountSelection;
    ServicePopUp *_toAccountPopup;
    NSView *_topReferenceView;
    NSWindow *_proposedNewRecordWindow;
    NSPopUpButton *_proposedAccountTypePopUpButton;
    ExtendedComboBox *_proposedAccountNameTextField;
    ExtendedComboBox *_proposedFirstNameTextField;
    ExtendedComboBox *_proposedLastNameTextField;
    CollapseView *_groupsCollapseView;
    CollapseView *_accountCollapseView;
    NSPopUpButton *_proposedGroupPopUpButton;
    NSButton *_proposedAddButton;
    NSWindow *_recordWindow;
    NSTabView *_tabView;
    CollapseView *_accountsCollapseView;
    NSView *_accountTypeView;
    NSView *_pickerArea;
    NSTextField *_addCardTitle;
    NSButton *_disclosure;
    NSView *_contentView;
    NSView *_titleView;
    ABPeoplePickerView *_pickerView;
    PeoplePicker *_picker;
    NSWindow *_buddyWindow;
    Presentity *_person;
    ABPerson *_abPerson;
    NSArray *_groups;
    NSArray *_presentities;
    Service *_service;
    AbstractAccount *_account;
    NSMutableArray *_abAddressesCache;
    NSMutableArray *_abFirstNameCache;
    NSMutableArray *_abLastNameCache;
    NSMutableDictionary *_abFirstNameToLastNameCache;
    NSMutableDictionary *_abLastNameToFirstNameCache;
    Presentity *_cachedSelectedPresentity;
    ABPerson *_cachedSelectedPerson;
    NSString *_cachedKeyName;
    NSArray *_cachedPossibleNames;
}

+ (id)openForPresentity:(id)fp8 groups:(id)fp12 buddyWindow:(id)fp16 forService:(id)fp20;
+ (id)openForNewPresentityWithGroups:(id)fp8 buddyWindow:(id)fp12 forService:(id)fp16;
- (void)_removeAccountTypePopup;
- (void)_removeJabberMenuItem;
- (void)_configureServicePopup;
- (id)initWithPresentity:(id)fp8 vCard:(id)fp12 buddyWindow:(id)fp16 service:(id)fp20 account:(id)fp24;
- (id)initWithAccount:(id)fp8;
- (id)initWithService:(id)fp8;
- (void)_clearFields;
- (void)_removeDotMacLabel;
- (void)_installDotMacLabel;
- (void)_setupNewRecordSheet;
- (void)_setAccountName:(id)fp8 service:(id)fp12 force:(BOOL)fp16;
- (id)_itemsInField:(id)fp8;
- (id)insertHandlesIntoABPerson:(id)fp8;
- (void)_registerForNotifications;
- (void)awakeFromNib;
- (void)dealloc;
- (void)setCandidateAccounts:(id)fp8;
- (void)setAccountSelectionLocked:(BOOL)fp8;
- (void)_configureTitleForLockedPresentity;
- (void)setPresentity:(id)fp8;
- (void)setABPerson:(id)fp8;
- (void)setBuddyWindow:(id)fp8;
- (void)setGroups:(id)fp8;
- (void)openForABPerson:(id)fp8 groups:(id)fp12 buddyWindow:(id)fp16;
- (void)openForPresentity:(id)fp8 groups:(id)fp12 buddyWindow:(id)fp16;
- (void)openForNewPresentityWithGroups:(id)fp8 buddyWindow:(id)fp12;
- (void)addressBookChanged:(id)fp8;
- (void)textDidEndEditing:(id)fp8;
- (void)controlTextDidChange:(id)fp8;
- (void)_controlTextDidChange:(id)fp8;
- (void)comboBoxWillPopUp:(id)fp8;
- (void)comboBoxWillDismiss:(id)fp8;
- (void)comboBoxSelectionDidChange:(id)fp8;
- (void)comboBoxSelectionIsChanging:(id)fp8;
- (void)_peoplePickerValueUpdated:(id)fp8;
- (void)_peoplePickerPaletteUpdated:(id)fp8;
- (void)_peoplePickerPalettePropertyChanged:(id)fp8;
- (BOOL)_isAccountUserCustomized;
- (void)_synchronizeDisclosureArea;
- (void)_validateAddButton;
- (void)_configurePeoplePickerPaletteForMe;
- (id)_selectedGroup;
- (BOOL)_isDotMacLabelVisible;
- (BOOL)_firstNameCustomized;
- (BOOL)_lastNameCustomized;
- (BOOL)_firstOrLastNameCustomized;
- (void)_updateFromABPersonForce:(BOOL)fp8 setAsNotAutoFilled:(BOOL)fp12;
- (void)_updateFromABPerson;
- (BOOL)_abPersonAndFieldsAreTheSame;
- (BOOL)isPickerVisible;
- (id)selectedCard;
- (void)_selectService:(id)fp8;
- (id)selectedService;
- (void)openCardList:(id)fp8;
- (void)displayPeoplePickerSheet:(id)fp8;
- (void)recordSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)displayRecordSheet:(id)fp8;
- (void)dismissRecordSheet:(id)fp8;
- (void)_chooseAccountType:(id)fp8;
- (void)changeToAccount:(id)fp8;
- (void)chooseAccountType:(id)fp8;
- (void)chooseAccountName:(id)fp8;
- (void)switchTab:(id)fp8;
- (void)acceptRecord:(id)fp8;
- (void)_acceptEntry;
- (void)extendedComboBoxDidPressEnter:(id)fp8;
- (void)cancelChanges:(id)fp8;
- (void)togglePickerView:(id)fp8;
- (id)_selectedPresentityForABPerson:(id)fp8;
- (BOOL)_fillAccountInformationIfNecessary;
- (void)nameChanged:(id)fp8;
- (id)_completedAccount;
- (id)_completedFirstName;
- (id)_completedLastName;
- (id)_possibleFirstNames;
- (id)_possibleLastNames;
- (int)numberOfItemsInComboBox:(id)fp8;
- (id)comboBox:(id)fp8 objectValueForItemAtIndex:(int)fp12;
- (unsigned int)comboBox:(id)fp8 indexOfItemWithStringValue:(id)fp12;
- (id)comboBox:(id)fp8 completedString:(id)fp12;
- (void)_rebuildAddressBookInformation;

@end

@interface AnimatingTabView : NSTabView
{
    BOOL _transitionsEnabled;
    BOOL _synchronous;
    double _transitionTime;
    BOOL _wantsDrawTickle;
    EffectView *_effectView;
}

- (void)_commonInit;
- (id)initWithFrame:(struct _NSRect)fp8;
- (id)initWithCoder:(id)fp8;
- (void)dealloc;
- (void)setTransitionsEnabled:(BOOL)fp8;
- (BOOL)areTransitionsEnabled;
- (void)setSynchronous:(BOOL)fp8;
- (BOOL)isSynchronous;
- (void)setTransitionTime:(double)fp8;
- (double)transitionTime;
- (BOOL)inTransition;
- (id)_imageOfCurrentTabView;
- (void)_notifyDelegate:(SEL)fp8;
- (void)_effectComplete;
- (void)selectTabViewItem:(id)fp8;
- (void)setEffectNeedsDisplay:(BOOL)fp8;
- (void)setOnlyUpdateWhenAsked:(BOOL)fp8;
- (BOOL)onlyUpdateWhenAsked;

@end

@interface FezExtendedTableView : NSTableView
{
    NSTextFieldCell *_messageCell;
    NSButtonCell *_triangleCell;
    unsigned int _delegateSelectors;
    BOOL _drawsStripes;
    BOOL _drawingStripes;
    BOOL _hasDropRange;
    struct _NSRange _dropRange;
    BOOL _smallGroupRows;
    float _normalRowHeight;
    float _groupRowHeight;
    SimpleArray *_rowOrigins;
    BOOL _groupRowRolloversEnabled;
    BOOL _runningGroupAnimation;
    BOOL _allowsGroupRowDragging;
    BOOL _mouseIsDown;
    BOOL _mouseInside;
    int _mouseInsideTag;
    int _trackingRow;
    int _clickRow;
    BOOL _mouseDown;
    BOOL _trackingRectsEnabled;
    BOOL _redisplayOnMouseover;
    BOOL _tracksOnlyWhenWindowIsKey;
    BOOL _drawingRowsIntoImage;
    NSColor *_customHighlightColor;
    unsigned int _cellTipRow;
    BOOL _enableCellTips;
    FezCellTipWindow *_cellTipWindow;
    BOOL _drawsSelection;
    float _topGap;
    BOOL _refuseResponder;
    BOOL _wasInPreviousButtonRect;
    struct _NSPoint _previousPoint;
    long _previousRow;
    BOOL _drawsRightShadow;
    struct _NSPoint _tooltipPoint;
    BOOL _tooltipPending;
    Tooltip *_tooltip;
    BOOL _tooltipBlocked;
    BOOL _allowQuickTooltipPop;
    BOOL _tooltipTracksMouse;
    NSString *_headerString;
}

+ (struct _NSRect)groupDisclosureIndicatorRectInRowRect:(struct _NSRect)fp8 isDisclosed:(BOOL)fp24 indicatorImage:(id *)fp28;
- (void)_etvCommonInit;
- (id)initWithCoder:(id)fp8;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)setDelegate:(id)fp8;
- (void)dealloc;
- (void)tile;
- (void)setRefusesResponder:(BOOL)fp8;
- (BOOL)refusesResponder;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (BOOL)resignFirstResponder;
- (void)keyDown:(id)fp8;
- (void)viewDidMoveToWindow;
- (id)selectedRows;
- (BOOL)validateMenuItem:(id)fp8;
- (void)setRowNeedsDisplay:(unsigned int)fp8;
- (void)cut:(id)fp8;
- (void)copy:(id)fp8;
- (void)paste:(id)fp8;
- (void)delete:(id)fp8;
- (struct _NSRect)_dropRect;
- (void)setDropRange:(struct _NSRange)fp8;
- (void)clearDropRange;
- (void)draggingExited:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)_drawDropHighlightBackgroundForRow:(int)fp8;
- (void)_drawDropHighlight;
- (float)normalRowHeight;
- (void)setRowHeight:(float)fp8;
- (void)setIntercellSpacing:(struct _NSSize)fp8;
- (BOOL)_wantsLiveResizeToUseCachedImage;
- (void)setCustomHighlightColor:(id)fp8;
- (id)customHighlightColor;
- (void)setAllowsGroupRowDragging:(BOOL)fp8;
- (BOOL)allowsGroupRowDragging;
- (void)setDrawsStripes:(BOOL)fp8;
- (BOOL)drawsStripes;
- (void)_drawStripesInRect:(struct _NSRect)fp8 startingAt:(float)fp24 endingAt:(float)fp28;
- (void)_drawStripesInRect:(struct _NSRect)fp8;
- (id)_selectionColor;
- (void)setTopGap:(float)fp8;
- (float)topGap;
- (void)_drawCustomSelectionHighlight:(struct _NSRect)fp8;
- (void)drawBackgroundInClipRect:(struct _NSRect)fp8;
- (void)highlightSelectionInClipRect:(struct _NSRect)fp8;
- (void)setDrawsSelection:(BOOL)fp8;
- (BOOL)drawsSelection;
- (void)_hideCellTip;
- (void)_updateCellTipWithPoint:(struct _NSPoint)fp8;
- (BOOL)showCellTips;
- (void)setShowCellTips:(BOOL)fp8;
- (void)_updateRowOrigins;
- (void)setHasGroupRows:(BOOL)fp8;
- (void)setSmallGroupRows:(BOOL)fp8;
- (BOOL)smallGroupRows;
- (float)groupRowHeight;
- (void)rowHeightsChanged;
- (float)tableHeight;
- (struct _NSRect)frameOfCellAtColumn:(int)fp8 row:(int)fp12;
- (int)rowAtPoint:(struct _NSPoint)fp8;
- (struct _NSRect)rectOfRow:(int)fp8;
- (int)numberOfRows;
- (void)noteNumberOfRowsChanged;
- (BOOL)hasHeader;
- (void)setHeaderString:(id)fp8;
- (id)headerString;
- (void)_drawGroupRowInRect:(struct _NSRect)fp8 withTitle:(id)fp24 andNumber:(id)fp28 mouseDown:(BOOL)fp32 rowIndex:(int)fp36 isHeader:(BOOL)fp40;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setDrawsRightShadow:(BOOL)fp8;
- (BOOL)drawsRightShadow;
- (void)drawRow:(int)fp8 clipRect:(struct _NSRect)fp12;
- (int)_rowAtEventLocation:(id)fp8;
- (void)_trackMouseDown:(id)fp8 inRow:(int)fp12 allowDrag:(BOOL)fp16;
- (BOOL)acceptsFirstMouse:(id)fp8;
- (id)_menuForEvent:(id)fp8;
- (id)menuForEvent:(id)fp8;
- (void)mouseDown:(id)fp8;
- (BOOL)mouseIsDownInView;
- (struct _NSRect)visibleRect;
- (id)_imageOfGroupRow:(int)fp8 withNumberString:(id)fp12 drawWhiteBackground:(BOOL)fp16;
- (id)imageOfGroupRow:(int)fp8 drawWhiteBackground:(BOOL)fp12;
- (id)_imageOfGroupRow:(int)fp8 withNumberString:(id)fp12;
- (id)imageOfRows:(struct _NSRange)fp8 fraction:(float)fp16 shadow:(id)fp20;
- (id)_currentImageOfRowAtIndex:(int)fp8;
- (struct _NSRect)_rectToMoveWithMinY:(float)fp8 range:(struct _NSRange)fp12 extraRow:(BOOL)fp20;
- (id)_imageOfRect:(struct _NSRect)fp8;
- (void)_runAnimationAt:(struct _NSPoint)fp8 headerBefore:(id)fp16 headerAfter:(id)fp20 rowsToMove:(id)fp24 howFar:(float)fp28 reveal:(BOOL)fp32 extraMovement:(float)fp36;
- (BOOL)runningGroupAnimation;
- (void)concealRowsInRange:(struct _NSRange)fp8;
- (void)finishConcealRowsInRange:(struct _NSRange)fp8;
- (void)revealRowsInRange:(struct _NSRange)fp8;
- (void)draggedImage:(id)fp8 endedAt:(struct _NSPoint)fp12 operation:(unsigned int)fp20;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)fp8;
- (void)tabletPoint:(id)fp8;
- (void)mouseUp:(id)fp8;
- (void)mouseDragged:(id)fp8;
- (void)rightMouseDown:(id)fp8;
- (void)rightMouseUp:(id)fp8;
- (void)otherMouseDown:(id)fp8;
- (void)otherMouseUp:(id)fp8;
- (void)rightMouseDragged:(id)fp8;
- (void)otherMouseDragged:(id)fp8;
- (void)_closeTooltip;
- (void)_abortTooltip;
- (void)cancelTooltips;
- (void)_makeTooltipVisible;
- (void)_updateTooltip;
- (void)_showTooltip;
- (void)_delayTooltip;
- (void)_updateTooltipPoint:(struct _NSPoint)fp8;
- (void)_setMouseInside:(BOOL)fp8;
- (BOOL)mouseInside;
- (int)previousHoveredRow;
- (void)_cancelMouseTracking;
- (void)_updateForMovementAtPoint:(struct _NSPoint)fp8;
- (void)mouseMoved:(id)fp8;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)_windowDidResignKey:(id)fp8;
- (void)_appDidHide:(id)fp8;
- (void)_appResignedActive:(id)fp8;
- (void)_windowDidBecomeKey:(id)fp8;
- (void)_windowWillClose:(id)fp8;
- (void)_boundsChanged:(id)fp8;
- (void)_setTracking:(BOOL)fp8 window:(id)fp12;
- (void)setTracksOnlyWhenWindowIsKey:(BOOL)fp8;
- (BOOL)tracksOnlyWhenWindowIsKey;
- (void)setTrackingRectsEnabled:(BOOL)fp8;
- (BOOL)trackingRectsEnabled;
- (BOOL)redisplayCellsOnMouseover;
- (void)setRedisplayCellsOnMouseover:(BOOL)fp8;

@end

@interface AnimatingTableView : FezExtendedTableView
{
    BOOL _animationEnabled;
    BOOL _drawingRowIntoImageCache;
    NSMutableDictionary *_originsSnapshot;
    SimpleArray *_prevRowOrigins;
    NSDate *_startTime;
    double _animationTime;
    struct _NSRange _movementRange;
    struct _NSRect _movementRect;
    double _spline;
    NSImage **_rowCache;
    int _rowCacheSize;
    NSTimer *_timer;
}

- (void)_clearRowCache;
- (void)removeFromSuperview;
- (void)_finishAnimation;
- (void)dealloc;
- (void)logDebugInfo;
- (struct _NSPoint)_animatedRowOrigin:(int)fp8;
- (id)_prevRowOriginsFromSnapshot;
- (void)forgetIndexes;
- (void)rememberIndexes;
- (void)stepAnimation:(id)fp8;
- (void)animateMovementOverTime:(double)fp8;
- (void)setAnimationEnabled:(BOOL)fp8;
- (BOOL)isAnimationEnabled;
- (BOOL)drawsSelection;
- (void)_drawHighlightForRowCacheOfSize:(struct _NSSize)fp8;
- (void)drawRow:(int)fp8 clipRect:(struct _NSRect)fp12;
- (struct _NSRect)rectOfRow:(int)fp8;
- (void)setDrawingIntoRowCache:(BOOL)fp8;
- (struct _NSRect)frameOfCellAtColumn:(int)fp8 row:(int)fp12;
- (struct _NSRange)rowsInRect:(struct _NSRect)fp8;
- (int)numberOfRows;
- (void)tile;
- (void)reloadData;
- (void)rowHeightsChanged;
- (void)concealRowsInRange:(struct _NSRange)fp8;
- (void)revealRowsInRange:(struct _NSRange)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityDescriptionAttribute;

@end

@interface Animator : NSObject
{
    NSTimer *_timer;
    NSDate *_startTime;
    id _target;
    double _animationTime;
    float _fps;
    CDAnonymousStruct10 _contour;
    void *_applyContour;
    float _linearProgress;
    float _progress;
    BOOL _reversed;
    BOOL _autoreverses;
}

+ (CDAnonymousStruct10)defaultContourForType:(int)fp8;
+ (BOOL)isContourValid:(CDAnonymousStruct10)fp8;
+ (float)applySimpleContour:(int)fp8 toValue:(float)fp12;
+ (float)applyContour:(CDAnonymousStruct10)fp8 toValue:(float)fp28;
+ (id)linearAnimatorWithTarget:(id)fp8 time:(double)fp12 fps:(float)fp20;
+ (id)easeOutAnimatorWithTarget:(id)fp8 time:(double)fp12 fps:(float)fp20;
+ (id)sineWaveAnimatorWithTarget:(id)fp8 time:(double)fp12 fps:(float)fp20;
- (id)initWithTarget:(id)fp8 time:(double)fp12 fps:(float)fp20 contour:(CDAnonymousStruct10)fp24;
- (void)_timerStep:(id)fp8;
- (void)setAutoreverses:(BOOL)fp8;
- (BOOL)autoreverses;
- (void)start;
- (void)startSynchronous;
- (void)reverse;
- (void)stop;
- (void)complete;
- (BOOL)isAnimating;
- (BOOL)isSynchronous;
- (BOOL)isReversed;
- (void)setAnimationTime:(double)fp8;
- (double)animationTime;
- (float)fps;
- (CDAnonymousStruct10)contour;
- (double)elapsedTime;
- (float)linearProgress;
- (float)progress;

@end

@interface AttachmentButton : NSButton
{
    NSString *_filePath;
    NSImage *_baseIcon;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)awakeFromNib;
- (void)dealloc;
- (id)attachedFile;
- (void)setAttachedFile:(id)fp8;
- (BOOL)sendAction:(SEL)fp8 to:(id)fp12;
- (void)_attachmentChosen:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (id)_fileBeingDraggedFrom:(id)fp8;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (void)draggingExited:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;

@end

@interface AudioConferenceView : NSView
{
    AudioChatController *_acController;
    unsigned int _audioConferenceMode;
}

- (id)initWithFrame:(struct _NSRect)fp8 controller:(id)fp24;
- (void)setAudioConferenceMode:(unsigned int)fp8;
- (unsigned int)audioConferenceMode;
- (id)_participantForDragInfo:(id)fp8;
- (void)_highlightParticipant:(id)fp8;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (void)draggingExited:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (BOOL)isFlipped;
- (struct _NSRect)_frameOfParticipantViewAtIndex:(int)fp8;
- (float)_heightAdjustmentForCount:(int)fp8;
- (void)_createGradient;
- (void)_adjustHeight;
- (unsigned int)_subviewIndexOfParticipant:(id)fp8;
- (unsigned int)_subviewIndexOfParticipantWithID:(id)fp8;
- (id)_viewForParticipant:(id)fp8;
- (void)_addParticipant:(id)fp8 saveNib:(BOOL)fp12;
- (void)addParticipant:(id)fp8;
- (void)addParticipants:(id)fp8;
- (void)removeParticipantWithID:(id)fp8;
- (int)participantCount;
- (BOOL)containsParticipantWithID:(id)fp8;
- (id)participants;
- (void)startConnectingParticipant:(id)fp8;
- (void)connectParticipant:(id)fp8;
- (void)disconnectParticipant:(id)fp8;
- (void)recordingPermissionRequestedForParticipant:(id)fp8;
- (void)recordingPermissionGrantedForParticipant:(id)fp8;
- (void)recordingPermissionDeniedForParticipant:(id)fp8;
- (void)recordingPermissionForgottenForParticipant:(id)fp8;
- (void)finishARDUpgradeForParticipant:(id)fp8;
- (void)_updateMouseTrackingAndRefresh:(BOOL)fp8;
- (void)refreshMouseTracking;
- (void)updateMouseTracking;

@end

@interface AudioSampler : NSObject
{
    NSMutableSet *_localObservers;
    BOOL _micIrisClosed;
    NSMutableDictionary *_remoteObservers;
    NSTimer *_timer;
    FZVideoConferenceController *_vcc;
}

+ (id)sharedSampler;
- (id)init;
- (void)dealloc;
- (void)_broadcastLevel;
- (void)_startTimerIfNecessary;
- (void)_stopTimerIfPossible;
- (void)_handleMicChangeNotification:(id)fp8;
- (void)addLocalObserver:(id)fp8;
- (void)removeLocalObserver:(id)fp8;
- (void)addRemoteObserver:(id)fp8 forUserID:(id)fp12;
- (void)_clearRemoteObserversIfPossible;
- (void)removeRemoteObserverForUserID:(id)fp8;
- (void)removeRemoteObserver:(id)fp8;

@end

@interface Notifier : NSObject
{
    NSWindow *_realWindow;
    CustomWindow *_floaterWindow;
    struct _NSPoint _floaterOffset;
    float _prevRealHeight;
    BOOL _canHideShowRealWindow;
    int _stage;
    BOOL _respondedToInvite;
    int _inviteType;
    struct CGAffineTransform _finalXform;
    NSString *_openNoteID;
    NSDictionary *_eventActions;
    Presentity *_sender;
    BOOL _beSilent;
    BOOL _forcedOrderFront;
}

+ (id)floaterBackgroundColor;
+ (void)addItemsToMenu:(id)fp8 atIndex:(unsigned int)fp12 fromData:(id)fp16 target:(id)fp20 action:(SEL)fp24;
+ (id)notifierWithType:(int)fp8 from:(id)fp12;
+ (id)notifierWithType:(int)fp8 fromID:(id)fp12;
+ (id)allNotifiers;
+ (id)staleNotifiersWithType:(int)fp8 fromID:(id)fp12;
+ (void)orderFrontNotifierWithID:(id)fp8;
- (id)init;
- (void)dealloc;
- (void)installSecurityNotificationsFrom:(id)fp8;
- (void)installRealWindowNotifications;
- (BOOL)respondedToInvite;
- (void)setRespondedToInvite:(BOOL)fp8;
- (int)inviteType;
- (void)setInviteType:(int)fp8;
- (BOOL)canHideShowRealWindow;
- (void)setCanHideShowRealWindow:(BOOL)fp8;
- (int)stage;
- (void)setStage:(int)fp8;
- (id)sender;
- (void)setSender:(id)fp8;
- (void)setupChildRelationshipWithNotifierMain:(BOOL)fp8;
- (id)openNoteID;
- (void)setOpenNoteID:(id)fp8;
- (struct _NSPoint)floaterOffset;
- (void)setFloaterOffset:(struct _NSPoint)fp8;
- (void)moveFloaterOffset:(struct _NSSize)fp8;
- (float)previousRealHeight;
- (void)setPreviousRealHeight:(float)fp8;
- (BOOL)isActiveNotification;
- (BOOL)isStale;
- (id)floaterWindow;
- (id)realWindow;
- (void)setRealWindow:(id)fp8;
- (BOOL)_collidesWithExistingWindow:(struct _NSRect)fp8;
- (void)positionRealWindowInCorner:(BOOL)fp8;
- (void)buildFloaterWindowWithFrame:(struct _NSRect)fp8 styleMask:(int)fp24;
- (void)setAccessibilityDescription:(id)fp8;
- (void)setSilent:(BOOL)fp8;
- (BOOL)silent;
- (void)performActionsForEvent:(int)fp8 message:(id)fp12;
- (void)setEventActions:(id)fp8;
- (void)stopEventActions;
- (void)_addSelfToNotifierList;
- (BOOL)isRealWindowHidden;
- (void)updateLockUI;
- (void)_securityLevelChanged:(id)fp8;
- (struct CGAffineTransform)_xformForFloaterScale:(float)fp8;
- (void)_doAnimateFloaterDisplay;
- (void)animateFloaterDisplay;
- (void)_doFrameOfFloaterDisplay:(id)fp8;
- (void)floaterWillBecomeVisible;
- (void)floaterBecomingVisible;
- (void)forceOrderFrontRealWindow;
- (void)orderFrontRealWindow;
- (void)_animateRealDisplay:(id)fp8;
- (void)_doFrameOfRealDisplay:(id)fp8;
- (void)realWindowVisible;
- (BOOL)canShowRealWindow;
- (BOOL)canHideRealWindow;
- (void)_animateRealHiding;
- (void)_doFrameOfRealHiding:(id)fp8;
- (void)realWindowHiding;
- (void)floaterVisible;
- (void)_blockSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)closeDownShop:(BOOL)fp8;
- (void)_rejectNotificationAndCloseRealWindow:(BOOL)fp8;
- (void)rejectNotificationAndCloseRealWindow:(BOOL)fp8;
- (void)acceptNotification;
- (void)blockNotification;
- (void)_realWindowDidBecomeKey:(id)fp8;
- (void)_realWindowDidResize:(id)fp8;
- (void)_realWindowWillMiniaturize:(id)fp8;
- (void)_realWindowWillClose:(id)fp8;
- (void)_realWindowResignedMain:(id)fp8;
- (void)_realWindowBeginSheet:(id)fp8;
- (void)_realWindowEndSheet:(id)fp8;
- (void)_appWillHide:(id)fp8;
- (void)_appDidUnhide:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (id)menuItemFormat;

@end

@interface BannerNotifier : Notifier
{
    AVParticipantView *_bannerView;
}

- (BOOL)isActiveNotification;
- (id)bannerView;
- (void)makeFloaterWindow;
- (void)dealloc;

@end

@interface AuthNotifier : BannerNotifier
{
    NSWindowController *_authRequest;
}

+ (void)openOnJabberAuthRequestFrom:(id)fp8;
- (id)bannerView;
- (id)initWithJabberAuthRequest:(id)fp8;
- (void)dealloc;

@end

@interface AutoAway : NSObject <ScreenSaverMonitorListener>
{
    NSPanel *_welcomeBackPanel;
    NSTextField *_messageField;
    NSButton *_dontShowAgainCheckbox;
    NSString *_availableMessage;
    BOOL _idleWhileAway;
    BOOL _canceledWelcomeBack;
    BOOL _autoAway;
    NSTimer *_autoAwayTimer;
}

+ (void)install;
+ (int)welcomeBackMode;
+ (void)setWelcomeBackMode:(int)fp8;
+ (BOOL)autoAwayEnabled;
+ (void)setAutoAwayEnabled:(BOOL)fp8;
+ (double)autoAwayDelay;
+ (void)setAutoAwayDelay:(double)fp8;
+ (void)setAutoReplyEnabled:(BOOL)fp8;
- (id)init;
- (void)dealloc;
- (void)_myStatusChanged:(id)fp8;
- (void)_welcomeBack;
- (void)_setAutoAwayIfNecessary;
- (void)_autoAwayTimerFired;
- (void)_clearAutoAwayTimer;
- (void)_startAutoAwayTimer;
- (void)awakeFromNib;
- (void)goAvailable:(id)fp8;
- (void)dontGoAvailable:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)screenSaverDidStart;
- (void)screenSaverDidStop;

@end

@interface AutoManualSlider : NSSlider
{
}

- (double)logicalValue;
- (void)setLogicalValue:(double)fp8;
- (BOOL)automatic;
- (void)constrainValueWhileDragging;
- (BOOL)sendAction:(SEL)fp8 to:(id)fp12;

@end

@interface AutoSendTextField : NSTextField
{
    NSDate *_firstKey;
    NSDate *_lastKey;
    NSTimer *_timer;
    unsigned int _disableAutoSend:1;
    unsigned int _nonEmpty:1;
    unsigned int _significantChange:1;
    unsigned int _dirty:1;
}

+ (void)initialize;
- (void)prepareToRelease;
- (void)dealloc;
- (BOOL)textChangedSinceSent;
- (void)setDirty:(BOOL)fp8;
- (void)setAutoSend:(BOOL)fp8;
- (void)_autoSend:(int)fp8;
- (void)_timerFired;
- (BOOL)textView:(id)fp8 shouldChangeTextInRange:(struct _NSRange)fp12 replacementString:(id)fp20;
- (void)textDidChange:(id)fp8;

@end

@interface AuxVideoAlert : NSWindowController
{
}

+ (void)showAlert:(BOOL)fp8;
- (void)windowDidLoad;
- (void)windowWillClose:(id)fp8;
- (void)cancelAuxVideo:(id)fp8;

@end

@interface MoviePlayer : NSObject
{
    QTMovie *_movie;
    struct _NSSize _movieSize;
    struct OpaqueQTVisualContext *_textureContext;
    NSConditionLock *_postingLock;
    NSOpenGLContext *_context;
}

- (id)init;
- (void)dealloc;
- (void)gotoBeginning;
- (void)play;
- (void)stop;
- (void)_initOpenGL;
- (void)cleanup;
- (void)_prepareMovie;
- (void)openMovie:(id)fp8;
- (void)openMovieFromPath:(id)fp8;
- (void)_newFrameRequested;
- (void)_renderFrame;
- (void)provideFrame:(struct __CVBuffer *)fp8;
- (id)movie;

@end

@interface AuxVideoMoviePlayer : MoviePlayer
{
    BOOL _playing;
}

- (void)play;
- (void)stop;
- (void)provideFrame:(struct __CVBuffer *)fp8;

@end

@interface AuxVideoReceiver : NSObject <IMAuxVideoReceiver>
{
    IMLocalObject *_videoReceiver;
    IMRemoteObject<IMAuxVideoProvider> *_videoProvider;
    NSString *_providerBundleID;
    NSString *_newProviderBundleID;
    int _numAudioChannels;
    BOOL _optimizeForStills;
    BOOL _replacementMode;
    BOOL _receivedFrameFromThisProvider;
    BOOL _theaterDisabled;
    NSTimer *_activityTimeoutTimer;
    BOOL _runServer;
    VideoProcessor *_videoProcessor;
    IMSharedPixelBufferPool *_sharedBufferPool;
    unsigned int _state;
    unsigned int _providerPixelFormat;
    struct _NSSize _auxVideoSize;
    double _framerate;
    BOOL _setFramerateScheduled;
}

+ (id)sharedAuxVideoReceiver;
- (id)init;
- (void)dealloc;
- (void)_activityTimeout;
- (void)_registerActivity:(BOOL)fp8;
- (BOOL)hasAudioProvider;
- (BOOL)hasVideoProvider;
- (id)providerBundleID;
- (BOOL)optimizeVideoForStills;
- (BOOL)replacementMode;
- (unsigned int)state;
- (void)_setInputState:(unsigned int)fp8;
- (BOOL)startServerForProvider:(id)fp8 URL:(id)fp12;
- (void)stopServer;
- (void)setTheaterDisabled:(BOOL)fp8 forceDisconnect:(BOOL)fp12;
- (BOOL)isTheaterDisabled;
- (void)_receiverDidDie:(id)fp8;
- (void)_mainThreadClientDidDisconnect:(id)fp8;
- (void)_clientDidDisconnect:(id)fp8;
- (void)_configureProvider;
- (oneway void)provider:(id)fp8 bundleID:(id)fp12 connectWithPixelFormat:(unsigned long)fp16 videoStills:(BOOL)fp20 replacement:(BOOL)fp24 audioChannels:(int)fp28;
- (void)beginAuxiliaryInput:(struct _NSSize)fp8;
- (void)cancelAuxiliaryInput;
- (void)endAuxiliaryInput;
- (void)_setFramerate:(id)fp8;
- (void)updateFramerateWith:(id)fp8;
- (oneway void)provider:(id)fp8 sentBuffer:(int)fp12 withAttachments:(id)fp16;

@end

@interface AuxVideoViewPlayer : NSObject
{
    BOOL _playing;
    NSView *_playerView;
    struct __CVPixelBufferPool *_cvPixelBufferPool;
}

- (id)init;
- (void)dealloc;
- (void)playView:(id)fp8;
- (void)stop;
- (void)cleanup;
- (void)_newFrameRequested;

@end

@interface BaseThreadedObject : NSObject
{
    id _delegate;
    BOOL _kill;
    BOOL _inProgress;
    BOOL _willNotFork;
    float _timeout;
    NSTimer *_timeoutTimer;
    BOOL _done;
}

- (void)setTimeout:(double)fp8;
- (void)_clearTimeoutTimer;
- (void)_timeoutHit:(id)fp8;
- (void)_setTimeoutTimer;
- (id)init;
- (void)dealloc;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (void)setWillNotFork:(BOOL)fp8;
- (BOOL)willNotFork;
- (void)_threadedDoStart;
- (void)_doSendDone;
- (void)_workerThread;
- (void)_timedOut;
- (void)_workerThreadFinished;
- (void)startThread;
- (void)stopWatchingThread;
- (BOOL)inProgress;
- (BOOL)done;

@end

@interface BlackNotifierContentView : NSView
{
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface BlockListController : NSObject
{
    NSView *prefsView;
    NSPanel *editListPanel;
    NSButton *addButton;
    NSButton *deleteButton;
    NSTableView *tableView;
    NSTextField *tableLabel;
    NSMatrix *blockModeMatrix;
    Prefs_Accounts *prefsController;
    BOOL _dirty;
    BOOL _blockStopEditing;
    int _mode;
    NSMutableArray *_list;
    AbstractAccount *_account;
}

+ (id)_presentityNamesFromPasteboard:(id)fp8;
- (id)init;
- (void)awakeFromNib;
- (void)setAccount:(id)fp8;
- (id)account;
- (void)dealloc;
- (void)_accountPrivacySettingsChanged:(id)fp8;
- (void)_setupControls;
- (void)_showList;
- (void)blockingModeChanged:(id)fp8;
- (void)_listEditingDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(id)fp16;
- (void)showBlockList:(id)fp8;
- (void)showAllowList:(id)fp8;
- (void)doneEditing:(id)fp8;
- (void)addRow:(id)fp8;
- (void)deleteRow:(id)fp8;
- (void)tableViewSelectionDidChange:(id)fp8;
- (void)controlTextDidBeginEditing:(id)fp8;
- (void)controlTextDidEndEditing:(id)fp8;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)_stopEditing:(id)fp8;
- (void)_emptyList;
- (void)tableView:(id)fp8 setObjectValue:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (BOOL)tableView:(id)fp8 shouldEditTableColumn:(id)fp12 row:(int)fp16;
- (unsigned int)tableView:(id)fp8 validateDrop:(id)fp12 proposedRow:(int)fp16 proposedDropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 acceptDrop:(id)fp12 row:(int)fp16 dropOperation:(unsigned int)fp20;

@end

@interface BonjourXHTMLGenerator : XHTMLGenerator
{
}

+ (id)parseHTML:(id)fp8 resultingBGColor:(id *)fp12 resultingFontColor:(id *)fp16 defaultFont:(id)fp20;
+ (id)_generatorString;
- (void)_pushHTMLTag;
- (void)_pushBodyTagWithForegroundColor:(id)fp8 backgroundColor:(id)fp12 isRTL:(BOOL)fp16;
- (id)_currentColor;
- (id)_currentBgColor;
- (id)_currentFont;
- (void)_generateTagsWithBold:(id)fp8 italic:(id)fp12 link:(id)fp16 font:(id)fp20 color:(id)fp24 bgColor:(id)fp28 underline:(id)fp32 myName:(id)fp36;

@end

@interface BorderedButton : NSButton
{
}

+ (Class)cellClass;
- (void)_commonInit;
- (void)awakeFromNib;
- (id)initWithFrame:(struct _NSRect)fp8;

@end

@interface BorderedButtonCell : NSButtonCell
{
}

- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)drawWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface BorderedProgressIndicator : NSProgressIndicator
{
}

- (void)awakeFromNib;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface BuddyInfo : NSWindowController
{
    ABPerson *_abPerson;
    NSArray *_presentities;
    BOOL _profileViewsLayoutPending;
    BOOL _setFirstNamePending;
    BOOL _setLastNamePending;
    BOOL _setNicknamePending;
    BOOL _tryToMergeABPerson;
    BOOL _updatingUI;
    BOOL _fitProfile;
    ActionsController *_actionsController;
    NSWindow *_infoWindow;
    NSSegmentedControl *_tabControl;
    NSTabView *_tabView;
    NSTabViewItem *_profileTab;
    NSView *_profileContainer;
    NSTabViewItem *_actionsTab;
    NSTabViewItem *_addressCardTab;
    ABPictureControl *_abPicture;
    NSButton *_abAlwaysUsePictureButton;
    NSTextField *_abAlwaysUsePictureField;
    NSTextField *_abFirstNameField;
    NSTextField *_abLastNameField;
    NSTextField *_abNicknameField;
    NSTokenField *_abEmailField;
    NSTextField *_abAIMLabel;
    NSTokenField *_abAIMField;
    NSTextField *_abJabberLabel;
    NSTokenField *_abJabberField;
    NSButton *_abButton;
    NSMenu *_tokenMenu;
    NSWindow *_peoplePickerSheet;
    PeoplePicker *_peoplePicker;
    NSButton *_chooseCardButton;
}

+ (id)openForPresentity:(id)fp8 showProfile:(BOOL)fp12;
+ (id)videoFrameProviderForPictureTaker:(id)fp8;
+ (void)pictureTakerDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
+ (void)openPictureIconWidgetWithImage:(id)fp8 forPresentity:(id)fp12 allowEditing:(BOOL)fp16;
- (void)_setupMetrics;
- (id)_personName;
- (void)_updateWindowTitle;
- (void)windowDidLoad;
- (void)selectTab:(id)fp8;
- (void)actionsControllerChanged:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)dealloc;
- (id)_bestCustomPicture;
- (void)_updatePictureUI;
- (void)_updatePresentitiesArrayWithABPerson:(id)fp8 orPresentity:(id)fp12;
- (void)_updateUIWithNoBuddyList;
- (void)_updateUIWithABPerson;
- (void)_updateUIWithNoABPerson;
- (void)_updateUI;
- (id)tokenField:(id)fp8 shouldAddObjects:(id)fp12 atIndex:(unsigned int)fp16;
- (BOOL)control:(id)fp8 textView:(id)fp12 doCommandBySelector:(SEL)fp16;
- (void)_abDBChanged:(id)fp8;
- (void)_setABPerson:(id)fp8;
- (void)_addPresentitiesToABPerson:(id)fp8 andSave:(BOOL)fp12;
- (void)_setABPerson:(id)fp8 addPresentity:(BOOL)fp12;
- (id)_existingCardsWithFirstName:(id)fp8 lastName:(id)fp12 nickname:(id)fp16;
- (void)_createCardWithFirstName:(id)fp8 lastName:(id)fp12 nickname:(id)fp16 addPresentity:(BOOL)fp20;
- (void)_createCardAndAddPresentity:(BOOL)fp8;
- (void)setPicture:(id)fp8;
- (void)toggleAlwaysUsePicture:(id)fp8;
- (void)_editPicture:(id)fp8;
- (void)_addEmails:(id)fp8 toABPerson:(id)fp12;
- (void)_mergeWith:(id)fp8;
- (void)_setName;
- (void)_setFirstName;
- (void)_setLastName;
- (void)_setNickname;
- (void)setFirstName:(id)fp8;
- (void)setLastName:(id)fp8;
- (void)setNickname:(id)fp8;
- (void)setAccountIDs:(id)fp8;
- (id)_selectedABPerson;
- (void)_peoplePickerDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_pickerDoubleClicked;
- (void)dismissPeoplePicker:(id)fp8;
- (void)_peoplePickerValueUpdated:(id)fp8;
- (void)addressBookButton:(id)fp8;
- (BOOL)tokenField:(id)fp8 hasMenuForRepresentedObject:(id)fp12;
- (id)tokenField:(id)fp8 menuForRepresentedObject:(id)fp12;
- (void)startChat:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)sendMessage:(id)fp8;
- (void)sendDirectMessage:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)sendFile:(id)fp8;
- (void)toggleBuddy:(id)fp8;
- (void)block:(id)fp8;
- (void)requestValidation:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (struct _NSSize)_windowSizeForTabSize:(struct _NSSize)fp8;
- (float)_profileTabHeight;
- (struct _NSSize)_maxSizeForProfile;
- (struct _NSSize)_minSizeForProfile;
- (void)_updateMinMaxSizeForProfile;
- (void)_layoutProfileViews;
- (void)setProfileViewsNeedLayout;
- (void)_createProfileViews;
- (void)windowDidResize:(id)fp8;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;

@end

@interface DirectlyObservableObject : NSObject
{
    NSMutableArray *_observers;
}

- (id)init;
- (void)dealloc;
- (void)_objectDidPostNotification:(id)fp8;
- (void)addObserver:(id)fp8;
- (void)removeObserver:(id)fp8;
- (id)observers;
- (void)informObserversOfNotification:(id)fp8;

@end

@interface Presence : DirectlyObservableObject <DirectlyObservableObjectObserver>
{
    BOOL _quiet;
    NSMutableArray *_presentities;
    NSMutableSet *_presentitiesSet;
    unsigned int _previousStatus;
    unsigned int _status;
    NSString *_statusMessage;
    Presentity *_mostAvailablePresentity;
}

+ (id)notifications;
+ (id)selectors;
- (id)init;
- (void)dealloc;
- (BOOL)isQuiet;
- (void)setIsQuiet:(BOOL)fp8;
- (void)_observePresentity:(id)fp8;
- (void)_unobservePresentity:(id)fp8;
- (void)_presentityCapabilitiesChanged:(id)fp8;
- (void)_presentityStatusChanged:(id)fp8;
- (void)_presentityPictureChanged:(id)fp8;
- (void)_presentityInfoChanged:(id)fp8;
- (void)_presentityGroupsChanged:(id)fp8;
- (void)_presentityExtraPropsChanged:(id)fp8;
- (void)_presentityMobileChanged:(id)fp8;
- (void)_presentityCertsChanged:(id)fp8;
- (void)_presentitySortOrderChanged:(id)fp8;
- (void)objectDidPostDirectNotification:(id)fp8;
- (void)_setMostAvailablePresentity:(id)fp8;
- (BOOL)_fullRecache;
- (BOOL)canAddPresentity:(id)fp8;
- (BOOL)addPresentity:(id)fp8;
- (void)removePresentity:(id)fp8;
- (int)numberOfPresentities;
- (BOOL)containsPresentity:(id)fp8;
- (id)presentitySet;
- (id)presentities;
- (id)mostAvailablePresentity;
- (id)groups;
- (id)firstName;
- (id)lastName;
- (id)fullName;
- (id)shortName;
- (id)displayName;
- (id)nameAndEmail;
- (BOOL)isAnonymous;
- (unsigned int)status;
- (unsigned int)previousStatus;
- (id)statusMessage;
- (id)previousStatusMessage;
- (id)nameOfStatus;
- (BOOL)isMobile;
- (id)mobileDeviceName;
- (BOOL)hasPicture;
- (id)picture;
- (id)smallStatusIcon;
- (id)balloonColor;
- (id)tooltipString;
- (double)timeSinceWentOffline;
- (double)timeSinceStatusChanged;
- (BOOL)hasValidCertificates;
- (BOOL)canBeSecure;
- (void)postNotificationNamed:(id)fp8 forPresentity:(id)fp12;
- (id)description;

@end

@interface BuddyListPresence : Presence
{
    NSSet *_filterGroups;
    NSArray *_filterABPersons;
    NSArray *_filterServices;
    NSString *_filterSingleGroup;
}

- (id)initWithABPersonFilters:(id)fp8 serviceFilters:(id)fp12 groupFilters:(id)fp16 quiet:(BOOL)fp20;
- (id)initWithABPersonFilters:(id)fp8 serviceFilters:(id)fp12 groupFilters:(id)fp16;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (void)dealloc;
- (id)group;
- (id)service;
- (id)abPerson;
- (id)_filterSingleGroup;
- (id)groups;
- (id)_servicesArray;
- (id)services;
- (id)_abPersonsArray;
- (id)abPersons;
- (BOOL)canAddPresentity:(id)fp8;
- (BOOL)isEqual:(id)fp8;
- (unsigned int)sortOrder;

@end

@interface BuddyPicture : NSObject
{
    NSData *_data;
    NSDataRetainingImage *_image;
    struct _NSSize _size;
    NSMutableDictionary *_cache;
    NSMutableArray *_repcache;
    BOOL _animating;
    int _currentframe;
    int _frames;
    NSMutableDictionary *_frameDelays;
    NSBitmapImageRep *_animatedRep;
    BOOL _lookedForAnimatedRep;
    NSTimer *_animationStopTimer;
    NSDate *_lastDrawn;
    NSTimer *_animationTimer;
    NSString *_key;
}

+ (id)buddyPictureStore;
+ (id)allBuddyPictures;
+ (id)keyForData:(id)fp8;
+ (void)rememberBuddyPicture:(id)fp8 withKey:(id)fp12;
+ (void)removeBuddyPicture:(id)fp8;
+ (id)buddyPictureForKey:(id)fp8;
+ (id)buddyPictureWithData:(id)fp8 key:(id)fp12;
+ (id)buddyPictureWithData:(id)fp8;
+ (id)buddyPictureWithImage:(id)fp8;
+ (void)initialize;
+ (void)_postCleanupNotification:(id)fp8;
+ (id)runLoopDrawingModes;
+ (void)_setupFramePulse;
+ (void)_cleanupFrameTimer;
+ (void)buddyPictureTimerFired:(id)fp8;
+ (void)_userSwitchedOut;
+ (void)_userSwitchedIn;
+ (void)enqueBuddyPicturePost:(id)fp8;
- (void)_registerForPreferenceChanges;
- (id)init;
- (id)initWithData:(id)fp8 key:(id)fp12;
- (id)initWithData:(id)fp8;
- (id)initWithImage:(id)fp8 key:(id)fp12;
- (id)initWithImage:(id)fp8;
- (id)key;
- (void)dealloc;
- (void)_cleanupAnimationIfNecessary:(id)fp8;
- (void)_animationPrefsChanged:(id)fp8;
- (id)description;
- (id)data;
- (struct _NSSize)size;
- (void)_cacheImage;
- (void)flushCaches;
- (BOOL)hasNiceAlpha;
- (id)image;
- (void)addToRecentPicturesWithUserInfo:(void *)fp8;
- (void)stopAnimation;
- (void)_pushOutStopTimer;
- (void)_stepAnimationTimer:(id)fp8;
- (void)_synchronizeFrame:(float)fp8;
- (void)stepAnimation;
- (void)startAnimation;
- (float)nextFrameDelayForFrame:(int)fp8;
- (float)nextFrameDelay;
- (int)frames;
- (id)animatedRepresentation;
- (BOOL)shouldAnimate;
- (id)imageWithMaxSize:(struct _NSSize)fp8 frame:(int)fp16;
- (id)imageWithMaxSize:(struct _NSSize)fp8;
- (id)imageWithSize:(struct _NSSize)fp8;
- (id)_dataRepresentation;
- (id)dataRepresentation;
- (id)TIFFRepresentation;
- (void)drawUncroppedInRect:(struct _NSRect)fp8 inView:(id)fp24 operation:(unsigned int)fp28 fraction:(float)fp32 firstFrameOnly:(BOOL)fp36 scaled:(BOOL)fp40;
- (void)drawInRect:(struct _NSRect)fp8 operation:(unsigned int)fp24 fraction:(float)fp28 firstFrameOnly:(BOOL)fp32 scaled:(BOOL)fp36;
- (void)drawInRect:(struct _NSRect)fp8 operation:(unsigned int)fp24 fraction:(float)fp28 firstFrameOnly:(BOOL)fp32;
- (void)drawInRect:(struct _NSRect)fp8 inView:(id)fp24 operation:(unsigned int)fp28 fraction:(float)fp32 firstFrameOnly:(BOOL)fp36;
- (void)drawInRect:(struct _NSRect)fp8 inView:(id)fp24 operation:(unsigned int)fp28 fraction:(float)fp32 firstFrameOnly:(BOOL)fp36 scaled:(BOOL)fp40;
- (id)dataWithMaxSize:(struct _NSSize)fp8 minSize:(struct _NSSize)fp16 maxDataSize:(float)fp24 allowAnimated:(BOOL)fp28;
- (id)animatedGIFDataWithSize:(struct _NSSize)fp8 minSize:(struct _NSSize)fp16 maxDataSize:(float)fp24;

@end

@interface BuddyPictureCell : NSActionCell
{
    PeopleList *_peopleList;
    struct _NSSize _iconSize;
}

- (id)initWithPeopleList:(id)fp8;
- (struct _NSRect)rectOfPictureWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)setIconSize:(struct _NSSize)fp8;
- (struct _NSSize)iconSize;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (id)presentity;
- (id)peopleListItem;
- (BOOL)shouldAnimate;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface BuddyPictureCell (BuddyPictureCellAccessibility)
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityDescriptionAttribute;
- (id)accessibilityValueAttribute;
@end

@interface CameraCountdownController : NSObject
{
    NSMutableArray *_timers;
    BOOL _isSilent;
    struct ComponentInstanceRecord *_musicDeviceAU;
    struct ComponentInstanceRecord *_systemOutputAU;
    unsigned int _instrumentID;
    float _pitch;
    float _velocity;
    unsigned int _noteInstanceID;
}

+ (id)defaultCountdownController;
- (id)init;
- (BOOL)isSilent;
- (void)setIsSilent:(BOOL)fp8;
- (void)dealloc;
- (void)_setupNote;
- (void)_cleanupNote;
- (void)_playNote;
- (void)_playSilence;
- (void)start;
- (void)_countdownAdvanced;
- (void)_countdownFinished;
- (void)cancel;

@end

@interface CameraCountdownView : NSView
{
    unsigned int _counter;
    NSImage *_backgroundImage;
    NSImage *_threeDimmed;
    NSImage *_threeOn;
    NSImage *_twoDimmed;
    NSImage *_twoOn;
    NSImage *_oneDimmed;
    NSImage *_oneOn;
    NSImage *_cameraDimmed;
    NSImage *_cameraOn;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (void)drawImage:(id)fp8 atPoint:(struct _NSPoint)fp12;
- (void)drawRect:(struct _NSRect)fp8;
- (void)resetCounter;
- (void)nextCounter;

@end

@interface OpenGLLayerView : NSOpenGLView
{
    CIContext *_ciContext;
    OpenGLLayerModel *_layerModel;
    NSImage *_offscreenImage;
    float _bgRed;
    float _bgGreen;
    float _bgBlue;
    unsigned int _vramTextureId;
    AVRecorder *_recorder;
    BOOL _redrawPending;
}

- (id)_initWithFrame:(struct _NSRect)fp8 masterContext:(id)fp24;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)_deferredWindowDidChangeScreen;
- (void)_windowDidChangeScreen:(id)fp8;
- (void)dealloc;
- (id)ciContext;
- (void)setLayerModel:(id)fp8;
- (id)layerModel;
- (void)viewDidMoveToWindow;
- (void)setFrameSize:(struct _NSSize)fp8;
- (void)_setAutoscalesBoundsToPixelUnits:(BOOL)fp8;
- (BOOL)isOpaque;
- (void)draw;
- (id)bitmapImageFromSurfaceInRect:(struct _NSRect)fp8;
- (id)bitmapImageFromSurface;
- (void)_recompositeLayers;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setLayerModelNeedsDisplay;
- (void)reshape;
- (void)setBackgroundRed:(float)fp8 green:(float)fp12 blue:(float)fp16;
- (void)setBackgroundWhite:(float)fp8;
- (void)setBackgroundColor:(id)fp8;
- (struct _NSSize)adjustWindow:(id)fp8 proposedSize:(struct _NSSize)fp12;
- (BOOL)saveVideoSnapshotToFile:(id)fp8;
- (void)renderIntoContext:(id)fp8 width:(int)fp12 height:(int)fp16;
- (void)setRecorder:(id)fp8;

@end

@interface CameraPreferencesView : OpenGLLayerView
{
    OpenGLVideoConferenceLayer *_layer;
    struct _NSRect _oldTrackingRect;
    BOOL _videoCapable;
    BOOL _abortedVideo;
    BOOL _videoIsStarted;
    NSString *_videoErrorMessage;
    BOOL _registeredForNotifications;
    BOOL _videoCapabilityIsKnown;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (id)videoErrorMessage;
- (void)setVideoErrorMessage:(id)fp8;
- (id)layerName;
- (void)_createLayer;
- (void)clearKnownVideoState;
- (void)_irisStateNotification:(id)fp8;
- (void)_cameraChangedNotification:(id)fp8;
- (BOOL)videoIsStarted;
- (void)_removeCameraPrefsNotifications;
- (BOOL)canStartVideo;
- (void)startVideo;
- (void)restartVideo;
- (void)abortVideo;
- (void)stopVideo;
- (void)mouseDown:(id)fp8;
- (void)mouseDragged:(id)fp8;
- (void)setCameraOnState:(BOOL)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setFrame:(struct _NSRect)fp8;
- (void)prepareOpenGL;
- (void)handleShutdownAVPreview:(id)fp8;

@end

@interface CameraPreferencesView (DragAndDrop)
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (id)accessibilityAttributeValue:(id)fp8;
- (BOOL)accessibilityIsIgnored;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
@end

@interface CenteredView : NSView
{
    BOOL _horiz;
    BOOL _vert;
    NSView *_leftFitView;
}

- (void)superviewDidResize;
- (void)awakeFromNib;
- (void)dealloc;
- (void)setCenteredHoriz:(BOOL)fp8;
- (void)setCenteredVert:(BOOL)fp8;
- (BOOL)centeredHoriz;
- (BOOL)centeredVert;

@end

@interface CertController : NSObject
{
    NSMutableDictionary *_pendingRequests;
    NSTimer *_tickleTimer;
    BOOL _stopController;
}

+ (id)sharedInstance;
+ (BOOL)showPasswordButtonForRequest:(id)fp8;
+ (BOOL)showRevokeButtonForRequest:(id)fp8;
+ (id)failureStringForRequest:(id)fp8;
- (id)init;
- (void)dealloc;
- (id)_nearestDateToPoll;
- (void)_clearTimer;
- (void)_setTimerDate;
- (void)_setTimer;
- (void)_updateTimer;
- (void)_tickleCertRequest:(id)fp8;
- (void)_timerFired:(id)fp8;
- (void)pollRequestsNow;
- (void)setIsStopped:(BOOL)fp8;
- (BOOL)isStopped;
- (BOOL)requestExistsForAccount:(id)fp8;
- (id)scheduledCertRequestWithAccount:(id)fp8;
- (id)scheduledRenewCertRequestWithAccount:(id)fp8;
- (id)cancelAnyExistingRequestsForAccount:(id)fp8;
- (void)certificateTrustSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_failedSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(id)fp16;
- (void)activateEncryptionForAccountIfPossible:(id)fp8;
- (void)activateCertificate:(struct OpaqueSecCertificateRef *)fp8 forAIMAccount:(id)fp12;
- (void)resurrectPendingCertRequests;
- (void)_handleCertificateRequestDateChanged:(id)fp8;
- (void)_handleCertificateRequestFinished:(id)fp8;

@end

@interface CertExpirationChecker : NSObject
{
    ValidationObject *_signingCertThread;
    ValidationObject *_encryptionCertThread;
    AIMAccount *_account;
}

+ (id)checkAccount:(id)fp8;
- (id)initWithAccount:(id)fp8;
- (void)dealloc;
- (void)_done;
- (void)validationObject:(id)fp8 screenName:(id)fp12 finishedWithResult:(int)fp16;
- (void)start;

@end

@interface CertRequest : NSObject
{
    URLFetcher *_intermediateFetcher;
    AIMAccount *_aimAccount;
    NSString *_userName;
    BOOL _shouldArchive;
    BOOL _backedUp;
    BOOL _gotIntermediate;
    BOOL _launchedDaemon;
    unsigned int _attempts;
    NSDate *_attentionDate;
    unsigned int _fallbackTimes;
    int _certRequestStatus;
    int _failureReason;
}

+ (void)downloadAndInstallIntermediate;
+ (id)_stringFromCertStatus:(int)fp8;
- (id)initWithAccount:(id)fp8;
- (void)dealloc;
- (void)urlFetcher:(id)fp8 fetchedResult:(id)fp12;
- (void)urlFetcher:(id)fp8 fetchFailedWithError:(id)fp12;
- (void)_sendOffIntermediateRequestIfNecessary;
- (void)setWhenNeedsAttentionInSeconds:(float)fp8;
- (void)setWhenNeedsAttention:(id)fp8;
- (id)whenNeedsAttention;
- (id)userName;
- (id)aimAccount;
- (int)status;
- (void)_resetNumberOfFallbackTimes;
- (void)_resetNumberOfAttempts;
- (void)_setNextTimeIntervalUsingFallbacks;
- (void)determineCertStatus;
- (void)tryToFetchCertNow;
- (void)performRequest;
- (void)stopRequest;
- (int)failureReason;
- (void)setFailureReason:(int)fp8;
- (id)description;
- (BOOL)_checkUsernameAndPassword;
- (void)_requestNewDotMacCertificate;
- (void)_checkCertProgress:(BOOL)fp8;
- (void)_postNotification:(id)fp8;
- (void)postNotification:(id)fp8;

@end

@interface CertViewer : NSWindowController
{
    NSTabView *_tabView;
    NSProgressIndicator *_progView;
    SFCertificateView *_signView;
    Presentity *_pres;
    struct OpaqueSecCertificateRef *_signCert;
}

- (id)initWithPresentity:(id)fp8;
- (id)windowNibName;
- (void)awakeFromNib;
- (void)dealloc;
- (void)_updateCertificate;
- (void)_setSigningCertificate:(struct OpaqueSecCertificateRef *)fp8;
- (void)windowWillClose:(id)fp8;

@end

@interface Chat (Scripting)
- (id)scriptID;
- (id)scriptService;
- (id)scriptParticipants;
- (id)scriptName;
- (id)scriptInvitationMessage;
- (id)scriptChatType;
- (id)scriptSubject;
- (id)scriptSecure;
- (id)scriptInvitation;
- (id)scriptJoinState;
- (id)scriptActive;
- (id)scriptStarted;
- (id)scriptUpdated;
- (id)objectSpecifier;
- (void)acceptInvitationScriptCommand:(id)fp8;
- (void)declineInvitationScriptCommand:(id)fp8;
- (void)sendInChatScriptCommand:(id)fp8;
@end

@interface Chat (TabSortingAdditions)
- (int)compareChat:(id)fp8;
@end

@interface ChatController : NSObject <PeopleListDelegate>
{
    struct _NSRect _savedRect;
    BOOL _inTransition;
    BOOL _pendingShowParticipants;
    BOOL _windowClosing;
    NSImageView *_serviceImage;
    NSExtendedBox *_statusArea;
    NSExtendedBox *_toFromDivider;
    ExtendedSplitViewGrabber *_inputLineGrabber;
    ExtendedSplitViewGrabber *_rejoinGrabber;
    ExtendedSplitViewGrabber *_emptyGrabber;
    NSTextField *_participantCount;
    NSView *_fromStatusArea;
    NSView *_toStatusArea;
    AbbreviatingTextField *_fromText;
    AbbreviatingTextField *_toText;
    MyNameControl *_fromPopup;
    MyNameControl *_toPopup;
    NSView *_enclosingView;
    ChatInputLine *_inputLine;
    AbbreviatingTextField *_whyIsInputLineGoneField;
    AnimatingTabView *_inputLineTabView;
    NSView *_participantsArea;
    PeopleList *_peopleList;
    NSDrawer *_peopleDrawer;
    ChatDOMView *_transcript;
    id _transcriptIB;
    NSMenu *_chatContextMenu;
    ChooseBuddyButton *_chooseIDButton;
    NSView *_transcriptArea;
    float _initialMinWidth;
    NSPanel *_linkSheet;
    ExtendedTextField *_linkTextField;
    LinkSheetController *_linkSheetController;
    NSWindow *_inviteMsgSheet;
    NSTextField *_inviteMsgText;
    NSTextField *_inviteMsgLabel;
    NSString *_inviteMsg;
    BOOL _participantsWereVisible;
    NSView *_buttonArea;
    NSButton *_notifyAccept;
    NSButton *_joinAtLogin;
    NSButton *_notifyReject;
    NSButton *_notifyBlock;
    float _buttonAmountVisible;
    NSString *_origNotifyAcceptTitle;
    NSTabView *_notifyButtonTabView;
    NSButton *_rejoinChatButton;
    NSProgressIndicator *_joiningSpinner;
    NSWindow *_chooseIDSheet;
    NSWindow *_chatOptionsSheet;
    NSPopUpButton *_chatOptionsStyle;
    ExtendedTextField *_chatOptionsName;
    NSViewAnimation *_statusViewAnimation;
    ChatFieldEditor *_fieldEditor;
    Chat *_chat;
    BOOL _primaryController;
    BOOL _chooseIDMenuIsValid;
    BOOL _isDeciding;
    BOOL _msgsHidden;
    BOOL _finishChatWhenClosed;
    BOOL _inputLineSpacerRemoved;
    ChatNotifier *_notifier;
    SecureWindow *_window;
    BOOL _resizingInputLine;
    float _inputLineRightMargin;
    CertViewer *_certViewer;
    BOOL _isInTab;
    BOOL _isResizing;
}

+ (id)chatControllerInstalledInView:(id)fp8;
- (void)chatWillBecomeVisibleInWindow:(id)fp8 resizeWindow:(BOOL)fp12;
- (void)chatWillBeRemovedFromWindow:(id)fp8;
- (BOOL)animationShouldStart:(id)fp8;
- (void)animationDidStop:(id)fp8;
- (void)animationDidEnd:(id)fp8;
- (void)animation:(id)fp8 didReachProgressMark:(float)fp12;
- (BOOL)_isStatusAreaVisible;
- (void)_makeStatusAreaShowFrom:(BOOL)fp8 to:(BOOL)fp12;
- (id)_possibleFromAccounts;
- (id)_possibleToParticipants;
- (id)menuForMyRolloverButton:(id)fp8;
- (void)_prepareStatusArea;
- (void)_synchonizeStatusAreaItems;
- (void)_switchToPresentityFromMenuItem:(id)fp8;
- (void)_switchFromAccountFromMenuItem:(id)fp8;
- (void)_hideStatusArea;
- (void)_showStatusArea;
- (BOOL)_statusAreaWantsToBeVisible;
- (void)_updateStatusArea;
- (void)awakeFromNib;
- (void)setResizersVisible:(BOOL)fp8;
- (void)unhookResizers;
- (void)hookupResizersToSplitView:(id)fp8;
- (void)_finishChat;
- (void)dealloc;
- (void)_windowDidResize:(id)fp8;
- (void)handleChatWindowClosing:(id)fp8;
- (id)window;
- (id)selectedPresentities;
- (BOOL)isComposing;
- (id)account;
- (id)peopleList;
- (id)chat;
- (float)minWidth;
- (void)_loadRejoinButton;
- (void)setChat:(id)fp8;
- (void)setChatRoomName:(id)fp8;
- (BOOL)finishesChatWhenClosed;
- (void)setFinishesChatWhenClosed:(BOOL)fp8;
- (id)inputLine;
- (id)fieldEditor;
- (void)_updateInputLineAttachmentSupport;
- (BOOL)inputLineHasFocus;
- (void)setPrimaryChatController:(BOOL)fp8;
- (id)_activeChatChat;
- (BOOL)_serviceMightChat;
- (BOOL)_anonymousPeopleInPeopleList;
- (id)displayName:(BOOL)fp8;
- (void)_postDisplayNameChanged;
- (void)_postPeopleChanged;
- (int)joinState;
- (int)style;
- (id)people;
- (id)notifier;
- (BOOL)isActive;
- (BOOL)isInTab;
- (void)setIsInTab:(BOOL)fp8;
- (void)_fixBottomBorderThickness;
- (void)_clearCurrentPosition;
- (void)_saveCurrentPosition;
- (struct _NSRect)_rectAdjustingForSavedPositionWithRect:(struct _NSRect)fp8;
- (BOOL)isResizing;
- (void)_adjustInputLineHeightBy:(float)fp8 resizeWindow:(BOOL)fp12;
- (void)_setInputLineHeight:(float)fp8 resizeWindow:(BOOL)fp12;
- (void)_showInputLine:(BOOL)fp8;
- (void)_msgStyleChanged:(id)fp8;
- (float)_currentTextHeight;
- (void)controlTextDidChange:(id)fp8;
- (void)_inputLineDidEndLiveResize:(id)fp8;
- (BOOL)resizingInputLine;
- (BOOL)inputLineCanAttachFile;
- (id)enclosingView;
- (id)transcriptView;
- (id)_preparedFieldEditor;
- (void)makeInputLineKey;
- (void)insertText:(id)fp8;
- (void)paste:(id)fp8;
- (void)pasteAndMatchStyle:(id)fp8;
- (void)tabView:(id)fp8 willSwitchFromTab:(int)fp12 toTab:(int)fp16 effect:(int *)fp20 direction:(int *)fp24;
- (BOOL)isInputLineVisible;
- (void)_setUnjoinedState;
- (void)_setJoiningState;
- (void)_setJoinedState;
- (void)makeInputLineFlushLeft:(BOOL)fp8;
- (void)_accountLoginStatusChanged:(id)fp8;
- (void)_updateInputLineTabView:(id)fp8;
- (BOOL)canParticipantsBeVisible;
- (BOOL)_wereParticipantsVisible;
- (BOOL)areParticipantsVisible;
- (void)showParticipants:(id)fp8;
- (void)hideParticipants:(id)fp8;
- (void)toggleParticipants:(id)fp8;
- (void)personDoubleClicked:(id)fp8;
- (void)drawerDidOpen:(id)fp8;
- (void)drawerWillClose:(id)fp8;
- (void)toggleHidePictures:(id)fp8;
- (void)toggleHideAudioStatus:(id)fp8;
- (void)toggleHideVideoStatus:(id)fp8;
- (void)sortByStatus:(id)fp8;
- (void)sortByFirstName:(id)fp8;
- (void)sortByLastName:(id)fp8;
- (void)_updateAddBuddyButtonState;
- (BOOL)addNewPresentities:(id)fp8;
- (void)addLink:(id)fp8;
- (void)acceptLinkText:(id)fp8;
- (void)cancelLinkSheet:(id)fp8;
- (void)removeLinkSheet:(id)fp8;
- (void)_linkSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (BOOL)textView:(id)fp8 clickedOnLink:(id)fp12 atIndex:(unsigned int)fp16;
- (id)_messageTextAndFlags:(int *)fp8;
- (BOOL)_sendMessage:(BOOL)fp8 forceEmpty:(BOOL)fp12 forceSend:(BOOL)fp16;
- (void)_clearInputLine;
- (void)joinAtLoginChanged:(id)fp8;
- (void)rejoinChat:(id)fp8;
- (void)cancelMessage:(id)fp8;
- (void)_sendMessage;
- (void)sendMessage:(id)fp8;
- (void)sendPartialMessage:(id)fp8;
- (BOOL)canSendPartialMessage;
- (BOOL)textField:(id)fp8 didChangeSignificantly:(int)fp12;
- (BOOL)control:(id)fp8 textShouldBeginEditing:(id)fp12;
- (void)sendSMS:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)sendFile:(id)fp8;
- (void)insertSmiley:(id)fp8;
- (void)setRendererFromMenuItem:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (BOOL)canUseInputField;
- (void)_reformatOutgoingColors;
- (void)_reformatOutgoingFonts;
- (void)_reformatOverrideIncoming;
- (void)_reformatOverrideIncomingFont;
- (void)_reformatOverrideIncomingColors;
- (void)_watchMessageAddressingChanged;
- (void)toggleRecipientBar:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)makeTextBigger:(id)fp8;
- (void)makeTextStandardSize:(id)fp8;
- (void)makeTextSmaller:(id)fp8;
- (void)_updateParticipantCount;
- (void)_chatOverallStatusChangedNotification:(id)fp8;
- (void)_memberChanged:(id)fp8;
- (void)finishChat:(id)fp8;
- (void)ignore:(id)fp8;
- (void)toggleQuietMode:(id)fp8;
- (void)showInAddressBook:(id)fp8;
- (void)block:(id)fp8;
- (void)_chatStatusChanged:(id)fp8;
- (void)_chatComposingStatusChanged:(id)fp8;
- (void)_chatErrorPosted:(id)fp8;
- (void)_showErrorSheet:(id)fp8;
- (void)_personInfoChanged:(id)fp8;
- (void)buddySelected:(id)fp8;
- (id)chooseBuddyButton:(id)fp8 filterPresentities:(id)fp12;
- (void)chooseBuddySheetCanceled:(id)fp8;
- (id)peopleList:(id)fp8 alternateNameTextForPresentity:(id)fp12;
- (id)peopleList:(id)fp8 alternateStatusTextForPresentity:(id)fp12;
- (float)peopleList:(id)fp8 alphaForStatus:(unsigned int)fp12;
- (id)propertiesForGroup:(id)fp8;
- (id)peopleList:(id)fp8 siblingsForPresentity:(id)fp12;
- (BOOL)canAddPeople;
- (id)peopleList:(id)fp8 addablePeople:(id)fp12;
- (void)peopleList:(id)fp8 setGroupsSortOrder:(id)fp12;
- (BOOL)peopleList:(id)fp8 canRemoveRows:(id)fp12;
- (void)peopleList:(id)fp8 deleteGroup:(id)fp12;
- (BOOL)peopleList:(id)fp8 deletePeople:(id)fp12;
- (void)_syncPeopleWithChat;
- (void)_adjustChatStyleAndLockUI:(BOOL)fp8;
- (void)chatWindowRevealed:(BOOL)fp8;
- (BOOL)peopleList:(id)fp8 pastePeople:(id)fp12 intoGroup:(id)fp16;
- (void)_peopleChanged;
- (BOOL)peopleListAboutToResort:(id)fp8;
- (id)peopleList:(id)fp8 filterPresentityFromPasteboard:(id)fp12;
- (BOOL)peopleList:(id)fp8 addPersonWithoutID:(id)fp12;
- (BOOL)peopleList:(id)fp8 people:(id)fp12 draggedFromGroups:(id)fp16 toGroup:(id)fp20 atLocation:(int)fp24 copying:(BOOL)fp28;
- (id)peopleList:(id)fp8 menuForGroup:(id)fp12;
- (void)peopleListSelectedItemInfoChanged:(id)fp8;
- (id)peopleListService:(id)fp8;
- (id)secureWindowCertificates:(id)fp8;
- (id)secureWindowTrustPolicies:(id)fp8;
- (void)_updateChatTranscriptSecurityState:(int)fp8 oldLevel:(int)fp12;
- (void)_chatSecurityLevelChanged:(id)fp8;
- (void)_syncLockState;
- (void)_hideLockMessage:(id)fp8;
- (void)_showLockMessage:(id)fp8;
- (void)_updateLockUIFromPreviousLevel:(int)fp8;
- (void)_requestCertificates;
- (void)_accountCapabilitiesChanged:(id)fp8;
- (void)_certificatesChanged:(id)fp8;
- (void)_chatStyleChanged:(id)fp8;
- (BOOL)isInTransition;
- (void)setInTransition:(BOOL)fp8;
- (void)setIsDeciding:(BOOL)fp8 doKnockKnock:(BOOL)fp12 withChatNotifier:(id)fp16;
- (void)forgetNotifier:(id)fp8;
- (BOOL)isDeciding;
- (void)setVisiblePortionOfNotifyButtons:(float)fp8 showInputLine:(BOOL)fp12;
- (void)acceptNotification:(id)fp8;
- (void)rejectNotification:(id)fp8;
- (void)blockNotification:(id)fp8;
- (void)_runInviteSheetForInvitees:(id)fp8;
- (void)acceptInviteMessage:(id)fp8;
- (void)cancelInviteMessage:(id)fp8;
- (void)_inviteMsgDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)scrollToBottom:(id)fp8;
- (void)clearTranscript:(id)fp8;
- (void)showFindPanel:(id)fp8;
- (void)findNext:(id)fp8;
- (void)findPrevious:(id)fp8;
- (void)copySelectionToFindPboard:(id)fp8;
- (void)toggleHideSmileys:(id)fp8;
- (void)chooseBackgroundImage:(id)fp8;
- (void)clearBackground:(id)fp8;
- (void)toggleShowPictures:(id)fp8;
- (void)toggleShowNames:(id)fp8;
- (void)setChatShowsNames:(id)fp8;
- (void)setChatShowsPictures:(id)fp8;
- (void)setChatShowsNamesAndPictures:(id)fp8;
- (void)_updateChatModeSheet;
- (void)chooseChatOptions:(id)fp8;
- (void)pickChatMode:(id)fp8;
- (void)acceptChatOptions:(id)fp8;
- (void)cancelChatOptions:(id)fp8;
- (void)_chatOptionsDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_savePanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)saveChatAs:(id)fp8;

@end

@interface ChatDOMEngines : NSObject
{
    ChatPluginLoader *_engineLoader;
}

+ (id)defaultEngines;
- (id)init;
- (void)dealloc;
- (BOOL)enumerateEngines;
- (id)engines;
- (id)engineWithIdentifier:(id)fp8;
- (id)engineIdentifierForClass:(Class)fp8;

@end

@interface ChatDOMEngines (RendererItems)
+ (id)rendererMenuItems;
@end

@interface ChatDOMView : WebView <WebDocumentSearching, DOMEventListener>
{
    NSMenu *_viewMenu;
    NSTextField *_textField;
    TranscriptStyleManager *_renderer;
    Class _rendererClass;
    id _delegate;
    int _totalPreloaded;
    NSTimer *_dailyRebuildTimer;
    NSMutableDictionary *_preloadStyles;
    Chat *_chat;
    NSMutableArray *_messages;
    int _viewFlags;
    ChatScrollerAnimation *_scroller;
    FileTransfer *_fileBeingDragged;
    NSString *_fileDragDestination;
    BOOL _fileDragIsDup;
    BOOL _pinToBottomOnResize;
    BOOL _readyToMessage;
    BOOL _pendingRebuildLayout;
    BOOL _isSmoothScrolling;
    BOOL _canShowMessages;
    id <ShowMessagesDelegate> _showMessagesDelegate;
    BOOL _willAddNewInvitees;
    NSMutableArray *_newInvitees;
    BOOL _addPresentitiesToChat;
    BOOL _needsDataDetectorsPass;
    NSMutableSet *_loadCache;
    NSMutableDictionary *_deferredRuleChanges;
    NSMutableDictionary *_hiddenPreloadItems;
    BOOL _isDeferringRules;
    NSMutableArray *_finishedResources;
}

+ (void)initialize;
+ (int)flagsToSave;
- (void)_rethrowException:(id)fp8;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (void)handleEvent:(id)fp8;
- (void)deferRuleChangeForURL:(id)fp8 change:(id)fp12;
- (void)deferRuleChangeForURL:(id)fp8 rule:(id)fp12 body:(id)fp16;
- (void)applyDeferredChangesForURL:(id)fp8;
- (BOOL)allResourcesLoaded;
- (void)initializeWebView;
- (void)awakeFromNib;
- (void)restoreTranscriptRendererFromPrefs;
- (void)restoreTranscriptPrefs;
- (void)chatDidBecomeVisible;
- (void)_setNeedsDataDetectorsPass;
- (void)_doDataDetectorsPass;
- (void)resizeWithOldSuperviewSize:(struct _NSSize)fp8;
- (void)setFrame:(struct _NSRect)fp8;
- (void)viewWillMoveToSuperview:(id)fp8;
- (void)viewWillMoveToWindow:(id)fp8;
- (void)setTextSizeMultiplier:(float)fp8;
- (void)makeTextLarger:(id)fp8;
- (void)makeTextSmaller:(id)fp8;
- (void)makeTextStandardSize:(id)fp8;
- (void)viewDidMoveToSuperview;
- (void)removeFromSuperview;
- (void)clearDailyRebuildTimer;
- (void)resetDailyRebuildTimer;
- (void)dateDisplayChanged;
- (void)_dateDisplayChanged:(id)fp8;
- (void)_dateOrTimeFormatsChanged:(id)fp8;
- (void)_setRenderer:(id)fp8;
- (BOOL)changeToNewRenderer:(Class)fp8;
- (id)window;
- (void)setWindow:(id)fp8;
- (id)chat;
- (void)setSampleChat;
- (void)setChat:(id)fp8;
- (void)_chatMessagesChanged:(id)fp8;
- (void)clearUnreadMessageIfVisible;
- (BOOL)_lastMessageIsVisible;
- (void)windowDidBecomeMainOrKey:(id)fp8;
- (void)loadBaseDocument;
- (void)restoreDefaultBackground;
- (void)insertAllMessages;
- (float)documentHeight;
- (BOOL)shouldPinToBottom;
- (void)viewWillStartLiveResize;
- (void)setFrameSize:(struct _NSSize)fp8;
- (void)viewDidEndLiveResize;
- (void)_addInfoBannerMessage:(id)fp8 date:(id)fp12;
- (id)_infoBannerForMessage:(id)fp8;
- (void)addChatInfoBannerForMessage:(id)fp8;
- (id)_chatFieldEditor;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)fp8;
- (id)namesOfPromisedFilesDroppedAtDestination:(id)fp8;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (void)draggingExited:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (void)keyDown:(id)fp8;
- (void)_increaseResourceLoadCountForURL:(id)fp8;
- (void)_decreaseResourceLoadCountForURL:(id)fp8;
- (id)webView:(id)fp8 identifierForInitialRequest:(id)fp12 fromDataSource:(id)fp16;
- (id)webView:(id)fp8 resource:(id)fp12 willSendRequest:(id)fp16 redirectResponse:(id)fp20 fromDataSource:(id)fp24;
- (void)webView:(id)fp8 resource:(id)fp12 didFailLoadingWithError:(id)fp16 fromDataSource:(id)fp20;
- (void)webView:(id)fp8 resource:(id)fp12 didFinishLoadingFromDataSource:(id)fp16;
- (id)_inlineStyleForTextNode:(id)fp8 usingComputedStyle:(id)fp12;
- (BOOL)_generateBasicHTMLFromNode_r:(id)fp8 foundStart:(char *)fp12 foundEnd:(char *)fp16 range:(id)fp20 depth:(int)fp24 string:(id)fp28 endsWithBreak:(char *)fp32;
- (id)_generateBasicHTMLFromRange:(id)fp8;
- (void)addRTFDContentToPasteboard:(id)fp8 forDOMRange:(id)fp12;
- (void)_copySelectionToPasteboard:(id)fp8;
- (BOOL)webView:(id)fp8 doCommandBySelector:(SEL)fp12;
- (void)webView:(id)fp8 willPerformDragSourceAction:(int)fp12 fromPoint:(struct _NSPoint)fp16 withPasteboard:(id)fp24;
- (id)webView:(id)fp8 contextMenuItemsForElement:(id)fp12 defaultMenuItems:(id)fp16;
- (id)webView:(id)fp8 plugInViewWithArguments:(id)fp12;
- (void)finishLoad;
- (void)webView:(id)fp8 didFinishLoadForFrame:(id)fp12;
- (void)webView:(id)fp8 decidePolicyForNavigationAction:(id)fp12 request:(id)fp16 frame:(id)fp20 decisionListener:(id)fp24;
- (void)webView:(id)fp8 decidePolicyForNewWindowAction:(id)fp12 request:(id)fp16 newFrameName:(id)fp20 decisionListener:(id)fp24;
- (BOOL)drawsBackground;
- (struct _NSRect)messagePreviewBounds;
- (struct _NSRect)boundsOfMessage:(id)fp8;
- (void)suppressAutoscroll:(BOOL)fp8;
- (void)clearAllMessages;
- (void)addSampleMessage:(id)fp8;
- (void)reformatOutgoingColors;
- (void)reformatOutgoingFonts;
- (void)watchMessageAddressing;
- (void)reformatOverrideIncoming;
- (void)reformatOverrideIncomingFont;
- (void)reformatOverrideIncomingColors;
- (BOOL)drawingInsideImage;
- (void)setDrawingInsideImage:(BOOL)fp8;
- (id)messages;
- (BOOL)_forwardViewFlagsToRenderer:(int)fp8;
- (void)setViewFlag:(int)fp8 toValue:(BOOL)fp12;
- (void)setViewFlags:(int)fp8;
- (BOOL)isViewFlagOn:(int)fp8;
- (int)viewFlags;
- (void)saveViewFlags;
- (void)scrollToPosition:(float)fp8 smoothly:(BOOL)fp12;
- (void)scrollToEndSmoothly:(BOOL)fp8;
- (void)scrollToBeginningSmoothly:(BOOL)fp8;
- (float)savedScrollPosition;
- (void)restoreSavedScrollPositionFromNumber:(id)fp8;
- (void)restoreSavedScrollPosition:(float)fp8;
- (void)setScrollPositionToEnd;
- (void)animationDidEnd:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (BOOL)setBackgroundImageFile:(id)fp8;
- (void)_setShowsPictures:(BOOL)fp8 names:(BOOL)fp12;
- (void)_personPictureChanged:(id)fp8;
- (void)_personInfoChanged:(id)fp8;
- (void)_boundsChanged:(id)fp8;
- (void)willBecomeVisible;
- (id)showMessagesDelegate;
- (void)setShowMessagesDelegate:(id)fp8;

@end

@interface ChatDOMView (IBActions)
- (void)undo:(id)fp8;
- (void)paste:(id)fp8;
- (void)toggleHideSmileys:(id)fp8;
- (void)chooseBackgroundImage:(id)fp8;
- (void)openPanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)clearBackground:(id)fp8;
- (void)toggleShowPictures:(id)fp8;
- (void)toggleShowNames:(id)fp8;
- (void)setChatShowsNames:(id)fp8;
- (void)setChatShowsPictures:(id)fp8;
- (void)setChatShowsNamesAndPictures:(id)fp8;
- (void)setRendererFromMenuItem:(id)fp8;
- (void)copySelectionToFindPboard:(id)fp8;
@end

@interface ChatDoc : NSDocument
{
    Chat *_chat;
    SecureWindow *_chatWindow;
    NSView *_chatView;
    ChatController *_controller;
    ChatMiniwindowController *_miniwindowController;
    unsigned int _loadedNib:1;
    NSWindow *_printingWindow;
    NSPrintOperation *_printingOperation;
    BOOL _saving;
}

- (void)dealloc;
- (void)_setChat:(id)fp8;
- (id)chat;
- (id)controller;
- (void)_forceNibLoading;
- (void)makeWindowControllers;
- (id)windowNibName;
- (void)windowControllerDidLoadNib:(id)fp8;
- (id)displayName;
- (void)_updateDisplayName;
- (void)windowDidResize:(id)fp8;
- (id)windowWillReturnFieldEditor:(id)fp8 toObject:(id)fp12;
- (id)window;
- (void)_setFirstResponder;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (void)saveDocumentTo:(id)fp8;
- (BOOL)readFromURL:(id)fp8 ofType:(id)fp12 error:(id *)fp16;
- (BOOL)loadDataRepresentation:(id)fp8 ofType:(id)fp12;
- (id)dataRepresentationOfType:(id)fp8;
- (void)updateChangeCount:(unsigned int)fp8;
- (void)close;
- (BOOL)windowShouldClose:(id)fp8;
- (void)toggleParticipants:(id)fp8;
- (void)toggleHidePictures:(id)fp8;
- (void)toggleHideAudioStatus:(id)fp8;
- (void)toggleHideVideoStatus:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)setRendererFromMenuItem:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)toggleHideSmileys:(id)fp8;
- (void)toggleShowNames:(id)fp8;
- (void)toggleShowPictures:(id)fp8;
- (void)setChatShowsNames:(id)fp8;
- (void)setChatShowsPictures:(id)fp8;
- (void)setChatShowsNamesAndPictures:(id)fp8;
- (void)showInAddressBook:(id)fp8;
- (void)showFindPanel:(id)fp8;
- (void)findNext:(id)fp8;
- (void)findPrevious:(id)fp8;
- (void)copySelectionToFindPboard:(id)fp8;
- (void)makeTextBigger:(id)fp8;
- (void)makeTextSmaller:(id)fp8;
- (void)makeTextStandardSize:(id)fp8;
- (void)printOperationDidRun:(id)fp8 success:(BOOL)fp12 contextInfo:(void *)fp16;
- (void)printShowingPrintPanel:(BOOL)fp8;
- (id)presentityToGetInfoOn;
- (void)showSelectedBuddyInfo:(id)fp8;
- (void)showSelectedBuddyProfile:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;

@end

@interface ChatFieldEditor : NSTextView
{
    Presentity *_attachmentRecipient;
    BOOL _allowsAttachments;
    BOOL _allowsInlineImages;
    NSView *_forwardingView;
    BOOL _isChat;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (BOOL)validateMenuItem:(id)fp8;
- (void)addFontTrait:(id)fp8;
- (void)toggleContinuousSpellChecking:(id)fp8;
- (void)toggleGrammarChecking:(id)fp8;
- (void)changeFont:(id)fp8;
- (void)setMarkedText:(id)fp8 selectedRange:(struct _NSRange)fp12;
- (void)insertText:(id)fp8;
- (void)setKeyForwardingView:(id)fp8;
- (id)keyForwardingView;
- (void)keyDown:(id)fp8;
- (void)smileyPicked:(id)fp8;
- (void)_setAllowsAttachments:(BOOL)fp8;
- (void)_setAllowsInlineImages:(BOOL)fp8;
- (void)setIsChatChat:(BOOL)fp8;
- (void)setAttachmentRecipient:(id)fp8;
- (BOOL)canAttachFile;
- (BOOL)canFileBeAttachedInline:(id)fp8;
- (void)_showAttachErrorSheetWithMessage:(id)fp8;
- (id)nonImageFilesFromFiles:(id)fp8;
- (BOOL)insertAttachedFiles:(id)fp8;
- (BOOL)insertAttachedFile:(id)fp8;
- (id)attachedFileFrom:(id)fp8;
- (void)sendFile:(id)fp8;
- (void)copySelectionToFindPboard:(id)fp8;
- (void)_attachmentChosen:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (BOOL)panel:(id)fp8 isValidFilename:(id)fp12;
- (id)acceptableDragTypes;
- (id)readablePasteboardTypes;
- (void)_getPresentityURL:(id *)fp8 andText:(id *)fp12 fromPasteboard:(id)fp16;
- (BOOL)readSelectionFromPasteboard:(id)fp8 type:(id)fp12;
- (BOOL)_readSelectionFromPasteboard:(id)fp8 types:(id)fp12;
- (void)_clearParagraphStyle;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;
- (id)writablePasteboardTypes;
- (BOOL)writeSelectionToPasteboard:(id)fp8 type:(id)fp12;
- (void)paste:(id)fp8;
- (void)pasteAndMatchStyle:(id)fp8;
- (id)selectedLink_adjustingSelection:(BOOL)fp8;
- (void)applyLinkToSelection:(id)fp8;
- (BOOL)insertLinkAtSelection:(id)fp8 withText:(id)fp12;
- (void)setTypingAttributes:(id)fp8;
- (void)_setTypingAttributesForSelection:(struct _NSRange)fp8;
- (void)_fixAttrsOnSelectionChange:(id)fp8;
- (void)changeDocumentBackgroundColor:(id)fp8;

@end

@interface ChatInputLine : AutoSendTextField
{
    NSButton *_smileyButton;
    Chat *_chat;
}

- (unsigned int)validModesForFontPanel:(id)fp8;
- (void)awakeFromNib;
- (void)dealloc;
- (void)viewDidEndLiveResize;
- (id)_preparedFieldEditor;
- (void)setChat:(id)fp8;
- (id)_chatFieldEditor;
- (void)pickSmiley:(id)fp8;
- (void)smileyPicked:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (id)accessibilityAttributeValue:(id)fp8;

@end

@interface ChatInputLineCell : NSTextFieldCell
{
}

- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)editWithFrame:(struct _NSRect)fp8 inView:(id)fp24 editor:(id)fp28 delegate:(id)fp32 event:(id)fp36;
- (void)selectWithFrame:(struct _NSRect)fp8 inView:(id)fp24 editor:(id)fp28 delegate:(id)fp32 start:(int)fp36 length:(int)fp40;
- (void)_drawFocusRingWithFrame:(struct _NSRect)fp8;

@end

@interface ChatMiniwindowController : NSObject
{
    NSWindow *_window;
    Chat *_chat;
    NSTimer *_miniwindowTimer;
}

- (id)initWithWindow:(id)fp8;
- (void)dealloc;
- (id)chat;
- (void)setChat:(id)fp8;
- (void)_updateMiniwindowImage;
- (void)windowDidMiniaturize:(id)fp8;
- (void)windowDidDeminiaturize:(id)fp8;
- (void)_needsDrawFromAnimate:(id)fp8;
- (void)_chatChanged:(id)fp8;

@end

@interface ChatNotifier : Notifier
{
    BOOL _msgsHidden;
    ActiveChat *_chat;
    NSString *_autosaveFrameName;
    ChatController *_controller;
    ChatDOMView *_transcript;
    NSView *_notifierClipView;
    ChatDOMView *_notifierTranscript;
    struct _NSRect _originalFrame;
    struct _NSSize _origTranscriptSize;
    BOOL _shouldRestoreSize;
    struct _NSPoint _realMsgFloaterOffset;
    struct _NSRect _messagePreviewRect;
}

+ (void)openOnChat:(id)fp8;
+ (void)openOnChat:(id)fp8 silently:(BOOL)fp12;
- (void)dealloc;
- (void)_makeRealWindowMsgRect:(struct _NSRect *)fp8 message:(id)fp12;
- (void)_installChatViewInFrame:(struct _NSRect)fp8 hideMessages:(BOOL)fp24;
- (void)_makeFloaterWindowWithMessageRect:(struct _NSRect)fp8 knockKnock:(BOOL)fp24;
- (void)_sizeWindowsToMessagePreview;
- (id)initWithChat:(id)fp8 silently:(BOOL)fp12;
- (id)initWithChat:(id)fp8;
- (void)disconnectFromChatController:(id)fp8;
- (id)menuItemFormat;
- (void)closeDownShop:(BOOL)fp8;
- (void)updateLockUI;
- (void)_animateRealSizeRestore;
- (void)acceptNotification;
- (void)clearKnockKnock;
- (void)_realWindowDidResize:(id)fp8;
- (void)realWindowHiding;
- (void)realWindowVisible;

@end

@interface ChatPluginLoader : NSObject
{
    NSMutableArray *_pluginIdentifiers;
}

- (id)init;
- (void)dealloc;
- (BOOL)enumeratePluginsAtPath:(id)fp8;
- (id)identifiers;
- (id)pluginWithIdentifier:(id)fp8;

@end

@interface ChatScrollerAnimation : NSAnimation
{
    float _startingValue;
    float _endingValue;
    ChatDOMView *_chatView;
}

- (id)initWithChatWebView:(id)fp8 position:(float)fp12 smoothly:(BOOL)fp16;
- (void)dealloc;
- (void)setCurrentProgress:(float)fp8;

@end

@interface ChatWindowController : NSWindowController
{
    AnimatingTabView *_chatTabView;
    NSExtendedBox *_chatListTitle;
    AnimatingTableView *_chatTable;
    NSView *_chatViewContainer;
    NSButton *_choosePersonButton;
    ExtendedSplitView *_splitView;
    MenuButton *_actionButton;
    NSTimer *_chatAnimationTimer;
    float _animationStep;
    NSTimer *_blinkChatsTimer;
    float _blinkProgress;
    ChatMiniwindowController *_miniwindowController;
    NSMutableArray *_chatAnimationProgresses;
    NSMutableArray *_lastReadMessage;
    NSMutableArray *_chats;
    NSMutableArray *_chatControllers;
    int _coalesceCount;
    BOOL _animateWhenEnded;
    BOOL _pendingResort;
    BOOL _pendingUpdateNumber;
    BOOL _pendingSync;
    BOOL _closing;
    BOOL _dontResizeWindowNextSidebarChange;
    NSMutableSet *_savedSelection;
    struct CGAffineTransform _finalXform;
    NSTimer *_notifierAnimationTimer;
    NSDate *_notifierStartTime;
    float _notifierAnimationTime;
    NSWindow *_notifierWindow;
    struct _NSRect _targetRect;
    struct _NSRect _startRect;
    int _targetNotifierRow;
    NSWindow *_secondaryNotifierWindow;
    NSTimer *_sidebarAnimationTimer;
    NSDate *_sidebarStartTime;
    BOOL _expandSidebar;
    BOOL _wasSidebarVisibleWhenNotifierAnimationStarted;
    BOOL _shouldChangeSidebarWidth;
    struct _NSRect _savedRect;
    NSPrintOperation *_printingOperation;
}

+ (BOOL)wantsCollectedChats;
+ (void)registerChatWindowController:(id)fp8;
+ (void)unregisterChatWindowController:(id)fp8;
+ (id)allChatWindowControllers;
+ (unsigned int)openTabbedChatWindows;
+ (id)existingChatWithPresentity:(id)fp8;
+ (id)chatWindowControllerSuitableForAddingChat:(id)fp8;
+ (void)openChat:(id)fp8;
+ (void)displayChat:(id)fp8;
+ (void)displayChat:(id)fp8 fromNotifierWindow:(id)fp12;
+ (id)displayChatForPresentity:(id)fp8 style:(int)fp12;
+ (id)visibleChatToHookUpWithPresentity:(id)fp8;
+ (id)visibleChatWithID:(id)fp8;
+ (id)createUIForChat:(id)fp8;
+ (id)createChatWindowWithPresentities:(id)fp8 style:(int)fp12;
+ (BOOL)canCollectChat:(id)fp8;
- (id)init;
- (void)dealloc;
- (void)windowDidLoad;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (void)_setNotifierWindowProgress:(float)fp8;
- (void)_installSnapshotOfNotifierIntoWindow:(id)fp8;
- (void)stepNotifierAnimation:(id)fp8;
- (void)_startNotifierAnimationTimer;
- (void)animateNotifierWindowToRect:(struct _NSRect)fp8;
- (void)showWindow:(id)fp8;
- (int)activeNotifierTargetRow;
- (void)_getPresentities:(id *)fp8 andGroups:(id *)fp12 fromPasteboard:(id)fp16 allowDuplicates:(BOOL)fp20;
- (id)tableView:(id)fp8 cellTipForRow:(int)fp12;
- (BOOL)tableView:(id)fp8 writeRowsWithIndexes:(id)fp12 toPasteboard:(id)fp16;
- (unsigned int)tableView:(id)fp8 validateDrop:(id)fp12 proposedRow:(int)fp16 proposedDropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 acceptDrop:(id)fp12 row:(int)fp16 dropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 shouldDrawWhenMovingFrom:(struct _NSPoint)fp12 toPoint:(struct _NSPoint)fp20;
- (BOOL)_mouseInButtons:(id)fp8 trackMouse:(BOOL)fp12;
- (BOOL)tableView:(id)fp8 mouseDown:(id)fp12;
- (void)_sidebarAnimationWillStart;
- (void)_sidebarAnimationDidFinish;
- (void)dontResizeWindowNextSidebarChange;
- (BOOL)isInSmallMode;
- (struct _NSRect)fullSidebarFrame;
- (BOOL)isSidebarAnimating;
- (BOOL)isSidebarVisible;
- (void)_setSidebarVisiblePercent:(float)fp8;
- (void)stepSidebarAnimation:(id)fp8;
- (void)_startSidebarAnimationTimer;
- (void)_clearCurrentPosition;
- (void)_saveCurrentPosition;
- (struct _NSRect)_rectAdjustingForSavedPositionWithRect:(struct _NSRect)fp8;
- (void)showSidebar:(id)fp8;
- (void)hideSidebar:(id)fp8;
- (void)_forgetSelection;
- (void)_rememberSelection;
- (void)_restoreSelection;
- (void)_resortNow;
- (void)_resort;
- (void)beginChangesNoAnimation;
- (void)beginChanges;
- (void)endChanges;
- (BOOL)makingChanges;
- (struct _NSRect)splitView:(id)fp8 effectiveRect:(struct _NSRect)fp12 forDrawnRect:(struct _NSRect)fp28 ofDividerAtIndex:(int)fp44;
- (void)_showCellTipsIfNecessary;
- (void)_fixMinWidthForSplitView;
- (void)splitView:(id)fp8 resizeSubviewsWithOldSize:(struct _NSSize)fp12;
- (float)splitView:(id)fp8 constrainMinCoordinate:(float)fp12 ofSubviewAt:(int)fp16;
- (float)splitView:(id)fp8 constrainMaxCoordinate:(float)fp12 ofSubviewAt:(int)fp16;
- (void)splitViewWillResizeSubviews:(id)fp8;
- (void)splitViewDidResizeSubviews:(id)fp8;
- (BOOL)splitView:(id)fp8 canCollapseSubview:(id)fp12;
- (float)splitView:(id)fp8 constrainSplitPosition:(float)fp12 ofSubviewAt:(int)fp16;
- (id)targetViewForCustomSavingWindow:(id)fp8;
- (BOOL)shouldSaveFrameForWindow:(id)fp8;
- (BOOL)isNotifier;
- (id)controllerForChat:(id)fp8;
- (id)currentChat;
- (id)currentChatController;
- (id)chats;
- (int)numberOfUnreadMessages;
- (int)numberOfChats;
- (id)chatAtIndex:(int)fp8;
- (id)tableView:(id)fp8 objectValueForRow:(int)fp12;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)tableViewSelectionDidChange:(id)fp8;
- (BOOL)containsChat:(id)fp8;
- (BOOL)canCollectChat:(id)fp8;
- (void)windowDidDeminiaturize:(id)fp8;
- (void)windowDidExpose:(id)fp8;
- (void)windowDidMove:(id)fp8;
- (void)windowDidResize:(id)fp8;
- (void)windowDidResignMain:(id)fp8;
- (void)windowDidResignKey:(id)fp8;
- (void)windowDidBecomeMain:(id)fp8;
- (void)windowShouldCloseAlertDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (BOOL)windowShouldClose:(id)fp8;
- (void)windowDidBecomeKey:(id)fp8;
- (void)cancelActiveNotifierAnimations;
- (void)windowWillClose:(id)fp8;
- (BOOL)_moveChatFromIndex:(unsigned int)fp8 toIndex:(unsigned int)fp12;
- (void)_synchronizeChatAndTableForced:(BOOL)fp8;
- (void)selectChat:(id)fp8;
- (void)_updateDisplayName;
- (void)_reallyUpdateNumberOfChats;
- (void)_updateNumberOfChats;
- (void)addChatInvite:(id)fp8 withNotifierWindow:(id)fp12;
- (void)addChat:(id)fp8 atIndex:(int)fp12 withController:(id)fp16;
- (void)addChat:(id)fp8 atIndex:(int)fp12;
- (void)addChat:(id)fp8;
- (void)addChat:(id)fp8 withController:(id)fp12;
- (void)removeChat:(id)fp8;
- (void)_reallyCloseChat:(id)fp8;
- (void)tabShouldCloseAlertDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)closeHighlightedTabItem;
- (void)closeChat:(id)fp8;
- (void)closeCurrentChat:(id)fp8;
- (void)displayChat:(id)fp8;
- (id)visibleChatWithID:(id)fp8;
- (id)visibleChatToHookUpWithPresentity:(id)fp8;
- (id)visibleChatToHookUpWithPresentities:(id)fp8;
- (void)_chatAddedToList:(id)fp8;
- (void)_chatRemovedFromList:(id)fp8;
- (void)_chatOverallStatusChanged:(id)fp8;
- (void)_chatUnreadStatusChanged:(id)fp8;
- (void)_chatStatusChanged:(id)fp8;
- (void)_chatMembersChanged:(id)fp8;
- (void)_personChanged:(id)fp8;
- (id)windowWillReturnFieldEditor:(id)fp8 toObject:(id)fp12;
- (void)_updateSelectedRow;
- (BOOL)chatIsRecent:(id)fp8;
- (id)drawMessageForChat:(id)fp8;
- (BOOL)chatIsPulsing:(id)fp8;
- (float)pulseProgressForChat:(id)fp8;
- (BOOL)chatIsAnimating:(id)fp8;
- (float)animationProgressForChat:(id)fp8;
- (void)_clearAnimationTimer;
- (void)_setAnimationTimer;
- (void)_checkAnimationTimer;
- (void)_animateChats:(id)fp8;
- (void)selectChatAction:(id)fp8;
- (id)displayNewChatWithPresentities:(id)fp8 style:(int)fp12;
- (void)choosePerson:(id)fp8;
- (void)_moveSelectedChatIndex:(int)fp8;
- (void)gotoNextChat:(id)fp8;
- (void)gotoPreviousChat:(id)fp8;
- (id)presentityToGetInfoOn;
- (void)saveDocumentTo:(id)fp8;
- (void)showSelectedBuddyInfo:(id)fp8;
- (void)showSelectedBuddyProfile:(id)fp8;
- (void)addABuddy:(id)fp8;
- (void)toggleParticipants:(id)fp8;
- (void)toggleHidePictures:(id)fp8;
- (void)toggleHideAudioStatus:(id)fp8;
- (void)toggleHideVideoStatus:(id)fp8;
- (void)sortByStatus:(id)fp8;
- (void)sortByFirstName:(id)fp8;
- (void)sortByLastName:(id)fp8;
- (void)addLink:(id)fp8;
- (void)sendSMS:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)sendFile:(id)fp8;
- (void)attachFile:(id)fp8;
- (void)insertSmiley:(id)fp8;
- (void)setRendererFromMenuItem:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)toggleHideSmileys:(id)fp8;
- (void)chooseBackgroundImage:(id)fp8;
- (void)clearTranscript:(id)fp8;
- (void)clearBackground:(id)fp8;
- (void)toggleShowNames:(id)fp8;
- (void)toggleRecipientBar:(id)fp8;
- (void)toggleShowPictures:(id)fp8;
- (void)setChatShowsNames:(id)fp8;
- (void)setChatShowsPictures:(id)fp8;
- (void)setChatShowsNamesAndPictures:(id)fp8;
- (void)makeTextBigger:(id)fp8;
- (void)makeTextStandardSize:(id)fp8;
- (void)makeTextSmaller:(id)fp8;
- (void)chooseChatOptions:(id)fp8;
- (void)ignore:(id)fp8;
- (void)toggleQuietMode:(id)fp8;
- (void)block:(id)fp8;
- (void)showInAddressBook:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)showFindPanel:(id)fp8;
- (void)findNext:(id)fp8;
- (void)findPrevious:(id)fp8;
- (void)copySelectionToFindPboard:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)printOperationDidRun:(id)fp8 success:(BOOL)fp12 contextInfo:(void *)fp16;
- (void)printDocument:(id)fp8;
- (void)tabView:(id)fp8 willSwitchFromTab:(int)fp12 toTab:(int)fp16 effect:(int *)fp20 direction:(int *)fp24;
- (void)_needsDrawFromAnimate:(id)fp8;

@end

@interface MenuButton : NSButton
{
    NSPopUpButtonCell *_popUpCell;
    NSString *_axDescription;
    BOOL _overlayStyle;
}

- (void)dealloc;
- (void)setUsesMenu:(BOOL)fp8;
- (BOOL)usesMenu;
- (void)runPopUpInFrame:(struct _NSRect)fp8 ofView:(id)fp24;
- (BOOL)_runPopUp;
- (BOOL)sendAction:(SEL)fp8 to:(id)fp12;
- (void)mouseDown:(id)fp8;
- (void)rightMouseDown:(id)fp8;
- (void)performClick:(id)fp8;
- (void)setAccessibilityDescription:(id)fp8;
- (id)accessibilityDescriptionAttribute;
- (id)accessibilityAttributeNames;
- (void)setOverlayStyle:(BOOL)fp8;
- (BOOL)isOverlayStyle;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface ChooseBuddyButton : MenuButton
{
    int _nCustomItems;
    AbstractAccount *_account;
    Presentity *_selectedPresentity;
    BOOL _registered;
    BOOL _menuIsValid;
    NSArray *_cachedPresentites;
    NSWindow *_customIDSheet;
    ExtendedComboBox *_customIDText;
    NSButton *_customIDOK;
    ServicePopUp *_customIDService;
}

- (void)awakeFromNib;
- (void)dealloc;
- (void)setAccount:(id)fp8;
- (id)selectedPresentity;
- (void)_registerForNotifications;
- (void)_personChanged:(id)fp8;
- (void)_buddyListChanged:(id)fp8;
- (void)_addItemForPresentity:(id)fp8 toMenu:(id)fp12 atIndex:(int)fp16 showingDetails:(BOOL)fp20;
- (void)_addItemForEmptyList;
- (void)_addItemForAccount:(id)fp8 atIndex:(int *)fp12;
- (void)_rebuildBuddyMenu;
- (BOOL)validateMenuItem:(id)fp8;
- (void)_recachePresentityInformation;
- (void)windowDidBecomeMain:(id)fp8;
- (int)numberOfItemsInComboBox:(id)fp8;
- (id)comboBox:(id)fp8 objectValueForItemAtIndex:(int)fp12;
- (unsigned int)comboBox:(id)fp8 indexOfItemWithStringValue:(id)fp12;
- (id)comboBox:(id)fp8 completedString:(id)fp12;
- (void)invalidateMenu;
- (void)runPopUpInFrame:(struct _NSRect)fp8 ofView:(id)fp24;
- (void)_selectPresentity:(id)fp8;
- (void)_personSelected:(id)fp8;
- (void)chooseCustomID:(id)fp8;
- (void)customIDServiceSelected:(id)fp8;
- (void)selectedAccountStatusChanged:(id)fp8;
- (void)windowDidUpdate:(id)fp8;
- (void)acceptCustomID:(id)fp8;
- (void)cancelCustomID:(id)fp8;
- (void)_chooseIDDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;

@end

@interface CollapseView : NSClipView
{
    float _expandedHeight;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)awakeFromNib;
- (BOOL)isCollapsed;
- (id)_highestAncestor:(id)fp8;
- (void)_resizeWindowToFrame:(struct _NSRect)fp8 animate:(BOOL)fp24;
- (void)collapse:(BOOL)fp8;
- (void)collapse:(BOOL)fp8 animate:(BOOL)fp12;
- (void)toggleCollapsed:(id)fp8;
- (void)takeStateFromSender:(id)fp8;

@end

@interface CompositionList : QCPlugIn
{
    NSMutableArray *_effectsArray;
    NSMutableArray *_pageList;
    unsigned int _pageIndex;
    unsigned int _previousIndex;
    NSDictionary *_normalDesc;
    BOOL _updateOutput;
}

+ (int)executionMode;
+ (int)timeMode;
+ (id)attributes;
- (id)init;
- (void)dealloc;
- (void)_repositoryUpdated;
- (void)_loadAllEffects;
- (void)_rebuildBankList;
- (BOOL)startExecution:(id)fp8;
- (void)enableExecution:(id)fp8;
- (BOOL)execute:(id)fp8 atTime:(double)fp12 withArguments:(id)fp20;

@end

@interface ConfigKeyEditor : NSTextView
{
    id _master;
    NSNumber *_virtualKey;
    unsigned int _modifiers;
    id _textField;
    BOOL _operationModeEnabled;
    unsigned int _savedHotKeyOperatingMode;
}

- (void)_disableHotKeyOperationMode;
- (void)_restoreHotKeyOperationMode;
- (void)_windowDidBecomeKeyNotification:(id)fp8;
- (void)_windowDidResignKeyNotification:(id)fp8;
- (id)initConfigKeyEditorWithMaster:(id)fp8;
- (void)dealloc;
- (BOOL)becomeFirstResponder;
- (BOOL)resignFirstResponder;
- (void)mouseDown:(id)fp8;
- (void)keyDown:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (BOOL)performKeyEquivalent:(id)fp8;
- (id)key;
- (id)modifier;
- (id)textField;
- (void)setTextField:(id)fp8;

@end

@interface CoreGraphicsUtilities : NSObject
{
}

+ (struct CGImage *)CGImageFromNSBitmapImageRep:(id)fp8;
+ (struct CGImage *)CGImageFromNSImage:(id)fp8;

@end

@interface CustomImageView : NSImageView
{
}

- (void)mouseDown:(id)fp8;

@end

@interface CustomMessageTableView : FezExtendedTableView
{
}

- (void)_userSelectTextOfNextCellInSameColumn;

@end

@interface CustomWindow : SecureWindow
{
    Notifier *_notifier;
    BOOL _blackNotifier;
    NSMutableArray *_keyDownQueue;
}

- (void)setBlackNotifier:(BOOL)fp8;
- (BOOL)blackNotifier;
- (void)setWindowLevel;
- (void)setTitle:(id)fp8;
- (void)_adjustNotifierButton:(unsigned int)fp8;
- (void)setNotifier:(id)fp8;
- (void)moveWindow:(id)fp8;
- (void)sendEvent:(id)fp8;

@end

@interface DaemonListenerStub : NSObject <FZDaemonListener>
{
}

- (oneway void)defaultsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)activeAccountsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)account:(id)fp8 defaultsChanged:(id)fp12;
- (oneway void)account:(id)fp8 loginStatusChanged:(unsigned int)fp12 message:(id)fp16 reason:(unsigned int)fp20 properties:(id)fp24;
- (oneway void)account:(id)fp8 capabilitiesChanged:(unsigned long long)fp12;
- (oneway void)account:(id)fp8 buddyPropertiesChanged:(id)fp12;
- (oneway void)shutdownAVForAccount:(id)fp8;
- (oneway void)account:(id)fp8 buddyPictureChanged:(id)fp12 imageData:(id)fp16 imageHash:(id)fp20;
- (oneway void)account:(id)fp8 groupsChanged:(id)fp12 error:(id)fp16;
- (oneway void)account:(id)fp8 buddyProperties:(id)fp12 buddyPictures:(id)fp16;
- (oneway void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (oneway void)account:(id)fp8 directIMRequestFrom:(id)fp12 invitation:(id)fp16;
- (oneway void)chat:(id)fp8 statusChanged:(int)fp12;
- (oneway void)chat:(id)fp8 messageReceived:(id)fp12;
- (oneway void)chat:(id)fp8 showError:(id)fp12;
- (oneway void)chat:(id)fp8 member:(id)fp12 statusChanged:(int)fp16;
- (oneway void)account:(id)fp8 invitedToVC:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 responseToVCRequest:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 cancelVCInviteFrom:(id)fp12;
- (oneway void)account:(id)fp8 counterProposalFrom:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 updateVCFrom:(id)fp12 data:(id)fp16;
- (oneway void)account:(id)fp8 handleAVMessage:(id)fp12 sessionID:(unsigned int)fp16 type:(unsigned int)fp20 userInfo:(id)fp24;
- (oneway void)account:(id)fp8 handleSubscriptionRequestFrom:(id)fp12;
- (oneway void)showInvalidCertNotificationForAccount:(id)fp8;
- (oneway void)showForgotPasswordNotificationForAccount:(id)fp8;
- (oneway void)myStatusChanged:(id)fp8;
- (oneway void)daemonPersistentProperty:(id)fp8 changedTo:(id)fp12;
- (oneway void)currentAVChatInfoRequestedWithTransactionID:(unsigned int)fp8;
- (oneway void)audioReflectorRequested:(BOOL)fp8 transactionID:(unsigned int)fp12;
- (oneway void)videoStillForPersonRequested:(id)fp8 withTransactionID:(unsigned int)fp12;
- (oneway void)currentAVChatInfoProvided:(id)fp8 result:(unsigned int)fp12 responseID:(id)fp16;
- (oneway void)videoStill:(id)fp8 providedForPerson:(id)fp12 result:(unsigned int)fp16 responseID:(id)fp20;
- (oneway void)avManagerStateProvided:(unsigned int)fp8 result:(unsigned int)fp12 responseID:(id)fp16;
- (oneway void)setAVManagerRequested:(BOOL)fp8 URLToShare:(id)fp12;
- (oneway void)contextUpdate:(id)fp8;
- (oneway void)contextEndedForGUID:(id)fp8;
- (oneway void)displayStatusText:(id)fp8;
- (oneway void)account:(id)fp8 capabilities:(unsigned long long)fp12 serviceLoginStatus:(unsigned int)fp20 loginStatusMessage:(id)fp24;
- (oneway void)services:(id)fp8 myStatus:(id)fp12 persistentProperties:(id)fp16;
- (oneway void)service:(id)fp8 properties:(id)fp12 defaults:(id)fp16 defaultAccountSettings:(id)fp20 allAccounts:(id)fp24 activeAccounts:(id)fp28;
- (oneway void)account:(id)fp8 blockListChanged:(id)fp12;
- (oneway void)account:(id)fp8 allowListChanged:(id)fp12;
- (oneway void)account:(id)fp8 blockingModeChanged:(unsigned int)fp12;
- (oneway void)account:(id)fp8 blockIdleStatusChanged:(BOOL)fp12;
- (oneway void)vcCapabilitiesChanged:(unsigned long long)fp8;
- (oneway void)setupComplete;

@end

@interface DefaultApplicationPopUpButton : NSPopUpButton
{
    NSURL *_appURL;
    int _index;
    NSArray *_schemes;
}

- (id)mainScheme;
- (void)setHandler:(id)fp8 forScheme:(id)fp12;
- (id)imageForURL:(id)fp8;
- (int)addItemToPopup:(id)fp8;
- (void)populateSchemeHandlerPopupWithURL:(id)fp8;
- (id)copyDefaultURLForScheme:(id)fp8;
- (void)selectDefaultMailClientAtIndex:(int)fp8;
- (void)selectItemInPopup:(id)fp8;
- (void)setNewApplication;
- (void)selectNewAppSelected:(id)fp8;
- (void)sheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)configurePopUpForURLSchemes:(id)fp8 usingExampleURLString:(id)fp12;

@end

@interface DisclosureButton : NSButton
{
}

- (void)awakeFromNib;

@end

@interface DotMacCaps : NSObject
{
    NSString *_urlKey;
    NSString *_dotMacAccount;
    NSString *_dotMacPassword;
    URLFetcher *_serverRequest;
    URLFetcher *_prefRequest;
    URLFetcher *_linkRequest;
    int _couldContactDotMac;
    int _validPassword;
    int _canEncrypt;
    int _validDotMacAccount;
}

+ (void)openURLWithKey:(id)fp8;
+ (id)_normalizedLanguageStringsFor:(id)fp8;
+ (id)_urlForKey:(id)fp8;
+ (id)dotMacLearnMoreURL;
+ (id)dotMacRevokeURL;
+ (id)dotMacExpiredURL;
+ (id)dotMacCreateTrialURL;
+ (id)dotMacCreateSubscriberURL;
+ (id)dotMacBaseURL;
+ (id)dotMacForgottenPasswordURL;
- (void)dealloc;
- (id)_initWithURLKey:(id)fp8;
- (id)initWithAccount:(id)fp8 withPassword:(id)fp12;
- (id)dotMacAccount;
- (void)_setupServerRequestWithURL:(id)fp8 userConfigData:(id)fp12 userConfigDictionary:(id)fp16;
- (void)_setupPrefRequest;
- (void)_setupLinkRequest;
- (void)_configureLinks;
- (void)_configurePrefs;
- (void)_linkRequestFinishedWithData:(id)fp8;
- (void)_serverRequestFinishedWithData:(id)fp8;
- (void)_prefRequestFinishedWithData:(id)fp8;
- (void)urlFetcher:(id)fp8 fetchedResult:(id)fp12;
- (void)urlFetcher:(id)fp8 fetchFailedWithError:(id)fp12;
- (void)_setValidDotMacAccount:(int)fp8;
- (int)validDotMacAccount;
- (void)_setCanEncrypt:(int)fp8;
- (int)canEncrypt;
- (int)couldContactDotMac;
- (void)_setCouldContactDotMac:(int)fp8;
- (int)validPassword;
- (void)_setValidPassword:(int)fp8;

@end

@interface DotMacCertHelper : NSObject
{
}

+ (int)dotMacCertRequestStatusForUser:(id)fp8;
+ (int)requestDotMacIdentityCertForUser:(id)fp8 remainingTime:(int *)fp12;
+ (int)renewDotMacIdentityForUser:(id)fp8 remainingTime:(int *)fp12;
+ (BOOL)certificateIsPresentForUser:(id)fp8;
+ (struct OpaqueSecCertificateRef *)copyCertificateForLocalDotMacAccount:(id)fp8;
+ (struct OpaqueSecIdentityRef *)copyIdentityForLocalDotMacAccount:(id)fp8;
+ (BOOL)dotMacAccountNeedsRenewal:(id)fp8;
+ (int)installIntermediateInKeychain:(id)fp8;
+ (BOOL)hasPendingRequestsForUser:(id)fp8;

@end

@interface EffectView : NSView
{
    NSImage *_startImage;
    NSImage *_endImage;
    NSDate *_startTime;
    double _effectTime;
    int _effect;
    int _direction;
    float _prevProgress;
    BOOL _manuallyInvalidate;
}

- (id)initWithFrame:(struct _NSRect)fp8 startImage:(id)fp24 endImage:(id)fp28;
- (void)dealloc;
- (void)doEffect:(int)fp8 direction:(int)fp12 time:(double)fp16;
- (void)_doFadeEffect:(float)fp8 inRect:(struct _NSRect)fp12;
- (void)_doSlideEffect:(float)fp8 inRect:(struct _NSRect)fp12 moveOld:(BOOL)fp28 moveNew:(BOOL)fp32;
- (void)_doZoomEffect:(float)fp8 inRect:(struct _NSRect)fp12 scale:(BOOL)fp28;
- (void)_doSplitEffect:(float)fp8 inRect:(struct _NSRect)fp12 horiz:(BOOL)fp28 wipe:(BOOL)fp32;
- (void)_setNeedsDisplay;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setManualInvalidation:(BOOL)fp8;
- (BOOL)doingEffect;
- (void)stopEffect;

@end

@interface EffectsPickerController : NSObject <FrameListener>
{
    QCCompositionPickerPanel *_picker;
    Texture *_texture;
    BOOL _isRunning;
}

+ (void)showEffectsPanel;
- (id)init;
- (void)dealloc;
- (void)startVideo;
- (void)stopVideo;
- (void)showEffectsPanel;
- (void)frameNotifier:(id)fp8 postedNewFrame:(id)fp12 fromSource:(id)fp16;
- (void)windowDidBecomeKey:(id)fp8;
- (void)windowDidResignKey:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)windowDidExpose:(id)fp8;
- (id)_setPosterFrameForFile:(id)fp8 composition:(id)fp12;
- (id)_posterFrameForFile:(id)fp8 composition:(id)fp12;
- (void)compositionPickerView:(id)fp8 didSelectComposition:(id)fp12;
- (void)compositionPickerView:(id)fp8 didLoadComposition:(id)fp12;
- (void)compositionPickerView:(id)fp8 willSelectComposition:(id)fp12;
- (unsigned int)compositionPickerView:(id)fp8 draggingEnteredComposition:(id)fp12 sender:(id)fp16;
- (BOOL)compositionPickerView:(id)fp8 performDragOperationOnComposition:(id)fp12 sender:(id)fp16;

@end

@interface EffectsPickerImageCache : NSObject
{
}

+ (id)sharedInstance;
+ (id)_cachePath;
- (BOOL)imageExistsForKey:(id)fp8;
- (id)imageForKey:(id)fp8;
- (void)setImage:(id)fp8 forKey:(id)fp12;
- (void)cleanCacheExceptForKeys:(id)fp8;
- (void)removeImageForKey:(id)fp8;

@end

@interface EncryptionAssistantController : NSObject
{
    NSWindow *_certAsstWindow;
    NSButton *_goBackButton;
    NSButton *_continueButton;
    NSButton *_learnMoreButton;
    NSTabView *_tabView;
    NSTabViewItem *_contactingTab;
    NSProgressIndicator *_contactingDotmacSpinner;
    NSTextField *_contactingDotmacText;
    NSTabViewItem *_encryptionTab;
    NSButton *_useCertCheckbox;
    NSTabViewItem *_finishTab;
    NSTextField *_doneText;
    NSImageView *_donePic;
    NSTextField *_currentTitle;
    NSString *_resultTitle;
    NSString *_aimAccount;
    NSString *_password;
    BOOL _disableGoBack;
    BOOL _showRevokeButton;
    NSTabViewItem *_firstTab;
    AIMAccount *_aimAccountObject;
    BOOL _showServerProcessingText;
    BOOL _showEncryptionActiveText;
}

+ (id)openForAIMAccount:(id)fp8;
+ (void)showCertFailedWithDictionary:(id)fp8;
+ (void)showCertFailedAlertForAccount:(id)fp8 withTitle:(id)fp12 andError:(id)fp16;
+ (void)checkCertExpirationForAccount:(id)fp8;
- (id)account;
- (void)_showWindow;
- (void)dealloc;
- (void)_updateTitle;
- (void)_setConclusionTitle:(id)fp8;
- (void)_updateContinueDone:(BOOL)fp8;
- (void)awakeFromNib;
- (id)initWithAIMAccount:(id)fp8;
- (void)tabView:(id)fp8 willSelectTabViewItem:(id)fp12;
- (void)tabView:(id)fp8 didSelectTabViewItem:(id)fp12;
- (void)goBack:(id)fp8;
- (void)continueDone:(id)fp8;
- (void)revokeCertificate:(id)fp8;
- (void)tellMeMore:(id)fp8;
- (void)_finishedGettingCertStatus:(id)fp8;
- (void)_retrieveDotMacCertWithPassword:(id)fp8;

@end

@interface ErrorReport : NSObject
{
    NSMutableString *_fullReport;
}

- (id)initWithDescription:(id)fp8;
- (void)dealloc;
- (id)fullReport;
- (BOOL)send;

@end

@interface ErrorReporterController : NSObject
{
    NSWindow *_errorReporterSheet;
    NSTextField *_textualDescription;
    NSTextView *_errorLogTextView;
    NSButton *_sendButton;
    NSButton *_dontSendButton;
    NSButton *_revealButton;
    NSBox *_revealBox;
    AVChatController *_chatController;
    NSInvocation *_endingCallback;
    BOOL _displayedAsSheet;
    BOOL _revealBoxShown;
    float _fullSizeFrameAdditionalHeight;
    float _minWidth;
    float _largeSizeMinHeight;
    ErrorReport *_errorReport;
}

+ (void)presentErrorReporterForChatController:(id)fp8 asSheet:(BOOL)fp12 thenInvoke:(id)fp16;
- (id)initForAVChatController:(id)fp8 asSheet:(BOOL)fp12 thenInvoke:(id)fp16;
- (void)_setupErrorReport;
- (void)sendToApple:(id)fp8;
- (void)dontSendToApple:(id)fp8;
- (void)_hideRevealBox;
- (void)_showRevealBox;
- (void)revealButtonPressed:(id)fp8;
- (void)_sheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)dealloc;

@end

@interface ExceptionReportingApp : NSApplication
{
    id _keyEventHandler;
}

- (id)init;
- (void)sendEvent:(id)fp8;
- (void)setKeyEventHandler:(id)fp8;

@end

@interface ExceptionReportingApp (SecureWindowMenuTitle)
- (void)addWindowsItem:(id)fp8 title:(id)fp12 filename:(BOOL)fp16;
- (void)changeWindowsItem:(id)fp8 title:(id)fp12 filename:(BOOL)fp16;
@end

@interface ExtendedComboBox : NSComboBox
{
    BOOL _allowsLineBreaks;
    BOOL _passesReturnKey;
    BOOL _allowsRichText;
    ServicePopUp *_servicePopUp;
    NSString *_prefKey;
    BOOL _autoFilled;
    NSString *_suffix;
    id _returnDelegate;
}

- (id)init;
- (void)_installCustomCell;
- (void)dealloc;
- (BOOL)passesReturnEvent;
- (void)setPassesReturnEvent:(BOOL)fp8;
- (void)setReturnDelegate:(id)fp8;
- (void)setAllowsLineBreaks:(BOOL)fp8;
- (BOOL)allowsLineBreaks;
- (void)setAllowsRichText:(BOOL)fp8;
- (BOOL)allowsRichText;
- (void)keyDown:(id)fp8;
- (id)_suffixAttributes;
- (void)setSuffix:(id)fp8;
- (id)suffix;
- (BOOL)textView:(id)fp8 doCommandBySelector:(SEL)fp12;
- (void)textDidChange:(id)fp8;
- (struct _NSRange)textView:(id)fp8 willChangeSelectionFromCharacterRange:(struct _NSRange)fp12 toCharacterRange:(struct _NSRange)fp20;
- (void)setStringValue:(id)fp8;
- (BOOL)isPopUpButtonVisible;
- (void)setPopUpButtonVisible:(BOOL)fp8;
- (void)setObjectValue:(id)fp8;
- (BOOL)isAutoFilled;
- (void)setAutoFilled:(BOOL)fp8;
- (void)updateNumberOfVisibleItems;
- (id)_prefKey;
- (void)setRecentsListPrefKey:(id)fp8;
- (id)recentsListPrefKey;
- (void)loadLastRecentValue;
- (void)updateRecentsList;
- (void)saveRecentsList;
- (void)textDidEndEditing:(id)fp8;
- (BOOL)becomeFirstResponder;

@end

@interface ExtendedSlider : NSSlider
{
    StretchyImageView *_backgroundImage;
}

- (void)awakeFromNib;
- (void)setEnabled:(BOOL)fp8;

@end

@interface ExtendedSliderCell : NSSliderCell
{
    NSImage *_knobImage;
    NSImage *_knobDownImage;
    struct _NSRect _knobSourceRect;
}

- (id)init;
- (void)dealloc;
- (void)drawKnob:(struct _NSRect)fp8;
- (void)_drawTickMarks;
- (void)drawWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface ExtendedSplitView : NSSplitView
{
    NSString *_autosaveName;
    int _savedSplitPosition;
    int _minSavedSplitPosition;
}

+ (id)_keyForSavingSplitviewWithName:(id)fp8;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)setMinSavedSplitPosition:(int)fp8;
- (int)minSavedSplitPosition;
- (void)_rememberSavedSplitViewPosition;
- (void)_setPositionFromAutosaveName;
- (void)rememberCurrentSplitPosition;
- (int)savedSplitPosition;
- (void)setSavedSplitPosition:(int)fp8;
- (int)splitPosition;
- (void)setSplitPosition:(int)fp8;
- (id)autosaveName;
- (void)setAutosaveName:(id)fp8;
- (void)adjustSubviews;
- (float)dividerThickness;
- (void)drawDividerInRect:(struct _NSRect)fp8;
- (BOOL)isOpaque;
- (id)accessibilityAttributeValue:(id)fp8;
- (void)mouseDown:(id)fp8;

@end

@interface ExtendedSplitViewGrabber : NSView
{
    ExtendedSplitView *_splitView;
    struct _NSPoint _startPoint;
    struct _NSRect _startFrame;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setSplitView:(id)fp8;
- (BOOL)mouseDownCanMoveWindow;
- (BOOL)prepareForDragOperation:(id)fp8;
- (void)mouseDown:(id)fp8;
- (void)mouseUp:(id)fp8;
- (void)resetCursorRects;
- (void)mouseDragged:(id)fp8;

@end

@interface ExtendedTextField : NSTextField
{
    BOOL _allowsLineBreaks;
    NSString *_suffix;
    BOOL _autoFilled;
    BOOL _allowsRichText;
}

- (id)init;
- (void)dealloc;
- (void)setAllowsLineBreaks:(BOOL)fp8;
- (BOOL)allowsLineBreaks;
- (void)setAllowsRichText:(BOOL)fp8;
- (BOOL)allowsRichText;
- (BOOL)textView:(id)fp8 doCommandBySelector:(SEL)fp12;
- (void)textDidChange:(id)fp8;
- (BOOL)isAutoFilled;
- (void)setAutoFilled:(BOOL)fp8;
- (id)_suffixAttributes;
- (void)setSuffix:(id)fp8;
- (id)suffix;
- (struct _NSRange)textView:(id)fp8 willChangeSelectionFromCharacterRange:(struct _NSRange)fp12 toCharacterRange:(struct _NSRange)fp20;
- (void)textDidEndEditing:(id)fp8;
- (BOOL)becomeFirstResponder;
- (void)setObjectValue:(id)fp8;
- (void)setStringValue:(id)fp8;

@end

@interface FTUBackgroundView : NSView
{
    NSBox *_backgroundView;
}

- (void)drawRect:(struct _NSRect)fp8;

@end

@interface FZInvocationQueue : NSObject
{
    NSMutableArray *_queue;
    NSMutableArray *_options;
    BOOL _holdQueue;
    id _target;
    id _delegate;
    double _dequeueRate;
}

- (id)init;
- (void)dealloc;
- (void)forwardInvocation:(id)fp8;
- (id)methodSignatureForSelector:(SEL)fp8;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (void)setTarget:(id)fp8;
- (id)target;
- (void)setDequeueRate:(double)fp8;
- (double)dequeueRate;
- (void)_stepQueueNotification:(id)fp8;
- (void)_holdQueueNotification:(id)fp8;
- (void)_releaseQueueNotification:(id)fp8;
- (void)_setQueueTimer;
- (BOOL)_invokeInvocation:(id)fp8;
- (void)_checkQueue;
- (unsigned int)_optionsForInvocation:(id)fp8;
- (int)_numberOfLimitedMessagesInQueue;
- (int)_maxQueueLimitSize;
- (BOOL)_acceptsOptions:(unsigned int)fp8;
- (BOOL)_replaceSimilarInvocation:(id)fp8;
- (BOOL)_insertInvocation:(id)fp8 options:(unsigned int)fp12;
- (int)_enqueueInvocation:(id)fp8 options:(unsigned int)fp12;
- (id)_dequeueInvocation;
- (void)removeAllInvocations;
- (void)invokeAll;
- (BOOL)isEmpty;
- (id)peek;

@end

@interface FZMessage : NSObject <NSCoding, NSCopying, FZSecureObject>
{
    NSString *_sender;
    NSDate *_time;
    unsigned int _bodyFormat;
    NSString *_body;
    NSDictionary *_attributes;
    NSArray *_inlineFiles;
    NSString *_fileTransferGUID;
    NSArray *_inlineFileGUIDs;
    int _flags;
    NSError *_error;
    NSString *_guid;
    NSString *_subject;
    NSString *_URL;
}

- (void)_cleanMessage;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (id)replacementObjectForPortCoder:(id)fp8;
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;
- (id)init;
- (id)initWithSender:(id)fp8 format:(unsigned int)fp12 body:(id)fp16 secure:(BOOL)fp20;
- (id)initWithSender:(id)fp8 time:(id)fp12 format:(unsigned int)fp16 body:(id)fp20 attributes:(id)fp24 fileTransferGUID:(id)fp28 inlineFiles:(id)fp32 flags:(int)fp36 error:(id)fp40 guid:(id)fp44;
- (void)dealloc;
- (id)URL;
- (id)subject;
- (id)sender;
- (id)time;
- (id)guid;
- (unsigned int)bodyFormat;
- (id)body;
- (id)attributes;
- (id)inlineFiles;
- (int)flags;
- (BOOL)isAlert;
- (BOOL)isFinished;
- (BOOL)isEmpty;
- (BOOL)isPrepared;
- (id)error;
- (id)fileTransferGUID;
- (id)inlineFileGUIDs;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (void)setSubject:(id)fp8;
- (void)setURL:(id)fp8;
- (void)setSender:(id)fp8;
- (void)setTime:(id)fp8;
- (void)setAttributes:(id)fp8;
- (void)setInlineFiles:(id)fp8;
- (void)setFileTransferGUID:(id)fp8;
- (void)setInlineFileGUIDs:(id)fp8;
- (void)setFlags:(int)fp8;
- (void)setBody:(id)fp8 format:(unsigned int)fp12;
- (void)adjustIsEmptyFlag;
- (void)setError:(id)fp8;

@end

@interface FZVideoConferenceController : VideoConferenceMultiController <NetworkChangeNotificationListener>
{
    int _initStatus;
    BOOL _everOpenedCamera;
    BOOL _openCameraRequired;
    BOOL _recacheSelectedCamera;
    VCCamera *_cachedSelectedCamera;
    int _localVideoClientCount;
    int _localAudioClientCount;
    int _audioReflectorClientCount;
    BOOL _auxInputActive;
    BOOL _restartPreviewAtWake;
    BOOL _openCameraAtWake;
}

+ (BOOL)hasBeenInitialized;
+ (id)sharedInstance;
+ (id)newcameraList;
- (void)initVCC;
- (BOOL)isVCCReady;
- (void)_doInitVCC;
- (void)_initVCCDidFinish;
- (void)_doInitVCCDidFinish;
- (void)shutdownAV;
- (id)init;
- (void)dealloc;
- (void)_postPrefsChangedNotification:(id)fp8;
- (void)_hardwareCapsNotification:(id)fp8;
- (unsigned long long)basicVCCapabilitiesCanAudio:(char *)fp8 canVideo:(char *)fp12;
- (BOOL)canHostMultiVideo:(BOOL)fp8;
- (BOOL)canRecordVideo:(BOOL)fp8;
- (void)systemWillSleep;
- (void)systemDidWake;
- (void)systemNetworkDidChange;
- (BOOL)getLocalVideoTextureBuffer:(CDAnonymousStruct9 *)fp8;
- (BOOL)isLocalVideoChanged;
- (void)_removedClient;
- (BOOL)addLocalVideoClient;
- (BOOL)removeLocalVideoClient;
- (void)addLocalAudioClient;
- (void)removeLocalAudioClient;
- (void)restartPreviewIfNecessary;
- (BOOL)startReflector;
- (BOOL)stopReflector;
- (id)preferredMic:(id)fp8;
- (BOOL)setPreferredMic;
- (BOOL)selectMicrophone:(id)fp8;
- (id)_defaultMicrophoneFromList:(id)fp8;
- (id)_UIDFromMicrophone:(id)fp8;
- (id)micNamePref;
- (void)_selectSoundOutputDevice;
- (BOOL)selectSoundOutputDevice:(id)fp8;
- (id)soundOutputdeviceNamePref;
- (void)setSystemMute:(BOOL)fp8;
- (BOOL)haveBluetooth;
- (id)bluetoothHeadsetMic;
- (id)bluetoothHeadsetSpeaker;
- (BOOL)haveBluetoothHeadset;
- (BOOL)usingBluetoothHeadset;
- (BOOL)setUsingBluetoothHeadset:(BOOL)fp8;
- (BOOL)openCamera;
- (void)__iChatCancelPreview;
- (int)cancelPreview;
- (void)__iChatCloseCamera;
- (BOOL)closeCamera;
- (id)realCameraInList:(id)fp8;
- (BOOL)currentCameraIsQ8;
- (BOOL)getCameraIrisState;
- (BOOL)getMicrophoneIrisState;
- (BOOL)selectCameraByGUID:(id)fp8;
- (void)_selectCamera;
- (id)_defaultCameraFromList:(id)fp8;
- (id)cameraGUIDPref;
- (void)forceCameraRecache;
- (id)selectedCamera;
- (void)auxiliaryInputReady;
- (void)disableAuxiliaryVideoInput;
- (void)setCameraSettingsFromDefaults;
- (BOOL)setColor:(float)fp8;
- (float)color;
- (BOOL)setBrightness:(float)fp8;
- (float)brightness;
- (BOOL)setContrast:(float)fp8;
- (float)contrast;
- (BOOL)setFocus:(float)fp8;
- (float)focus;
- (BOOL)setSharpness:(float)fp8;
- (float)sharpness;
- (int)lightingProfile;

@end

@interface FetchICEDataOp : ExtendedOperation
{
    AVChatParticipant *_participant;
    NSData *_ICEData;
}

- (id)initWithParticipant:(id)fp8;
- (void)dealloc;
- (void)main;
- (id)ICEData;

@end

@interface FezCellTipView : NSView
{
    NSAttributedString *_cellTip;
}

- (void)setAttributedCellTip:(id)fp8;
- (id)attributedCellTip;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface FezCellTipWindow : NSWindow
{
    FezCellTipView *_cellTipView;
}

- (id)init;
- (void)dealloc;
- (void)setCellTip:(id)fp8;
- (id)cellTip;

@end

@interface FezCreateCommand : NSCreateCommand
{
}

- (id)performDefaultImplementation;
- (id)_retrieveObjectOfClass:(Class)fp8 named:(id)fp12;
- (id)_retrieveParticipantsArrayNamed:(id)fp8;
- (id)_retrieveAbstractAccountNamed:(id)fp8;
- (id)_retrieveStringNamed:(id)fp8;
- (int)_retrieveIntNamed:(id)fp8;
- (BOOL)_retrieveBoolNamed:(id)fp8;
- (BOOL)_verifyParticipants:(id)fp8 areOnService:(id)fp12;
- (id)_genericIMFromPresentity:(id)fp8 withText:(id)fp12;
- (id)_createTextChatWithService:(id)fp8 participants:(id)fp12 name:(id)fp16 invitation:(id)fp20;
- (id)_createTextChat;
- (id)_createAVChat;

@end

@interface FezDeleteCommand : NSCreateCommand
{
}

- (id)performDefaultImplementation;

@end

@interface FezIKPictureTakerVideoReceiver : NSObject <IKPictureTakerVideoProvider, FrameListener>
{
    id /*<IKPictureTakerVideoReceiver>*/ _receiver;
    FrameReader *_frameReader;
    NSOpenGLContext *_glContext;
    struct __CVBuffer *_readBuffer;
}

+ (id)sharedInstance;
- (struct __CVBuffer *)_textureToCVPixelBuffer:(id)fp8;
- (void)frameNotifier:(id)fp8 postedNewFrame:(id)fp12 fromSource:(id)fp16;
- (void)startGrabbingForReceiver:(id)fp8;
- (void)stopGrabbing;
- (BOOL)canStartGrabbing;
- (void)dealloc;

@end

@interface FezPreferences : NSPreferences
{
}

+ (void)initialize;
- (id)init;
- (struct _NSSize)preferencesContentSize;
- (BOOL)usesNewLayout;
- (BOOL)usesButtons;
- (id)windowWillReturnFieldEditor:(id)fp8 toObject:(id)fp12;
- (void)windowWillClose:(id)fp8;
- (struct _NSSize)windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12;
- (id)selectModuleOfClass:(Class)fp8;
- (void)_selectModuleOwner:(id)fp8;
- (void)cancel:(id)fp8;

@end

@interface FezQCRenderer : QCRenderer
{
}

+ (BOOL)requires8BitInternalBuffers;
+ (id)defaultRenderingOptions;
- (id)init;

@end

@interface Fezz : NSObject <ChatViewer, HotKeyHandler>
{
    NSMenuItem *_smsMenuItem;
    NSMenuItem *_smileyMenuItem;
    NSMenuItem *_balloonMenuItem;
    NSMenuItem *_firstServiceStatusItem;
    NSMenuItem *_closeChatMenuItem;
    NSMenuItem *_closeWindowMenuItem;
    NSMenuItem *_myStatusMenuItem;
    NSMenuItem *_accountsMenuItem;
    NSMenuItem *_firstPeopleListMenuItem;
    NSMenuItem *_avMenuItem;
    NSMenu *_avMenu;
    StatusController *_statusController;
    NSArray *_inviteData;
    NSMutableArray *_aeQueue;
    BOOL _setupComplete;
    BOOL _connectedToDaemon;
    NSMenuItem *_switchToMenuItem;
    int _switchToMenuIndex;
    NSWindow *_chooserWindow;
    NSMutableDictionary *_hotKeyInfo;
    NSDictionary *_buddyIconDownloadInfo;
    BOOL _finishedLaunching;
    BOOL _finishedDelayedLaunching;
    BOOL _finishedDefferredLaunching;
    BOOL _terminating;
    NSMutableArray *_filesToOpen;
}

+ (id)sharedInstance;
+ (void)showCouldNotConnectDialog;
+ (void)connectAndAutoLogin;
+ (unsigned int)numberOfUnreadMessages;
- (id)init;
- (void)dealloc;
- (void)agentDidLaunch:(id)fp8;
- (id)_openFile:(id)fp8;
- (void)openFilesAfterLaunch;
- (BOOL)application:(id)fp8 openFile:(id)fp12;
- (BOOL)applicationShouldOpenUntitledFile:(id)fp8;
- (void)_orderFrontAllActiveWindows;
- (unsigned int)applicationShouldTerminate:(id)fp8;
- (BOOL)_appHasOpenUnminiaturizedWindows;
- (BOOL)applicationShouldHandleReopen:(id)fp8 hasVisibleWindows:(BOOL)fp12;
- (void)handleHotKey:(unsigned long)fp8 pressed:(BOOL)fp12;
- (id)windowForSheet;
- (BOOL)isChatViewerOpen;
- (void)openChat:(id)fp8;
- (void)displayChat:(id)fp8;
- (id)displayChatForPresentity:(id)fp8 style:(int)fp12;
- (id)createChatWindowWithPresentities:(id)fp8 style:(int)fp12;
- (id)createChatUIWithPresentities:(id)fp8 style:(int)fp12;
- (id)createUIForChat:(id)fp8;
- (id)visibleChatToHookUpWithPresentity:(id)fp8;
- (id)visibleChatWithID:(id)fp8;
- (void)doAddBuddyCommandForPresentity:(id)fp8 withWindow:(id)fp12;
- (void)showInfoForPresentity:(id)fp8;
- (void)showProfileForPresentity:(id)fp8;
- (id)chooserWindow;

@end

@interface Fezz (FezzActions)
- (void)showAbout:(id)fp8;
- (void)showPrefs:(id)fp8;
- (void)showVideoPrefs:(id)fp8;
- (void)sendSMS:(id)fp8;
- (void)newChat:(id)fp8;
- (void)newChatWithPerson:(id)fp8;
- (void)goToChat:(id)fp8;
- (void)_togglePeopleList:(id)fp8;
- (void)toggleAccountConnection:(id)fp8;
- (void)showPeopleListControllerSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)showPeopleListController:(id)fp8;
- (void)showFileTransferManager:(id)fp8;
- (void)showChatList:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)showVCInfo:(id)fp8;
- (void)showEffectsPalette:(id)fp8;
- (void)resetBackground:(id)fp8;
- (void)showSelfPreview:(id)fp8;
- (void)shareWithiChatTheater:(id)fp8;
- (void)shareiPhotoWithiChatTheater:(id)fp8;
- (void)showAddressBook:(id)fp8;
- (void)changeBuddyPicture:(id)fp8;
- (void)toggleNameDisplay:(id)fp8;
- (void)togglePublishMic:(id)fp8;
- (void)togglePublishCamera:(id)fp8;
- (void)togglePublishARD:(id)fp8;
- (void)deleteSelectedBuddies:(id)fp8;
- (void)showMyProfile:(id)fp8;
- (void)shopForiChatProducts:(id)fp8;
- (void)provideBetaFeedback:(id)fp8;
- (void)ignore:(id)fp8;
- (void)block:(id)fp8;
- (void)toggleHidePictures:(id)fp8;
- (void)toggleHideAudioStatus:(id)fp8;
- (void)toggleHideVideoStatus:(id)fp8;
- (void)toggleShowOfflines:(id)fp8;
- (void)toggleArrangesByGroup:(id)fp8;
- (void)toggleUsesOfflineGroup:(id)fp8;
- (void)sortByStatus:(id)fp8;
- (void)sortByFirstName:(id)fp8;
- (void)sortByLastName:(id)fp8;
- (void)addABuddy:(id)fp8;
- (void)toggleHideSmileys:(id)fp8;
- (void)toggleHideLocalVideo:(id)fp8;
- (void)toggleRecording:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
@end

@interface Fezz (FezzAdditions)
- (id)_hotKeyInfoForSignature:(unsigned long)fp8;
- (long)_handleHotKeyEvent:(struct OpaqueEventRef *)fp8;
- (void)installGlobaliChatKeyCode:(int)fp8 modifiers:(int)fp12 signature:(unsigned long)fp16 handler:(id)fp20;
- (void)uninstallGlobaliChatKeyWithSignature:(unsigned long)fp8;
- (void)installGlobaliChatKey;
- (void)setupComplete:(id)fp8;
- (void)_resurrectPersistedChats;
- (void)_persistCurrentChats;
- (void)_updateAVMenu;
- (void)_initAVMenu;
- (void)_createCacheFolder;
- (void)_saveCameraSettings;
- (void)_prepareInternals;
- (void)_createDownloadsFolder;
- (void)createRequiredFolders;
- (void)_checkCertExpiration;
- (void)_runTestsIfRequested;
- (void)_finishDeferredLaunching;
- (void)_deferredApplicationDidFinishLaunching;
- (void)_setupViceroy;
- (void)_timeZoneChanged;
- (void)_delayedApplicationLoading;
- (void)_daemonConnected;
- (void)applicationDidFinishLaunching:(id)fp8;
- (void)applicationWillTerminate:(id)fp8;
- (void)_updateUnreadBadge:(id)fp8;
- (void)setPrefersCloseChat:(BOOL)fp8;
- (BOOL)activateRecentChat;
- (id)_otherSMSMenuItem;
- (void)_removeSMSMenuIfNeeded;
- (void)_removeOpenRecentMenu;
- (void)_updateBuddyListMenu:(id)fp8;
- (void)updatePeopleListWindowItem;
- (id)applicationDockMenu:(id)fp8;
- (void)_dockItemPicked:(id)fp8;
- (BOOL)willRunFTU;
- (void)afterLaunchMakeObject:(id)fp8 performSelector:(SEL)fp12;
- (BOOL)deferredLaunchComplete;
- (BOOL)delayedLaunchComplete;
- (BOOL)isAppLaunching;
- (BOOL)isAppTerminating;
- (void)_populateChatMenuItems;
- (void)awakeFromNib;
- (void)setChooserWindow:(id)fp8;
- (void)_setImage:(id)fp8 forPresentity:(id)fp12 allowEditing:(BOOL)fp16;
- (void)_cleanUpDownloadWithError:(BOOL)fp8;
- (void)urlFetcher:(id)fp8 fetchedResult:(id)fp12;
- (void)urlFetcher:(id)fp8 fetchFailedWithError:(id)fp12;
- (void)_setImageAtURL:(id)fp8 forPresentity:(id)fp12 allowEditing:(BOOL)fp16;
- (void)_installAEHandlers;
- (void)_handleAEQueue;
- (id)_presentitiesWithIDs:(id)fp8 forAccount:(id)fp12;
- (id)_presentitiesWithCardUIDs:(id)fp8 forSpecificAccount:(id)fp12;
- (id)_presentitiesWithCardUIDs:(id)fp8 forAccount:(id)fp12 preferOnline:(BOOL)fp16;
- (id)_handleTextComposeRequestFor:(id)fp8 style:(int)fp12 roomName:(id)fp16 message:(id)fp20;
- (BOOL)_confirmAction:(id)fp8 info:(id)fp12 button:(id)fp16;
- (BOOL)_confirmAndInviteToAVChatVideo:(BOOL)fp8 presentities:(id)fp12;
- (BOOL)_confirmAndGoToChatRoom:(id)fp8 account:(id)fp12;
- (BOOL)_handleRequestFor:(id)fp8 style:(int)fp12 roomName:(id)fp16 message:(id)fp20;
- (void)_handleGURLAppleEvent:(id)fp8 reply:(id)fp12;
@end

@interface Fezz (PersistentChatAdditions)
+ (void)resurrectPersistedChats;
+ (void)savePersistedChatsWithData:(BOOL)fp8;
+ (void)cleanPersistedCache;
+ (id)persistedChatInfoWithData:(BOOL)fp8;
@end

@interface Fezz (SelfTestExtensions)
- (id)presentityForIteration:(int)fp8;
- (id)messageForIteration:(int)fp8;
- (id)chatWindowControllerForIteration:(int)fp8;
- (void)verifyLoginAndSendAnIM;
- (void)verifyResponseToIMAndStartAV;
- (void)verifyAVIsRunningAndCloseWindow;
- (void)verifyAddedBuddyAndStartAV;
- (void)verifyVideoIsRunningAndTryAudio;
- (void)startAudio;
- (void)verifyAudioIsRunningAndStartNewIteration;
- (void)loginIfNecessary;
- (void)application:(id)fp8 runTest:(unsigned int)fp12 duration:(double)fp16;
@end

@interface FileDragOutView : NSImageView
{
    FileTransfer *_file;
    NSImage *_fileIcon;
    id <FileDragOutViewDelegate> _delegate;
    struct _NSPoint _clickLoc;
    NSString *_dropPath;
    BOOL _isDup;
}

- (void)setDelegate:(id)fp8;
- (void)_updateImage;
- (void)setFile:(id)fp8;
- (id)file;
- (void)dealloc;
- (void)mouseDown:(id)fp8;
- (void)mouseDragged:(id)fp8;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)fp8;
- (void)pasteboard:(id)fp8 provideDataForType:(id)fp12;
- (id)namesOfPromisedFilesDroppedAtDestination:(id)fp8;
- (void)draggedImage:(id)fp8 endedAt:(struct _NSPoint)fp12 operation:(unsigned int)fp20;

@end

@interface FileNotifier : BannerNotifier
{
    FileTransferRequest *_fileRequest;
    FileTransfer *_file;
}

+ (void)openOnFileTransferRequest:(id)fp8;
- (id)initWithFileTransfer:(id)fp8;
- (id)menuItemFormat;
- (id)bannerView;
- (void)updateLockUI;
- (void)dealloc;
- (void)closeDownShop:(BOOL)fp8;

@end

@interface FileQuarantine : NSObject
{
    NSString *_originalFilePath;
    NSString *_quarantineFolder;
    NSString *_releasedFilePath;
    id _delegate;
}

+ (id)propertiesForQuarantineAtPath:(id)fp8;
- (id)initWithOriginalPath:(id)fp8 delegate:(id)fp12;
- (id)initWithDictionaryRep:(id)fp8;
- (id)dictionaryRep;
- (void)setDelegate:(id)fp8;
- (void)dealloc;
- (id)_generateQuarantineFolderPath;
- (id)quarantineFolder;
- (id)originalFilePath;
- (BOOL)prepareQuarantine;
- (id)quarantineFilePath;
- (id)releasedFilePath;
- (void)_tagFileAtPath:(id)fp8 withProperties:(id)fp12;
- (void)_tagFilesInDirectory:(id)fp8 withProperties:(id)fp12;
- (void)_tagQuarantinedFiles;
- (void)_moveOutOfQuarantineToPath:(id)fp8;
- (void)moveOutOfQuarantineToPath:(id)fp8;
- (void)removeQuarantine;

@end

@interface FileSender : NSObject
{
    NSPanel *_confirmPanel;
    NSTextField *_messageField;
    NSButton *_dontAskAgainBox;
    NSArray *_filePaths;
    Presentity *_receiver;
    NSWindow *_originatingWindow;
    struct _NSPoint _centerPointInWindow;
}

+ (BOOL)isDirectory:(id)fp8;
+ (BOOL)isEmptyDirectory:(id)fp8;
+ (void)runEmptyDirectoryAlert;
+ (void)showAlertFor:(id)fp8 isIMAttachment:(BOOL)fp12 fileCount:(int)fp16 message:(id)fp20 inWindow:(id)fp24;
+ (BOOL)validatePasteboard:(id)fp8 forPresentity:(id)fp12 showAlert:(BOOL)fp16 inWindow:(id)fp20;
+ (void)sendFiles:(id)fp8 toPresentity:(id)fp12 atPosition:(struct _NSPoint)fp16 inWindow:(id)fp24 confirm:(BOOL)fp28;
+ (void)sendFile:(id)fp8 toPresentity:(id)fp12 atPosition:(struct _NSPoint)fp16 inWindow:(id)fp24 confirm:(BOOL)fp28;
+ (BOOL)sendFilesOnPasteboard:(id)fp8 toPresentity:(id)fp12 atPosition:(struct _NSPoint)fp16 inWindow:(id)fp24 confirm:(BOOL)fp28 showAlert:(BOOL)fp32;
+ (void)sendFileToPresentity:(id)fp8 inWindow:(id)fp12;
- (id)initWithFiles:(id)fp8 receiver:(id)fp12 position:(struct _NSPoint)fp16 inWindow:(id)fp24;
- (void)dealloc;
- (void)_sendFile;
- (void)_runConfirmPanel;
- (void)_confirmSend:(BOOL)fp8;
- (void)start:(id)fp8;
- (void)cancel:(id)fp8;
- (void)_runOpenPanel;
- (void)_openPanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (BOOL)panel:(id)fp8 isValidFilename:(id)fp12;

@end

@interface FileTransfer : NSObject <FZSecureObject>
{
    BOOL _isIncoming;
    BOOL _wasSaved;
    BOOL _isTempFile;
    NSDictionary *_lastUpdate;
    NSString *_guid;
    NSString *_filePath;
    NSImage *_cachedIcon;
    FileQuarantine *_quarantine;
    BOOL _shouldOverwrite;
    BOOL _explicitSave;
    BOOL _movingOutOfQuaratine;
}

+ (id)stringFromError:(int)fp8;
- (id)initWithGUID:(id)fp8 isIncoming:(BOOL)fp12;
- (id)initWithDictionaryRep:(id)fp8;
- (id)dictionaryRep;
- (void)dealloc;
- (id)guid;
- (id)_context;
- (BOOL)isIncoming;
- (BOOL)isInline;
- (BOOL)canBeAccepted;
- (BOOL)existsAtPath;
- (unsigned long long)sentBytes;
- (id)_createTempFile;
- (id)kindString;
- (id)displayName;
- (BOOL)checkSavePath:(id)fp8 window:(id)fp12;
- (BOOL)wasSaved;
- (id)account;
- (id)sender;
- (id)message;
- (int)error;
- (id)name;
- (int)state;
- (id)currentFilename;
- (BOOL)isDirectory;
- (unsigned long long)size;
- (id)savePath;
- (unsigned long)hfsType;
- (unsigned long)hfsCreator;
- (unsigned short)hfsFlags;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (void)declineTransfer;
- (void)stopTransfer;
- (void)cancelTransfer;
- (id)filePath;
- (id)_getIcon;
- (id)icon;
- (BOOL)_acceptIncomingFileToPath:(id)fp8;
- (BOOL)saveAs:(id)fp8 explicitlySaved:(BOOL)fp12 overwrite:(BOOL)fp16;
- (id)quarantineFolder;
- (id)responsibleSender;
- (BOOL)fileQuarantine:(id)fp8 shouldUseExistingQuarantineFolder:(id)fp12;
- (void)_addMetaDataToPath:(id)fp8;
- (id)dateStarted;
- (BOOL)attemptsToResume;
- (void)contextEnded;
- (void)contextUpdated:(id)fp8;
- (void)fileQuarantineMoveFinished:(id)fp8;
- (void)acceptQuarantinedFiles;
- (void)rejectQuarantinedFiles;

@end

@interface FileTransfer (Scripting)
- (id)scriptID;
- (id)scriptName;
- (id)scriptDirection;
- (id)scriptService;
- (id)scriptFilePath;
- (id)scriptParticipant;
- (id)scriptTransferSize;
- (id)scriptTransferProgress;
- (id)scriptSecure;
- (id)scriptTransferStatus;
- (id)scriptStarted;
- (void)acceptTransferCommand:(id)fp8;
- (void)declineTransferCommand:(id)fp8;
- (id)objectSpecifier;
@end

@interface FileTransferCenter : NSObject
{
    NSMutableDictionary *_activeTransfers;
    NSMutableArray *_orderedTransfers;
    NSMutableDictionary *_preauthorizedTransfers;
}

+ (id)sharedInstance;
- (void)_setupTransferForContext:(id)fp8;
- (void)_attemptToRemoveObserverForSender:(id)fp8;
- (void)_presentityStatusChanged:(id)fp8;
- (id)transferForGUID:(id)fp8;
- (id)init;
- (void)dealloc;
- (void)sessionAdded:(id)fp8;
- (void)abortTransferContext:(id)fp8;
- (void)acceptTransferContext:(id)fp8 withPath:(id)fp12;
- (void)declineTransferContext:(id)fp8;
- (void)sessionUpdated:(id)fp8;
- (void)sessionRemoved:(id)fp8;
- (void)startMonitoringTransfers;
- (void)stopMonitoringTransfers;
- (BOOL)sendFile:(id)fp8 toPerson:(id)fp12;
- (id)inlineTransferContext:(id)fp8 toPerson:(id)fp12;
- (BOOL)hasActiveFileTransfers;
- (BOOL)transferExistsWithQuarantineFolder:(id)fp8;
- (void)closeFileTransfersForAccount:(id)fp8;
- (void)closeAllFileTransfers;
- (void)preauthorizeFileTransferFrom:(id)fp8 sourceFile:(id)fp12 destinationPath:(id)fp16;
- (id)_preauthorizedPathForTransfer:(id)fp8;

@end

@interface FileTransferCenter (FileTransferManagerAdditions)
- (void)_notifyAdded:(BOOL)fp8 transfers:(id)fp12;
- (void)_insertTransfer:(id)fp8 atIndex:(unsigned int)fp12;
- (BOOL)_removeTransferAtIndex:(unsigned int)fp8 andCancel:(BOOL)fp12;
- (void)_removeAllTransfersAndNotify;
- (void)restoreOrderedTransfers;
- (void)_saveOrderedTransfers:(id)fp8;
- (void)_insertOrderedTransfer:(id)fp8;
- (void)_transferUpdated:(id)fp8;
- (void)_transferContextAdded:(id)fp8;
- (id)orderedTransfers;
- (void)removeTransfers:(id)fp8;
- (BOOL)seenTransferLike:(id)fp8;
- (id)orderedTransferWithGUID:(id)fp8;
@end

@interface FileTransferCenter (Scripting)
- (id)activeTransfers;
- (id)allTransfers;
@end

@interface FileTransferFragment : NSObject <DOMEventListener>
{
    DOMDocumentFragment *_fragment;
    BOOL _mouseDown;
    DOMNode *_statusTextNode;
    int _statusIconAction;
    DOMNode *_statusNode;
    NSString *_statusId;
    DOMNode *_iconNode;
    NSString *_iconId;
    FileTransfer *_file;
    NSString *_filename;
    TranscriptStyleManager *_style;
}

- (id)fragment;
- (id)initWithFileTransfer:(id)fp8 inChat:(id)fp12;
- (void)dealloc;
- (void)handleEvent:(id)fp8;
- (void)_updateFileTransferStatusIcon;
- (void)_fileXferUpdated:(id)fp8;
- (void)_flagsChanged:(id)fp8;

@end

@interface FileTransferFragmentProvider : TranscriptFragmentProvider
{
    NSString *_filename;
}

- (id)role;
- (void)transcriptWillLoad;
- (void)dealloc;
- (id)fragmentForImageAtPath:(id)fp8;
- (id)fragmentForFileTransfer:(id)fp8;

@end

@interface FileTransferManager : NSWindowController
{
    NSButton *_clearButton;
    NSTextField *_countField;
    ViewTable *_table;
    BOOL _securityDialogInProgress;
    NSMutableArray *_securityDialogQueue;
}

+ (void)_savePanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
+ (void)_replaceSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
+ (void)fileTransfer:(id)fp8 saveAs:(id)fp12 attachedToWindow:(id)fp16;
+ (void)fileTransfer:(id)fp8 saveTo:(id)fp12 attachedToWindow:(id)fp16;
+ (void)fileTransfer:(id)fp8 saveTo:(id)fp12 attachedToWindow:(id)fp16 forceReplace:(BOOL)fp20;
+ (void)fileTransfer:(id)fp8 saveTo:(id)fp12 attachedToWindow:(id)fp16 automaticallyRename:(BOOL)fp20;
+ (void)fileTransfer:(id)fp8 saveTo:(id)fp12 attachedToWindow:(id)fp16 forceReplace:(BOOL)fp20 automaticallyRename:(BOOL)fp24;
+ (id)sharedInstance;
- (void)awakeFromNib;
- (void)windowDidLoad;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (BOOL)windowShouldClose:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)dealloc;
- (void)_countChanged;
- (id)_viewForTransferGUID:(id)fp8;
- (void)_addTransfers:(id)fp8;
- (void)_transfersAdded:(id)fp8;
- (void)_transfersRemoved:(id)fp8;
- (id)_transfersMatchingCondition:(int)fp8;
- (void)deleteSelectedRowsInViewTable:(id)fp8;
- (void)showWindow:(id)fp8;
- (void)showTransfer:(id)fp8;
- (void)clearTransfers:(id)fp8;
- (void)selectAll:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;

@end

@interface FileTransferRequest : NSWindowController <FileDragOutViewDelegate>
{
    NSExtendedBox *_box;
    NSView *_bannerContainer;
    AVParticipantView *_bannerView;
    FileDragOutView *_fileIconView;
    NSTextField *_filenameField;
    NSTextField *_descriptionField;
    NSTabView *_buttonTabView;
    NSButton *_notifyAccept;
    NSButton *_notifyReject;
    NSButton *_notifyBlock;
    NSButton *_notifyOK;
    FileNotifier *_notifier;
    FileTransfer *_file;
    int _action;
}

+ (id)fileTransferRequestWithFile:(id)fp8 notifier:(id)fp12;
- (id)_initWithIncomingFile:(id)fp8 notifier:(id)fp12;
- (id)fileTransfer;
- (void)setNotifier:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)dealloc;
- (void)_flagsChanged:(id)fp8;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (void)windowDidLoad;
- (void)_fileXferUpdated:(id)fp8;
- (void)_securityLevelChanged:(id)fp8;
- (void)acceptButtonPressed:(id)fp8;
- (BOOL)fileDragOutView:(id)fp8 shouldDragFile:(id)fp12;
- (void)fileDragOutView:(id)fp8 file:(id)fp12 draggedTo:(id)fp16 isDuplicate:(BOOL)fp20;
- (void)fileDragOutView:(id)fp8 fileDoubleClicked:(id)fp12;
- (void)rejectButtonPressed:(id)fp8;
- (void)blockButtonPressed:(id)fp8;
- (void)contextUpdated:(id)fp8;

@end

@interface ViewTableRow : NSView
{
    NSView *_containerView;
    BOOL _selected;
}

- (void)awakeFromNib;
- (id)initWithNibNamed:(id)fp8 saveNib:(BOOL)fp12;
- (void)dealloc;
- (BOOL)isSelected;
- (void)selectedDidChange;
- (void)windowKeyChanged;
- (void)_setSelected:(BOOL)fp8;
- (void)_setSelected;
- (void)_deselect;
- (void)_setSingleSelection;
- (void)_extendSelection;
- (void)mouseDown:(id)fp8;

@end

@interface FileTransferView : ViewTableRow <FileDragOutViewDelegate>
{
    FileTransfer *_fileTransfer;
    BOOL _canUpdate;
    FileDragOutView *_fileIcon;
    NSButton *_lockButton;
    NSTextField *_fileNameField;
    NSTextField *_statusField;
    NSProgressIndicator *_progressBar;
    NSButton *_stopButton;
    NSButton *_revealButton;
    NSImage *_pressedCancel;
    NSImage *_selectedCancel;
    NSImage *_activeCancel;
}

+ (id)_timeRemainingStringWithProgress:(float)fp8 forTransfer:(id)fp12;
+ (id)statusStringForFileTransfer:(id)fp8;
- (id)initWithFileTransfer:(id)fp8 saveNib:(BOOL)fp12;
- (id)fileTransfer;
- (void)awakeFromNib;
- (void)dealloc;
- (void)_removeProgressBar;
- (id)_statusString;
- (void)_setupLockButton;
- (void)_updateButtons;
- (void)_update:(id)fp8;
- (void)viewDidMoveToWindow;
- (void)_updateTextColor;
- (void)windowKeyChanged;
- (void)selectedDidChange;
- (id)hitTest:(struct _NSPoint)fp8;
- (float)dwToFit;
- (void)showCertificates:(id)fp8;
- (void)acceptTransfer:(id)fp8;
- (void)stopTransfer:(id)fp8;
- (void)revealInFinder:(id)fp8;
- (BOOL)fileDragOutView:(id)fp8 shouldDragFile:(id)fp12;
- (void)fileDragOutView:(id)fp8 file:(id)fp12 draggedTo:(id)fp16 isDuplicate:(BOOL)fp20;
- (void)fileDragOutView:(id)fp8 fileDoubleClicked:(id)fp12;

@end

@interface FindPanelController : NSWindowController
{
    NSTextField *searchTextField;
    NSTextField *statusTextField;
    int _lastFindPasteboardChangeCount;
}

+ (id)sharedController;
- (id)windowNibName;
- (void)updateFindPasteboardFromSearchField;
- (void)_updateSearchFieldFromFindPasteboard;
- (void)windowDidLoad;
- (id)_searchString;
- (id)_searchTarget;
- (BOOL)_doSearchForString:(id)fp8 direction:(BOOL)fp12 caseSensitive:(BOOL)fp16 inTarget:(id)fp20;
- (void)_setStatus:(id)fp8;
- (void)_findWithDirection:(BOOL)fp8 caseSensitive:(BOOL)fp12;
- (BOOL)readyToFind;
- (void)findNext:(id)fp8;
- (void)findPrevious:(id)fp8;
- (void)selectText;

@end

@interface FrameNotifier : NSObject
{
    id _delegate;
    NSArray *_runloopModes;
    NSMutableDictionary *_listenersForFrame;
    NSRecursiveLock *_listenersForFrameLock;
    NSThread *_notificationThread;
}

+ (id)runLoopModes;
- (id)initWithDelegate:(id)fp8;
- (void)dealloc;
- (void)addListener:(id)fp8 forSource:(id)fp12 onThread:(id)fp16;
- (void)removeListener:(id)fp8;
- (void)removeListener:(id)fp8 forSource:(id)fp12;
- (void)_setupThread;
- (void)_notificationThread;
- (void)_callListener:(id)fp8;
- (void)_postFrame:(id)fp8 fromSource:(id)fp12 toListenerWithValue:(id)fp16 onThread:(id)fp20;
- (void)postFrame:(id)fp8 fromSource:(id)fp12;
- (BOOL)hasListeners;
- (BOOL)hasListenersForSource:(id)fp8;

@end

@interface GLObject : NSObject
{
    NSOpenGLContext *_context;
    struct _CGLContextObject *cgl_ctx;
}

- (id)initWithOpenGLContext:(id)fp8;
- (void)dealloc;
- (void)throwOnGLError:(const char *)fp8:(int)fp12;
- (void)throwOnGLError:(id)fp8;

@end

@interface FrameReader : GLObject
{
    unsigned int _rowBytes;
    unsigned int _pixelsWide;
    unsigned int _pixelsHigh;
    unsigned int _glPixelBufferId;
    void *_frameBuffer;
    void *_flipBuffer;
    GLFBO *_fbo;
    GLSLProgram *_shader;
}

+ (unsigned int)nativePixelFormat;
+ (unsigned int)nativePixelType;
+ (unsigned int)nativePixelTypeFBO;
+ (BOOL)_isIntel950Graphics:(id)fp8;
- (id)initWithOpenGLContext:(id)fp8 pixelsWide:(unsigned int)fp12 pixelsHigh:(unsigned int)fp16;
- (void)dealloc;
- (void)_FBO_readFrameIntoBuffer:(void *)fp8 wantYuv:(BOOL)fp12 rowBytes:(int)fp16;
- (void)_glReadPixels_readFrameIntoBuffer:(void *)fp8 wantYuv:(BOOL)fp12 rowBytes:(int)fp16;
- (void)_PBuffer_readFrameIntoBuffer:(void *)fp8 wantYuv:(BOOL)fp12 rowBytes:(int)fp16;
- (void)_readFrameIntoBuffer:(void *)fp8 wantYuv:(BOOL)fp12 rowBytes:(int)fp16 flipBuffer:(BOOL)fp20;
- (id)bitmap;
- (void)copyFrameTo:(struct __CVBuffer *)fp8 flipBuffer:(BOOL)fp12;
- (void)copyFrameTo:(struct __CVBuffer *)fp8;
- (struct _NSSize)size;

@end

@interface FrameResizer : NSObject
{
    NSOpenGLContext *_context;
    FrameReader *_frameReader;
    struct __CVOpenGLBufferPool *_bufferPool;
    struct __CVBuffer *_buffer;
}

+ (BOOL)resizeBufferPool:(struct __CVOpenGLBufferPool **)fp8 width:(int)fp12 height:(int)fp16;
- (id)init;
- (void)dealloc;
- (void)resizeTexture:(id)fp8 intoBuffer:(struct __CVBuffer *)fp12 fromRect:(struct _NSRect)fp16 sizeToFitCIF:(BOOL)fp32;

@end

@interface FramerateTracker : NSObject
{
    unsigned int _sampleCount;
    double *_samples;
    unsigned int _curSample;
    double _sampleSum;
    double _curTime;
    double _rounding;
}

- (id)initWithSampleCount:(unsigned int)fp8 framerate:(double)fp12 rounding:(double)fp20;
- (double)nextSample;
- (void)dealloc;

@end

@interface FullScreenQCTransitionWindow : NSWindow
{
    QCView *_qcView;
    double _transitionTime;
    id _completionDelegate;
    SEL _completionSelector;
}

+ (struct CGImage *)imageOfScreenWithoutWindows:(id)fp8;
+ (void)performTransitionWithScreen:(id)fp8 transitionPath:(id)fp12 image1:(id)fp16 fromRect:(struct _NSRect)fp20 toRect:(struct _NSRect)fp36 image2:(id)fp52 fromRect:(struct _NSRect)fp56 toRect:(struct _NSRect)fp72 bgColor:(id)fp88 completionDelegate:(id)fp92 completionSelector:(SEL)fp96 transitionTime:(double)fp100;
- (id)_initWithScreen:(id)fp8 transitionPath:(id)fp12 image1:(id)fp16 fromRect:(struct _NSRect)fp20 toRect:(struct _NSRect)fp36 image2:(id)fp52 fromRect:(struct _NSRect)fp56 toRect:(struct _NSRect)fp72 bgColor:(id)fp88 completionDelegate:(id)fp92 completionSelector:(SEL)fp96 transitionTime:(double)fp100;
- (void)_transitionDidComplete;
- (void)_startTransition;
- (void)dealloc;

@end

@interface FullScreenWindow : NSWindow
{
    NSView *_placeholderView;
}

- (id)initWithScreen:(id)fp8 backing:(unsigned int)fp12;
- (BOOL)canBecomeKeyWindow;
- (BOOL)canBecomeMainWindow;
- (void)keyDown:(id)fp8;
- (void)acquireView:(id)fp8;
- (void)restoreView;

@end

@interface GLFBO : GLObject
{
    unsigned int _textureTarget;
    unsigned int _textureName;
    unsigned int _fboName;
    int _width;
    int _height;
}

+ (BOOL)fboIsSupportedOnContext:(id)fp8;
- (id)initWithTarget:(unsigned int)fp8 width:(int)fp12 height:(int)fp16 internalFormat:(unsigned int)fp20 format:(unsigned int)fp24 type:(unsigned int)fp28 context:(id)fp32;
- (void)dealloc;
- (void)bind;
- (void)unbind;
- (void)readBack:(int)fp8:(int)fp12:(int)fp16:(int)fp20:(unsigned int)fp24:(unsigned int)fp28:(void *)fp32;
- (void)readBack:(int)fp8:(int)fp12:(int)fp16:(int)fp20:(unsigned int)fp24:(unsigned int)fp28:(void *)fp32:(unsigned int)fp36;
- (unsigned int)name;
- (unsigned int)textureName;
- (void)setAsSource;
- (void)setAsDestination;

@end

@interface GLSLProgram : GLObject
{
    void *_prog;
    void *_frag;
    void *_vert;
}

+ (id)rgbToYCbCr601Shader:(id)fp8;
- (id)initWithVertexShader:(const char *)fp8 fragmentShader:(const char *)fp12 context:(id)fp16;
- (void)dealloc;
- (void)useProgram;
- (void)unuseProgram;
- (int)uniformLocation:(id)fp8;

@end

@interface GLTexture : GLObject
{
    unsigned int _target;
    unsigned int _name;
    unsigned int _wide;
    unsigned int _high;
}

+ (id)bgraTextureWithOpenGLContext:(id)fp8 pixelsWide:(unsigned int)fp12 pixelsHigh:(unsigned int)fp16;
+ (id)yuvTextureWithOpenGLContext:(id)fp8 pixelsWide:(unsigned int)fp12 pixelsHigh:(unsigned int)fp16;
- (id)initWithOpenGLContext:(id)fp8 target:(unsigned int)fp12 pixelsWide:(unsigned int)fp16 pixelsHigh:(unsigned int)fp20 internalFormat:(unsigned int)fp24 format:(unsigned int)fp28 type:(unsigned int)fp32 pixels:(const void *)fp36;
- (void)dealloc;
- (void)bind;
- (void)unbind;
- (unsigned int)pixelsHigh;
- (unsigned int)pixelsWide;
- (unsigned int)name;
- (unsigned int)target;

@end

@interface GatherValidCertificates : BaseThreadedObject
{
    NSString *_screenName;
    unsigned short _usage;
    BOOL _forMe;
    NSArray *_certs;
}

+ (id)gatherCertsForScreenName:(id)fp8 usage:(unsigned short)fp12 forMyUse:(BOOL)fp16;
- (id)initWithScreenName:(id)fp8 usage:(unsigned short)fp12 forMyUse:(BOOL)fp16;
- (void)dealloc;
- (void)_workerThread;
- (void)_workerThreadFinished;
- (id)certificates;

@end

@interface NullNode : NSObject <Node>
{
}

+ (void)initialize;
+ (id)createNullNode;
- (id)createChild:(id)fp8;
- (void)addText:(id)fp8;
- (void)childFinished:(id)fp8;
- (void)finished;

@end

@interface GenericNode : NullNode
{
    NSString *_name;
    NSDictionary *_attrs;
    NSMutableArray *_elements;
    NSMutableString *_curText;
}

- (id)initWithHeader:(id)fp8;
- (void)dealloc;
- (void)_finishText;
- (id)createChild:(id)fp8;
- (void)addText:(id)fp8;
- (void)childFinished:(id)fp8;
- (void)finished;
- (id)name;
- (id)attributes;
- (id)attributeNamed:(id)fp8;
- (id)elementsWithNamespace:(id)fp8 named:(id)fp12;
- (id)firstElementWithNamespace:(id)fp8 named:(id)fp12;
- (id)elementsNamed:(id)fp8;
- (id)firstElementNamed:(id)fp8;
- (id)firstElementWithNamespace:(id)fp8 tag:(id)fp12;
- (id)firstElementWithNamespace:(id)fp8;
- (id)elements;
- (id)text;
- (id)trimmedStringValue;
- (int)intValue;
- (unsigned int)unsignedIntValue;
- (id)dataWithHexString;
- (id)description;

@end

@interface GoToChat : NSWindowController
{
    NSButton *_addButton;
    NSTableView *_bookmarkTable;
    ExtendedComboBox *_chatNameField;
    NSView *_sizeView;
    NSTextField *_errorField;
    NSButton *_goButton;
    NSButton *_removeButton;
    ServicePopUp *_servicePopUp;
}

+ (BOOL)canGoToChat;
+ (void)showPanel;
- (void)windowDidLoad;
- (void)dealloc;
- (void)_pruneDeadAccounts;
- (void)_updateUI;
- (void)_updateRecentKey;
- (void)_updateServicePopUp;
- (void)selectedAccountStatusChanged:(id)fp8;
- (void)selectedServiceChanged:(id)fp8;
- (void)comboBoxWillDismiss:(id)fp8;
- (void)controlTextDidChange:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)_loadBookmarks;
- (void)_saveBookmarks;
- (void)_removeBookmarkAtIndex:(int)fp8;
- (void)_addBookmarkForRoom:(id)fp8 account:(id)fp12;
- (void)tableViewSelectionDidChange:(id)fp8;
- (void)tableView:(id)fp8 setObjectValue:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (void)tableView:(id)fp8 willDisplayCell:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)add:(id)fp8;
- (void)remove:(id)fp8;
- (void)go:(id)fp8;
- (void)cancel:(id)fp8;
- (void)showWindow:(id)fp8;

@end

@interface GoToChatTableCell : NSCell
{
}

- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface GoToChatTableCell (AccountPreferencesTableCellAccessibility)
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityValueAttribute;
@end

@interface GradientView : NSView
{
    NSColor *_color1;
    NSColor *_color2;
    NSImage *_gradientImage;
    struct _NSRect _imageRect;
    BOOL _isOpaque;
    BOOL _dropHighlight;
}

- (void)dealloc;
- (void)drawRect:(struct _NSRect)fp8;
- (BOOL)isOpaque;
- (int)_gradientSteps;
- (void)_regenerateGradientImage;
- (void)setColor1:(id)fp8;
- (void)setColor2:(id)fp8;
- (void)setColor1:(id)fp8 color2:(id)fp12;
- (id)color1;
- (id)color2;
- (void)setDropHighlight:(BOOL)fp8;
- (BOOL)dropHighlight;

@end

@interface GroupchatMessage : InstantMessage <NSCoding, FZSecureObject>
{
    Presentity *_actualSender;
}

- (id)initWithSender:(id)fp8 time:(id)fp12 text:(id)fp16 originalText:(id)fp20 incomingFile:(id)fp24 flags:(int)fp28 error:(id)fp32 guid:(id)fp36;
- (void)dealloc;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;
- (BOOL)hasAnEquivalentMessageIn:(id)fp8;
- (id)actualSender;
- (id)senderName;

@end

@interface GroupsEditorController : NSObject
{
    PeopleListController *_peopleListController;
    NSMutableArray *_deletedGroups;
    NSMutableArray *_oldGroups;
    NSMutableArray *_newGroups;
    NSString *_renamingGroup;
    NSString *_deletingGroup;
    BOOL _allowsCustomSort;
    NSWindow *_renameGroupSheet;
    NSTextField *_renameGroupField;
    NSButton *_renameGroupAcceptButton;
    NSWindow *_addGroupSheet;
    NSTextField *_renameGroupLabel;
    NSTextField *_addGroupField;
    NSButton *_addGroupButton;
    NSWindow *_editGroupsSheet;
    NSTableView *_editGroupsTable;
    NSButton *_newGroupButton;
    NSButton *_deleteGroupButton;
    NSButton *_renameGroupButton;
}

+ (void)addGroupForPeopleListController:(id)fp8;
+ (void)renameGroup:(id)fp8 forPeopleListController:(id)fp12;
+ (void)deleteGroup:(id)fp8 forPeopleListController:(id)fp12;
+ (void)editGroupsForPeopleListController:(id)fp8;
- (id)initWithPeopleListController:(id)fp8 editingGroups:(BOOL)fp12 renamingGroup:(id)fp16 deletingGroup:(id)fp20;
- (void)awakeFromNib;
- (void)_unattachFromTable;
- (void)_sheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_beginSheet:(int)fp8;
- (void)endSheet:(id)fp8;
- (void)dealloc;
- (void)_doAddGroup;
- (id)_array:(id)fp8 equivalentString:(id)fp12;
- (void)_doRenameGroup;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)tableView:(id)fp8 setObjectValue:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (BOOL)_nameExists:(id)fp8 atRowOtherThan:(int)fp12;
- (BOOL)control:(id)fp8 textShouldEndEditing:(id)fp12;
- (BOOL)tableView:(id)fp8 writeRowsWithIndexes:(id)fp12 toPasteboard:(id)fp16;
- (unsigned int)tableView:(id)fp8 validateDrop:(id)fp12 proposedRow:(int)fp16 proposedDropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 acceptDrop:(id)fp12 row:(int)fp16 dropOperation:(unsigned int)fp20;
- (void)_updateButtons;
- (id)_newGroupName;
- (void)_editItemAtIndex:(int)fp8;
- (void)newGroup:(id)fp8;
- (void)deleteGroup:(id)fp8;
- (void)renameGroup:(id)fp8;
- (void)_deleteGroupsSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (BOOL)_confirmDeletionOfGroups;
- (void)deleteGroups:(id)fp8 andRenameGroupsFrom:(id)fp12 to:(id)fp16;
- (void)_doEditGroups;

@end

@interface HiddenButton : AccessibilityIgnoredButton
{
}

- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;

@end

@interface HotKeyInfo : NSObject
{
    struct OpaqueEventHotKeyRef *_carbonHotKey;
    id <HotKeyHandler> _handler;
}

- (id)initWithCode:(int)fp8 modifiers:(int)fp12 signature:(unsigned long)fp16 handler:(id)fp20;
- (void)dealloc;
- (id)handler;

@end

/*@interface IKPictureTakerRecentPicture (FezAdditions)
+ (id)mostRecentPicture;
@end*/

@interface IMServiceErrorDialog : NSObject
{
    NSPanel *_errorPanel;
    NSTextField *_errorTimestampField;
    NSTextField *_errorTitleField;
    NSTextField *_errorMessageField;
    NSImageView *_errorIcon;
    int _requestID;
    AbstractAccount *_account;
    int _type;
}

+ (void)closeErrorDialogsForAccount:(id)fp8 ofType:(int)fp12;
+ (id)errorDialogsForAccount:(id)fp8 ofType:(int)fp12;
+ (id)allErrorDialogsOfType:(int)fp8;
+ (void)closeErrorDialogsForAccount:(id)fp8;
+ (id)errorDialogsForAccount:(id)fp8;
+ (id)allErrorDialogs;
+ (void)displayAlert:(id)fp8 title:(id)fp12 windowTitle:(id)fp16 forAccount:(id)fp20 ofType:(int)fp24;
+ (void)displayAlert:(id)fp8 forAccount:(id)fp12 ofType:(int)fp16;
+ (void)displayDisconnectAlert:(id)fp8 wasConnected:(BOOL)fp12 forAccount:(id)fp16;
+ (void)displayErrorMessage:(id)fp8 forAccount:(id)fp12;
+ (void)displayError:(id)fp8 forAccount:(id)fp12 ofType:(int)fp16;
+ (void)displayDaemonDisconnectedDialog;
- (int)type;
- (id)associatedAccount;
- (void)showPanel:(id)fp8;
- (void)closeErrorPanel:(id)fp8;
- (void)_resizePanelForField:(id)fp8 withOtherField:(id)fp12 havingYMargin:(unsigned int)fp16;
- (void)dealloc;
- (id)initWithTitle:(id)fp8 message:(id)fp12 windowTitle:(id)fp16 date:(id)fp20 image:(id)fp24 associatedAccount:(id)fp28 errorType:(int)fp32 closeOnDaemonReconnect:(BOOL)fp36;

@end

@interface IndexChanged : QCPlugIn
{
    unsigned int _previousIndex;
}

+ (int)executionMode;
+ (int)timeMode;
+ (id)attributes;
- (id)init;
- (BOOL)execute:(id)fp8 atTime:(double)fp12 withArguments:(id)fp20;

@end

@interface InputArea : NSView
{
    NSView *_minibar;
    AnimatingTabView *_tabView;
    NSButton *_vcInviteButton;
    NSButton *_vcAcceptFromTextButton;
    NSButton *_vcAcceptVCOnlyButton;
    float _minHeight;
    int _mode;
}

- (void)awakeFromNib;
- (void)_setTabViewStretchy:(BOOL)fp8;
- (float)setMode:(int)fp8;
- (int)mode;
- (float)minHeight;
- (id)tabView;
- (void)tabView:(id)fp8 willSwitchFromTab:(int)fp12 toTab:(int)fp16 effect:(int *)fp20 direction:(int *)fp24;
- (void)tabViewTransitionWillBegin:(id)fp8;
- (void)tabViewTransitionDidFinish:(id)fp8;

@end

@interface InstantMessage (GroupchatAdditions)
- (id)groupchatMessage;
- (BOOL)isGroupchatMessage;
@end

@interface InstantMessage (MessageAddressingAdditions)
- (void)checkMessageAddressingForChat:(id)fp8;
@end

@interface InstantPopUpSegementedControlCell : NSSegmentedCell
{
    int _segmentToToggle;
}

- (void)awakeFromNib;
- (void)setSegmentToAllowToggle:(int)fp8;
- (id)_segmentsDeselectedBySegment:(int)fp8;
- (double)_menuDelayTimeForSegment:(int)fp8;
- (int)interiorBackgroundStyleForSegment:(int)fp8;

@end

@interface InviteCommand : NSScriptCommand
{
}

- (id)performDefaultImplementation;

@end

@interface JabberAccount : AbstractAccount
{
}

+ (int)defaultPort;
+ (int)defaultSSLPort;
+ (BOOL)supportsMultipleConnections;
+ (id)defaultBuddylistDescription;
+ (BOOL)isValidAccount:(id)fp8;
+ (BOOL)nameAppearsToBeGmailAccount:(id)fp8;
+ (id)service;
- (BOOL)canActivate;
- (BOOL)_validLogin;
- (BOOL)_validCustomPort;
- (BOOL)_validCustomServer;
- (BOOL)isManaged;
- (int)invalidSettings;
- (BOOL)useMachineName;
- (void)setUseMachineName:(BOOL)fp8;
- (BOOL)allowClearText;
- (void)setAllowClearText:(BOOL)fp8;
- (BOOL)useSSL;
- (void)setUseSSL:(BOOL)fp8;
- (int)priority;
- (void)setPriority:(int)fp8;
- (void)setUseKerberos5:(BOOL)fp8;
- (BOOL)useKerberos5;
- (BOOL)autoDiscoverHostAndPort;
- (void)setAutoDiscoverHostAndPort:(BOOL)fp8;
- (id)jidAndResource;
- (id)resource;
- (void)setResource:(id)fp8;
- (int)port;
- (void)setPort:(int)fp8;
- (BOOL)hasCustomServer;
- (id)server;
- (void)setServer:(id)fp8;
- (void)setLogin:(id)fp8;
- (id)description;
- (id)chatIDForRoomName:(id)fp8;
- (struct _FZChatRoomValidity)validityOfChatRoomName:(id)fp8;
- (BOOL)appearsToBeGmailAccount;
- (void)nowLoggedOut;

@end

@interface JabberAuthRequest : NSWindowController
{
    Notifier *_notifier;
    Presentity *_presentity;
    NSExtendedBox *_box;
    NSView *_bannerContainer;
    AVParticipantView *_bannerView;
}

+ (id)jabberAuthNotifierWithPresentity:(id)fp8 notifier:(id)fp12;
- (id)_initWithPresentity:(id)fp8 notifier:(id)fp12;
- (void)awakeFromNib;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (void)windowDidLoad;
- (void)dealloc;
- (void)acceptButtonPressed:(id)fp8;
- (void)rejectButtonPressed:(id)fp8;
- (void)presentityInfoUpdated:(id)fp8;
- (id)presentity;

@end

@interface JabberXHTMLGenerator : XHTMLGenerator
{
}

+ (id)_generatorString;
- (void)_pushHTMLTag;
- (void)_pushBodyTagWithForegroundColor:(id)fp8 backgroundColor:(id)fp12 isRTL:(BOOL)fp16;
- (void)_generateTagsWithBold:(id)fp8 italic:(id)fp12 link:(id)fp16 font:(id)fp20 color:(id)fp24 bgColor:(id)fp28 underline:(id)fp32 myName:(id)fp36;

@end

@interface KeyWindow : NSWindow
{
}

- (BOOL)canBecomeKeyWindow;

@end

@interface KeychainPasswordFetcher : BaseThreadedObject
{
    NSString *_service;
    NSString *_username;
    NSString *_password;
}

- (id)initWithUsername:(id)fp8 service:(id)fp12;
- (void)dealloc;
- (void)_workerThread;
- (void)_workerThreadFinished;

@end

@interface KeychainProxySettingsFetcher : BaseThreadedObject
{
    NSString *_host;
    NSString *_account;
    NSString *_password;
    int _port;
    int _protocol;
}

- (void)dealloc;
- (void)_workerThread;
- (void)_workerThreadFinished;

@end

@interface LinkSheetController : NSObject
{
    NSTextField *_linkTextField;
    NSButton *_okButton;
}

- (void)controlTextDidChange:(id)fp8;

@end

@interface ListenerSet : NSObject
{
    id _lastFrame;
    NSMutableSet *_listeners;
    NSMutableDictionary *_threadForListener;
    NSMutableDictionary *_countForListener;
    NSMutableDictionary *_notificationAndRemovalLockForListener;
}

+ (id)listenerSet;
- (id)init;
- (id)description;
- (void)dealloc;
- (id)notificationAndRemovalLockForListener;
- (id)countForListener;
- (id)threadForListener;
- (id)listeners;
- (id)lastFrame;
- (void)setLastFrame:(id)fp8;

@end

@interface LockButton : NSButton
{
    Animator *_animator;
    BOOL _collapsed;
    BOOL _dimmed;
}

+ (Class)cellClass;
- (id)init;
- (void)dealloc;
- (struct _NSSize)minSize;
- (void)setFadeTitle:(BOOL)fp8;
- (void)setIsWhiteLock:(BOOL)fp8;
- (BOOL)isWhiteLock;
- (void)setDimmed:(BOOL)fp8;
- (BOOL)dimmed;
- (BOOL)isThrobbing;
- (void)setThrob:(BOOL)fp8;
- (void)setLockState:(int)fp8;
- (int)lockState;
- (void)animator:(id)fp8 doStep:(float)fp12 lastStep:(BOOL)fp16;
- (void)setCollapsed:(BOOL)fp8;
- (BOOL)collapsed;
- (void)mouseDown:(id)fp8;
- (void)frameChanged:(id)fp8;
- (BOOL)accessibilityIsIgnored;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityAttributeValue:(id)fp8;
- (BOOL)isFlipped;
- (BOOL)isOpaque;
- (BOOL)mouseDownCanMoveWindow;
- (BOOL)acceptsFirstMouse:(id)fp8;
- (id)menuForEvent:(id)fp8;

@end

@interface LockButtonCell : NSButtonCell
{
    NSImage *_blackLock;
    NSImage *_redLock;
    float _throbPhase;
    int _lockState;
    BOOL _fadeTitle;
    BOOL _isWhiteLock;
    NSTextFieldCell *_titleCell;
    NSImage *_cacheImage;
    NSButtonCell *_lockCell;
}

- (id)init;
- (void)dealloc;
- (void)setIsWhiteLock:(BOOL)fp8;
- (BOOL)isWhiteLock;
- (struct _NSSize)minCellSize;
- (struct _NSSize)cellSize;
- (BOOL)_isMouseInside:(id)fp8;
- (void)_drawTitleWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (struct _NSRect)imageRectForBounds:(struct _NSRect)fp8;
- (struct _NSRect)titleRectForBounds:(struct _NSRect)fp8;
- (void)setFadeTitle:(BOOL)fp8;
- (void)setThrobPhase:(float)fp8;
- (void)setLockState:(int)fp8;
- (int)lockState;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (BOOL)accessibilityIsIgnored;

@end

@interface Presentity : DirectlyObservableObject <PresentityProtocol, NSCopying, NSCoding, ABImageClient>
{
    NSString *_guid;
    AbstractAccount *_account;
    NSString *_id;
    unsigned int _locationIndex;
    NSDictionary *_otherServiceIDs;
    unsigned long long _capabilities;
    BOOL _isBuddy;
    BuddyPicture *_customPicture;
    NSDate *_idleSince;
    BOOL _willUpdateIdleTime;
    NSDate *_feedUpdatedDate;
    NSDictionary *_extraProps;
    NSDictionary *_certs;
    NSSet *_groups;
    BOOL _dirty;
    int _priority;
    int _pictureLoadTag;
    unsigned int _subscriptionStatus;
    ABPerson *_abPerson;
    NSString *_abPersonUniqueID;
    NSMutableSet *_uniqueNameRelated;
    NSString *_abFirstName;
    NSString *_abLastName;
    NSString *_abFullName;
    NSString *_abNickname;
    NSArray *_abEmails;
    NSString *_firstName;
    NSString *_lastName;
    NSString *_nickname;
    NSArray *_emails;
    NSString *_canonicalFormOfID;
    NSString *_IDWithoutLocation;
    NSString *_IDWithTrimmedServer;
    NSString *_uniqueName;
    BuddyPicture *_picture;
    BOOL _isMobile;
    int _isChatHandle;
    Presentity *_mappedChatID;
    unsigned int _status;
    NSString *_statusMsg;
    NSDate *_whenWentOffline;
    NSDate *_whenStatusChanged;
    unsigned int _prevStatus;
    NSString *_prevStatusMsg;
    NSMutableSet *_notificationNameQueue;
    BOOL _blockNotifications;
    BOOL _hasTemporaryWatch;
    NSURL *_statusMessageURL;
    NSURL *_statusURL;
    NSColor *_balloonColor;
    NSColor *_lastCustomBackgroundColor;
    NSColor *_lastCustomFontColor;
    unsigned int _sortOrder;
    unsigned int _checkedMappedChatID:1;
    unsigned int _customPictureChecked:1;
    int _notificationQueueCount;
}

+ (void)setNotificationsEnabled:(BOOL)fp8;
+ (BOOL)notificationsEnabled;
+ (void)_loadStatusImages;
+ (id)invisibleImageName;
+ (id)invisibleStatusImage;
+ (id)etchedInvisibleStatusImage;
+ (id)imageForStatus:(unsigned int)fp8;
+ (id)etchedImageForStatus:(unsigned int)fp8;
+ (id)nameOfStatus:(unsigned int)fp8;
+ (BOOL)usesAlternateStatusImages;
+ (void)setUsesAlternateStatusImages:(BOOL)fp8;
+ (id)anonymousPicture;
+ (id)genericPicture;
+ (id)presentitiesForABPerson:(id)fp8;
+ (id)filterPresentitiesForBestAccountSiblings:(id)fp8;
+ (id)filterPresentitiesForAccountSiblings:(id)fp8 onAccount:(id)fp12;
+ (id)bestPresentityInArray:(id)fp8;
+ (void)resetAllUniqueNames;
- (id)initWithStatus:(unsigned int)fp8 message:(id)fp12;
- (id)retain;
- (id)autorelease;
- (oneway void)release;
- (id)init;
- (id)guid;
- (id)_bestGuessMappedIDForJabberChatID:(id)fp8;
- (id)_mappedChatID;
- (id)mappedPresentity;
- (void)setPersonStatus:(unsigned int)fp8;
- (void)_postNotificationName:(id)fp8 userInfo:(id)fp12;
- (void)_postNotificationName:(id)fp8;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (id)uniqueName;
- (void)setUniqueName:(id)fp8;
- (id)nameAndEmail;
- (void)setBalloonColor:(id)fp8;
- (id)lastCustomBackgroundColor;
- (void)setLastCustomBackgroundColor:(id)fp8;
- (id)lastCustomFontColor;
- (void)setLastCustomFontColor:(id)fp8;
- (id)currentFontColor;
- (id)currentBackgroundColor;
- (BOOL)hasConferencing;
- (BOOL)hasVideo;
- (BOOL)hasMultiwayVideo;
- (BOOL)hasAudio;
- (BOOL)hasMultiwayAudio;
- (BOOL)hasCapability:(unsigned long long)fp8;
- (unsigned int)status;
- (unsigned int)previousStatus;
- (id)offlineString;
- (id)idleString;
- (id)statusMessage;
- (id)previousStatusMessage;
- (void)_clearStatusMessageURLCache;
- (void)_scheduleIdleTimeUpdate;
- (void)_updateIdleTime;
- (void)_updateIdleTimer;
- (void)_setStatus:(unsigned int)fp8 message:(id)fp12;
- (double)timeSinceWentOffline;
- (double)timeSinceStatusChanged;
- (id)customPicture;
- (BOOL)_customPictureChecked;
- (void)_forgetCustomPicture;
- (id)anonymousPicture;
- (id)image;
- (BOOL)hasPicture;
- (void)_setPicture:(id)fp8;
- (void)setPictureFromImage:(id)fp8;
- (void)drawNameIn:(struct _NSRect)fp8 flipped:(BOOL)fp24;
- (id)smallStatusIcon;
- (id)_nameForComparisonPreferFirst:(BOOL)fp8;
- (int)compareFirstNames:(id)fp8;
- (int)compareLastNames:(id)fp8;
- (int)compareStatus:(id)fp8;
- (id)initWithAccount:(id)fp8 ID:(id)fp12;
- (BOOL)isSystemUser;
- (BOOL)hasOtherSiblings;
- (id)accountSiblingsArray;
- (id)bestAccountSibling;
- (id)siblings;
- (BOOL)isAccountSiblingOf:(id)fp8;
- (BOOL)isSiblingOf:(id)fp8;
- (id)bestPresentityForAccount:(id)fp8 onService:(id)fp12 inGroup:(id)fp16 otherThan:(id)fp20;
- (id)bestSiblingInGroup:(id)fp8 otherThan:(id)fp12;
- (id)bestSiblingInGroup:(id)fp8;
- (id)bestSibling;
- (void)clearABPerson;
- (BOOL)resetABPerson;
- (id)_abPersonCreateIfNeeded;
- (id)abPersonUniqueID;
- (id)abPerson;
- (void)_resetUniqueNameByNotifyingOthers:(BOOL)fp8;
- (void)_resetUniqueName;
- (id)nickname;
- (BOOL)areABPropertiesRecent;
- (void)_resetABProperties;
- (void)setABPerson:(id)fp8;
- (void)dealloc;
- (id)initWithCoder:(id)fp8;
- (void)encodeWithCoder:(id)fp8;
- (BOOL)isMyLogin;
- (BOOL)justLoggedIn;
- (id)description;
- (BOOL)watchingPresentity;
- (void)setHasTemporaryWatch:(BOOL)fp8;
- (BOOL)isBuddy;
- (id)presentities;
- (id)bestPresentity;
- (id)bestPresentityForService:(id)fp8;
- (id)bestPresentityForAccount:(id)fp8;
- (BOOL)hasOfflinePresentities;
- (void)propertiesChanged:(id)fp8;
- (BOOL)isgMe;
- (id)account;
- (id)service;
- (BOOL)_hasBaseName;
- (BOOL)_hasABName;
- (BOOL)hasName;
- (BOOL)hasServer;
- (BOOL)hasLocation;
- (id)server;
- (id)_IDWithoutServer;
- (id)_IDWithTrimmedServer;
- (void)setPriority:(int)fp8;
- (int)priority;
- (id)_nameUsingUnique:(BOOL)fp8;
- (id)name;
- (id)fullName;
- (id)_displayID;
- (id)firstName;
- (id)lastName;
- (void)_setABPersonFirstName:(id)fp8 lastName:(id)fp12;
- (void)_setBaseFirstName:(id)fp8 lastName:(id)fp12;
- (void)setNickname:(id)fp8 andUpdateABPerson:(BOOL)fp12;
- (void)setFirstName:(id)fp8 lastName:(id)fp12 andUpdateABPerson:(BOOL)fp16;
- (void)setEmail:(id)fp8 andUpdateABPerson:(BOOL)fp12;
- (id)email;
- (void)setEmails:(id)fp8 andUpdateABPerson:(BOOL)fp12;
- (id)emails;
- (void)setIsChatHandle;
- (BOOL)isAnonymous;
- (BOOL)canBeAddedToBuddyList;
- (id)canonicalFormOfID;
- (id)ID;
- (id)nameAndID;
- (void)setOtherServiceIDs:(id)fp8;
- (id)otherServiceIDs;
- (id)presentityForOtherAccount:(id)fp8;
- (id)mobileSiblings;
- (BOOL)matchesPresentity:(id)fp8;
- (BOOL)isBetterThanPresentity:(id)fp8;
- (int)compareIDs:(id)fp8;
- (id)groups;
- (id)balloonColor;
- (id)extraProperties;
- (void)requestValueOfProperty:(id)fp8;
- (void)setValue:(id)fp8 ofExtraProperty:(id)fp12;
- (void)_setExtraProperties:(id)fp8;
- (void)setStatusURLFromString:(id)fp8;
- (void)setIsMobile:(BOOL)fp8;
- (BOOL)isMobile;
- (id)mobileDeviceName;
- (int)_trustResultForKey:(id)fp8;
- (void)setCertificates:(id)fp8;
- (id)signingCertificate;
- (int)signingTrustResult;
- (id)encryptionCertificate;
- (int)encryptionTrustResult;
- (int)certificateStatus;
- (BOOL)hasValidCertificates;
- (int)_individualSecurityLevel;
- (BOOL)canBeSecure;
- (BOOL)couldBeSecure;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
- (void)disableCertificates;
- (id)location;
- (id)IDWithoutLocation;
- (id)presentityWithoutLocation;
- (id)existingPresentityWithoutLocation;
- (id)dependentPresentities;
- (BOOL)isDependentOnPresentity:(id)fp8;
- (unsigned long long)capabilities;
- (void)setCapabilities:(unsigned long long)fp8;
- (unsigned int)subscriptionStatus;
- (void)_updateStatusBasedOnSubscription;
- (void)setSubscriptionStatus:(unsigned int)fp8;
- (void)statusChanged:(unsigned int)fp8 message:(id)fp12;
- (void)statusMessageChanged:(id)fp8;
- (void)statusChanged:(unsigned int)fp8;
- (void)requestStatusMessage;
- (id)nameOfStatus;
- (double)idleTime;
- (void)setIdleSince:(id)fp8;
- (id)feedUpdatedDate;
- (void)setFeedUpdatedDate:(id)fp8;
- (id)picture;
- (id)pictureKey;
- (id)genericPicture;
- (void)setCustomPictureData:(id)fp8 key:(id)fp12;
- (void)setCustomPictureData:(id)fp8;
- (void)consumeImageData:(id)fp8 forTag:(int)fp12;
- (id)_createCustomPicture;
- (void)setPicture:(id)fp8;
- (BOOL)blockingPresentityPictures;
- (void)setBlockingPresentityPictures:(BOOL)fp8;
- (id)customPictureRegardlessOfBlocking;
- (id)statusURL;
- (id)statusMessageAsURL;
- (BOOL)_isMyIDInList:(id)fp8;
- (BOOL)isVisiblyBlocked;
- (BOOL)isBlocked;
- (void)setBlocked:(BOOL)fp8;
- (unsigned int)sortOrderInGroup:(id)fp8;
- (id)accountTypeName;

@end

@interface Me : Presentity <ABImageClient>
{
    NSMutableArray *_presentities;
    NSMutableArray *_allLoginPresentities;
    NSMutableArray *_meLoginPresentities;
}

+ (id)fallbackUserName;
+ (id)me;
+ (id)presentityForService:(id)fp8;
- (id)init;
- (void)dealloc;
- (id)_presentitiesWithIDs:(id)fp8 onAccount:(id)fp12;
- (void)rebuildPresentities;
- (void)resetABPerson;
- (void)_setABPerson:(id)fp8;
- (id)abPerson;
- (BOOL)addLoginPresentity:(id)fp8;
- (BOOL)removeLoginPresentity:(id)fp8;
- (id)loginPresentities;
- (BOOL)addPresentity:(id)fp8;
- (BOOL)isPresentityLoginPresentity:(id)fp8;
- (BOOL)removePresentity:(id)fp8;
- (void)setFirstName:(id)fp8 lastName:(id)fp12;
- (id)firstName;
- (id)emails;
- (id)email;
- (id)nickname;
- (id)lastName;
- (id)fullName;
- (id)_presentityForService:(id)fp8;
- (id)myPicture;
- (id)picture;
- (id)_createCustomPicture;
- (void)setPicture:(id)fp8;
- (void)myPictureChanged;
- (void)consumeImageData:(id)fp8 forTag:(int)fp12;
- (id)presentities;
- (id)balloonColor;
- (BOOL)isgMe;

@end

@interface MenuComboBox : NSComboBox
{
    NSButtonCell *_cbButtonCell;
}

- (void)awakeFromNib;
- (void)statusPopUp:(id)fp8;

@end

@interface MessageEditorController : NSObject
{
    NSWindow *_window;
    NSTableView *_availableTable;
    NSTableView *_awayTable;
    NSButton *_availableAddButton;
    NSButton *_awayAddButton;
    NSButton *_availableRemoveButton;
    NSButton *_awayRemoveButton;
    NSButton *_autoCreateCheckbox;
    NSPopUpButton *_rememberLastPopup;
    NSMutableArray *_availableMessages;
    NSMutableArray *_awayMessages;
    NSString *_messageToSet;
    BOOL _setMessage;
    unsigned int _startingStatus;
}

- (void)_statusIndicatorDidChange:(id)fp8;
- (void)awakeFromNib;
- (void)dealloc;
- (id)currentMessage;
- (void)setCurrentStatus:(unsigned int)fp8 andMessage:(id)fp12;
- (void)runAsSheetInWindow:(id)fp8;
- (void)_trimList:(id)fp8;
- (void)sheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)endSheet:(id)fp8;
- (id)availableMessages;
- (id)awayMessages;
- (void)setAvailableMessages:(id)fp8;
- (void)setAwayMessages:(id)fp8;
- (void)_determineList:(id *)fp8 andTable:(id *)fp12 toUseForStatus:(unsigned int)fp16;
- (void)newItem:(id)fp8;
- (void)removeItems:(id)fp8;
- (void)autoCreateChecked:(id)fp8;
- (void)changeNumberOfRememberedMessages:(id)fp8;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)tableView:(id)fp8 setObjectValue:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (BOOL)tableView:(id)fp8 canDeleteRows:(id)fp12;
- (BOOL)tableView:(id)fp8 deleteRows:(id)fp12;
- (BOOL)control:(id)fp8 textShouldEndEditing:(id)fp12;
- (BOOL)control:(id)fp8 textView:(id)fp12 doCommandBySelector:(SEL)fp16;
- (void)tableViewSelectionDidChange:(id)fp8;
- (BOOL)tableView:(id)fp8 writeRows:(id)fp12 toPasteboard:(id)fp16;
- (unsigned int)tableView:(id)fp8 validateDrop:(id)fp12 proposedRow:(int)fp16 proposedDropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 acceptDrop:(id)fp12 row:(int)fp16 dropOperation:(unsigned int)fp20;

@end

@interface ModifierTabView : AnimatingTabView
{
    unsigned int _modifierFlags[5];
    BOOL _disabled;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (id)initWithCoder:(id)fp8;
- (void)dealloc;
- (void)_updateNotification;
- (void)_flagsChanged:(id)fp8;
- (void)setModifierFlags:(unsigned int [5])fp8;
- (void)setStandardFlags;
- (unsigned int *)modifierFlags;
- (void)setDisabled:(BOOL)fp8;
- (BOOL)isDisabled;
- (id)tabViewItemForFlags:(unsigned int)fp8;

@end

@interface MsgComposePrefsBox : NSBox
{
    Prefs_MsgCompose *_prefsManager;
}

- (unsigned int)validModesForFontPanel:(id)fp8;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (void)changeColor:(id)fp8;
- (void)changeAttributes:(id)fp8;
- (void)changeFont:(id)fp8;
- (void)setRendererFromMenuItem:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;

@end

@interface MultiBuddyImageView : NSView
{
    NSArray *_presentities;
    unsigned int _curImage;
    unsigned int _oldImage;
    float _opacity;
    BOOL _transitionPending;
    BOOL _animateBuddyIcon;
    Animator *_animator;
}

- (void)_commonInit;
- (id)initWithFrame:(struct _NSRect)fp8;
- (id)initWithCoder:(id)fp8;
- (void)dealloc;
- (void)_pictureChanged:(id)fp8;
- (void)_subscribe:(BOOL)fp8;
- (void)setPresentity:(id)fp8;
- (void)setPresentities:(id)fp8;
- (void)setAllowsBuddyIconAnimation:(BOOL)fp8;
- (BOOL)allowsBuddyIconAnimation;
- (void)_needsDrawFromAnimate:(id)fp8;
- (void)setOpacity:(float)fp8;
- (float)opacity;
- (void)_nextImage;
- (void)_startTransition;
- (void)_delayTransition;
- (void)animator:(id)fp8 doStep:(float)fp12 lastStep:(BOOL)fp16;
- (void)startCycling;
- (void)stopCycling;
- (void)_drawPicture:(id)fp8 fraction:(float)fp12;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface RolloverButton : NSControl
{
    NSTextFieldCell *_messageCell;
    NSPopUpButtonCell *_popUpButtonCell;
    NSPopUpButtonCell *_triangleCell;
    NSString *_message;
    BOOL _toggles;
    BOOL _state;
    unsigned int _alignment;
    unsigned int _imagePosition;
    id _target;
    SEL _action;
    BOOL _mouseOver;
    BOOL _mouseDown;
    int _trackingRectTag;
    struct _NSRect _activeRect;
    float _cornerRadius;
    struct _NSSize _triangleSize;
    int _leftMargin;
    int _rightMargin;
    BOOL _rollsOver;
    id _delegate;
}

+ (id)_lineBreakAttributes;
- (void)setShowsDropDownArrow:(BOOL)fp8;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)_startNotifications;
- (void)_stopNotifications;
- (void)awakeFromNib;
- (void)dealloc;
- (id)customCell;
- (BOOL)toggles;
- (void)setToggles:(BOOL)fp8;
- (void)setState:(BOOL)fp8;
- (BOOL)state;
- (void)setImagePosition:(unsigned int)fp8;
- (unsigned int)alignment;
- (void)setAlignment:(unsigned int)fp8;
- (id)target;
- (void)setTarget:(id)fp8;
- (SEL)action;
- (void)setAction:(SEL)fp8;
- (void)clearActiveRect;
- (void)updateActiveRect;
- (id)menu;
- (void)addMenuItem:(id)fp8;
- (void)resetMenu;
- (struct _NSRect)messageRect;
- (struct _NSRect)triangleRect;
- (struct _NSRect)_popupRect;
- (void)_resizeEditingIfNeeded;
- (float)bgTextColorForRollover:(BOOL)fp8;
- (float)fgTextColorForRollover:(BOOL)fp8;
- (void)drawTitleInRect:(struct _NSRect)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (BOOL)canBecomeKeyView;
- (BOOL)acceptsFirstMouse:(id)fp8;
- (BOOL)mouseDownCanMoveWindow;
- (id)menuForEvent:(id)fp8;
- (void)_runPopUp:(id)fp8;
- (void)mouseDown:(id)fp8;
- (void)rightMouseDown:(id)fp8;
- (void)mouseDragged:(id)fp8;
- (void)mouseUp:(id)fp8;
- (void)setRollsOver:(BOOL)fp8;
- (BOOL)rollsOver;
- (void)_removeTrackingRect;
- (void)_updateTrackingRect;
- (void)viewWillStartLiveResize;
- (void)viewDidEndLiveResize;
- (void)setFrameSize:(struct _NSSize)fp8;
- (void)setFrameOrigin:(struct _NSPoint)fp8;
- (void)viewWillMoveToWindow:(id)fp8;
- (void)viewDidMoveToWindow;
- (void)refreshTracking;
- (void)viewDidMoveToSuperview;
- (void)windowDidResize:(id)fp8;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)setAttributedTitle:(id)fp8;
- (id)title;
- (void)setTitle:(id)fp8;
- (void)setStringValue:(id)fp8;
- (BOOL)acceptsFirstResponder;
- (BOOL)needsPanelToBecomeKey;
- (BOOL)becomeFirstResponder;
- (void)windowDidResignKey:(id)fp8;
- (void)performClick:(id)fp8;

@end

@interface MyNameControl : RolloverButton
{
}

- (void)awakeFromNib;
- (void)drawTitleInRect:(struct _NSRect)fp8;

@end

@interface MyPictureControl : ABPictureControl
{
    AbstractAccount *_account;
    int _trackingRectTag;
    BOOL _mouseOver;
    NSButtonCell *_imageCell;
}

+ (void)configureDefaultImagePicker;
+ (BOOL)usePictureTaker;
- (void)awakeFromNib;
- (void)setAccount:(id)fp8;
- (void)dealloc;
- (void)_updateUI;
- (void)_myPictureChanged:(id)fp8;
- (BOOL)acceptsFirstMouse:(id)fp8;
- (void)_needsDrawFromAnimate:(id)fp8;
- (void)_ensurePickerConfigured;
- (void)_updatePickerWithPicture:(id)fp8;
- (id)videoFrameProviderForPictureTaker:(id)fp8;
- (void)pictureTakerDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_centerPickerInParentWindow:(id)fp8;
- (void)_openWidgetOn:(id)fp8 asDownload:(BOOL)fp12 centerOnScreen:(BOOL)fp16;
- (void)openPicturePickerAndCenterOnScreen:(BOOL)fp8;
- (void)openPicturePickerWithDownloadedImage:(id)fp8;
- (void)_setImageAndNotifyTarget:(id)fp8;
- (void)_updateTrackingRect;
- (void)setFrame:(struct _NSRect)fp8;
- (void)windowDidResize:(id)fp8;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (void)mouseDown:(id)fp8;
- (void)performClick:(id)fp8;

@end

@interface MyPictureControl (MyPictureControlAccessibility)
- (id)accessibilityActionNames;
- (void)accessibilityPerformAction:(id)fp8;
- (id)accessibilityFocusedUIElement;
- (id)accessibilityHitTest:(struct _NSPoint)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityTitleAttribute;
- (id)accessibilityRoleAttribute;
- (BOOL)accessibilityIsIgnored;
@end

@interface MyProfileTextView : NSTextView
{
}

- (void)changeDocumentBackgroundColor:(id)fp8;

@end

@interface MyProfileWindow : NSWindowController
{
    NSToolbar *_toolbar;
    NSPanel *_linkSheet;
    ExtendedTextField *_linkTextField;
    LinkSheetController *_linkSheetController;
    NSColorWell *_backgoundColorWell;
    MyProfileTextView *_profileText;
    NSAttributedString *_originalString;
    NSColor *_originalColor;
}

+ (void)showWindow;
- (id)init;
- (void)_updateProfile;
- (void)awakeFromNib;
- (void)_textDidChange:(id)fp8;
- (void)_errorSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (unsigned int)validModesForFontPanel:(id)fp8;
- (BOOL)_showErrorSheetTitle:(id)fp8 text:(id)fp12 helpAnchor:(id)fp16;
- (BOOL)_setProfile;
- (void)confirmSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_showCloseConfirmationSheet;
- (BOOL)windowShouldClose:(id)fp8;
- (void)finish:(id)fp8;
- (void)cancel:(id)fp8;
- (void)changeColor:(id)fp8;
- (void)changeBackgroundColor:(id)fp8;
- (void)changeTextFont:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (void)dealloc;
- (void)_smileyPicked:(id)fp8;
- (void)insertSmiley:(id)fp8;
- (id)_selectedLink_adjustingSelection:(BOOL)fp8;
- (BOOL)_insertLinkAtSelection:(id)fp8 withText:(id)fp12;
- (void)_applyLinkToSelection:(id)fp8;
- (void)addLink:(id)fp8;
- (void)acceptLinkText:(id)fp8;
- (void)cancelLinkSheet:(id)fp8;
- (void)removeLinkSheet:(id)fp8;
- (void)_linkSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (id)toolbar:(id)fp8 itemForItemIdentifier:(id)fp12 willBeInsertedIntoToolbar:(BOOL)fp16;
- (id)toolbarDefaultItemIdentifiers:(id)fp8;
- (id)toolbarAllowedItemIdentifiers:(id)fp8;
- (BOOL)textView:(id)fp8 clickedOnLink:(id)fp12 atIndex:(unsigned int)fp16;

@end

@interface MyScrollView : NSScrollView
{
}

- (void)awakeFromNib;
- (void)viewDidEndLiveResize;

@end

@interface MyScroller : NSScroller
{
}

- (void)drawRect:(struct _NSRect)fp8;

@end

@interface MyStatusControl : RolloverButton
{
    id _statusDelegate;
    int _currentStatus;
    int _oldStatus;
    BOOL _isiTunesMessage;
}

+ (BOOL)stringIsStatusType:(id)fp8;
- (void)dealloc;
- (void)viewDidMoveToWindow;
- (void)awakeFromNib;
- (void)setStatus:(int)fp8 message:(id)fp12;
- (void)addMenuItemForInvisible;
- (void)addMenuItemForITunesStatus;
- (void)addMenuItemsForStatus:(int)fp8 customizable:(BOOL)fp12;
- (BOOL)validateMenuItem:(id)fp8;
- (void)setStatusAndMessage:(id)fp8;
- (void)setInvisibleStatus:(id)fp8;
- (void)_startEditingCurrentStatus;
- (void)startEditingCurrentStatus;
- (void)customStatusAndMessage:(id)fp8;
- (BOOL)textShouldBeginEditing:(id)fp8;
- (BOOL)textShouldEndEditing:(id)fp8;
- (void)textDidEndEditing:(id)fp8;
- (void)_windowResignedKey:(id)fp8;
- (struct _NSRect)triangleRect;
- (float)_bgTextColorForRollover:(BOOL)fp8;
- (float)_fgTextColorForRollover:(BOOL)fp8;
- (void)setCurrentMessage:(id)fp8;
- (void)setTitle:(id)fp8;
- (id)currentMessage;
- (void)setCurrentStatus:(int)fp8;
- (BOOL)textView:(id)fp8 doCommandBySelector:(SEL)fp12;
- (void)textDidChange:(id)fp8;
- (void)editMessageField:(BOOL)fp8;

@end

@interface MyStatusControl (AccessibilityAdditions)
- (id)accessibilityTitleAttribute;
- (id)accessibilityDescriptionAttribute;
@end

@interface NSAppleScript (iChatAdditionsCopiedFromMessage)
+ (id)_createScriptAtPath:(id)fp8 errorInfo:(id *)fp12;
+ (id)executeHandlerWithEventClass:(unsigned long)fp8 eventID:(unsigned long)fp12 inScriptAtPath:(id)fp16 withArguments:(id)fp20 forEvent:(int)fp24 forPresentity:(id)fp28 usingGlobalPrefs:(BOOL)fp32 error:(id *)fp36;
- (id)executeHandlerWithEventClass:(unsigned long)fp8 eventID:(unsigned long)fp12 andArguments:(id)fp16 error:(id *)fp20;
@end

@interface NSApplication (Scripting)
- (void)loginScriptCommand:(id)fp8;
- (void)logoutScriptCommand:(id)fp8;
- (void)showChatChooserCommand:(id)fp8;
- (void)storeRecentPictureCommand:(id)fp8;
- (void)inviteScriptCommand:(id)fp8;
- (void)setMyStatus:(id)fp8;
- (id)myStatus;
- (void)setMyStatusMessage:(id)fp8;
- (id)myStatusMessage;
- (id)myIdleTime;
- (void)setMyImage:(id)fp8;
- (id)myImage;
- (id)scriptActiveAVChat;
- (id)buddies;
- (id)valueInBuddiesWithName:(id)fp8;
- (id)valueInBuddiesWithUniqueID:(id)fp8;
- (id)services;
- (id)valueInServicesWithUniqueID:(id)fp8;
- (id)valueInServicesWithName:(id)fp8;
- (id)scriptFileTransfers;
- (id)objectInScriptFileTransfersAtIndex:(unsigned int)fp8;
- (id)valueInScriptFileTransfersWithUniqueID:(id)fp8;
- (id)scriptChats;
- (id)objectInScriptChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptChatsWithUniqueID:(id)fp8;
- (id)valueInScriptChatsWithName:(id)fp8;
- (id)scriptAVChats;
- (id)objectInScriptAVChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptAVChatsWithUniqueID:(id)fp8;
- (id)scriptAudioChats;
- (id)objectInScriptAudioChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptAudioChatsWithUniqueID:(id)fp8;
- (id)scriptVideoChats;
- (id)objectInScriptVideoChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptVideoChatsWithUniqueID:(id)fp8;
- (id)scriptTextChats;
- (id)objectInScriptTextChatsAtIndex:(unsigned int)fp8;
- (id)valueInScriptTextChatsWithUniqueID:(id)fp8;
- (id)valueInScriptTextChatsWithName:(id)fp8;
@end

@interface NSArray (DotMacArrayExtras)
- (BOOL)containsString:(id)fp8;
@end

@interface NSArray (FezSearchExtensions)
- (int)indexOfObject:(id)fp8 usingComparator:(SEL)fp12;
@end

@interface NSArray (Presentity_Additions)
- (id)URLForChatRoom;
- (id)URLForIMOrChatRoom;
@end

@interface NSBezierPath (DebuggingAdditions)
- (void)drawControlPoint1:(struct _NSPoint)fp8 controlPoint2:(struct _NSPoint)fp16 color:(id)fp24;
@end

@interface NSControl (TextFieldCellAdditions)
- (void)setRomanOnly:(BOOL)fp8;
- (BOOL)isRomanOnly;
@end

@interface NSData (FezSecurityAdditions)
+ (id)dataWithCertificate:(struct OpaqueSecCertificateRef *)fp8;
+ (id)dataWithPublicKey:(struct OpaqueSecKeyRef *)fp8;
- (unsigned int)_encryptWithAlgorithm:(int)fp8 into:(char *)fp12 withSize:(int)fp16;
- (unsigned int)_SHA1Into:(unsigned char [20])fp8;
- (unsigned int)_MD5Into:(unsigned char [32])fp8;
- (id)CRAM_MD5DataWithKey:(id)fp8;
- (id)SHA1Data;
- (id)MD5Data;
- (id)CRAM_MD5HexStringWithKey:(id)fp8;
- (id)MD5HexString;
- (id)SHA1HexString;
- (struct OpaqueSecCertificateRef *)certificateFromData;
- (struct OpaqueSecKeyRef *)publicKeyFromData;
@end

@interface NSData (Scripting)
+ (id)scriptingImageWithDescriptor:(id)fp8;
+ (id)scriptingTiffPictureWithDescriptor:(id)fp8;
- (id)scriptingImageDescriptor;
- (id)scriptingTiffPictureDescriptor;
@end

@interface NSDictionary (CompositionAdditions)
- (id)identifier;
- (id)localizedName;
- (id)attributes;
- (BOOL)wantsSlider;
- (BOOL)backdropsEnabled;
- (id)backdropsForegroundPath;
- (id)backdropsBackgroundPath;
- (BOOL)allowDragAndDrop;
@end

@interface NSDictionary (FileTransferContextGetters)
- (id)fileTransferStartedTransferring;
- (id)fileTransferMessage;
- (int)fileTransferContextState;
- (id)fileTransferBuddy;
- (BOOL)isInlineTransfer;
- (BOOL)isFileTransferContext;
- (id)fileTransferDownloadPath;
- (BOOL)fileTransferIsIncoming;
- (unsigned int)fileTransferNumFiles;
- (id)fileTransferCurrentFilename;
- (id)fileTransferFilename;
- (BOOL)fileTransferSecurityEnabled;
- (unsigned long long)fileTransferTotalSentBytes;
- (unsigned long long)fileTransferTotalSize;
- (BOOL)fileTransferIsDirectory;
- (int)fileTransferError;
- (int)securityLevel;
- (unsigned short)fileTransferHFSFlags;
- (unsigned int)fileTransferHFSType;
- (unsigned int)fileTransferHFSCreator;
- (unsigned int)fileTransferCurrentFileNum;
- (id)fileTransferSecurityEvaluation;
- (BOOL)fileTransferAttemptsToResume;
@end

@interface NSDictionary (SessionContextGetters)
- (id)type;
- (id)guid;
- (id)account;
- (int)securityLevel;
@end

@interface NSDictionary (VCChannelNegotiationAdditions)
- (id)vcChannelRequestID;
@end

@interface NSExtendedBox : NSBox
{
    BOOL _isNewAquaDivider;
    BOOL _isAudioDivider;
    BOOL _isVideoBorder;
    BOOL _isSingleLineDivider;
    NSColor *_interiorColor;
    BOOL _fadeToSecondaryInteriorColor;
    BOOL _fadeToSecondaryInteriorColorVertically;
    NSColor *_secondaryInteriorColor;
    float _lengthForFadeToSecondaryInteriorColor;
    BOOL _drawGradient;
    NSString *_string;
    NSString *_shortString;
    BOOL _drawRoundedBox;
    NSColor *_roundedBoxBorderColor;
    NSColor *_roundedBoxInteriorColor;
    BOOL _isOpaque;
    float _opacity;
    float _radius;
    NSImage *_backgroundImage;
}

+ (void)initialize;
+ (id)_titleAttributes;
+ (id)_titleDisabledAttributes;
+ (id)_titleShadowAttributes;
+ (void)_setShadowStyle;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (void)awakeFromNib;
- (void)setSingleLineDivider:(BOOL)fp8;
- (BOOL)singleLineDivider;
- (void)setIsNewAquaDivider:(BOOL)fp8;
- (BOOL)isNewAquaDivider;
- (void)setBackgroundImage:(id)fp8;
- (id)backgroundImage;
- (void)setRadius:(float)fp8;
- (float)radius;
- (void)setOpacity:(float)fp8;
- (float)opacity;
- (void)setDrawsRoundedBox:(BOOL)fp8;
- (BOOL)drawsRoundedBox;
- (void)setRoundedBoxBorderColor:(id)fp8;
- (id)roundedBoxBorderColor;
- (void)setRoundedBoxInteriorColor:(id)fp8;
- (id)roundedBoxInteriorColor;
- (void)setIsAudioDivider:(BOOL)fp8;
- (BOOL)isAudioDivider;
- (void)setIsVideoBorder:(BOOL)fp8;
- (BOOL)isVideoBorder;
- (void)setInteriorColor:(id)fp8;
- (void)setFadeToSecondaryInteriorColor:(BOOL)fp8;
- (BOOL)fadeToSecondaryInteriorColor;
- (void)setFadeToSecondaryInteriorColorVertically:(BOOL)fp8;
- (BOOL)fadeToSecondaryInteriorColorVertically;
- (void)setSecondaryInteriorColor:(id)fp8;
- (id)secondaryInteriorColor;
- (void)setLengthForFadeToSecondaryInteriorColor:(float)fp8;
- (float)lengthFoFadeToSecondaryInteriorColorLength;
- (void)setDrawGradient:(BOOL)fp8;
- (BOOL)drawGradient;
- (id)interiorColor;
- (void)setShortStringValue:(id)fp8;
- (id)shortStringValue;
- (void)setStringValue:(id)fp8;
- (id)stringValue;
- (void)setIsOpaque:(BOOL)fp8;
- (BOOL)isOpaque;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface NSExtendedComboBoxCell : NSComboBoxCell
{
    BOOL _drawPopUpButton;
    NSTextFieldCell *_textFieldCell;
}

- (void)dealloc;
- (void)setPopUpButtonVisible:(BOOL)fp8;
- (BOOL)isPopUpButtonVisible;
- (void)drawWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (struct _NSRect)boundsForTextCell:(struct _NSRect)fp8;
- (struct _NSRect)boundsForButtonCell:(struct _NSRect)fp8;
- (float)_buttonWidth;

@end

@interface NSExtendedImageView : NSImageView
{
    BOOL _mouseDownCanMoveWindow;
}

- (BOOL)mouseDownCanMoveWindow;
- (void)setMouseDownCanMoveWindow:(BOOL)fp8;

@end

@interface NSImage (FadeDrawingAdditions)
+ (id)gradientOfSize:(struct _NSSize)fp8 topBorder:(id)fp16 top:(id)fp20 bottom:(id)fp24 bottomBorder:(id)fp28;
- (void)drawFadeAtPoint:(struct _NSPoint)fp8 fromRect:(struct _NSRect)fp16 start:(float)fp32 end:(float)fp36;
@end

@interface NSImage (Private_Additions)
- (struct _NSRect)bounds;
@end

@interface NSMenu (NSMenuItemReplacementAdditions)
- (void)replaceItem:(id)fp8 withItem:(id)fp12;
@end

@interface NSMutableAttributedString (FezCharAdditions)
- (void)setMaxCharacterWidth:(int)fp8;
@end

@interface NSMutableDictionary (FileTransferContextSetters)
- (void)setFileTransferMessage:(id)fp8;
- (void)setHFSFlags:(unsigned short)fp8;
- (void)setHFSType:(unsigned int)fp8;
- (void)setHFSCreator:(unsigned int)fp8;
- (void)setIsFileTransferContext;
- (void)setIsIncoming:(BOOL)fp8;
- (void)setCurrentFilename:(id)fp8;
- (void)setFilename:(id)fp8;
- (void)setCurrentFileNum:(unsigned int)fp8;
- (void)setCurrentFileSize:(unsigned long long)fp8;
- (void)setNumFiles:(unsigned int)fp8;
- (void)setTotalSize:(unsigned long long)fp8;
- (void)setTotalSentBytes:(unsigned long long)fp8;
- (void)setTransferError:(int)fp8;
- (void)setDownloadPath:(id)fp8;
- (void)setBuddy:(id)fp8;
- (void)setTransferState:(int)fp8;
- (void)setSecurityEnabled:(BOOL)fp8;
- (void)setIsDirectory:(BOOL)fp8;
- (void)setSecurityLevel:(int)fp8;
- (void)setIsInlineTransfer:(BOOL)fp8;
- (void)setFileTransferStartedTransferring:(id)fp8;
- (void)setFileTransferSecurityEvaluation:(id)fp8;
- (void)setAttemptsToResume:(BOOL)fp8;
@end

@interface NSMutableDictionary (SessionContextSetters)
- (void)setType:(id)fp8;
- (void)setAccount:(id)fp8;
- (void)setGUID:(id)fp8;
- (void)setSecurityLevel:(int)fp8;
@end

@interface NSNotificationCenter (SessionContextNotificationAdditions)
- (void)addObserver:(id)fp8 selector:(SEL)fp12 name:(id)fp16 type:(id)fp20;
- (void)addObserver:(id)fp8 selector:(SEL)fp12 name:(id)fp16 guid:(id)fp20;
- (void)removeObserver:(id)fp8 name:(id)fp12 type:(id)fp16;
- (void)removeObserver:(id)fp8 name:(id)fp12 guid:(id)fp16;
- (void)postSessionContextNotificationNamed:(id)fp8 context:(id)fp12;
@end

@interface NSObject (FezExtendedTableViewDataSource)
- (BOOL)tableView:(id)fp8 canPasteFromPasteboard:(id)fp12;
- (BOOL)tableView:(id)fp8 pasteFromPasteboard:(id)fp12;
- (BOOL)tableView:(id)fp8 canDeleteRows:(id)fp12;
- (BOOL)tableView:(id)fp8 deleteRows:(id)fp12;
- (void)tableView:(id)fp8 performDragOperation:(unsigned int)fp12 withPasteboard:(id)fp16;
- (BOOL)tableView:(id)fp8 groupRowAtIndex:(int)fp12;
- (unsigned int)tableView:(id)fp8 groupRowGreaterThanIndex:(unsigned int)fp12;
- (id)tableView:(id)fp8 titleForGroupRow:(int)fp12;
- (BOOL)tableView:(id)fp8 prepareTooltip:(id)fp12 row:(int)fp16;
- (id)tableView:(id)fp8 numberStringForGroupRow:(int)fp12 ignoreCollapsed:(BOOL)fp16;
- (void)tableView:(id)fp8 groupRowClicked:(int)fp12;
- (id)tableView:(id)fp8 menuForGroupRow:(int)fp12;
- (void)tableView:(id)fp8 willReturnMenu:(id)fp12 forRow:(int)fp16;
- (void)tableView:(id)fp8 mouseExited:(id)fp12;
- (void)tableView:(id)fp8 mouseEntered:(id)fp12;
- (void)tableView:(id)fp8 mouseMoved:(id)fp12;
- (BOOL)tableView:(id)fp8 shouldStartDraggingForGroupRow:(int)fp12;
- (void)tableView:(id)fp8 dragStarted:(id)fp12 originPoint:(struct _NSPoint)fp16;
- (void)tableViewTrackingChanged:(id)fp8;
- (BOOL)tableView:(id)fp8 shouldDrawWhenMovingFrom:(struct _NSPoint)fp12 toPoint:(struct _NSPoint)fp20;
- (id)tableView:(id)fp8 cellTipForRow:(int)fp12;
- (id)tableView:(id)fp8 tooltipForRow:(int)fp12;
- (BOOL)tableView:(id)fp8 shouldShowTooltipForRow:(int)fp12;
@end

@interface NSObject (FileQuarantineDelegate)
- (void)fileQuarantineMoveFinished:(id)fp8;
- (BOOL)fileQuarantine:(id)fp8 shouldUseExistingQuarantineFolder:(id)fp12;
- (id)responsibleSender;
@end

@interface NSObject (MainThreadKVO)
- (void)observeValueForKeyPathOnMainThread:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)_observeValueForKeyPathOnMainThread:(id)fp8;
- (void)performObserveValueForKeyPathOnMainThread:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
@end

@interface NSOpenGLContext (FezAdditions)
- (id)initWithCompatibleFormatIncluding:(int *)fp8 shareContext:(id)fp12;
@end

@interface NSOpenGLContext (QCSharedContext)
+ (BOOL)_usesIntel950VideoChip;
+ (id)_sharedQCCGLContext;
+ (id)sharedContext;
+ (BOOL)supportsAcceleratedEffects;
+ (BOOL)supportsBackdrops;
@end

@interface NSOpenGLContext (SupportedSystem)
+ (long)vramForDisplayID:(unsigned int)fp8;
+ (BOOL)supportsFullScreenModeForDisplay:(unsigned int)fp8;
+ (BOOL)_exceedsOriginalTiBook;
+ (BOOL)isSupportedSystem;
@end

@interface NSOpenGLPixelFormat (FezAdditions)
+ (id)compatiblePixelFormatIncludingAttributes:(int *)fp8 forContext:(id)fp12;
@end

@interface NSPanel (SecureWindowUtils)
- (id)lockButton;
- (void)setSecurityLevel:(int)fp8;
- (int)securityLevel;
@end

@interface NSPreferences (PrivateOverrides)
- (id)currentModule;
@end

@interface NSPreferencesModule (PrivateImpls)
- (void)setMinSize:(struct _NSSize)fp8;
@end

@interface NSRecursiveLock (PrivateAdditions)
- (BOOL)lockBeforeTimeout:(double)fp8 fromLine:(int)fp16;
- (void)unlockFromLine:(int)fp8;
@end

@interface NSSavePanel (HackToGetTheOKButton)
- (id)okButton;
@end

@interface NSSegmentedControl (AccessibilityAdditions)
- (void)setAccessibilityDescription:(id)fp8 forSegment:(int)fp12;
@end

@interface NSSet (FastPresentityCompareAdditions)
- (BOOL)fastIsEqualToPointerCompareSet:(id)fp8;
@end

@interface NSSound (iChatSoundAdditions)
+ (id)systemLibrarySoundsDirs;
+ (id)librarySoundsDirs;
+ (id)networkLibrarySoundsDirs;
+ (id)tildeLibrarySoundsDirs;
+ (id)appendSoundsToPaths:(id)fp8;
+ (id)soundsAtPaths:(id)fp8;
@end

@interface NSSoundPopUpButton : NSPopUpButton
{
    NSButton *addSoundButton;
    NSButton *removeSoundButton;
    NSButton *doneButton;
    NSTableView *soundTableView;
    NSMutableArray *userSounds;
    NSPanel *soundPanel;
    id delegate;
    NSMenu *soundMenu;
    NSString *_selectedItem;
    NSMenuItem *_otherItem;
    BOOL _amIAwake;
    BOOL _showSoundsFromBundle;
    BOOL _showSoundsFromDelegate;
    BOOL _showSoundsFromSystemLibrary;
    BOOL _showSoundsFromLibrary;
    BOOL _showSoundsFromNetworkLibrary;
    BOOL _showSoundsFromTildeLibrary;
    BOOL _showNone;
    BOOL _showAddRemove;
    NSSound *_currentSound;
}

+ (id)soundsAtPaths:(id)fp8;
- (id)_addItemWithTitle:(id)fp8;
- (void)_appendSoundsFromDirectories:(id)fp8;
- (void)_popupMenuChanged:(id)fp8;
- (void)_configureSoundMenu;
- (void)_playSound;
- (void)sound:(id)fp8 didFinishPlaying:(BOOL)fp12;
- (void)_playSoundForItemAtIndex:(int)fp8;
- (void)_invalidateSoundMenu;
- (id)otherMenuItem;
- (void)_commonInit;
- (id)initWithFrame:(struct _NSRect)fp8;
- (id)initWithCoder:(id)fp8;
- (void)awakeFromNib;
- (id)menu;
- (id)soundPath;
- (int)selectSoundPath:(id)fp8;
- (void)openPanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)addRemoveMailSound:(id)fp8;
- (void)soundSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)newSoundClicked:(id)fp8;
- (void)removeSoundClicked:(id)fp8;
- (void)doneClicked:(id)fp8;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)tableViewSelectionDidChange:(id)fp8;
- (BOOL)showSoundsFromBundle;
- (void)setShowSoundsFromBundle:(BOOL)fp8;
- (BOOL)showSoundsFromDelegate;
- (void)setShowSoundsFromDelegate:(BOOL)fp8;
- (BOOL)showSoundsFromSystemLibrary;
- (void)setShowSoundsFromSystemLibrary:(BOOL)fp8;
- (BOOL)showSoundsFromLibrary;
- (void)setShowSoundsFromLibrary:(BOOL)fp8;
- (BOOL)showSoundsFromNetworkLibrary;
- (void)setShowSoundsFromNetworkLibrary:(BOOL)fp8;
- (BOOL)showSoundsFromTildeLibrary;
- (void)setShowSoundsFromTildeLibrary:(BOOL)fp8;
- (BOOL)showNone;
- (void)setShowNone:(BOOL)fp8;
- (BOOL)showAddRemove;
- (void)setShowAddRemove:(BOOL)fp8;
- (void)stopCurrentSound;
- (void)dealloc;
- (void)finalize;

@end

@interface NSString (FadeDrawingAdditions)
- (void)_rebuildFadeDrawingImageIfNeeded:(struct _NSSize)fp8;
- (void)drawAtPoint:(struct _NSPoint)fp8 fromBounds:(struct _NSRect)fp16 fadeLeft:(int)fp32 fadeRight:(int)fp36 withAttributes:(id)fp40;
@end

@interface NSString (JIDAdditions)
- (BOOL)hasNode;
- (BOOL)hasResource;
- (id)IDWithoutResource;
- (id)IDWithResource:(id)fp8;
- (id)presentityIDFromChatIDName;
- (BOOL)isChatID;
- (id)resource;
- (id)domain;
- (id)node;
@end

@interface NSString (SecureImAdditions)
- (id)equivalentEmailAddressForScreenName;
@end

@interface NSString (SpaceAdditions)
- (id)preSpace;
- (id)postSpace;
@end

@interface NSTextField (FindPanelAdditions)
- (BOOL)isFirstResponder;
@end

@interface NSTextFieldCell (TextFieldCellAdditions)
- (id)romanOnlyLocales;
- (BOOL)allowsOnlyRomanCharacters;
- (void)setAllowsOnlyRomanCharacters:(BOOL)fp8;
@end

@interface NSUserDefaults (BackdropsPrefs)
- (void)setBackdropsBackgroundPath:(id)fp8 forKey:(id)fp12;
- (id)backdropsBackgroundPathForKey:(id)fp8;
@end

@interface NSUserDefaults (DeferredSavingAdditions)
- (BOOL)delayedSynchronize;
- (void)applicationWillTerminate:(id)fp8;
@end

@interface NSView (BalloonDrawingAdditions)
- (void)drawBalloonInRect:(struct _NSRect)fp8 tailAtPoint:(struct _NSPoint)fp24 withShadow:(id)fp32 fillColor:(id)fp36 strokeColor:(id)fp40 lineWidth:(float)fp44 curve:(float)fp48;
@end

@interface NSView (CollapseView_Additions)
- (void)_setAutoresizingVerticalMask:(int)fp8;
@end

@interface NSView (NSViewShouldHaveAVisibleBitLikeEveryOtherFrameworkInExistance)
- (BOOL)visible;
- (void)setVisible:(BOOL)fp8;
@end

@interface NSView (QCRendererAdditions)
- (struct _NSPoint)normalizedMouseLocationWithOptionalEvent:(id)fp8;
@end

@interface NSViewAnimation (iChatAdditions)
+ (id)animationWithDuration:(double)fp8 viewAnimations:(id)fp16;
+ (id)animationWithTarget:(id)fp8 toRect:(struct _NSRect)fp12 effect:(id)fp28;
+ (id)animationWithTarget:(id)fp8 toRect:(struct _NSRect)fp12;
+ (id)animationWithTarget:(id)fp8 fromRect:(struct _NSRect)fp12 toRect:(struct _NSRect)fp28;
+ (id)animationWithTarget:(id)fp8 fromRect:(struct _NSRect)fp12 toRect:(struct _NSRect)fp28 effect:(id)fp44;
+ (id)animationWithTarget:(id)fp8 effect:(id)fp12;
+ (id)animationWithTarget:(id)fp8 fromRect:(struct _NSRect)fp12 toRect:(struct _NSRect)fp28 effect:(id)fp44 startKey:(id)fp48 endKey:(id)fp52;
- (id)initWithDuration:(double)fp8 viewAnimations:(id)fp16;
@end

@interface NSWindow (FezAdditions)
+ (id)_snapshotView:(id)fp8;
- (void)bottomLeftAlignOnFirstScreen;
- (void)bottomAlignCenterOnFirstScreen;
- (void)centerOnFirstScreen;
- (struct _NSPoint)_positionNextToWindow:(id)fp8 gapLeft:(float)fp12 right:(float)fp16 top:(float)fp20 bottom:(float)fp24;
- (void)positionRelativeToWindow:(id)fp8 gapLeft:(float)fp12 right:(float)fp16 top:(float)fp20 bottom:(float)fp24;
- (struct _NSRect)frame:(struct _NSRect)fp8 constrainedToScreen:(id)fp24;
- (void)setContentRelativeFrame:(struct _NSRect)fp8 constrainedToScreen:(id)fp24 display:(BOOL)fp28 animate:(BOOL)fp32;
- (void)setContentRelativeFrame:(struct _NSRect)fp8 constrainedToScreen:(id)fp24 display:(BOOL)fp28;
- (void)setContentRelativeFrame:(struct _NSRect)fp8 constrainedToScreen:(id)fp24;
- (void)morphToFrame:(struct _NSRect)fp8;
- (void)dragWithEvent:(id)fp8;
- (BOOL)hasVisibleDrawer;
- (float)minFrameWidthWithTitle:(id)fp8;
- (void)fixMaxWidth:(BOOL)fp8 height:(BOOL)fp12;
- (BOOL)screenHasMenubar;
- (BOOL)screenHasDock;
@end

@interface NSWindow (HiDPIAdditions)
+ (struct _NSPoint)offsetOrigin:(struct _NSPoint)fp8 relativeToWindow:(id)fp16 offsetAmount:(struct _NSSize)fp20;
+ (struct _NSPoint)originForWindow:(id)fp8 relativeToWindow:(id)fp12 afterOffset:(struct _NSSize)fp16;
+ (struct _NSRect)contentRelativeRectAdjustingOriginInRect:(struct _NSRect)fp8 srcRect:(struct _NSRect)fp24 srcWindow:(id)fp40;
- (void)positionRelativeToWindow:(id)fp8 offset:(struct _NSSize)fp12;
- (void)offsetContentRelativeOrigin:(struct _NSSize)fp8;
- (void)outsetContentRelativeLeft:(float)fp8 right:(float)fp12 top:(float)fp16 bottom:(float)fp20;
- (void)outsetContentRelativeLeft:(float)fp8 right:(float)fp12 top:(float)fp16 bottom:(float)fp20 display:(BOOL)fp24 animate:(BOOL)fp28;
- (struct _NSRect)contentRelativeFrame;
- (struct _NSSize)contentRelativeMinSize;
- (struct _NSSize)contentRelativeMaxSize;
- (void)setContentRelativeFrame:(struct _NSRect)fp8 display:(BOOL)fp24 animate:(BOOL)fp28;
- (void)setContentRelativeFrame:(struct _NSRect)fp8 display:(BOOL)fp24 srcFrame:(struct _NSRect)fp28;
- (void)setContentRelativeFrame:(struct _NSRect)fp8 display:(BOOL)fp24;
- (void)setContentRelativeFrame:(struct _NSRect)fp8;
- (void)setContentRelativeMinSize:(struct _NSSize)fp8;
- (void)setContentRelativeMaxSize:(struct _NSSize)fp8;
- (void)ensureEntirelyOnScreen;
- (struct _NSRect)contentRelativeRectAdjustingOriginInRect:(struct _NSRect)fp8;
- (void)setWindowBackgroundToLight;
- (void)setWindowBackgroundToDark;
- (void)makeUnresizable;
@end

@interface NSWindow (iChatFrameSavingAdditions)
- (void)saveWindowPositionUsingName:(id)fp8 saveWidth:(BOOL)fp12 saveHeight:(BOOL)fp16;
- (BOOL)hasSavedPositionUsingName:(id)fp8;
- (void)restoreWindowPositionUsingName:(id)fp8 restoreWidth:(BOOL)fp12 restoreHeight:(BOOL)fp16;
@end

/*@interface NSWindowGraphicsContext (CGLayerContext)
- (id)initWithCoreGraphicsContext:(struct CGContext *)fp8;
@end*/

@interface NameTableCell : NSActionCell
{
    PeopleList *_peopleList;
    BOOL _oneLine;
    BOOL _disabled;
    int _imageIndex;
    struct _NSRect _trackingRect;
    struct _NSRect _cellTrackingFrame;
    BOOL _urlMouseDown;
    BOOL _urlMouseOver;
    BOOL _showVCIcons;
    BOOL _showArrow;
    BOOL _showColorHint;
}

+ (id)_lineBreakAttributes;
- (id)initWithPeopleList:(id)fp8;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (BOOL)_validStatusURL:(id)fp8;
- (void)_openURL;
- (BOOL)_tracking;
- (void)setShowsColorHint:(BOOL)fp8;
- (BOOL)showsColorHint;
- (void)setShowsArrow:(BOOL)fp8;
- (BOOL)showsArrow;
- (void)setShowVCIcon:(BOOL)fp8;
- (BOOL)showVCIcon;
- (void)setOneLine:(BOOL)fp8;
- (BOOL)oneLine;
- (void)setDisabled:(BOOL)fp8;
- (BOOL)isDisabled;
- (id)_currentVCImage;
- (void)_setNoImage;
- (void)_setImageIsVideo:(BOOL)fp8 multiway:(BOOL)fp12 state:(int)fp16;
- (void)_setImageState:(int)fp8;
- (void)setNoImage;
- (BOOL)hasImage;
- (void)setImageIsVideo:(BOOL)fp8 multiway:(BOOL)fp12 state:(int)fp16;
- (void)setImageState:(int)fp8;
- (BOOL)imageIsVideo;
- (BOOL)imageIsMultiway;
- (int)imageState;
- (struct _NSSize)vcImageSizeMultiway:(BOOL)fp8;
- (struct _NSRect)vcRectForFrame:(struct _NSRect)fp8 multiway:(BOOL)fp24;
- (struct _NSRect)rectOfStatusImageWithFrame:(struct _NSRect)fp8 inView:(id)fp24 usingStatusImageReference:(id)fp28;
- (struct _NSRect)rectOfStatusImageWithFrame:(struct _NSRect)fp8 inView:(id)fp24 forStatus:(unsigned int)fp28;
- (id)presentity;
- (id)peopleListItem;
- (void)_layoutInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24 urlRect:(struct _NSRect *)fp28 layoutOnly:(BOOL)fp32;
- (unsigned int)hitTestForEvent:(id)fp8 inRect:(struct _NSRect)fp12 ofView:(id)fp28;
- (struct _NSRect)urlRectForFrame:(struct _NSRect)fp8;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)_redisplay:(id)fp8;
- (BOOL)trackMouse:(id)fp8 inRect:(struct _NSRect)fp12 ofView:(id)fp28 untilMouseUp:(BOOL)fp32;
- (BOOL)startTrackingAt:(struct _NSPoint)fp8 inView:(id)fp16;
- (BOOL)continueTracking:(struct _NSPoint)fp8 at:(struct _NSPoint)fp16 inView:(id)fp24;
- (void)stopTracking:(struct _NSPoint)fp8 at:(struct _NSPoint)fp16 inView:(id)fp24 mouseIsUp:(BOOL)fp28;

@end

@interface NameTableCell (NameTableCellAccessibility)
- (id)accessibilityActionDescription:(id)fp8;
- (id)accessibilityActionNames;
- (void)accessibilityPerformAction:(id)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityTitleAttribute;
- (id)accessibilityValueAttribute;
@end

@interface NetworkChangeNotifier : NSObject
{
    struct __SCDynamicStore *_store;
    struct __CFRunLoopSource *_runLoopSource;
    NSMutableArray *_listeners;
    BOOL _pendingPost;
    BOOL _asleep;
}

+ (id)sharedNotifier;
+ (BOOL)enableNotifications;
+ (void)disableNotifications;
- (void)_delayPost;
- (void)_cancelPost;
- (void)_cancelAndRepostIfNecessary;
- (void)_sendNotification;
- (void)_goingToSleep:(id)fp8;
- (void)_wakeUp:(id)fp8;
- (BOOL)_listenForChanges;
- (id)init;
- (void)addListener:(id)fp8;
- (void)removeListener:(id)fp8;
- (void)dealloc;

@end

@interface NewChatChooser : NSWindowController
{
    ShadowView *_shadowView;
    ServicePopUp *_accountPopup;
    NSButton *_cancelButton;
    ABPictureControl *_imageView;
    NSTokenField *_nameField;
    NSTextField *_nameType;
    NSButton *_okButton;
    NSProgressIndicator *_progressIndicator;
    NSPopUpButton *_typePopup;
    CollapseView *_collapseView;
    NSArray *_cachedPresentites;
    BOOL _completedString;
    BOOL _lookingUpPresentity;
    NSMutableSet *_presentitiesForLookup;
}

+ (id)sharedChatChooser;
+ (void)openForPresentities:(id)fp8;
+ (BOOL)canOpenNewChat;
- (id)init;
- (void)dealloc;
- (void)windowDidLoad;
- (void)textFieldDidChange:(id)fp8;
- (void)setPresentities:(id)fp8;
- (void)_ensureValidMenuItemSelected;
- (BOOL)validateMenuItem:(id)fp8;
- (void)_validateChatButton;
- (void)_updateNameType;
- (id)_selectedBuddyIDs;
- (void)__setBuddyPictures:(id)fp8;
- (void)_setBuddyPictures:(id)fp8;
- (void)_updateSelectedBuddyPictureWithIDs:(id)fp8;
- (void)selectedAccountStatusChanged:(id)fp8;
- (void)showWindow:(id)fp8;
- (void)accountChanged:(id)fp8;
- (void)cancelPressed:(id)fp8;
- (void)nameChanged:(id)fp8;
- (void)okPressed:(id)fp8;
- (void)typeChanged:(id)fp8;
- (void)_targetPresentityUpdated:(id)fp8;
- (void)_cancelPendingLookupsForPresentity;
- (void)_startPresentityLookupNow;
- (void)_startPresentityLookupSoon;
- (BOOL)_updateBuddyPictureForExistingBuddies;
- (void)_validateButtons;
- (void)_recachePresentityInformation;
- (void)windowWillClose:(id)fp8;
- (void)windowDidBecomeMain:(id)fp8;
- (id)tokenField:(id)fp8 readFromPasteboard:(id)fp12;
- (id)tokenField:(id)fp8 shouldAddObjects:(id)fp12 atIndex:(unsigned int)fp16;
- (id)tokenField:(id)fp8 completionsForSubstring:(id)fp12 indexOfToken:(int)fp16 indexOfSelectedItem:(int *)fp20;

@end

@interface NicelyScaledImageView : NSImageView
{
}

- (void)drawRect:(struct _NSRect)fp8;

@end

@interface NodeHeader : NSObject
{
    char *_name;
    char **_attrs;
}

- (void)_setName:(const char *)fp8 attributes:(const char **)fp12;
- (id)name;
- (const char *)Cname;
- (id)attributeNamed:(id)fp8;
- (id)attributeNamedC:(const char *)fp8;
- (const char *)CattributeNamedC:(const char *)fp8;
- (id)attributes;

@end

@interface NonKeyPanel : NSPanel
{
}

- (BOOL)canBecomeKeyWindow;
- (BOOL)canBecomeMainWindow;

@end

@interface PeopleListGroup : NSObject
{
    NSMutableArray *_members;
    NSString *_name;
    PeopleListItem *_item;
    BOOL _expanded;
    int _maxMembers;
    BOOL _supportsReordering;
    BOOL _supportsMemberReordering;
    BOOL _supportsRename;
    BOOL _supportsAdding;
    BOOL _supportsRemoving;
    NSString *_localizableName;
}

- (id)init;
- (void)dealloc;
- (id)peopleListItem;
- (void)setPeopleListItem:(id)fp8;
- (BOOL)isExpanded;
- (void)setExpanded:(BOOL)fp8;
- (void)setName:(id)fp8;
- (id)name;
- (id)displayName;
- (void)addPeopleListItem:(id)fp8;
- (void)removePeopleListItem:(id)fp8;
- (int)numberOfItems;
- (int)actualNumberOfOnlineItems;
- (int)numberOfOnlineItems;
- (id)visibleMembers;
- (id)members;
- (id)description;
- (void)removeAllItems;
- (int)maxMembers;
- (BOOL)supportsReordering;
- (BOOL)supportsMemberReordering;
- (BOOL)supportsRename;
- (BOOL)supportsAdding;
- (BOOL)supportsRemoving;
- (void)setProperties:(id)fp8;

@end

@interface OfflinePeopleListGroup : PeopleListGroup
{
    NSMutableArray *_visibleMembers;
    NSMutableArray *_dontShowMembers;
    int _changes;
    BOOL _pendingClear;
}

- (id)init;
- (id)visibleMembers;
- (int)numberOfItems;
- (void)forgetIgnoredPresences;
- (void)_clearVisibleMembers;
- (BOOL)isChanging;
- (void)beginChanges;
- (void)endChanges;
- (void)dontShowPresence:(id)fp8;
- (void)addPeopleListItem:(id)fp8;
- (void)removePeopleListItem:(id)fp8;
- (void)removeAllItems;
- (void)dealloc;

@end

@interface OpenGLLayer : NSObject
{
    NSString *_name;
    struct _NSRect _layerFrame;
    float _opacity;
    unsigned char _flags;
    BOOL _isValid;
    BOOL _isVisible;
    unsigned int _autoresizingMask;
    NSMutableArray *_sublayers;
    unsigned int _positionInSublayers;
    OpenGLLayerModel *_layerModel;
    OpenGLLayer *_superLayer;
}

+ (id)sequentialLayerName:(id)fp8;
+ (id)masterOpenGLContext;
- (id)initWithFrame:(struct _NSRect)fp8 layerName:(id)fp24;
- (void)dealloc;
- (id)description;
- (void)setLayerIsValid:(BOOL)fp8;
- (BOOL)isValid;
- (void)setIsVisible:(BOOL)fp8;
- (void)setIsVisible:(BOOL)fp8 recursive:(BOOL)fp12;
- (BOOL)isVisible;
- (struct _NSRect)superLayerFrame;
- (struct _NSRect)layerFrame;
- (void)setLayerFrame:(struct _NSRect)fp8;
- (void)_parentMovedFrom:(struct _NSPoint)fp8 to:(struct _NSPoint)fp16;
- (void)setLayerOrigin:(struct _NSPoint)fp8;
- (void)_parent:(id)fp8 resizedFrom:(struct _NSSize)fp12 to:(struct _NSSize)fp20;
- (void)setLayerSize:(struct _NSSize)fp8;
- (void)setAutoresizingMask:(unsigned int)fp8;
- (unsigned int)autoresizingMask;
- (void)containerViewResizedFrom:(struct _NSSize)fp8 to:(struct _NSSize)fp16;
- (id)name;
- (void)setName:(id)fp8;
- (void)setOpacity:(float)fp8;
- (float)opacity;
- (float)scaleFactor;
- (void)_setLayerModel:(id)fp8;
- (id)layerModel;
- (void)setUsesAlphaBlending:(BOOL)fp8;
- (void)updateBuffer;
- (void)compositeLayer:(struct _CGLContextObject *)fp8;
- (id)ciContext;
- (BOOL)useCoreImage;
- (id)superLayer;
- (id)sublayers;
- (int)positionInSublayers;
- (void)addedToSuperLayer:(id)fp8;
- (void)addSublayer:(id)fp8 underSelf:(BOOL)fp12 underSiblings:(BOOL)fp16;
- (void)removedFromSuperLayer:(id)fp8;
- (BOOL)removeSublayer:(id)fp8;
- (id)sublayerWithName:(id)fp8;
- (id)sublayerWithPrefix:(id)fp8;
- (void)recursiveCompositeLayer:(struct _CGLContextObject *)fp8;
- (BOOL)containsPoint:(struct _NSPoint)fp8;

@end

@interface OpenGLTextureLayer : OpenGLLayer
{
    unsigned int _textureID;
    unsigned int _textureCapability;
    struct _NSSize _textureSize;
    struct _NSSize _bufferSize;
    unsigned int _pixelFormat;
    unsigned int _pixelType;
    unsigned int _internalFormat;
    BOOL _alphaIsPremultiplied;
    BOOL _textured;
    BOOL _mirrored;
    float _blackTint;
    BOOL _appWillTerminate;
}

- (id)initWithSize:(struct _NSSize)fp8 layerName:(id)fp16;
- (void)dealloc;
- (void)generateTextureID;
- (void)deleteTextureID;
- (unsigned int)textureID;
- (void)_updateAlphaBlending;
- (void)setBlackTint:(float)fp8;
- (void)setOpacity:(float)fp8;
- (float)blackTint;
- (void)setMirrored:(BOOL)fp8;
- (BOOL)isMirrored;
- (void)setTextureID:(unsigned int)fp8;
- (void)updateBuffer;
- (CDAnonymousStruct1)_textureLayerInfo;
- (void)_cleanupAfterRetexture:(void *)fp8;
- (void)_retexture:(struct _CGLContextObject *)fp8;
- (void)renderTexture:(struct _CGLContextObject *)fp8;
- (void)compositeLayer:(struct _CGLContextObject *)fp8;
- (struct _NSSize)textureSize;
- (struct _NSSize)bufferSize;
- (void)handleApplicationWillTerminate:(id)fp8;

@end

@interface OpenGLCGBitmapContextLayer : OpenGLTextureLayer
{
    char *_buffer;
    struct CGContext *_cgBitmapContext;
    int _textureMappingType;
    float _borderLeft;
    float _borderRight;
    float _borderTop;
    float _borderBottom;
    BOOL _mapCenter;
}

- (id)initWithSize:(struct _NSSize)fp8 layerName:(id)fp16;
- (void)dealloc;
- (CDAnonymousStruct1)_textureLayerInfo;
- (void)setTextureMappingType:(int)fp8;
- (void)setBorderTextureMappingInsetLeft:(float)fp8 right:(float)fp12 top:(float)fp16 bottom:(float)fp20;
- (int)textureMappingType;
- (void)setMapCenter:(BOOL)fp8;
- (void)clearContext;
- (void)updateBuffer;
- (void)draw;
- (void)_renderBorder:(struct _CGLContextObject *)fp8;
- (void)renderTexture:(struct _CGLContextObject *)fp8;

@end

@interface OpenGLColorLayer : OpenGLLayer
{
    float _bottomColor[4];
    float _topColor[4];
}

- (id)initWithFrame:(struct _NSRect)fp8 layerName:(id)fp24;
- (id)initWithFrame:(struct _NSRect)fp8 layerName:(id)fp24 red:(float)fp28 green:(float)fp32 blue:(float)fp36 alpha:(float)fp40;
- (void)setRed:(float)fp8 green:(float)fp12 blue:(float)fp16 alpha:(float)fp20;
- (void)setWhite:(float)fp8 alpha:(float)fp12;
- (void)setAlpha:(float)fp8;
- (void)setBottomRed:(float)fp8 green:(float)fp12 blue:(float)fp16 alpha:(float)fp20;
- (void)setTopRed:(float)fp8 green:(float)fp12 blue:(float)fp16 alpha:(float)fp20;
- (void)setBottomWhite:(float)fp8 topWhite:(float)fp12;
- (void)compositeLayer:(struct _CGLContextObject *)fp8;

@end

@interface OpenGLCoreVideoLayer : OpenGLLayer <FrameListener>
{
    BOOL _isRegisteredListener;
    NSString *_videoSourceName;
    Texture *_texture;
    BOOL _mirrored;
    float _blackTint;
    NSOpenGLContext *_frameReaderContext;
    CIContext *_frameReaderCIContext;
    FrameReader *_frameReader;
}

- (void)ensureRegisteredListener:(BOOL)fp8;
- (id)initWithFrame:(struct _NSRect)fp8 layerName:(id)fp24 videoSource:(id)fp28;
- (void)dealloc;
- (void)frameNotifier:(id)fp8 postedNewFrame:(id)fp12 fromSource:(id)fp16;
- (void)_setLayerModel:(id)fp8;
- (void)setTexture:(id)fp8;
- (id)texture;
- (void)textureDidChange;
- (void)setBlackTint:(float)fp8;
- (float)blackTint;
- (void)setMirrored:(BOOL)fp8;
- (BOOL)isMirrored;
- (void)compositeTexture:(struct _CGLContextObject *)fp8;
- (void)compositeLayer:(struct _CGLContextObject *)fp8;
- (id)bitmapFromLayer;
- (float)sceneBrightness;

@end

@interface OpenGLFullScreenController : NSObject
{
    FullScreenWindow *_fullScreenWindow;
    VideoConferenceLayerView *_vcLayerView;
    OpenGLLayerModel *_layerModel;
    NSView *_originalVCLayerViewContainer;
    struct _NSRect _originalVCLayerViewFrame;
    float _originalVCLayerWidth;
    VideoChatController *_videoChatController;
    BOOL _conferenceEnding;
    double _totalGammaFadeTime;
}

- (BOOL)_checkScreen:(id)fp8;
- (id)initWithVideoChatController:(id)fp8;
- (void)dealloc;
- (id)videoChatController;
- (void)handleAppWillResignActiveApplication:(id)fp8;
- (void)windowDidResignMain:(id)fp8;
- (void)_installVCLayerView;
- (void)setupFullScreenDisplay;
- (void)shutDownFullScreenDisplay;
- (id)window;
- (void)setConferenceEnding:(BOOL)fp8;
- (float)originalVCLayerWidth;
- (BOOL)fullScreenWindow:(id)fp8 keyDown:(id)fp12;
- (void)toggleFullScreen:(id)fp8;
- (void)toggleMute:(id)fp8;
- (void)togglePause:(id)fp8;
- (void)toggleHideLocalVideo:(id)fp8;
- (void)toggleRecording:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)copy:(id)fp8;

@end

@interface OpenGLImageLayer : OpenGLTextureLayer
{
    NSBitmapImageRep *_bitmap;
    NSString *_imageName;
    BOOL _alphaBorder;
    NSMutableDictionary *_savedBitmaps;
    float _texCoords[8];
    float _borderLeft;
    float _borderRight;
    float _borderTop;
    float _borderBottom;
    BOOL _mapCenter;
}

- (void)_updateTexCoords;
- (id)_bitmapFromImage:(id)fp8;
- (void)_setBitmap:(id)fp8;
- (id)initWithImage:(id)fp8 named:(id)fp12 alphaBorder:(BOOL)fp16 layerName:(id)fp20;
- (id)initWithImageNamed:(id)fp8 alphaBorder:(BOOL)fp12 layerName:(id)fp16;
- (void)dealloc;
- (BOOL)hasAlphaBorder;
- (CDAnonymousStruct1)_textureLayerInfo;
- (void)setImageToImage:(id)fp8 named:(id)fp12;
- (void)setImageToImageNamed:(id)fp8;
- (void)setTextureBorderLeft:(float)fp8 right:(float)fp12 top:(float)fp16 bottom:(float)fp20 mapCenter:(BOOL)fp24;
- (void)setTextureBorder:(float)fp8 mapCenter:(BOOL)fp12;
- (void)clearTextureBorders;
- (void)_renderBorder:(struct _CGLContextObject *)fp8;
- (void)renderTexture:(struct _CGLContextObject *)fp8;

@end

@interface OpenGLLayerModel : NSObject
{
    NSMutableArray *_remoteLayers;
    OpenGLVideoConferenceLayer *_localLayer;
    NSMutableArray *_floatingLayers;
    OpenGLNSViewLayer *_dropLayer;
    OpenGLLayerView *_layerView;
    float _scaleFactor;
    BOOL _needsDisplay;
    BOOL _theatricalLayout;
    int _sideshowMode;
    BOOL _needsToUpdateProjection;
    CDAnonymousStruct5 _projection;
    float _preferredAspectRatio;
    BOOL _localLayerHidden;
    int _localLayerSuppressed;
    struct _NSSize _standardVideoSize;
    void *_layoutStart;
    void *_layoutEnd;
}

+ (void)initialize;
- (id)init;
- (void)dealloc;
- (void)setLayerView:(id)fp8;
- (id)layerView;
- (void)setNeedsDisplay;
- (BOOL)needsDisplay;
- (void)addRemoteLayer:(id)fp8 atIndex:(unsigned int)fp12;
- (void)addFloatingLayer:(id)fp8;
- (id)floatingLayerWithName:(id)fp8;
- (void)_fadeInDropView:(BOOL)fp8;
- (void)addVCDropView:(id)fp8;
- (void)setLocalLayer:(id)fp8;
- (id)remoteLayer;
- (id)remoteLayers;
- (id)remoteLayerWithVCPartyID:(id)fp8;
- (id)sideshowLayerWithVCPartyID:(id)fp8;
- (id)localLayer;
- (id)vcDropView;
- (id)layers;
- (void)_positionLayerWithVCPartyID:(id)fp8 atIndex:(unsigned int)fp12 remoteLayersCount:(unsigned int)fp16;
- (void)positionRemoteParticipants:(id)fp8;
- (void)removeLocalLayer;
- (void)removeRemoteLayer:(id)fp8;
- (void)removeFloatingLayer:(id)fp8;
- (void)removeVCDropView;
- (void)_setLocalLayerHidden:(BOOL)fp8;
- (BOOL)_isLocalLayerHidden;
- (void)suppressLocalLayer:(BOOL)fp8;
- (float)scaleFactor;
- (void)_getTransforms:(CDAnonymousStruct8 *)fp8 count:(int)fp12 forLayoutForLayers:(int)fp16 extraIndex:(int)fp20 ofWidth:(float)fp24 sideshowMode:(int)fp28;
- (void)updateTheatricalLayoutForBoundsSize:(struct _NSSize)fp8;
- (void)_getCameraHeight:(float *)fp8 distance:(float *)fp12 forLayers:(int)fp16 ofWidth:(float)fp20 sideshowMode:(int)fp24;
- (void)_getProjection:(CDAnonymousStruct5 *)fp8 forLayers:(int)fp12 ofSize:(struct _NSSize)fp16 sideshowMode:(int)fp24;
- (void)_adjustFrustum:(float *)fp8 toAspectRatio:(float)fp12 clipProjection:(BOOL)fp16;
- (void)_updateProjection;
- (void)setTheatricalLayout:(BOOL)fp8;
- (BOOL)theatricalLayout;
- (void)setSideshowMode:(int)fp8;
- (int)sideshowMode;
- (void)setStandardVideoSize:(struct _NSSize)fp8;
- (struct _NSSize)standardVideoSize;
- (float)preferredAspectRatio;
- (float)_preferredAspectRatioForLayers:(int)fp8 sideshowMode:(int)fp12;
- (float)preferredAspectRatioForLayers:(int)fp8;
- (struct _NSSize)boundsSizeForRemoteLayers:(int)fp8 ofWidth:(float)fp12;
- (struct _NSSize)boundsSizeForRemoteLayers:(int)fp8 ofWidth:(float)fp12 sideshowMode:(int)fp16;
- (struct _NSSize)sizeForRemoteLayers:(int)fp8 inBoundsSize:(struct _NSSize)fp12 sideshowMode:(int)fp20;
- (struct _NSSize)sizeForRemoteLayers:(int)fp8 inBoundsSize:(struct _NSSize)fp12;
- (void)_setupCameraTheatrical:(BOOL)fp8 ctx:(struct _CGLContextObject *)fp12;
- (void)compositeAllLayers:(struct _CGLContextObject *)fp8;
- (void)compositeFloatingLayers:(struct _CGLContextObject *)fp8;
- (CDAnonymousStruct4 *)_saveLayoutForLayers:(int)fp8 extraIndex:(int)fp12 inBoundsSize:(struct _NSSize)fp16 sideshowMode:(int)fp24;
- (void)saveLayoutFor:(int)fp8 inBounds:(struct _NSSize)fp12 transitionTo:(int)fp20 inBounds:(struct _NSSize)fp24 extraIndex:(int)fp32 sideshowMode:(int)fp36;
- (void)_getTweenLayout:(CDAnonymousStruct4 *)fp8 progress:(float)fp12;
- (void)tweenLayoutWithProgress:(float)fp8;
- (void)endLayoutTransitionAsTheatrical:(BOOL)fp8 fullScreen:(BOOL)fp12;
- (void)updateVCQuads;
- (int)layerAtPoint:(struct _NSPoint)fp8 inCloseButton:(char *)fp16;

@end

@interface OpenGLNSViewLayer : OpenGLTextureLayer
{
    OpenGLNSViewLayerWindow *_window;
    NSView *_view;
    BOOL _alphaBorder;
    BOOL _projectsOrtho;
}

- (float)scaleFactor;
- (void)_updateLayout;
- (void)setLayerSize:(struct _NSSize)fp8;
- (void)setProjectsOrtho:(BOOL)fp8;
- (BOOL)projectsOrtho;
- (void)recursiveCompositeLayer:(struct _CGLContextObject *)fp8;
- (id)initWithView:(id)fp8 alphaBorder:(BOOL)fp12 layerName:(id)fp16;
- (void)dealloc;
- (id)view;
- (CDAnonymousStruct1)_textureLayerInfo;
- (void)_cleanupAfterRetexture:(void *)fp8;

@end

@interface OpenGLNSViewLayer (VCLayoutControllExtensions)
- (id)_initLabelWithStringValue:(id)fp8 fontSize:(float)fp12 lineBreakMode:(unsigned int)fp16 layerName:(id)fp20;
@end

@interface OpenGLNSViewLayerWindow : NSWindow
{
    OpenGLNSViewLayer *_owner;
}

- (void)setOwner:(id)fp8;
- (void)setViewsNeedDisplay:(BOOL)fp8;

@end

@interface OpenGLVideoConferenceLayer : OpenGLCoreVideoLayer
{
    BOOL _hasFirstFrame;
    NSString *_vcPartyID;
    BOOL _isLocal;
    BOOL _isSideshow;
    BOOL _isReplacement;
    BOOL _anamorphicScaling;
    int _videoAppearance;
    BOOL _hasDropHighlight;
    BOOL _hasReflection;
    BOOL _spotlightEffect;
    BOOL _shouldFadeOutSpotlight;
    NSDate *_spotlightFadeoutStart;
    float _endedFadeoutProgress;
    float _translationX;
    float _translationZ;
    float _rotationY;
    float _scaleXY;
    BOOL _allowsJaggies;
    float _jaggiesSmoothingBrightness;
    CDAnonymousStruct6 _layerQuad;
    CDAnonymousStruct6 _closeQuad;
    OpenGLNSViewLayer *_bannerSublayer;
    OpenGLImageLayer *_closeButtonSublayer;
}

- (id)initWithSize:(struct _NSSize)fp8 layerName:(id)fp16 vcPartyID:(id)fp20 appearance:(int)fp24 isLocal:(BOOL)fp28 isSideshow:(BOOL)fp32 isReplacement:(BOOL)fp36;
- (void)dealloc;
- (void)setTexture:(id)fp8;
- (void)textureDidChange;
- (id)vcPartyID;
- (BOOL)isLocal;
- (BOOL)isSideshow;
- (void)freezeFrame;
- (void)addBannerSublayer:(id)fp8;
- (id)bannerSublayer;
- (void)addCloseButtonSublayer:(id)fp8;
- (id)closeButtonSublayer;
- (BOOL)removeSublayer:(id)fp8;
- (void)fadeToBlack:(BOOL)fp8 overTime:(double)fp12;
- (id)_createAppeanceLayer:(BOOL)fp8;
- (void)setVideoAppearance:(int)fp8;
- (int)videoAppearance;
- (void)compositeTexture:(struct _CGLContextObject *)fp8;
- (void)setTranslationX:(float)fp8 z:(float)fp12;
- (void)getTranslationX:(float *)fp8 z:(float *)fp12;
- (void)setRotationY:(float)fp8;
- (float)rotationY;
- (void)setScaleXY:(float)fp8;
- (float)scaleXY;
- (void)clearTransforms;
- (void)setHasDropHighlight:(BOOL)fp8;
- (BOOL)hasDropHighlight;
- (void)setHasReflection:(BOOL)fp8;
- (BOOL)hasReflection;
- (void)_removeSpotlight;
- (void)setSpotlightEffect:(BOOL)fp8;
- (BOOL)hasSpotlightEffect;
- (void)setShouldFadeOutSpotlight;
- (void)setAllowsJaggies:(BOOL)fp8;
- (BOOL)allowsJaggies;
- (void)_applyTransforms:(struct _CGLContextObject *)fp8;
- (CDAnonymousStruct6)_project:(double *)fp8 model:(double *)fp12 viewport:(int *)fp16 rect:(struct _NSRect)fp20 isOrtho:(BOOL)fp36;
- (struct _NSRect)_projectLayerFrame:(double *)fp8 ctx:(struct _CGLContextObject *)fp12;
- (void)projectVCQuads:(double *)fp8 ctx:(struct _CGLContextObject *)fp12;
- (void)isPoint:(struct _NSPoint)fp8 inLayer:(char *)fp16 inCloseButton:(char *)fp20;
- (void)_renderReflectionFadeout:(struct _CGLContextObject *)fp8;
- (void)_renderSpotlightWithFrame:(struct _NSRect)fp8 ctx:(struct _CGLContextObject *)fp24;
- (void)_smoothJaggies:(struct _CGLContextObject *)fp8;
- (void)_renderTheaterOutline:(struct _NSRect)fp8 ctx:(struct _CGLContextObject *)fp24;
- (void)_renderDropHighlight:(struct _CGLContextObject *)fp8;
- (void)compositeLayer:(struct _CGLContextObject *)fp8;
- (void)_projectOrtho:(struct _NSSize)fp8 modelYTranslation:(float)fp16 ctx:(struct _CGLContextObject *)fp20;
- (void)recursiveCompositeLayer:(struct _CGLContextObject *)fp8;

@end

@interface OptionalScrollView : NSScrollView
{
}

- (void)reflectScrolledClipView:(id)fp8;
- (void)_doScroller:(id)fp8;

@end

@interface ParentalControls : NSObject
{
    BOOL _active;
    BOOL _disableAV;
    BOOL _disableAimService;
    BOOL _forceAimWhitelist;
    NSMutableSet *_aimWhitelist;
    BOOL _disableSubnetService;
    BOOL _forceSubnetWhitelist;
    NSMutableSet *_subnetWhitelist;
    BOOL _disableJabberService;
    BOOL _forceJabberWhitelist;
    NSMutableSet *_jabberWhitelist;
    BOOL _forceChatLogging;
    BOOL _shouldPostNotifications;
}

+ (id)objectForKey:(id)fp8;
+ (id)standardControls;
- (void)_updateParentalSettings;
- (id)init;
- (void)_managedPrefsNotification:(id)fp8;
- (BOOL)okToConnectAccount:(id)fp8;
- (BOOL)accountIsEnabled:(id)fp8;
- (BOOL)accountHasWhitelist:(id)fp8;
- (BOOL)active;
- (BOOL)disableAV;
- (BOOL)forceChatLogging;
- (BOOL)disableAimService;
- (BOOL)forceAimWhitelist;
- (id)aimWhitelist;
- (BOOL)disableSubnetService;
- (BOOL)forceSubnetWhitelist;
- (id)subnetWhitelist;
- (BOOL)disableJabberService;
- (BOOL)forceJabberWhitelist;
- (id)jabberWhitelist;
- (void)setShouldPostNotifications:(BOOL)fp8;

@end

@interface People : NSObject
{
    NSMutableArray *_people;
    BOOL _dirty;
    int _coalesceCount;
    BOOL _hidePeople;
    Class _personClass;
}

- (id)init;
- (void)dealloc;
- (void)setPersonClass:(Class)fp8;
- (BOOL)dirty;
- (void)setDirty:(BOOL)fp8;
- (BOOL)hidePeople;
- (void)setShouldHidePeople:(BOOL)fp8;
- (void)saveChanges;
- (void)removeNotificationObserver:(id)fp8;
- (void)addNotificationObserver:(id)fp8 selector:(SEL)fp12;
- (int)count;
- (BOOL)containsPresentity:(id)fp8;
- (id)presentityWithEmail:(id)fp8;
- (id)groups;
- (id)people;
- (void)_countChanged;
- (void)postNotificationNamed:(id)fp8 presentity:(id)fp12;
- (void)addedPresentity:(id)fp8;
- (void)_addedPeople:(id)fp8;
- (void)removedPresentity:(id)fp8;
- (void)beginCoalescedChanges;
- (void)endCoalescedChanges;
- (BOOL)coalescingChanges;
- (BOOL)addPresentity:(id)fp8;
- (BOOL)removePresentity:(id)fp8;
- (BOOL)removePeopleFromArray:(id)fp8;
- (BOOL)addPeopleFromArray:(id)fp8 skipMe:(BOOL)fp12;
- (BOOL)addPeopleFromArray:(id)fp8;

@end

@interface People (Actions)
+ (void)_postNoCommonServicesForPeople:(id)fp8;
+ (id)bestPresentitiesForPeople:(id)fp8 commonServices:(id)fp12 requireOnline:(BOOL)fp16;
+ (id)bestPresentitiesForPeople:(id)fp8 requireOnline:(BOOL)fp12;
+ (id)bestPresentitiesForPeople:(id)fp8;
+ (BOOL)allPeopleOnline:(id)fp8;
+ (BOOL)allPeopleOffline:(id)fp8;
+ (BOOL)_allPeople:(id)fp8 haveCapability:(unsigned long long)fp12 skipUnknown:(BOOL)fp20 rejectOffline:(BOOL)fp24;
+ (BOOL)allPeopleCanReceiveIMs:(id)fp8;
+ (BOOL)allPeopleCanReceiveDirectIMs:(id)fp8;
+ (BOOL)allPeople:(id)fp8 haveCapability:(unsigned long long)fp12;
+ (BOOL)allPeopleCanReceiveFiles:(id)fp8;
+ (BOOL)allPeopleCanChat:(id)fp8;
+ (id)servicesForPresentity:(id)fp8;
+ (id)commonServicesForPeople:(id)fp8;
+ (BOOL)allPeople:(id)fp8 canBeOnService:(id)fp12;
+ (BOOL)allPeopleCanBeSecure:(id)fp8;
+ (BOOL)allPeopleHaveEMailAddresses:(id)fp8;
+ (int)_allPeople:(id)fp8 canConferenceWithVideo:(BOOL)fp12 ardCap:(unsigned long long)fp16 minRequirement:(int)fp24;
+ (BOOL)allPeopleCanTwoWayVideoChat:(id)fp8;
+ (BOOL)allPeopleCanTwoWayAudioChat:(id)fp8;
+ (int)_allPeopleCanJoinVideoChat:(id)fp8;
+ (BOOL)allPeopleCanJoinVideoChat:(id)fp8;
+ (int)_allPeopleCanJoinAudioChat:(id)fp8;
+ (BOOL)allPeopleCanJoinAudioChat:(id)fp8;
+ (BOOL)allPeopleCanBeRecorded:(id)fp8;
+ (BOOL)allPeopleCanBeARDClient:(id)fp8;
+ (BOOL)allPeopleCanBeARDServer:(id)fp8;
+ (BOOL)personCanMultiwayAudioChat:(id)fp8;
+ (BOOL)personCanMultiwayVideoChat:(id)fp8;
+ (BOOL)validateMenuItem:(id)fp8 forPeople:(id)fp12;
+ (BOOL)_verifyAllPeopleAreOnline:(id)fp8;
+ (BOOL)doDefaultActionForPeople:(id)fp8;
+ (id)_sendMessageToPeople:(id)fp8 style:(int)fp12;
+ (BOOL)allPeopleHaveMobileNumbers:(id)fp8;
+ (id)sendSMSToPresentity:(id)fp8;
+ (id)sendMessageToPresentity:(id)fp8;
+ (id)sendMessageToPeople:(id)fp8;
+ (id)startChatWithPeople:(id)fp8;
+ (BOOL)allPeopleHaveCommonService:(id)fp8 postWarning:(BOOL)fp12;
+ (id)startVideoChatWithPeople:(id)fp8;
+ (id)startAudioChatWithPeople:(id)fp8;
+ (id)startARDClientChatWithPeople:(id)fp8;
+ (id)startARDServerChatWithPeople:(id)fp8;
+ (BOOL)searchInSpotlightWithPeople:(id)fp8;
+ (id)sendDirectMessageToPeople:(id)fp8;
+ (void)_blockSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
+ (BOOL)blockPersonWithPresentity:(id)fp8 inWindow:(id)fp12;
+ (BOOL)sendFileToPeople:(id)fp8 inWindow:(id)fp12;
+ (BOOL)composeEMailToPeople:(id)fp8;
+ (BOOL)openMailtoURLWithAddresses:(id)fp8;
+ (void)setDesiredChatFrame:(struct _NSRect)fp8;
+ (struct _NSRect)desiredChatFrame;
+ (void)retitleAddBuddyItem:(id)fp8 forPresentity:(id)fp12;
@end

@interface People (BuddyListPeople)
- (void)presentity:(id)fp8 buddyStatusChanged:(BOOL)fp12;
@end

@interface PeopleCollection : People
{
    NSMutableArray *_collectedPeople;
}

- (id)init;
- (void)dealloc;
- (void)addPeople:(id)fp8;
- (void)_collectionNotification:(id)fp8;
- (void)removePeople:(id)fp8;
- (id)people;
- (id)groups;
- (BOOL)containsPerson:(id)fp8;

@end

@interface PeopleList : NSObject <DirectlyObservableObjectObserver>
{
    NSMutableDictionary *_buddyPictureIndexLookup;
    BOOL _hideOfflinePeople;
    NSMutableArray *_peopleListItems;
    NSMutableArray *_peopleListGroups;
    OfflinePeopleListGroup *_offlineGroup;
    AnimatingTableView *_table;
    NSMenu *_contextualMenu;
    NSMenuItem *_showProfileMenuItem;
    id <PeopleListDelegate> _delegate;
    PresenceTooltip *_tooltip;
    BOOL _awokenFromNib;
    NSTableColumn *_statusColumn;
    NSTableColumn *_nameColumn;
    NSTableColumn *_pictureColumn;
    int _viewOptions;
    NSMutableSet *_savedSelection;
    BOOL _allowsPresentitySubstitution;
    BOOL _arrangesByGroup;
    BOOL _showsUnknownStatus;
    BOOL _usesOfflineGroup;
    BOOL _allowsGroupOrdering;
    NSMutableArray *_items;
    NSString *_collapsedGroupsPrefKey;
    NSArray *_groupsOrdering;
    NSTimer *_statusTransitionTimer;
    NSMutableSet *_itemsInTransition;
    int _coalesceCount;
    int _primarySort;
    int _secondarySort;
    BOOL _sortManually;
    NSString *_sortDefaultKey;
    BOOL _pendingResort;
    BOOL _suppressingAnimation;
    NSMutableSet *_statusChangeQueue;
    NSMutableSet *_groupChangeQueue;
    NSMutableDictionary *_changeQueuePreviousStatuses;
    BOOL _willForceChangeProcessing;
    BOOL _dontAnimateStatusQueue;
    BOOL _animateWhenEnded;
    BOOL _separateServices;
    NSMutableArray *_itemsToCleanup;
}

+ (id)_notificationNames;
+ (id)_notificationSelectors;
+ (id)peoplePasteboardTypes;
+ (id)_typeFromPasteboard:(id)fp8;
+ (BOOL)pasteboardContainsPeople:(id)fp8;
- (id)init;
- (void)_configureTableColumns;
- (void)_cleanUpItemsAndGroups;
- (void)dealloc;
- (void)awakeFromNib;
- (void)detachFromTableView;
- (void)_unobservePeopleListItem:(id)fp8;
- (void)_observePeopleListItem:(id)fp8;
- (void)_peopleListItemNeedsUpdating:(id)fp8;
- (void)_peopleListItemNeedsSorting:(id)fp8;
- (void)_peopleListItemSortOrderChangedNotification:(id)fp8;
- (void)_peopleListItemNeedsGroupChange:(id)fp8;
- (void)_peopleListItemAnimationStateChanged:(id)fp8;
- (void)objectDidPostDirectNotification:(id)fp8;
- (BOOL)peopleListItem:(id)fp8 canTransitionToStatus:(unsigned int)fp12;
- (void)_customColorChangedForPresentity:(id)fp8;
- (void)setShowPresentityColorHint:(BOOL)fp8;
- (void)setSeparateServices:(BOOL)fp8;
- (BOOL)separateServices;
- (id)table;
- (id)delegate;
- (void)setDelegate:(id)fp8;
- (void)setAllowsPresentitySubstitution:(BOOL)fp8;
- (BOOL)allowsPresentitySubstitution;
- (void)setArrangesByGroup:(BOOL)fp8;
- (BOOL)arrangesByGroup;
- (void)setShowsUnknownStatus:(BOOL)fp8;
- (BOOL)showsUnknownStatus;
- (void)setShowsOfflinePeople:(BOOL)fp8;
- (BOOL)showsOfflinePeople;
- (void)setUsesOfflineGroup:(BOOL)fp8;
- (BOOL)usesOfflineGroup;
- (void)setCollapsedGroupsPrefKey:(id)fp8;
- (id)collapsedGroupsPrefKey;
- (id)contextualMenu;
- (BOOL)_isOfflineGroup:(id)fp8;
- (id)_groupsForPresentity:(id)fp8 inItem:(id)fp12;
- (void)_updateGroupPreferences;
- (unsigned int)_indexOfGroup:(id)fp8 startingAtIndex:(int)fp12;
- (struct _NSRange)_rangeOfGroupAndItems:(id)fp8 startingAtIndex:(unsigned int)fp12;
- (BOOL)containsGroup:(id)fp8;
- (void)_addGroup:(id)fp8;
- (void)addGroup:(id)fp8;
- (void)_removeGroup:(id)fp8;
- (void)removeGroup:(id)fp8;
- (id)peopleListGroupSortOrder;
- (void)setGroups:(id)fp8;
- (id)groupForNewPresentities;
- (unsigned int)_visibleIndexOfPresentity:(id)fp8 startingAtIndex:(int)fp12;
- (unsigned int)_visibleIndexOfItem:(id)fp8 startingAtIndex:(int)fp12;
- (int)numberOfPresentities;
- (BOOL)containsPresentity:(id)fp8;
- (BOOL)isPresentityVisible:(id)fp8;
- (id)representedPeopleInGroup:(id)fp8;
- (id)peopleInGroup:(id)fp8;
- (void)selectPresentities:(id)fp8;
- (id)allPresentities;
- (BOOL)peopleListItemIsInOfflineGroup:(id)fp8;
- (BOOL)_peopleListItem:(id)fp8 shouldBeInGroup:(id)fp12;
- (BOOL)_peopleListItemShouldBeShown:(id)fp8 inGroup:(id)fp12;
- (void)_refreshContents;
- (void)_rebuildItems;
- (BOOL)_addPresentity:(id)fp8 toCollection:(id)fp12 usingOrphanItems:(id)fp16;
- (void)_pulsePresentity:(id)fp8 inCollection:(id)fp12;
- (void)pulsePresentity:(id)fp8;
- (void)pulsePresentities:(id)fp8;
- (void)addPresentity:(id)fp8;
- (void)addPeopleFromArray:(id)fp8 skipMe:(BOOL)fp12;
- (void)addPeopleFromArray:(id)fp8;
- (id)_removePresentity:(id)fp8 fromPeopleListItem:(id)fp12;
- (void)_removePresentity:(id)fp8 fromPeopleListGroup:(id)fp12;
- (void)removePresentity:(id)fp8 fromGroups:(id)fp12;
- (void)removePresentity:(id)fp8 fromGroup:(id)fp12;
- (void)removePresentity:(id)fp8;
- (void)removeAllPresentities;
- (void)removeAllPresentitiesAndGroups:(BOOL)fp8;
- (void)_repopulatePresentity:(id)fp8 filterGroups:(BOOL)fp12;
- (void)repopulatePresentity:(id)fp8;
- (id)presentityAtRow:(int)fp8;
- (id)selectedPresentities;
- (id)presentityForObjectValue:(id)fp8;
- (void)_rememberSelection;
- (void)_restoreSelection;
- (void)beginChangesNoAnimation;
- (void)beginChanges;
- (void)endChanges;
- (BOOL)makingChanges;
- (BOOL)_sortsByStatus;
- (BOOL)_sortsByName;
- (void)setAllowsGroupOrdering:(BOOL)fp8;
- (BOOL)allowsGroupOrdering;
- (void)setPreferCustomSort:(BOOL)fp8;
- (BOOL)preferCustomSort;
- (CDAnonymousStruct7)_sortParameters;
- (void)_resortNow;
- (void)_resort;
- (void)_postResortNotification;
- (void)resort;
- (void)setSortOrder:(int)fp8;
- (void)setSortOrder:(int)fp8 secondary:(int)fp12;
- (int)sortOrder;
- (int)secondarySortOrder;
- (void)setSortDefaultKey:(id)fp8;
- (id)sortDefaultKey;
- (void)setSortOrderFromDefaults;
- (void)saveSortOrderToDefaultsAndNotify:(BOOL)fp8;
- (void)_setPeopleListItemNeedsDisplay:(id)fp8;
- (void)setPresentityNeedsDisplay:(id)fp8;
- (void)_stopTransitions;
- (void)_animateTransitions:(id)fp8;
- (void)_endAnimationSuppression;
- (void)suppressAnimation;
- (void)_needsDrawFromAnimate:(id)fp8;
- (void)_processPresentityForGroupChange:(id)fp8;
- (void)_processGroupChangeQueue;
- (void)_processStatusChangeQueue;
- (void)_processStatusChangeQueueUnforced;
- (void)_processStatusChangeQueueForced;
- (void)_buddyPropertiesDone:(id)fp8;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (id)tableView:(id)fp8 objectValueForRow:(int)fp12;
- (void)tableView:(id)fp8 willDisplayCell:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (float)alphaForItem:(id)fp8 throbs:(int)fp12;
- (id)displayNameForItem:(id)fp8;
- (id)displayStatusForItem:(id)fp8;
- (BOOL)tableView:(id)fp8 shouldStartDraggingForGroupRow:(int)fp12;
- (void)tableView:(id)fp8 dragStarted:(id)fp12 originPoint:(struct _NSPoint)fp16;
- (BOOL)_mouseInButtons:(id)fp8;
- (BOOL)tableView:(id)fp8 acceptsFirstMouse:(id)fp12;
- (BOOL)tableView:(id)fp8 canDeleteRows:(id)fp12;
- (void)tableView:(id)fp8 performDragOperation:(unsigned int)fp12 withPasteboard:(id)fp16;
- (BOOL)tableView:(id)fp8 deleteRows:(id)fp12;
- (id)_peopleToAddFromABPerson:(id)fp8 isOK:(char *)fp12;
- (void)_getPresentities:(id *)fp8 andGroups:(id *)fp12 fromPasteboard:(id)fp16 allowDuplicates:(BOOL)fp20;
- (id)peopleFromPasteboard:(id)fp8 addToAB:(BOOL)fp12 notAddablePeople:(id *)fp16;
- (id)tableView:(id)fp8 typeSelectStringForTableColumn:(id)fp12 row:(int)fp16;
- (id)_propertyListForPresentities:(id)fp8 inGroup:(id)fp12;
- (id)_presentityPropertyListArrayForRows:(id)fp8;
- (BOOL)tableView:(id)fp8 writeRows:(id)fp12 toPasteboard:(id)fp16;
- (void)_setDropGroup:(id)fp8;
- (unsigned int)tableView:(id)fp8 validateDrop:(id)fp12 proposedRow:(int)fp16 proposedDropOperation:(unsigned int)fp20;
- (void)_warnPeopleNoValidIMAddresses:(id)fp8;
- (BOOL)tableView:(id)fp8 acceptDrop:(id)fp12 row:(int)fp16 dropOperation:(unsigned int)fp20;
- (BOOL)tableView:(id)fp8 canPasteFromPasteboard:(id)fp12;
- (BOOL)tableView:(id)fp8 pasteFromPasteboard:(id)fp12;
- (id)tableView:(id)fp8 tooltipForRow:(int)fp12;
- (BOOL)tableView:(id)fp8 prepareTooltip:(id)fp12 row:(int)fp16;
- (BOOL)tableView:(id)fp8 shouldShowTooltipForRow:(int)fp12;
- (struct _NSRect)_vcRectOfRow:(int)fp8;
- (BOOL)tableView:(id)fp8 shouldDrawWhenMovingFrom:(struct _NSPoint)fp12 toPoint:(struct _NSPoint)fp20;
- (void)refreshTracking;
- (void)_updateLayout;
- (void)setHides:(int)fp8;
- (void)setHides:(int)fp8 to:(BOOL)fp12;
- (void)toggleHides:(int)fp8;
- (BOOL)hides:(int)fp8;
- (float)widthToFitContent;
- (void)_statusIndicatorDidChange:(id)fp8;
- (BOOL)tableView:(id)fp8 groupRowAtIndex:(int)fp12;
- (unsigned int)tableView:(id)fp8 groupRowGreaterThanIndex:(unsigned int)fp12;
- (id)tableView:(id)fp8 titleForGroupRow:(int)fp12;
- (id)tableView:(id)fp8 numberStringForGroupRow:(int)fp12 ignoreCollapsed:(BOOL)fp16;
- (void)groupClicked:(id)fp8;
- (void)showContextMenuForPeopleListItem:(id)fp8;
- (void)tableView:(id)fp8 groupRowClicked:(int)fp12;
- (id)tableView:(id)fp8 menuForGroupRow:(int)fp12;
- (BOOL)tableView:(id)fp8 shouldSelectRow:(int)fp12;
- (void)tableView:(id)fp8 returnKeyPressedAtRow:(int)fp12;
- (void)doDefaultAction:(id)fp8;
- (void)sendMessage:(id)fp8;
- (void)requestValidation:(id)fp8;
- (void)sendDirectMessage:(id)fp8;
- (void)startChat:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)sendSMS:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)searchInSpotlight:(id)fp8;
- (void)sendFile:(id)fp8;
- (void)block:(id)fp8;
- (void)_showSelectedInfo:(BOOL)fp8;
- (void)showSelectedBuddyInfo:(id)fp8;
- (void)showSelectedBuddyProfile:(id)fp8;
- (void)showInAddressBook:(id)fp8;
- (void)openStatusAsURL:(id)fp8;
- (void)toggleArrangesByGroup:(id)fp8;
- (void)toggleUsesOfflineGroup:(id)fp8;
- (void)toggleShowsOfflines:(id)fp8;
- (BOOL)validateAction:(SEL)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)refreshList;

@end

@interface PeopleListController : NSWindowController <PeopleListDelegate>
{
    AbstractAccount *_representedAccount;
    PeopleList *_peopleList;
    NSMutableArray *_addBuffer;
    StatusController *_myStatusController;
    BOOL _showAll;
    BOOL _windowHasLoaded;
    NSMenu *_groupContextualMenu;
    NSString *_groupForContextualMenu;
    NSString *_name;
    NSString *_prefIdentifier;
    NSView *_statusArea;
    NSView *_listContainer;
    struct _NSSize _minContentSize;
    struct _NSSize _maxContentSize;
    MenuButton *_addButton;
    NSSegmentedControl *_buddyListButtons;
    MyPictureControl *_myPicture;
    MyNameControl *_myName;
    MyStatusControl *_myStatus;
    NSButton *_getInfoButton;
    NSButton *_myVCButton;
    BOOL _buttonIsVideo;
    int _myVCButtonTrackingRectTag;
    NSScrollView *_scrollView;
    BOOL _willRefresh;
    NSToolbar *_toolbar;
    NSToolbarItem *_statusToolbarItem;
    People *_sourcePeople;
    BOOL _supportsOfflineToggle;
    BOOL _supportsGroups;
    BOOL _supportsEditing;
    BOOL _supportsChild;
}

+ (id)peopleListControllerWithRepresentedAccount:(id)fp8;
+ (id)peopleListControllers;
+ (id)_allPreferenceKeys;
+ (id)_preferenceKeysToImport;
+ (id)_tigerPrefNameForAccount:(id)fp8;
+ (id)defaultUncollapsedFrameNameForAccount:(id)fp8;
+ (BOOL)_existingPeopleListControllerFrameCollidesWithFrame:(struct _NSRect)fp8 skipController:(id)fp24;
- (id)initWithAccount:(id)fp8;
- (id)initWithName:(id)fp8 prefIdentifier:(id)fp12;
- (void)removeFromList;
- (void)dealloc;
- (void)_setupAddButtonTooltip;
- (void)_importPrefsFromTiger;
- (void)windowDidLoad;
- (void)clearPreferences;
- (void)_fixGradientForCollapsed;
- (void)_fixGradient;
- (void)_configureUIForAccount;
- (void)_accountCapsChanged:(id)fp8;
- (void)_accountInfoChanged:(id)fp8;
- (void)_refreshTargetedNotifications;
- (id)representedAccount;
- (id)representedAccounts;
- (void)setRepresentedAccounts:(id)fp8;
- (void)setSourcePeople:(id)fp8;
- (void)setRepresentedAccount:(id)fp8;
- (BOOL)representsService:(id)fp8;
- (BOOL)representsAccount:(id)fp8;
- (void)setName:(id)fp8;
- (id)name;
- (void)setPrefIdentifier:(id)fp8;
- (id)prefIdentifier;
- (BOOL)prefVisible;
- (void)setPrefVisible:(BOOL)fp8;
- (id)peopleList;
- (id)sourcePeople;
- (id)pictureControl;
- (void)showWindow:(id)fp8;
- (void)enableWindow:(BOOL)fp8 quietly:(BOOL)fp12;
- (void)enableWindow:(BOOL)fp8;
- (void)_layoutInteriorViews;
- (void)displayWithKey:(BOOL)fp8;
- (void)displayWithoutKey;
- (void)displayIfPrefVisible;
- (void)display;
- (void)hide;
- (BOOL)isVisible;
- (BOOL)windowShouldClose:(id)fp8;
- (void)windowDidBecomeMain:(id)fp8;
- (void)windowDidResignMain:(id)fp8;
- (BOOL)addBuddy:(id)fp8 withWindow:(id)fp12;
- (id)addBuddy;
- (void)addABuddy:(id)fp8;
- (id)propertiesForGroup:(id)fp8;
- (id)peopleList:(id)fp8 siblingsForPresentity:(id)fp12;
- (id)peopleList:(id)fp8 addablePeople:(id)fp12;
- (void)addPresentity:(id)fp8;
- (void)_flushBuffer;
- (void)addWhitelistedNotInBuddyListSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (BOOL)peopleList:(id)fp8 canRemoveRows:(id)fp12;
- (BOOL)_deleteBuddies:(id)fp8;
- (void)pulsePresentity:(id)fp8;
- (void)_deleteSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_confirmDeletionOfPeople:(id)fp8 withContextInfo:(id)fp12;
- (BOOL)peopleList:(id)fp8 deletePeople:(id)fp12;
- (void)deleteSelectedBuddies:(id)fp8;
- (BOOL)containsPresentity:(id)fp8;
- (void)parentalSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)addAGroup:(id)fp8;
- (void)editGroups:(id)fp8;
- (void)renameGroup:(id)fp8;
- (void)startIMToGroup:(id)fp8;
- (void)inviteGroupToChat:(id)fp8;
- (void)deleteGroup:(id)fp8;
- (void)peopleList:(id)fp8 deleteGroup:(id)fp12;
- (BOOL)wantsSortedGroups;
- (void)setGroupsSortOrder:(id)fp8;
- (void)peopleList:(id)fp8 setGroupsSortOrder:(id)fp12;
- (id)groups;
- (id)groupsWithCapability:(id)fp8;
- (id)reorderableGroups;
- (void)_serviceGroupsChanged:(id)fp8;
- (void)_arrangesByGroupChanged;
- (id)groupsToAddTo;
- (BOOL)_doAddPeople:(id)fp8 toGroups:(id)fp12;
- (BOOL)peopleList:(id)fp8 pastePeople:(id)fp12 intoGroup:(id)fp16;
- (id)_presentitiesFromPeople:(id)fp8 inGroups:(id)fp12;
- (BOOL)peopleList:(id)fp8 people:(id)fp12 draggedFromGroups:(id)fp16 toGroup:(id)fp20 atLocation:(int)fp24 copying:(BOOL)fp28;
- (void)personABPersonChanged:(id)fp8;
- (void)_accountLoaded:(id)fp8;
- (void)_multiSessionSheedDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_accountLoginStatusChanged:(id)fp8;
- (void)refreshList;
- (void)_refreshList;
- (void)buddyListChanged:(id)fp8;
- (id)_myVCImage:(int)fp8 forState:(int)fp12;
- (void)_updateVCButtonRollover;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (BOOL)_setupVCButtonAsVideo:(BOOL)fp8 force:(BOOL)fp12;
- (BOOL)_addVCButtonIsVideo:(BOOL)fp8;
- (BOOL)_setVCButtonIsVideo:(BOOL)fp8;
- (BOOL)_updateVCButton;
- (void)_adjustWidgetsToTable:(BOOL)fp8;
- (void)_adjustWidgetsToTable;
- (void)_adjustWidgetsSoon:(id)fp8;
- (void)tableDidResize:(id)fp8;
- (BOOL)windowShouldZoom:(id)fp8 toFrame:(struct _NSRect)fp12;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (BOOL)isTableCollapsed;
- (void)collapseTableAnimated:(BOOL)fp8;
- (void)uncollapseTableAnimated:(BOOL)fp8;
- (void)setTableCollapsed:(BOOL)fp8 animate:(BOOL)fp12;
- (id)identifiedPref:(id)fp8 forIdentifier:(id)fp12;
- (id)identifiedPref:(id)fp8;
- (float)peopleList:(id)fp8 alphaForStatus:(unsigned int)fp12;
- (id)peopleList:(id)fp8 alternateNameTextForPresentity:(id)fp12;
- (id)peopleList:(id)fp8 alternateStatusTextForPresentity:(id)fp12;
- (id)peopleList:(id)fp8 filterPresentityFromPasteboard:(id)fp12;
- (BOOL)peopleList:(id)fp8 addPersonWithoutID:(id)fp12;
- (id)peopleList:(id)fp8 menuForGroup:(id)fp12;
- (void)peopleListSelectedItemInfoChanged:(id)fp8;
- (BOOL)supportsChild;
- (BOOL)supportsEditing;
- (BOOL)supportsGroups;
- (BOOL)supportsOfflineToggle;
- (void)screenSharingInviteSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)buddyListButtonsAction:(id)fp8;
- (void)sortManually:(id)fp8;
- (void)sortByStatus:(id)fp8;
- (void)sortByFirstName:(id)fp8;
- (void)sortByLastName:(id)fp8;
- (void)toggleHidePictures:(id)fp8;
- (void)toggleHideAudioStatus:(id)fp8;
- (void)toggleHideVideoStatus:(id)fp8;
- (void)toggleShowOfflines:(id)fp8;
- (void)toggleArrangesByGroup:(id)fp8;
- (void)toggleUsesOfflineGroup:(id)fp8;
- (void)personDoubleClicked:(id)fp8;
- (void)changeBuddyPicture:(id)fp8;
- (void)sendMessage:(id)fp8;
- (void)sendDirectMessage:(id)fp8;
- (void)startChat:(id)fp8;
- (void)inviteToAudioChat:(id)fp8;
- (void)inviteToVideoChat:(id)fp8;
- (void)inviteToARDAsClient:(id)fp8;
- (void)inviteToARDAsServer:(id)fp8;
- (void)composeEMail:(id)fp8;
- (void)sendSMS:(id)fp8;
- (void)sendFile:(id)fp8;
- (void)block:(id)fp8;
- (void)requestValidation:(id)fp8;
- (void)showInAddressBook:(id)fp8;
- (void)openStatusAsURL:(id)fp8;
- (void)showSelectedBuddyInfo:(id)fp8;
- (void)showSelectedBuddyProfile:(id)fp8;
- (BOOL)anythingConnected;
- (void)logServiceInOrOut:(id)fp8;
//- (BOOL)validateMenuItem:(id)fp8;
- (BOOL)validateMenuItem:(NSMenuItem *)sender;
- (void)tableViewSelectionDidChange:(id)fp8;
- (void)editMessageForCurrentStatus;
- (void)_savePosition;
- (void)windowDidMove:(id)fp8;
- (void)_fixBottomBorderThickness;
- (void)windowDidResize:(id)fp8;
- (void)windowWillClose:(id)fp8;

@end

@interface PeopleListControllerWindow : NSWindow
{
}

- (double)animationResizeTime:(struct _NSRect)fp8;

@end

@interface PeopleListItem : DirectlyObservableObject <NSCopying, DirectlyObservableObjectObserver>
{
    BOOL _isGroup;
    BuddyListPresence *_presence;
    NSDate *_whenStatusChanged;
    PeopleListGroup *_group;
    NSAttributedString *_attributedStatusMessage;
    NSDate *_transitionStartTime;
    BOOL _inTransition;
    float _currentTransitionTime;
    unsigned int _currentStatus;
    unsigned int _previousStatus;
    NSString *_statusMessage;
    NSString *_displayName;
    int _minutesIdle;
    id _delegate;
}

+ (id)notifications;
+ (id)selectors;
+ (id)displayNameForString:(id)fp8;
+ (id)displayStatusMessageForString:(id)fp8;
- (id)initWithBuddyListPresence:(id)fp8 inGroup:(id)fp12;
- (id)initAsGroup:(id)fp8;
- (void)dealloc;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (BOOL)isEqual:(id)fp8;
- (id)description;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (void)_postNotificationNamed:(id)fp8 userInfo:(id)fp12;
- (void)_observePresence:(id)fp8;
- (void)_unobservePresence:(id)fp8;
- (void)setBuddyListPresence:(id)fp8;
- (id)buddyListPresence;
- (void)_presenceInfoChanged:(id)fp8;
- (void)_presenceSortOrderChanged:(id)fp8;
- (void)_presenceCapabilitiesChanged:(id)fp8;
- (void)_presenceStatusChanged:(id)fp8;
- (void)_presencePictureChanged:(id)fp8;
- (void)_presenceGroupsChanged:(id)fp8;
- (void)_presenceMobileChanged:(id)fp8;
- (void)_presenceCertsChanged:(id)fp8;
- (void)objectDidPostDirectNotification:(id)fp8;
- (void)_cacheCurrentState;
- (BOOL)_currentInfoDiffersFromCache;
- (BOOL)_currentStatusDiffersFromCache;
- (id)peopleListGroup;
- (void)setPeopleListGroup:(id)fp8;
- (id)group;
- (BOOL)isGroup;
- (BOOL)isPresentity;
- (id)presentity;
- (id)displayName;
- (id)tooltipString;
- (void)_setWhenStatusChanged:(id)fp8;
- (BOOL)_updateCurrentStatus;
- (unsigned int)previousStatus;
- (unsigned int)currentStatus;
- (unsigned int)effectiveStatus;
- (double)timeSinceStatusChanged;
- (BOOL)canTransition;
- (BOOL)inStatusTransition;
- (void)_startAnimationPusling:(BOOL)fp8;
- (void)_startStatusTransition;
- (void)_startPulse;
- (BOOL)isPulseTransition;
- (void)startPulse;
- (void)stopTransition;
- (float)transitionPhase:(float)fp8;
- (float)transitionAlphaTo:(float)fp8 from:(float)fp12 throbs:(int)fp16;
- (int)_comparePresentitiesWith:(id)fp8 withSortParameters:(CDAnonymousStruct7 *)fp12;
- (int)compare:(id)fp8 withSortParameters:(CDAnonymousStruct7 *)fp12;
- (void)clearAttributedStatusMessageCache;
- (id)displayStatusMessage;
- (unsigned int)sortOrder;

@end

@interface PeopleListItem (AccessibilityAdditions)
- (id)accessibilityActionNames;
- (id)accessibilityActionDescription:(id)fp8;
- (void)accessibilityPerformAction:(id)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityTitleAttribute;
- (id)accessibilityValueAttribute;
@end

@interface PeoplePicker : NSObject
{
    ABUIController *_uiController;
    Service *_service;
    ABPeoplePickerView *_peoplePicker;
    NSView *_titleView;
    BOOL _alwaysPost;
}

- (id)init;
- (void)awakeFromNib;
- (void)dealloc;
- (void)setPeopleDoubleClickTarget:(id)fp8 andAction:(SEL)fp12;
- (void)enableMultiplePeopleSelection:(BOOL)fp8;
- (void)setAllowedServices:(id)fp8;
- (void)setAllowsAccountSelection:(BOOL)fp8;
- (void)setService:(id)fp8;
- (void)setAlwaysPosts:(BOOL)fp8;
- (void)_postChangedNotificationNamed:(id)fp8;
- (void)_postChangedNotification;
- (void)groupDidChange:(id)fp8;
- (void)nameDidChange:(id)fp8;
- (void)valueDidChange:(id)fp8;
- (void)propertyDidChange:(id)fp8;
- (id)displayedProperty;
- (id)selectedRecords;
- (id)selectedValues;
- (id)selectedPerson;
- (void)openInAddressBook:(id)fp8;
- (void)editInAddressBook:(id)fp8;
- (void)selectABPerson:(id)fp8 andPresentity:(id)fp12;
- (void)selectABPerson:(id)fp8;
- (void)selectABPerson:(id)fp8 andValue:(id)fp12;
- (void)personSelected:(id)fp8;

@end

@interface Person : Presence
{
    ABPerson *_abPerson;
}

- (void)setABPerson:(id)fp8;
- (id)abPerson;

@end

@interface PhoneNumberFormatter : NSFormatter
{
}

+ (id)numbersSet;
+ (id)nonNumbersSet;
+ (BOOL)getObjectValue:(id *)fp8 forString:(id)fp12 errorDescription:(id *)fp16;
+ (id)stringForObjectValue:(id)fp8;
+ (id)smsNumberStringFromString:(id)fp8;
- (BOOL)getObjectValue:(id *)fp8 forString:(id)fp12 errorDescription:(id *)fp16;
- (id)stringForObjectValue:(id)fp8;

@end

@interface PlainTextNode : NullNode
{
    NSMutableString *_text;
}

- (id)init;
- (id)initWithInitialText:(id)fp8;
- (void)dealloc;
- (void)addText:(id)fp8;
- (id)text;

@end

@interface Prefs : NSObject
{
}

+ (void)copyPreference:(id)fp8 toKey:(id)fp12;
+ (void)clearPreferenceForKey:(id)fp8;
+ (BOOL)boolForKey:(id)fp8 defaultValue:(BOOL)fp12;
+ (int)integerForKey:(id)fp8 defaultValue:(int)fp12;
+ (float)floatForKey:(id)fp8 defaultValue:(float)fp12;
+ (double)doubleForKey:(id)fp8 defaultValue:(double)fp12;
+ (id)arrayForKey:(id)fp8;
+ (void)readBuddyListSettings:(CDAnonymousStruct2 *)fp8 fromDict:(id)fp12;
+ (id)dictFromBuddyListSettings:(const CDAnonymousStruct2 *)fp8;
+ (void)setArray:(id)fp8 forKey:(id)fp12;
+ (void)setInteger:(int)fp8 forKey:(id)fp12;
+ (void)setBool:(BOOL)fp8 forKey:(id)fp12;
+ (void)setString:(id)fp8 forKey:(id)fp12;
+ (id)stringForKey:(id)fp8 defaultValue:(id)fp12;
+ (int)nameStyle;
+ (void)setNameStyle:(int)fp8;
+ (BOOL)loginAtSystemLogin;
+ (void)setLoginAtSystemLogin:(BOOL)fp8;
+ (BOOL)offlineOnQuit;
+ (void)setOfflineOnQuit:(BOOL)fp8;
+ (int)fastUserSwitchAction;
+ (void)setFastUserSwitchAction:(int)fp8;
+ (BOOL)usingABPicture;
+ (void)setUsingABPicture:(BOOL)fp8;
+ (int)numberOfCustomMessagesToRemember;
+ (void)setNumberOfCustomMessagesToRemember:(int)fp8;
+ (BOOL)knockKnock;
+ (void)setKnockKnock:(BOOL)fp8;
+ (BOOL)showMyLoginIdInBuddyList;
+ (void)setShowMyLoginIdInBuddyList:(BOOL)fp8;
+ (BOOL)fileTransferManagerShouldBeVisible;
+ (void)setFileTransferManagerShouldBeVisible:(BOOL)fp8;
+ (BOOL)animateBuddyIcons;
+ (void)setAnimateBuddyIcons:(BOOL)fp8;
+ (id)chatBookmarks;
+ (void)_setChatBookmarks:(id)fp8;
+ (BOOL)hasBookmarkForRoom:(id)fp8 onAccountID:(id)fp12;
+ (id)chatBookmarksForAccountID:(id)fp8;
+ (void)removeBookmarkAtIndex:(int)fp8;
+ (void)addBookmarkForRoom:(id)fp8 account:(id)fp12;
+ (void)removeBookmarkForRoom:(id)fp8 account:(id)fp12;
+ (void)setJoinAtLaunch:(BOOL)fp8 roomName:(id)fp12 accountID:(id)fp16;
+ (BOOL)shouldJoinRoomNameAtLaunch:(id)fp8 accountID:(id)fp12;
+ (BOOL)addressMeInGroupchat;
+ (void)setAddressMeInGroupchat:(BOOL)fp8;
+ (BOOL)autosaveChats;
+ (void)setAutosaveChats:(BOOL)fp8;
+ (BOOL)alwaysShowRecipientBar;
+ (void)setAlwaysShowRecipientBar:(BOOL)fp8;
+ (BOOL)persistChats;
+ (void)setPersistChats:(BOOL)fp8;
+ (id)savedChatPath;
+ (void)setSavedChatPath:(id)fp8;
+ (id)downloadPath;
+ (void)setDownloadPath:(id)fp8;
+ (BOOL)menuExtraIsVisible;
+ (long)setMenuExtraIsVisible:(BOOL)fp8;

@end

@interface PrefsBlockingTableView : NSTableView
{
}

- (void)textDidEndEditing:(id)fp8;

@end

@interface Prefs_Accounts : NSPreferencesModule
{
    GatherValidCertificates *_signingThread;
    GatherValidCertificates *_encryptionThread;
    AbstractAccount *_loadedAccount;
    AbstractAccount *_creationAccount;
    NSString *_loadedID;
    NSArray *_signCerts;
    NSArray *_encrCerts;
    struct OpaqueSecCertificateRef *_signCert;
    struct OpaqueSecCertificateRef *_encrCert;
    int _nextRowToSelect;
    NSButton *_configureMobileButton;
    NSTextField *_accountText;
    NSTableView *_serviceTable;
    NSButton *addButton;
    NSButton *removeButton;
    NSTabView *_servicesTab;
    NSTabView *aimTabView;
    NSButton *enableAIMCheckbox;
    NSButton *aimRecentBuddies;
    NSButton *aimAutoLogin;
    NSButton *aimMultiSession;
    NSPopUpButton *typePulldown;
    NSTabView *buttonTabView;
    ExtendedTextField *aimDescription;
    NSTextField *screenNameLabel;
    ExtendedTextField *aimScreenname;
    NSButton *aimUseSSL;
    NSImageView *aimLoginArrow;
    NSSecureTextField *aimPassword;
    NSTabViewItem *aimSecurityTabItem;
    NSTabView *secureImTab;
    NSButton *blockAddressesCheckbox;
    NSButton *blockIdleCheckbox;
    NSTextField *blockingInfoLabel;
    NSMatrix *blockingModeMatrix;
    BlockListController *blockListController;
    NSButton *editAllowListButton;
    NSButton *editBlockListButton;
    NSProgressIndicator *_secureSpinner;
    NSTextField *encryptionActionText;
    NSButton *encryptionActionButton;
    NSTextField *signingPopUpLabel;
    NSPopUpButton *signingPopUp;
    NSTextField *encryptionPopupLabel;
    NSPopUpButton *encryptionPopUp;
    NSView *_encryptionView;
    NSTabViewItem *aimServerSettingsTabItem;
    ExtendedTextField *aimServer;
    ExtendedTextField *aimPort;
    NSButton *useProxyCheckbox;
    NSButton *useSystemPrefsProxyCheckbox;
    ExtendedTextField *proxyHostField;
    ExtendedTextField *proxyPortField;
    NSPopUpButton *proxyProtocolPulldown;
    ExtendedTextField *proxyUsernameField;
    NSSecureTextField *proxyPasswordField;
    NSButton *useDefaultAIMServerSettingsButton;
    NSTabView *jabberTabView;
    NSButton *enableJabberCheckbox;
    NSButton *jabberAutoLogin;
    ExtendedTextField *jabberDescription;
    ExtendedTextField *jabberNameField;
    NSImageView *jabberLoginArrow;
    NSSecureTextField *jabberPasswordField;
    NSTabViewItem *jabberServerSettingsTabItem;
    ExtendedTextField *jabberHostName;
    ExtendedTextField *jabberPort;
    NSButton *jabberUseSSL;
    NSButton *_jabberAllowClearText;
    NSTextField *jabberResource;
    NSButton *jabberUseMachineName;
    NSButton *useDefaultJabberServerSettingsButton;
    NSButton *jabberUseKerberos5;
    NSButton *jabberAutoDiscoverHostAndPort;
    NSTabView *rendezvousTabView;
    NSButton *enableSubnetCheckbox;
    NSButton *rendezvousBlockIdle;
    NSButton *rendezvousAutoLogin;
    NSButton *sendTextAsType;
    NSTextField *subnetBlurbField;
}

+ (void)_enableSubnetSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (id)imageForPreferenceNamed:(id)fp8;
- (void)createAIMScreenName:(id)fp8;
- (void)createDotMac:(id)fp8;
- (void)configureMobile:(id)fp8;
- (void)_syncAIMTypes;
- (void)_updateAIMType;
- (void)_loadAIMAccount:(id)fp8;
- (void)_loadJabberAccount:(id)fp8;
- (void)_loadRendezvousAccount:(id)fp8;
- (void)loadAccount:(id)fp8;
- (void)_activeAccountChanged:(id)fp8;
- (void)_serviceEnablementChanged:(id)fp8;
- (void)_windowLostFocus:(id)fp8;
- (void)_windowBecameMain:(id)fp8;
- (void)_dotMacCertifiabilityDetermined:(id)fp8;
- (void)_addressBookChanged:(id)fp8;
- (void)_accountLoginStatusChanged:(id)fp8;
- (void)_accountDoubleClicked:(id)fp8;
- (void)_accountChanged:(id)fp8;
- (void)awakeFromNib;
- (id)init;
- (void)_releaseCerts;
- (void)dealloc;
- (BOOL)isResizable;
- (void)tabView:(id)fp8 didSelectTabViewItem:(id)fp12;
- (void)updateServiceTable:(id)fp8;
- (void)accountSelectionChanged:(id)fp8;
- (void)_managedPrefsChanged:(id)fp8;
- (void)selectAccount:(id)fp8;
- (void)useDefaultServerSettings:(id)fp8;
- (void)useDefaultJabberSettings:(id)fp8;
- (id)viewForPreferenceNamed:(id)fp8;
- (void)willBeDisplayed;
- (void)initializeFromDefaults;
- (BOOL)moduleCanBeRemoved;
- (BOOL)preferencesWindowShouldClose;
- (void)saveChanges;
- (void)selectFirstActiveAccount;
- (void)selectFirstAccountOfClass:(Class)fp8;
- (void)selectFirstAccountOfClass:(Class)fp8 needsActive:(BOOL)fp12;
- (void)setupComplete:(id)fp8;
- (void)addAccount:(id)fp8;
- (void)changeAutoLoginSetting:(id)fp8;
- (void)changeMultiSession:(id)fp8;
- (void)removeAccount:(id)fp8;
- (void)addDotMacAccount:(id)fp8;
- (void)addNewAccountOfClass:(Class)fp8;
- (void)addAIMAccount:(id)fp8;
- (void)addJabberAccount:(id)fp8;
- (void)showHelp:(id)fp8;
- (void)_askToChangePasswordDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_askToLoginDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_deleteSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_changeLoginSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_askToLoginAccount:(id)fp8;
- (void)_warnLongPassword:(id)fp8;
- (void)_warnInvalidHost:(id)fp8;
- (void)_warnInvalidPort:(id)fp8;
- (void)_warnNoLogin:(id)fp8;
- (void)_warnRemoveAccount:(id)fp8;
- (void)_warnSwitchingToAccount:(id)fp8;
- (void)logInAccount:(id)fp8;
- (void)logOutAccount:(id)fp8;
- (void)_updateAIMInvalidArrows;
- (void)_updateAIMPrivacyUI;
- (void)_updateAIMProxyStates;
- (void)_updateAIMDescription;
- (void)_updateAIMActive;
- (void)_updateAIMState;
- (void)_loadAIMPassword;
- (void)aimRecentBuddies:(id)fp8;
- (void)aimDescription:(id)fp8;
- (void)aimUseSSL:(id)fp8;
- (void)aimScreenname:(id)fp8;
- (void)aimType:(id)fp8;
- (void)aimPassword:(id)fp8;
- (void)aimServer:(id)fp8;
- (void)aimProxyServer:(id)fp8;
- (void)aimPort:(id)fp8;
- (void)aimProxyPort:(id)fp8;
- (void)aimProxyUser:(id)fp8;
- (void)aimIdle:(id)fp8;
- (void)aimProxyType:(id)fp8;
- (void)aimProxyPassword:(id)fp8;
- (void)_endProxyEditingStates;
- (void)aimProxy:(id)fp8;
- (void)aimSystemProxy:(id)fp8;
- (void)changeEnableAIM:(id)fp8;
- (id)_addCertificate:(struct OpaqueSecCertificateRef *)fp8 toMenu:(id)fp12;
- (void)_updateCertPopUp:(id)fp8 forCerts:(id)fp12 selected:(struct OpaqueSecCertificateRef *)fp16 tag:(int)fp20;
- (void)gatherValidCertificates:(id)fp8 screenName:(id)fp12 finishedWithCertificates:(id)fp16;
- (void)_stopEncryptionThreads;
- (void)_updateCertificates;
- (void)certificateChanged:(id)fp8;
- (void)_updateSecureIM;
- (void)_startSpinner;
- (void)secureImSignup:(id)fp8;
- (void)_secureImChanged:(BOOL)fp8;
- (void)secureImEnable:(id)fp8;
- (void)secureImDisable:(id)fp8;
- (void)_encryptionActionForAccount:(id)fp8;
- (void)_dropBadDotMacPassword;
- (void)_dropCouldNotContactDotMacSheet;
- (void)_dropExpiredSheet;
- (void)_dropEncryptIncapableSheet;
- (void)_forgotPassword:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_encryptionIncapableSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_accountExpiredSheet:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_updateJabberDescription;
- (void)_updateJabberHost;
- (void)_updateJabberInvalidArrows;
- (void)_updateJabberActive;
- (void)_updateJabberState;
- (void)jabberUseKerberos5:(id)fp8;
- (void)jabberAutoDiscoverHostAndPort:(id)fp8;
- (void)_updateJabberSSLStates;
- (void)_loadJabberPassword;
- (void)jabberDescription:(id)fp8;
- (void)jabberID:(id)fp8;
- (void)jabberPort:(id)fp8;
- (void)jabberSSL:(id)fp8;
- (void)jabberAllowClearText:(id)fp8;
- (void)jabberUseMachineName:(id)fp8;
- (void)jabberServer:(id)fp8;
- (void)jabberResource:(id)fp8;
- (void)jabberPriority:(id)fp8;
- (void)jabberPassword:(id)fp8;
- (void)changeEnableJabber:(id)fp8;
- (void)rendezvousBlockIdle:(id)fp8;
- (void)rendezvousPublish:(id)fp8;
- (void)rendezvousSendTextAsIType:(id)fp8;
- (void)_updateRendezvousActive;
- (void)_updateRendezvousState;
- (void)changeEnableSubnet:(id)fp8;
- (void)updateBottomText;

@end

@interface Prefs_Actions : NSPreferencesModule
{
    ActionsController *_actionsController;
    NSImageView *_lowVolume;
    NSImageView *_highVolume;
}

- (id)imageForPreferenceNamed:(id)fp8;
- (void)awakeFromNib;
- (BOOL)isResizable;
- (id)viewForPreferenceNamed:(id)fp8;
- (BOOL)hasChangesPending;
- (void)saveChanges;
- (void)actionsControllerChanged:(id)fp8;
- (void)willBeDisplayed;
- (BOOL)preferencesWindowShouldClose;
- (void)moduleWillBeRemoved;
- (void)showHelp:(id)fp8;

@end

@interface Prefs_BuddyList : NSPreferencesModule
{
}

- (id)viewForPreferenceNamed:(id)fp8;

@end

@interface Prefs_Camera : NSPreferencesModule
{
    CollapseView *cameraCollapseView;
    NSPopUpButton *cameraPulldownMenu;
    CollapseView *micCollapseView;
    NSPopUpButton *micPulldownMenu;
    CollapseView *soundOutputDeviceCollapseView;
    NSPopUpButton *soundOutputDevicePulldownMenu;
    CollapseView *pairHeadsetCollapseView;
    NSButton *pairHeadsetButton;
    NSTabView *cameraTabView;
    CameraPreferencesView *cameraView;
    NSExtendedBox *noCameraBox;
    NSTextField *noCameraTextField;
    CollapseView *volumeCollapseView;
    VolumeIndicator *volumeIndicator;
    CollapseView *lightingCollapseView;
    NSPopUpButton *bandwidthPulldownMenu;
    NSButton *launchOnCameraCheckbox;
    NSButton *repeatedRingCheckbox;
    BOOL stayingOnVideoPrefs;
    BOOL videoPrefsWindowWasClosed;
    BOOL didCancel;
    BOOL autoselectBTMic;
    BOOL autoselectBTOutput;
}

- (void)dealloc;
- (BOOL)isResizable;
- (id)viewForPreferenceNamed:(id)fp8;
- (void)saveChanges;
- (void)willBeDisplayed;
- (void)moduleWasInstalled;
- (void)moduleWillBeRemoved;
- (void)_updateUIElement:(int)fp8 animate:(BOOL)fp12;
- (id)_noneStr;
- (int)_updateDeviceList:(id)fp8 name:(id)fp12 popUp:(id)fp16;
- (int)_updateCameraList;
- (int)_updateMicList;
- (int)_updateSoundOutputDeviceList;
- (void)_startStopAV;
- (void)_prefsChangedNotification:(id)fp8;
- (void)changeCamera:(id)fp8;
- (void)changeMicrophone:(id)fp8;
- (void)changeSoundOutputDevice:(id)fp8;
- (void)_setBandwidth:(unsigned int)fp8;
- (void)changeBandwidth:(id)fp8;
- (void)changeLaunchOnCamera:(id)fp8;
- (void)changeRepeatedRing:(id)fp8;
- (void)pairHeadset:(id)fp8;
- (void)showHelp:(id)fp8;
- (void)privateResizeHack;
- (void)setStayingOnVideoPrefs:(BOOL)fp8;
- (BOOL)videoPrefsWindowWasClosed;
- (void)setVideoPrefsWindowWasClosed:(BOOL)fp8;
- (void)setDidCancel:(BOOL)fp8;

@end

@interface Prefs_General : NSPreferencesModule
{
    DefaultApplicationPopUpButton *defaultIMClientPopup;
    NSButton *showStatusMenuCheckbox;
    NSButton *offlineOnQuitCheckbox;
    NSButton *loginAtSystemLogin;
    NSButton *persistentChats;
    NSButton *useShapeForStatusCheckbox;
    NSMatrix *welcomeBackMode;
    NSButton *autoReplyCheckbox;
    NSButton *autoAwayCheckbox;
    NSButton *autoAwayTimeField;
    NSButton *animateBuddyIcons;
    NSButton *_confirmSend;
    NSPopUpButton *downloadPathPopupButton;
    NSPopUpButton *fastUserSwitchPopup;
    CollapseView *fusCollapseView;
}

- (id)imageForPreferenceNamed:(id)fp8;
- (void)awakeFromNib;
- (void)dealloc;
- (BOOL)isResizable;
- (id)viewForPreferenceNamed:(id)fp8;
- (void)_updateStatusMenuControls:(id)fp8;
- (void)initializeFromDefaults;
- (void)saveChanges;
- (void)changeLoginAtSystemLogin:(id)fp8;
- (void)changeAnimateBuddyIcons:(id)fp8;
- (void)changeOfflineOnQuit:(id)fp8;
- (void)changeShowFezStatus:(id)fp8;
- (void)changeUseShapesForStates:(id)fp8;
- (void)changeWelcomeBackMode:(id)fp8;
- (void)changeAutoReply:(id)fp8;
- (void)changeAutoAway:(id)fp8;
- (void)confirmSendSelected:(id)fp8;
- (void)changeAutoAwayTime:(id)fp8;
- (void)changeFastUserSwitchPopup:(id)fp8;
- (void)changeDownloadPath:(id)fp8;
- (void)_pathChosen:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_setupDownloadPathMenu;
- (void)showHelp:(id)fp8;

@end

@interface Prefs_MsgCompose : NSPreferencesModule <ShowMessagesDelegate>
{
    NSPopUpButton *_outBalloonColorPopUp;
    NSPopUpButton *_outFontColorPopUp;
    NSPopUpButton *_inBalloonColorPopUp;
    NSPopUpButton *_inFontColorPopUp;
    NSPopUpButton *_saveChatLocation;
    NSMenuItem *_outBalloonOtherItem;
    NSMenuItem *_outFontOtherItem;
    NSMenuItem *_inBalloonRandomItem;
    NSMenuItem *_inBalloonOtherItem;
    NSMenuItem *_inFontOtherItem;
    NSView *sampleTranscript;
    ChatDOMView *_sampleTranscript;
    NSTextField *_inBalloonColorLabel;
    NSTextField *_inFontColorLabel;
    NSButton *persistentChats;
    NSButton *_overrideIncomingStyle;
    NSButton *_autosaveChats;
    NSButton *_collectChats;
    BOOL _dirty;
    NSColor *_curFgColor;
    NSColor *_curBgColor;
    NSColor *_curInFgColor;
    NSColor *_curInBgColor;
    BOOL _customOutBalloonColor;
    BOOL _customInBalloonColor;
    NSFont *_curFont;
    NSFont *_curInFont;
    BOOL _overrideSendersFormatting;
    BOOL _editingInFont;
    BOOL _editingInColor;
    BOOL _editingBgColor;
    NSButton *activateRecentShortcut;
    NSButton *_addressMeInGroupchat;
    NSComboBox *recentShortcutKeyCombo;
    NSMutableArray *_shortcutKeyItems;
    ConfigKeyEditor *_menuHotKeyFieldEditor;
}

+ (id)quickSharedInstance;
+ (id)_colorFromPref:(id)fp8;
+ (id)_sampleForFont:(id)fp8 fgColor:(id)fp12 bgColor:(id)fp16;
+ (id)samplePresentity;
- (void)awakeFromNib;
- (id)init;
- (void)dealloc;
- (BOOL)isResizable;
- (id)messageFont;
- (id)messageFgColor;
- (id)messageBgColor;
- (BOOL)overrideSendersFormatting;
- (id)messageInFont;
- (id)messageInBgColor;
- (id)messageInFgColor;
- (void)setUpMessageTextField:(id)fp8;
- (id)textFromMessageTextField:(id)fp8;
- (void)_notifyChanged;
- (void)_notifyOverrideChanged;
- (void)_notifyOverrideColorsChanged;
- (void)_notifyOverrideFontChanged;
- (void)_notifyWatchMessageAddressingChanged;
- (id)viewForPreferenceNamed:(id)fp8;
- (id)_swatchForColor:(id)fp8;
- (void)setUpColorMenu:(id)fp8;
- (void)moduleWasInstalled;
- (void)willBeDisplayed;
- (void)chatView:(id)fp8 canShowMessages:(BOOL)fp12;
- (void)setRendererFromMenuItem:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)controlTextDidCancelEditing:(id)fp8;
- (void)keyEditorFinished:(id)fp8 forTextView:(id)fp12 virtualKey:(id)fp16 modifiers:(unsigned int)fp20;
- (id)windowWillReturnFieldEditor:(id)fp8 toObject:(id)fp12;
- (void)changeActivateRecentShortcut:(id)fp8;
- (id)comboBox:(id)fp8 objectValueForItemAtIndex:(int)fp12;
- (int)numberOfItemsInComboBox:(id)fp8;
- (void)comboBoxSelectionIsChanging:(id)fp8;
- (void)comboBoxSelectionDidChange:(id)fp8;
- (unsigned int)comboBox:(id)fp8 indexOfItemWithStringValue:(id)fp12;
- (void)_setupComboBox;
- (void)_saveColor:(id)fp8 inVar:(id *)fp12 isOutgoing:(BOOL)fp16;
- (void)_setOtherColor:(id)fp8 forMenuItem:(id)fp12 inPopUp:(id)fp16;
- (void)_outBalloonColorPicked:(id)fp8;
- (void)_outFontColorPicked:(id)fp8;
- (void)_inBalloonColorPicked:(id)fp8;
- (void)_inFontColorPicked:(id)fp8;
- (id)_fontFgColor;
- (void)_setColor:(id)fp8 asFontChange:(BOOL)fp12;
- (void)overrideSelected:(id)fp8;
- (void)_updateInColorControls;
- (void)colorChanged:(id)fp8;
- (void)_selectColor:(id)fp8 inPopUp:(id)fp12;
- (void)_showSampleText;
- (void)setMessageFont:(id)fp8;
- (void)_setCurrentFont:(id)fp8;
- (id)fontBeingChanged;
- (void)_chooseAFont;
- (void)chooseOutFont:(id)fp8;
- (void)chooseInFont:(id)fp8;
- (void)addressMeInGroupChatChanged:(id)fp8;
- (void)autosaveChanged:(id)fp8;
- (void)_pathChosen:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_setupChatPathMenu;
- (void)changeSaveChatLocation:(id)fp8;
- (void)openAutosaveFolder:(id)fp8;
- (void)changePersistentChats:(id)fp8;
- (BOOL)hasChangesPending;
- (void)saveChanges;
- (void)collectChats:(id)fp8;
- (void)showHelp:(id)fp8;

@end

@interface Tooltip : NSObject
{
    NSView *_view;
    NSWindow *_window;
    BOOL _fadingIn;
    NSTimer *_animationTimer;
    NSDate *_animationStartDate;
    struct _NSPoint _previousPosition;
}

- (void)awakeFromNib;
- (id)initWithNibNamed:(id)fp8;
- (void)dealloc;
- (void)positionAtPoint:(struct _NSPoint)fp8 inView:(id)fp16;
- (void)_setAnimationStartDate;
- (void)_stopAnimationTimer;
- (void)_setAnimationTimer;
- (void)_animationStep:(id)fp8;
- (void)_finishAnimation;
- (BOOL)isAnimating;
- (void)_fadeIn:(BOOL)fp8;
- (void)open;
- (BOOL)isVisible;
- (void)close;
- (void)closeImmediately;
- (void)showWindowImmediately;
- (void)hideWindowImmediately;
- (void)cleanupAfterClose;

@end

@interface PresenceTooltip : Tooltip <DirectlyObservableObjectObserver>
{
    Presence *_presence;
    NSArray *_uniquePresentities;
    NSMutableArray *_tableText;
    ABPictureControl *_iconView;
    NSTextField *_nameField;
    NSTableView *_table;
}

- (id)_attributesForNameBold:(BOOL)fp8 disabled:(BOOL)fp12;
- (id)_attributesForStatus;
- (id)init;
- (id)_textCell;
- (void)awakeFromNib;
- (void)dealloc;
- (id)_idleStringForPresentity:(id)fp8;
- (id)_offlineStringForPresentity:(id)fp8;
- (id)_otherServiceStringForPresentity:(id)fp8;
- (void)_addTextForPresentity:(id)fp8 highlighted:(BOOL)fp12;
- (void)_updateTableText;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (void)tableView:(id)fp8 willDisplayCell:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (float)tableView:(id)fp8 heightOfRow:(int)fp12;
- (void)_updateUIWithDisplay:(BOOL)fp8;
- (void)_updateUI;
- (void)_updatePresentities;
- (void)objectDidPostDirectNotification:(id)fp8;
- (id)presence;
- (void)setPresence:(id)fp8;

@end

@interface Presentity (AVChatExtensions)
- (BOOL)hasNoConferencingCaps;
@end

@interface Presentity (AddressBook)
- (void)_registerByUID;
- (void)_unregister;
- (BOOL)dirty;
- (void)setDirty:(BOOL)fp8;
- (void)saveChanges;
- (void)addToAddressBook;
- (void)removeFromAddressBook;
- (void)abPersonChangedPictureBlocking;
- (void)sendNotificationABPersonChanged;
@end

@interface Presentity (NotificationBlocking)
- (void)stopPostingNotifications;
- (void)startPostingNotifications;
@end

@interface Presentity (Presentity_Additions)
- (id)URLForIM;
@end

@interface Presentity (QueueNotifications)
- (BOOL)shouldQueueNotifications;
- (void)beginNotificationQueue;
- (void)releaseNotificationQueue;
@end

@interface Presentity (Scripting)
- (id)uniqueId;
- (id)scriptAccountName;
- (id)scriptAccountLegacyName;
- (id)scriptName;
- (id)scriptIdleTime;
- (id)scriptStatusMessage;
- (id)scriptStatus;
- (id)scriptImage;
- (id)scriptCaps;
- (id)scriptGroups;
- (id)scriptFirstName;
- (id)scriptLastName;
- (id)scriptFullName;
- (id)scriptService;
- (id)objectSpecifier;
- (void)inviteScriptCommand:(id)fp8;
@end

@interface PresentityRegistrar : NSObject
{
    NSMutableDictionary *_siblingsMap;
}

+ (void)_initAddressBookSyncing;
+ (void)addressBookChanged:(id)fp8;
+ (id)sharedInstance;
- (oneway void)release;
- (unsigned int)retainCount;
- (id)init;
- (void)dealloc;
- (void)_emptySiblingCacheForPresentity:(id)fp8;
- (void)_buildSiblingsForPresentity:(id)fp8;
- (void)_clearSiblingsCacheForPresentity:(id)fp8 rebuildAfter:(BOOL)fp12;
- (void)registerPresentity:(id)fp8;
- (void)unregisterPresentity:(id)fp8;
- (void)clearSiblingCacheForPresentity:(id)fp8;
- (id)siblingsForPresentity:(id)fp8;
- (id)presenceForPresentity:(id)fp8;

@end

@interface ProfileContainer : NSView
{
}

- (BOOL)isFlipped;
- (void)resizeSubviewsWithOldSize:(struct _NSSize)fp8;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface ProfileTextField : NSTextField
{
}

- (void)drawRect:(struct _NSRect)fp8;

@end

@interface ProfileTextView : NSTextView
{
}

- (void)_showSelectedText:(BOOL)fp8;
- (BOOL)becomeFirstResponder;
- (BOOL)resignFirstResponder;
- (BOOL)shouldDrawInsertionPoint;
- (void)scrollWheel:(id)fp8;

@end

@interface ProfileView : NSView
{
    BuddyInfo *_owner;
    Presentity *_presentity;
    NSView *_contentView;
    NSBox *_separator;
    NSImageView *_statusGemView;
    ABPictureControl *_buddyIconView;
    NSTextField *_accountNameField;
    NSImageView *_accountTypeView;
    NSTextField *_serviceNameField;
    NSImageView *_mobileIconView;
    NSView *_textContainer;
    NSTextField *_idleField;
    NSTextField *_profileLabel;
    NSTextView *_profileText;
    NSTextField *_messageLabel;
    NSTextView *_messageText;
    NSTextField *_capsLabel;
    NSTextView *_capsText;
    NSTextField *_notesLabel;
    NSTextField *_notesText;
}

- (BOOL)textView:(id)fp8 clickedOnLink:(id)fp12 atIndex:(unsigned int)fp16;
- (void)_adjustLabel:(id)fp8 toTextView:(id)fp12;
- (float)_adjustTextView:(id)fp8 dy:(float)fp12;
- (void)_hideMessage:(BOOL)fp8;
- (void)_removeProfile;
- (void)_removeNotes;
- (void)_updateLayout:(BOOL)fp8;
- (void)setFrame:(struct _NSRect)fp8;
- (void)mouseDown:(id)fp8;
- (id)_capabilitiesText;
- (void)_updateStatus:(id)fp8;
- (void)_updateCapabilities:(id)fp8;
- (void)_updatePicture:(id)fp8;
- (void)_hideNotes:(BOOL)fp8;
- (void)_updateNotesAndSetText:(BOOL)fp8;
- (void)_updateMobile:(id)fp8;
- (void)_feedUpdatedDateChanged:(id)fp8;
- (void)_infoChanged:(id)fp8;
- (void)_extraPropsChanged:(id)fp8;
- (void)_accountStatusChanged:(id)fp8;
- (id)initWithPresentity:(id)fp8 owner:(id)fp12 saveNib:(BOOL)fp16;
- (id)presentity;
- (void)setOwner:(id)fp8;
- (void)setShowsSeparator:(BOOL)fp8;
- (void)awakeFromNib;
- (void)dealloc;
- (void)toggleBuddy:(id)fp8;
- (void)showFullSizeBuddyIcon:(id)fp8;
- (void)setNotes:(id)fp8;

@end

@interface ProgressSpinner : NSView
{
    NSColor *_tint;
    NSImage *_art;
    unsigned int _step;
}

- (void)_regenerateArt:(BOOL)fp8;
- (void)setTint:(id)fp8;
- (id)tint;
- (void)dealloc;
- (void)drawRect:(struct _NSRect)fp8;
- (void)step;

@end

@interface QCBackgroundMoviePlayer : MoviePlayer
{
    NSString *_notificationName;
}

- (id)initWithNotificationName:(id)fp8;
- (void)dealloc;
- (void)_prepareMovie;
- (void)play;
- (void)provideFrame:(struct __CVBuffer *)fp8;

@end

@interface QCComposition (VideoPipelineAdditions)
- (id)asDictionary;
@end

@interface QLTheater : NSObject
{
    NSOpenPanel *_openPanel;
    int _canShare;
    BOOL _didPositionQLPanel;
    BOOL _panelDidShowPreview;
}

+ (id)sharedQLTheater;
+ (BOOL)_openExternalClient:(id)fp8 withBundleID:(id)fp12 documentURL:(id)fp16 isiPhoto:(BOOL)fp20;
+ (BOOL)_externalClientCanOpenURLs:(id)fp8 launch:(BOOL)fp12;
+ (BOOL)_warnARDChat;
+ (void)shareFilesWithiChatTheater:(id)fp8;
+ (BOOL)canChooseDocuments;
+ (void)chooseDocuments;
+ (id)_getiPhotoURL;
+ (id)_iPhotoURL;
+ (BOOL)canChooseiPhotoAlbum;
+ (void)chooseiPhotoAlbum;
- (void)_positionPreviewPanel:(id)fp8;
- (void)_mainThreadAVStateChanged:(id)fp8;
- (void)_avStateChanged:(id)fp8;
- (void)windowWillClose:(id)fp8;
- (struct _NSSize)windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12;
- (void)previewPanel:(id)fp8 didShowPreviewForURL:(id)fp12;
- (void)_shareFilesWithiChatTheater:(id)fp8;
- (void)_updateStatusText;
- (void)_openPanelDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_chooseDocuments;
- (void)dealloc;
- (void)_checkURLs:(id)fp8 succeeded:(BOOL)fp12;
- (void)_checkURLsFailed:(id)fp8;
- (void)_checkURLsSucceeded:(id)fp8;
- (void)_checkURLs:(id)fp8;
- (void)panelSelectionDidChange:(id)fp8;

@end

@interface RawXMLNode : PlainTextNode
{
    NSString *_name;
}

- (id)initWithHeader:(id)fp8;
- (id)stripNamespaceFrom:(id)fp8;
- (id)initWithHeader:(id)fp8 initialText:(id)fp12;
- (void)dealloc;
- (id)createChild:(id)fp8;
- (void)addText:(id)fp8;
- (void)childFinished:(id)fp8;
- (void)finished;
- (id)text;

@end

@interface RecentChat : NSObject
{
    NSString *_GUID;
    NSString *_accountID;
    int _style;
    unsigned int _ardRole;
    NSString *_roomName;
    BOOL _useRoomName;
    NSArray *_participants;
    BOOL _isValid;
}

- (id)initWithChat:(id)fp8;
- (void)dealloc;
- (id)initWithDictionary:(id)fp8;
- (id)dictionaryRepresentation;
- (BOOL)isEqual:(id)fp8;
- (BOOL)isEqualToRecentChat:(id)fp8;
- (void)startChatFromMenuItem:(id)fp8;
- (void)startChat;
- (id)title;
- (int)style;
- (void)setStyle:(int)fp8;
- (unsigned int)ardRole;
- (void)setArdRole:(unsigned int)fp8;
- (id)GUID;
- (void)setGUID:(id)fp8;
- (id)participants;
- (void)setParticipants:(id)fp8;
- (void)setParticipantsFromStringArray:(id)fp8;
- (BOOL)useRoomName;
- (void)setUseRoomName:(BOOL)fp8;
- (id)roomName;
- (void)setRoomName:(id)fp8;
- (id)accountID;
- (void)setAccountID:(id)fp8;
- (BOOL)isValid;

@end

@interface RecentItemsController : NSObject
{
    NSMutableArray *_recentChats;
    NSArray *_recentDocURLs;
}

+ (id)sharedObject;
- (id)init;
- (void)retrieveRecentsFromPrefs;
- (id)recentChats;
- (void)clearMenuItem:(id)fp8;
- (void)noteRecentSavedChat:(id)fp8;
- (void)noteRecentSavedChatURL:(id)fp8;
- (void)noteRecentChat:(id)fp8;
- (int)numberOfItemsInMenu:(id)fp8;
- (BOOL)menuHasKeyEquivalent:(id)fp8 forEvent:(id)fp12 target:(id *)fp16 action:(SEL *)fp20;
- (BOOL)menu:(id)fp8 updateItem:(id)fp12 atIndex:(int)fp16 shouldCancel:(BOOL)fp20;
- (void)openFile:(id)fp8;

@end

@interface RegistrationNotificationCenter : NSNotificationCenter
{
    id _delegate;
}

- (void)dealloc;
- (void)finalize;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (void)addObserver:(id)fp8 selector:(SEL)fp12 name:(id)fp16 object:(id)fp20;
- (void)removeObserver:(id)fp8 name:(id)fp12 object:(id)fp16;

@end

@interface RendezvousAccount : AbstractAccount
{
}

+ (id)service;
+ (BOOL)isPersistent;
+ (id)defaultBuddylistDescription;
- (BOOL)canActivate;
- (BOOL)sendTextAsIType;
- (void)setSendTextAsIType:(BOOL)fp8;
- (BOOL)publishIMInformation;
- (void)setPublishIMInformation:(BOOL)fp8;
- (id)login;
- (id)uniqueID;
- (id)speechDescription;
- (id)menuItemDescription;
- (id)buddyListDescription;
- (id)name;
- (id)description;
- (BOOL)addPresentity:(id)fp8 toABPerson:(id)fp12;

@end

@interface RenewCertRequest : CertRequest
{
    BOOL _sentRequest;
}

- (void)dealloc;
- (id)initWithAccount:(id)fp8;
- (void)renewDotMacCert;
- (void)performRequest;

@end

@interface ReplaceBackgroundUILayer : OpenGLNSViewLayer
{
}

- (id)initWithLayerName:(id)fp8;
- (void)dealloc;
- (void)_replaceBackgroundMessageChanged:(id)fp8;
- (void)_adjustLayerSize;
- (void)setTextMessage:(id)fp8;
- (void)addedToSuperLayer:(id)fp8;

@end

@interface ReplaceBackgroundUIView : NSView
{
    NSDictionary *_attributes;
    NSString *_message;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (BOOL)isOpaque;
- (void)drawRect:(struct _NSRect)fp8;
- (id)textAttributes;
- (id)textMessage;
- (void)setTextMessage:(id)fp8;

@end

@interface RolloverButton (AccessibilityAdditions)
- (id)accessibilityActionNames;
- (void)accessibilityPerformAction:(id)fp8;
- (id)accessibilityFocusedUIElement;
- (id)accessibilityHitTest:(struct _NSPoint)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityAttributeValue:(id)fp8;
- (id)accessibilityRoleAttribute;
- (id)accessibilityValueAttribute;
- (BOOL)accessibilityIsIgnored;
@end

@interface SKDashboardButton : NSButton
{
    int _direction;
    NSMutableDictionary *_attr;
    int _trackingRectTag;
    BOOL _active;
    BOOL _displayCapsule;
    struct _NSRect _activeRect;
    NSString *_string;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;
- (BOOL)isOpaque;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setDirection:(int)fp8;
- (void)setIndex:(unsigned int)fp8 count:(unsigned int)fp12;
- (void)mouseUp:(id)fp8;
- (void)mouseDown:(id)fp8;
- (void)viewDidMoveToWindow;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;

@end

@interface SKDashboardButton (Private)
- (id)leftArrowPathInRect:(struct _NSRect)fp8;
- (id)rightArrowPathInRect:(struct _NSRect)fp8;
- (id)capsulePathInRect:(struct _NSRect)fp8;
- (struct _NSSize)sizeForString;
- (void)updateTrackingRect;
- (void)drawHoverTarget;
- (void)drawCapsule;
- (struct _NSRect)capsuleRectForDirection;
- (struct _NSRect)hoverRectForDirection;
- (BOOL)checkPoint:(struct _NSPoint)fp8;
@end

@interface SMSWindowController : NSWindowController
{
    ServicePopUp *_accountPopup;
    NSButton *_cancelButton;
    NSButton *_okButton;
    ExtendedTextField *_numberField;
    CollapseView *_collapseView;
}

+ (id)sharedSMSController;
+ (void)open;
+ (id)supportedCountryCodes;
+ (BOOL)canSendSMSNow;
+ (BOOL)systemSupportsSMSSending;
- (id)init;
- (void)dealloc;
- (void)windowDidLoad;
- (void)textFieldDidChange:(id)fp8;
- (void)_validateSendButton;
- (void)selectedAccountStatusChanged:(id)fp8;
- (void)selectedAccountChanged:(id)fp8;
- (void)showWindow:(id)fp8;
- (void)cancel:(id)fp8;
- (void)accept:(id)fp8;
- (void)_validateButtons;
- (void)windowWillClose:(id)fp8;
- (void)windowDidBecomeMain:(id)fp8;

@end

@interface SavedChat : Chat
{
    NSString *_spotlightSearchString;
}

+ (void)removeSavedChat:(id)fp8;
+ (void)addSavedChat:(id)fp8;
+ (id)savedChats;
+ (id)savedChatPathCreate:(BOOL)fp8;
- (void)_loadAppleEventSearchInfo;
- (id)init;
- (id)initWithTranscriptFile:(id)fp8;
- (void)dealloc;
- (id)initWithSavedData:(id)fp8;
- (BOOL)_loadFromArray:(id)fp8 metadata:(id)fp12;
- (BOOL)_load;
- (BOOL)_loadFromData:(id)fp8;
- (id)messages;
- (id)initialSearchPhrase;

@end

@interface SavedChat (PersistentChatAdditions)
- (id)persistedChatInfo;
@end

@interface ScreenSaverMonitor : NSObject
{
    NSMutableArray *_listeners;
    BOOL _screensaverActive;
    BOOL _active;
}

+ (id)sharedMonitor;
- (id)init;
- (void)dealloc;
- (void)_screenSaverStopped:(id)fp8;
- (void)_screenSaverStarted:(id)fp8;
- (void)addListener:(id)fp8;
- (void)removeListener:(id)fp8;
- (BOOL)isScreenSaverActive;
- (void)setActive:(BOOL)fp8;
- (BOOL)isActive;

@end

@interface SecureWindowTitleCell : NSTextFieldCell
{
}

- (id)initTextCell:(id)fp8;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface SelfPreviewController : NSWindowController
{
    NSExtendedBox *_vcBevel;
    CameraPreferencesView *_cameraView;
    NSTabView *_cameraTabView;
    NSExtendedBox *_noCameraBox;
    NSTextField *_noCameraTextField;
    VolumeIndicator *_volumeIndicator;
}

+ (void)showSelfPreview;
- (void)_updateUI;
- (void)_startStopAV;
- (void)_setWindowTitle;
- (void)_prefsChangedNotification:(id)fp8;
- (void)windowDidLoad;
- (void)windowWillClose:(id)fp8;
- (struct _NSSize)windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (void)copy:(id)fp8;
- (void)takeVideoSnapshot:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;

@end

@interface SendCommand : NSScriptCommand
{
}

- (id)_sendInvitation;
- (id)_sendMessage;
- (id)_sendFile;
- (id)performDefaultImplementation;

@end

@interface Service : NSObject
{
    NSDictionary *_serviceDefaults;
    NSArray *_activeAccounts;
    NSArray *_allAccounts;
    unsigned int _acceptableFormats;
    BOOL _iconChecked;
    BOOL _defaultBuddyIconChecked;
    NSImage *_icon;
    NSArray *_defaultBuddyIcons;
    NSString *_name;
    NSDictionary *_serviceProps;
    NSDictionary *_defaultSettings;
    NSArray *_defaultBuddyImages;
    unsigned int _IDSensitivity;
    BOOL _handlesChatInvites;
    NSMutableArray *_deferredInvitations;
    NSDictionary *_IDToCardMap;
}

+ (BOOL)isConnectedToDaemon;
+ (BOOL)userAccountHasBeenSetup;
+ (void)autoLoginAllServices;
+ (void)loginAllServices;
+ (void)logoutAllServices;
+ (void)disconnectFromDaemon:(BOOL)fp8;
+ (void)disconnectAllServices;
+ (id)serviceWithInternalName:(id)fp8;
+ (unsigned int)myStatus;
+ (unsigned int)_myStatus;
+ (unsigned long)myIdleTime;
+ (BOOL)_setMyStatusMessage:(id)fp8;
+ (id)myStatusMessage;
+ (id)myNowPlayingString;
+ (void)setMyStatus:(unsigned int)fp8 message:(id)fp12;
+ (void)updateMyStatus:(unsigned int)fp8 message:(id)fp12 idleSince:(id)fp16;
+ (void)_handleDaemonException:(id)fp8;
+ (id)_daemonPortName;
+ (void)_makeConnection;
+ (id)remoteDaemon;
+ (void)displayStatusText:(id)fp8;
+ (void)broadcastVCCapabilites;
+ (BOOL)_connectToDaemonQuietly:(BOOL)fp8;
+ (BOOL)connectToDaemon;
+ (BOOL)connectToDaemonQuietly;
+ (void)preventReconnect;
+ (id)allServices;
+ (id)nowPlayingFormatString;
+ (void)_cacheValue:(id)fp8 forPersistentProperty:(id)fp12;
+ (void)setValue:(id)fp8 ofPersistentProperty:(id)fp12;
+ (id)valueOfPersistentProperty:(id)fp8;
+ (void)_setBoolValue:(BOOL)fp8 ofPersistentProperty:(id)fp12;
+ (BOOL)_boolValueOfPersistentProperty:(id)fp8;
+ (void)daemonPersistentProperty:(id)fp8 changedTo:(id)fp12;
+ (void)_localObjectDiedNotification:(id)fp8;
+ (void)_remoteObjectDiedNotification:(id)fp8;
+ (void)localObjectDiedNotification:(id)fp8;
+ (void)remoteObjectDiedNotification:(id)fp8;
+ (void)sendContextRequest:(id)fp8 withProperties:(id)fp12 forGUID:(id)fp16;
+ (void)askAboutEncryptionIfNecessary;
+ (void)displayDeferredInvitations;
+ (BOOL)hasDisplayDeferredInvitations;
+ (void)setHasActiveConference:(BOOL)fp8;
+ (void)_Q8TimeoutTimerTriggered:(id)fp8;
+ (void)updateQ8Dialog:(id)fp8;
+ (void)vcMicrophoneChanged:(id)fp8;
+ (void)vcHardwareChangedBroadcastChanges:(id)fp8;
+ (void)checkForFirmwareUpdates;
+ (void)_enableSoftwareCamera;
+ (void)_disableSoftwareCamera:(id)fp8;
+ (void)_enableSoftwareMicrophone;
+ (void)_disableSoftwareMicrophone:(id)fp8;
+ (BOOL)_updateSoftwareInputForCameras:(id)fp8 mics:(id)fp12;
+ (void)vcHardwareChanged:(id)fp8 duringLaunch:(BOOL)fp12;
+ (id)_stringForCaps:(unsigned long long)fp8 mask:(unsigned long long)fp16;
+ (void)_setServiceVCCaps:(unsigned long long)fp8 toCaps:(unsigned long long)fp16;
+ (BOOL)cameraConnected;
+ (BOOL)microphoneConnected;
+ (BOOL)hasActiveConference;
+ (BOOL)canBeARDServer;
+ (BOOL)cameraCapable;
+ (BOOL)microphoneCapable;
+ (BOOL)softwareCameraEnabled;
+ (void)_setSoftwareCameraEnabled:(BOOL)fp8;
+ (BOOL)softwareMicrophoneEnabled;
+ (void)_setSoftwareMicrophoneEnabled:(BOOL)fp8;
+ (BOOL)blockMicStatus;
+ (void)setBlockMicStatus:(BOOL)fp8;
+ (BOOL)blockCameraStatus;
+ (void)setBlockCameraStatus:(BOOL)fp8;
+ (BOOL)blockARDStatus;
+ (void)setBlockARDStatus:(BOOL)fp8;
+ (BOOL)multiCapableVideo:(BOOL)fp8;
+ (BOOL)multiAudioCapable;
+ (BOOL)multiVideoCapable;
+ (void)_provideCurrentAVChatInfo:(id)fp8 result:(unsigned int)fp12 transactionID:(unsigned int)fp16;
+ (void)_currentAVChatInfoRequestedWithTransactionID:(unsigned int)fp8;
+ (void)currentAVChatInfoChanged:(id)fp8;
+ (void)_audioReflectorRequested:(BOOL)fp8 transactionID:(unsigned int)fp12;
+ (void)_videoStillForPersonRequested:(id)fp8 withTransactionID:(unsigned int)fp12;
+ (void)setAVManagerClient:(id)fp8 URLToShare:(id)fp12;
+ (void)_auxVideoReceiverChangedState:(id)fp8;
+ (BOOL)_sendStatus:(id)fp8;
+ (id)myPicture;
+ (void)setMyPicture:(id)fp8;
+ (void)pushABInformationToDaemon;
+ (id)myProfile;
+ (BOOL)setMyProfile:(id)fp8;
+ (BOOL)setStatus:(unsigned int)fp8 message:(id)fp12;
+ (void)myStatusChanged:(id)fp8;
- (BOOL)handlesChatInvites;
- (void)dealloc;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (id)canonicalFormOfID:(id)fp8;
- (BOOL)equalID:(id)fp8 andID:(id)fp12;
- (void)_handleDaemonException:(id)fp8;
- (void)setServiceProperties:(id)fp8;
- (id)initWithInternalName:(id)fp8;
- (void)_deferNotification:(id)fp8;
- (void)displayDeferredInvitations;
- (void)disconnect;
- (id)IDToCardMap;
- (void)clearIDToCardMap;
- (unsigned int)IDSensitivity;
- (id)addressBookProperty;
- (id)emailDomains;
- (id)name;
- (id)shortName;
- (id)internalName;
- (id)description;
- (id)icon;
- (int)emailDomainOfID:(id)fp8;
- (void)_loadDefaultImages;
- (id)defaultImageForID:(id)fp8;
- (id)defaultBuddyIconForID:(id)fp8;
- (unsigned int)acceptableFormats;
- (id)defaultAccountSettings;
- (void)setDefaultAccountSettings:(id)fp8;
- (void)setServiceDefaults:(id)fp8;
- (id)serviceDefaults;
- (void)writeServiceDefaults:(id)fp8;
- (id)activeAccountObject;
- (void)setLocalActiveAccounts:(id)fp8;
- (id)activeAccounts;
- (void)setActiveAccounts:(id)fp8;
- (void)setAllAccounts:(id)fp8;
- (id)allAccounts;
- (void)writeAccount:(id)fp8 defaults:(id)fp12;
- (oneway void)defaultsChanged:(id)fp8;
- (oneway void)activeAccountsChanged:(id)fp8;
- (BOOL)loginAccount:(id)fp8 autoLogin:(BOOL)fp12;
- (void)loginAccount:(id)fp8;
- (void)autoLoginAccount:(id)fp8;
- (void)logoutAccount:(id)fp8;
- (int)compareNames:(id)fp8;
- (void)requestBuddyPicturesAndPropertiesForAccount:(id)fp8;
- (void)requestPresenceStatusFromPresentity:(id)fp8 forAccount:(id)fp12;
- (void)setPresenceStatus:(BOOL)fp8 forPresentity:(id)fp12 requestID:(id)fp16 forAccount:(id)fp20;
- (void)setValue:(id)fp8 ofExtraProperty:(id)fp12 ofPresentity:(id)fp16 forAccount:(id)fp20;
- (void)requestProperty:(id)fp8 ofPresentity:(id)fp12 forAccount:(id)fp16;
- (void)startWatchingPresentity:(id)fp8 forAccount:(id)fp12;
- (void)stopWatchingPresentity:(id)fp8 forAccount:(id)fp12;
- (void)requestGroupsForAccount:(id)fp8;
- (void)holdBuddyUpdatesForAccount:(id)fp8;
- (void)resumeBuddyUpdatesForAccount:(id)fp8;
- (void)renameGroup:(id)fp8 to:(id)fp12 forAccount:(id)fp16;
- (void)changeBuddyList:(id)fp8 forAccount:(id)fp12;
- (id)createChatWith:(id)fp8 invitation:(id)fp12 named:(id)fp16 forAccount:(id)fp20;
- (id)createChatForIMsWith:(id)fp8 isDirect:(BOOL)fp12 forAccount:(id)fp16;
- (id)goToChatNamed:(id)fp8 useRoomName:(BOOL)fp12 forAccount:(id)fp16;
- (void)invitePresentity:(id)fp8 toChat:(id)fp12 withMessage:(id)fp16;
- (void)respond:(BOOL)fp8 toInvitationToChat:(id)fp12;
- (int)sendMessage:(id)fp8 toChatID:(id)fp12;
- (void)leaveChatID:(id)fp8;
- (void)setPresentity:(id)fp8 isIgnored:(BOOL)fp12 inChat:(id)fp16;
- (oneway void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (oneway void)chat:(id)fp8 statusChanged:(int)fp12;
- (oneway void)chat:(id)fp8 messageReceived:(id)fp12;
- (void)_processDeferredInvitationDictionary:(id)fp8;
- (void)requestVCWithBuddy:(id)fp8 properties:(id)fp12 forAccount:(id)fp16;
- (void)respondToVCRequestWithBuddy:(id)fp8 properties:(id)fp12 forAccount:(id)fp16;
- (void)declineVCRequestWithBuddy:(id)fp8 response:(int)fp12 vcProps:(id)fp16 forAccount:(id)fp20;
- (void)cancelVCRequestWithBuddy:(id)fp8 forAccount:(id)fp12;
- (void)sendVCCounterProposalToBuddy:(id)fp8 properties:(id)fp12 forAccount:(id)fp16;
- (void)sendVCUpdate:(id)fp8 toBuddy:(id)fp12 forAccount:(id)fp16;
- (void)sendAVMessageToBuddy:(id)fp8 sessionID:(unsigned int)fp12 type:(unsigned int)fp16 userInfo:(id)fp20 forAccount:(id)fp24;
- (oneway void)account:(id)fp8 invitedToVC:(id)fp12 properties:(id)fp16;
- (void)shutdownAVForAccount:(id)fp8;
- (void)_postVCResponseNotification:(id)fp8 from:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)account:(id)fp8 counterProposalFrom:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 responseToVCRequest:(id)fp12 properties:(id)fp16;
- (void)setBlockList:(id)fp8 forAccount:(id)fp12;
- (void)setAllowList:(id)fp8 forAccount:(id)fp12;
- (void)setBlockingMode:(unsigned int)fp8 forAccount:(id)fp12;
- (void)setBlockIdleStatus:(BOOL)fp8 forAccount:(id)fp12;
- (void)setSigning:(struct OpaqueSecCertificateRef *)fp8 encryption:(struct OpaqueSecCertificateRef *)fp12 forAccount:(id)fp16;
- (void)enableSecureIM:(BOOL)fp8 forAccount:(id)fp12;
- (void)disableCertificatesForPresentity:(id)fp8 forAccount:(id)fp12;

@end

@interface Service (AccountAdditions)
- (Class)accountClass;
@end

@interface Service (IMService_GetService)
+ (id)aimService;
+ (id)subnetService;
+ (id)jabberService;
@end

@interface ServiceController : NSObject
{
}

+ (id)sharedObject;
- (id)init;
- (void)_accountNoLongerJustLoggedIn:(id)fp8;

@end

@interface ServicePopUp : NSPopUpButton
{
    unsigned long long _requiredCapabilities;
    Service *_requiredService;
    NSArray *_requiredServices;
    NSArray *_requiredAccounts;
    BOOL _requireActiveAccounts;
    BOOL _requireConnectedAccounts;
}

- (void)dealloc;
- (BOOL)_updateMenu;
- (void)awakeFromNib;
- (void)requireConnectedAccounts:(BOOL)fp8;
- (void)requireActiveAccounts:(BOOL)fp8;
- (void)requireAccounts:(id)fp8;
- (void)requireService:(id)fp8;
- (void)requireServices:(id)fp8;
- (void)requireCapabilities:(unsigned long long)fp8;
- (void)activeAccountsChanged:(id)fp8;
- (void)accountStatusChanged:(id)fp8;
- (id)selectedAccount;
- (void)selectAccount:(id)fp8;

@end

@interface SessionContextListener : NSObject
{
    NSMutableDictionary *_contexts;
    NSNotificationCenter *_notificationCenter;
}

+ (id)sharedInstance;
- (void)dealloc;
- (id)init;
- (id)contextsForType:(id)fp8;
- (id)contextForGUID:(id)fp8;
- (void)_clearAllContexts;
- (id)notificationCenter;
- (void)sendContextRequest:(id)fp8 withProperties:(id)fp12 forGUID:(id)fp16;
- (void)contextUpdate:(id)fp8;
- (void)contextEndedForGUID:(id)fp8;
- (id)createContextWithProperties:(id)fp8;
- (void)_daemonDied:(id)fp8;

@end

@interface ShadowView : NSView
{
    NSColor *_backgroundColor;
    NSColor *_contentColor;
    NSShadow *_shadow;
    BOOL _drawsShadow;
    id _eventDelegate;
}

- (void)dealloc;
- (void)setDefaultShadow;
- (void)setShadow:(id)fp8;
- (id)shadow;
- (void)setDrawsShadow:(BOOL)fp8;
- (BOOL)drawsShadow;
- (void)setContentColor:(id)fp8;
- (id)contentColor;
- (void)setBackgroundColor:(id)fp8;
- (id)backgroundColor;
- (BOOL)isOpaque;
- (void)drawRect:(struct _NSRect)fp8;
- (void)setEventDelegate:(id)fp8;
- (id)eventDelegate;
- (void)mouseDown:(id)fp8;

@end

@interface SimpleArray : NSObject
{
    void *_items;
    int _count;
    int _size;
}

- (id)copyWithItemSize:(int)fp8;
- (void)dealloc;
- (void *)items;
- (int)numberOfItems;
- (void)makeRoomForItems:(int)fp8 ofSize:(int)fp12 preserveValues:(BOOL)fp16;
- (void)removeAllItems;
- (void)setNumberOfItems:(int)fp8;
- (int)intAtIndex:(int)fp8;
- (int)lastInt;
- (void)setInt:(int)fp8 atIndex:(int)fp12;
- (void)addInt:(int)fp8;
- (void)makeRoomAndAddInt:(int)fp8;
- (id)intDescription;
- (id)objectAtIndex:(int)fp8;
- (id)lastObject;
- (void)setObject:(id)fp8 atIndex:(int)fp12;
- (void)addObject:(id)fp8;
- (void)makeRoomAndAddObject:(id)fp8;
- (id)objectDescription;
- (int)trackingRectTagAtIndex:(int)fp8;
- (int)lastTrackingRectTag;
- (void)setTrackingRectTag:(int)fp8 atIndex:(int)fp12;
- (void)addTrackingRectTag:(int)fp8;
- (void)makeRoomAndAddTrackingRectTag:(int)fp8;
- (id)trackingRectTagDescription;
- (float)floatAtIndex:(int)fp8;
- (float)lastFloat;
- (void)setFloat:(float)fp8 atIndex:(int)fp12;
- (void)addFloat:(float)fp8;
- (void)makeRoomAndAddFloat:(float)fp8;
- (id)floatDescriptionWithDigits:(int)fp8;

@end

@interface SingleLineDivider : NSExtendedBox
{
}

- (void)awakeFromNib;
- (id)initWithFrame:(struct _NSRect)fp8;

@end

@interface SmileyButton : NSButton
{
}

- (void)mouseDown:(id)fp8;

@end

@interface SmileyButton (MyPictureControlAccessibility)
- (id)accessibilityActionNames;
- (void)accessibilityPerformAction:(id)fp8;
- (id)accessibilityFocusedUIElement;
- (id)accessibilityHitTest:(struct _NSPoint)fp8;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityAttributeValue:(id)fp8;
@end

@interface SmileyCell : NSButtonCell
{
    NSString *_axDescription;
}

- (void)dealloc;
- (id)accessibilityAttributeNames;
- (void)accessibilitySetValue:(id)fp8 forAttribute:(id)fp12;
- (id)accessibilityAttributeValue:(id)fp8;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface SmileyGrid : NSMatrix
{
    int _numberOfImages;
}

- (void)_layoutCells:(int)fp8 cellsPerRow:(int)fp12;
- (void)setUpWithImages:(id)fp8 columns:(int)fp12;
- (int)numberOfImages;
- (void)highlightCell:(BOOL)fp8 atPosition:(int)fp12;
- (int)arrowKeyDown:(unsigned short)fp8 fromSelectedItem:(int)fp12;
- (id)accessibilityFocusedUIElement;

@end

@interface SmileyPicker : NSObject
{
    NSView *_smileyView;
    SmileyGrid *_smileyGrid;
    NSTextField *_smileyNameField;
    NSTextField *_smileyTextField;
    NSWindow *_window;
    NSTimer *_timer;
    int _numFlashes;
}

+ (void)_getSmileyList:(id *)fp8 smileysPerRow:(int *)fp12;
+ (id)smileyMenuItems;
+ (id)smileyNumber:(int)fp8;
+ (id)installSmileyButtonInView:(id)fp8 margin:(struct _NSSize)fp12;
+ (id)pickSmileyFromButton:(id)fp8;
+ (int)numberOfItemsInMenu:(id)fp8;
+ (BOOL)menu:(id)fp8 updateItem:(id)fp12 atIndex:(int)fp16 shouldCancel:(BOOL)fp20;
- (struct _NSRect)windowFrameForSmileyButton:(id)fp8;
- (void)_updateTextFieldsForItem:(int)fp8;
- (int)_trackMenuSelection;
- (void)_fadeOut:(id)fp8;
- (void)_doFlash:(id)fp8;
- (void)_flashItem:(int)fp8;
- (int)pickSmileyFromButton:(id)fp8;
- (void)awakeFromNib;
- (int)updateSelectedItem:(int)fp8 forKeyDown:(unsigned short)fp12;
- (void)highlightSelectedItem:(int)fp8;
- (int)newSelectionForMouseMoved:(id)fp8;

@end

@interface SmileyToolbarItem : NSToolbarItem
{
}

- (id)initWithPopUpButton:(id)fp8;
- (id)currentTextView;
- (void)validate;
- (BOOL)validateMenuItem:(id)fp8;
- (void)insertSmiley:(id)fp8;

@end

@interface StatusController : NSObject
{
    MyStatusControl *_statusControl;
    MyNameControl *_nameControl;
    MyPictureControl *_myPicture;
    NSExtendedImageView *_statusImage;
    NSMenu *_nameControlMenu;
    NSMutableArray *_customAvailableMessages;
    NSMutableArray *_customAwayMessages;
    BOOL _finishedInitializing;
    NSArray *_accounts;
    BOOL _supportsInvisible;
    BOOL _isInvisible;
    BOOL _isEntirelyInvisible;
}

- (void)awakeFromNib;
- (void)_updateStatusImage;
- (void)_statusIndicatorDidChange:(id)fp8;
- (void)finishInitializing;
- (void)dealloc;
- (void)_configureInvisibleSupport;
- (void)setAccounts:(id)fp8;
- (void)setAccount:(id)fp8;
- (id)accounts;
- (void)_readCustomMessagesFromPrefs;
- (void)_rebuildStatusControlMenu;
- (void)updateNameField;
- (void)showMyStatus;
- (void)accountUpdated:(id)fp8;
- (void)accountCapsChanged:(id)fp8;
- (void)invisibleStatusChanged:(id)fp8;
- (void)myStatusChanged:(id)fp8;
- (void)serviceStatusChanged:(id)fp8;
- (void)nowPlayingInfoChanged:(id)fp8;
- (void)customStatusMessagesChanged:(id)fp8;
- (void)editCustomMessages:(id)fp8;
- (void)viewAsName:(id)fp8;
- (void)viewAsHandle:(id)fp8;
- (BOOL)_timeExistsForStatusMessage:(id)fp8 forStatus:(int)fp12;
- (id)_oldestStatusMessageForStatus:(int)fp8;
- (void)_removeMessage:(id)fp8 forStatus:(int)fp12;
- (void)_touchStatusMessage:(id)fp8 forStatus:(int)fp12;
- (void)_trimStaleTimeStamps;
- (BOOL)_trimStatusMessagesForStatus:(int)fp8;
- (void)_status:(unsigned int)fp8 toCustomMessageList:(id *)fp12 andPrefsName:(id *)fp16;
- (void)myStatusControl:(id)fp8 changedStatus:(int)fp12 message:(id)fp16;
- (void)myStatusControl:(id)fp8 addedMessage:(id)fp12 forStatus:(int)fp16;
- (id)nameForStatus:(int)fp8;
- (id)imageForStatus:(int)fp8;
- (id)customMessagesForStatus:(int)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (BOOL)validateMessage:(id)fp8 forStatus:(int)fp12;
- (int)desiredStatus;
- (void)_checkInvisible;
- (BOOL)isInvisible;
- (BOOL)isEntirelyInvisible;
- (int)currentStatus;
- (int)lowestStatus;
- (BOOL)usingTemplateMessage;
- (id)currentRealMessage;
- (id)currentMessage;
- (id)menuForMyRolloverButton:(id)fp8;
- (void)_switchToAccountFromMenuItem:(id)fp8;
- (void)_setMyStatusFromItem:(id)fp8;
- (int)numberOfItemsInMenu:(id)fp8;
- (BOOL)_isCurrentlyCustomStatus;
- (BOOL)supportsInvisible;
- (void)_setStatusToStatus:(unsigned int)fp8;
- (void)_setAvailableFromMenu:(id)fp8;
- (void)_setAwayFromMenu:(id)fp8;
- (void)_setOfflineFromMenu:(id)fp8;
- (void)_setInvisibleFromMenu:(id)fp8;
- (void)setInvisible:(BOOL)fp8;
- (BOOL)menuHasKeyEquivalent:(id)fp8 forEvent:(id)fp12 target:(id *)fp16 action:(SEL *)fp20;
- (BOOL)menu:(id)fp8 updateItem:(id)fp12 atIndex:(int)fp16 shouldCancel:(BOOL)fp20;

@end

@interface Stopwatch : NSObject
{
    NSString *_name;
    double _startTime;
    double _elapsedTime;
    double _averageTime;
    double _averageSum;
    double _lastSampleTime;
    double _logInterval;
    double _lastLogTime;
    int _averageCount;
}

+ (id)stopwatchWithName:(id)fp8;
+ (id)stopwatchWithName:(id)fp8 logInterval:(double)fp12;
- (id)initWithName:(id)fp8 logInterval:(double)fp12;
- (void)dealloc;
- (double)totalElapsedTime;
- (void)reset;
- (void)resetElapsed;
- (void)sample;
- (id)description;
- (void)sampleAndLog;
- (void)sampleAndLogWithLabel:(id)fp8;
- (BOOL)shouldLog;
- (void)sampleAndLogIfNeeded;
- (double)averageTime;
- (double)elapsedTime;
- (double)logInterval;
- (void)setLogInterval:(double)fp8;
- (id)name;

@end

@interface StretchyImageView : NSView
{
    NSImage *_image;
    float _tileMargins[4];
    float _opacity;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (id)initWithCoder:(id)fp8;
- (void)setImage:(id)fp8;
- (id)image;
- (void)setTileLeft:(float)fp8 right:(float)fp12 top:(float)fp16 bottom:(float)fp20;
- (void)setTile:(float)fp8;
- (void)getTileLeft:(float *)fp8 right:(float *)fp12 top:(float *)fp16 bottom:(float *)fp20;
- (void)setOpacity:(float)fp8;
- (float)opacity;
- (void)drawRect:(struct _NSRect)fp8;

@end

@interface SystemSound : NSObject
{
    unsigned int _soundID;
    BOOL _createdSoundID;
}

+ (id)soundForPath:(id)fp8;
- (id)initWithSystemSoundID:(unsigned long)fp8;
- (id)initWithPath:(id)fp8;
- (void)dealloc;
- (void)play;

@end

@interface TabbedChatTableCell : NSActionCell
{
    ChatWindowController *_list;
    BOOL _oneLine;
    BOOL _disabled;
    int _imageIndex;
    int _imageState;
    struct _NSRect _imageRect;
    BOOL _urlMouseDown;
    BOOL _urlMouseOver;
    BuddyPicture *_personImage;
    BuddyPicture *_everyoneImage;
    NSButtonCell *_imageDrawingCell;
}

+ (struct _NSSize)tabCoseSize;
+ (id)_lineBreakAttributes;
+ (id)displayNameForString:(id)fp8;
+ (id)displayNameForChat:(id)fp8;
+ (id)displayNameForPresentity:(id)fp8;
+ (void)setIconSize:(struct _NSSize)fp8;
+ (struct _NSSize)iconSize;
+ (struct _NSRect)rectOfPictureWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
+ (struct _NSRect)rectOfCloseBox:(struct _NSRect)fp8 inView:(id)fp24 usingWidth:(float)fp28;
+ (struct _NSRect)rectOfCloseBox:(struct _NSRect)fp8 inView:(id)fp24;
+ (void)drawColorFadeOfColor:(id)fp8 inRect:(struct _NSRect)fp12;
- (void)setChatWindowController:(id)fp8;
- (id)list;
- (id)initWithChatWindowController:(id)fp8;
- (id)copyWithZone:(struct _NSZone *)fp8;
- (void)dealloc;
- (unsigned int)hitTestForEvent:(id)fp8 inRect:(struct _NSRect)fp12 ofView:(id)fp28;
- (void)_redisplay:(id)fp8;
- (void)_closeTabItem;
- (BOOL)trackMouseDown:(id)fp8 inCloseRect:(BOOL)fp12 withRect:(struct _NSRect)fp16 cellFrame:(struct _NSRect)fp32 ofView:(id)fp48;
- (BOOL)startTrackingAt:(struct _NSPoint)fp8 inView:(id)fp16;
- (BOOL)continueTracking:(struct _NSPoint)fp8 at:(struct _NSPoint)fp16 inView:(id)fp24;
- (void)stopTracking:(struct _NSPoint)fp8 at:(struct _NSPoint)fp16 inView:(id)fp24 mouseIsUp:(BOOL)fp28;
- (void)setOneLine:(BOOL)fp8;
- (BOOL)oneLine;
- (void)setDisabled:(BOOL)fp8;
- (BOOL)isDisabled;
- (id)closeImageWithRollover:(BOOL)fp8;
- (id)badgeColor;
- (id)badgeTextColor;
- (void)controlTintChanged:(id)fp8;
- (id)badgeTextAttributes;
- (float)badgeWidthWithCount:(int)fp8;
- (void)drawBadgeCenteredInRect:(struct _NSRect)fp8 withCount:(int)fp24;
- (BOOL)shouldAnimate;
- (id)highlightColorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)_drawHighlightWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)drawWithFrame:(struct _NSRect)fp8 inView:(id)fp24;
- (void)drawInteriorWithFrame:(struct _NSRect)fp8 inView:(id)fp24;

@end

@interface TabbedChatTableCell (NameTableCellAccessibility)
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (id)accessibilityValueAttribute;
@end

@interface Texture : NSObject
{
    struct __CVBuffer *_texture;
    QCImage *_qcImage;
    BOOL _mirrored;
    BOOL _replacementVideo;
}

+ (struct __CVOpenGLTextureCache *)sharedTextureCache;
+ (void)flushCache;
+ (BOOL)useCoreImage;
+ (id)textureWithCVImageBuffer:(struct __CVBuffer *)fp8;
- (id)initWithCVImageBuffer:(struct __CVBuffer *)fp8;
- (void)dealloc;
- (id)CVOpenGLTextureObj;
- (id)qcImage;
- (unsigned int)target;
- (unsigned int)name;
- (BOOL)_isFlipped;
- (struct _NSRect)textureRect;
- (id)displayImage;
- (id)_userFrames;
- (id)_userFrameForId:(id)fp8;
- (id)_auxVideoUserFrame;
- (id)userIds;
- (BOOL)hasSideshowFrame;
- (void)setReplacementVideo:(BOOL)fp8;
- (BOOL)isReplacementVideo;
- (struct _NSRect)userRect:(id)fp8 sideshow:(BOOL)fp12;
- (struct _NSRect)userRect:(id)fp8;
- (float)gamma;
- (double)time;
- (id)attachments;
- (void)drawInContext:(struct _CGLContextObject *)fp8 userId:(id)fp12 inRect:(struct _NSRect)fp16 flags:(int)fp32;
- (void)drawInContext:(struct _CGLContextObject *)fp8 textureRect:(struct _NSRect)fp12 inRect:(struct _NSRect)fp28 flags:(int)fp44;
- (void)drawInCIContext:(id)fp8 userId:(id)fp12 inRect:(struct _NSRect)fp16 flags:(int)fp32;
- (void)drawInCIContext:(id)fp8 textureRect:(struct _NSRect)fp12 inRect:(struct _NSRect)fp28 flags:(int)fp44;
- (BOOL)mirrored;
- (void)setMirrored:(BOOL)fp8;

@end

@interface TwoViewContainer : NSView
{
    NSView *_view1;
    NSView *_view2;
    float _spacerWidth;
    BOOL _vertical;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (float)spacerWidth;
- (void)setSpacerWidth:(float)fp8;
- (BOOL)isVertical;
- (void)setVertical:(BOOL)fp8;
- (void)resizeSubviewsWithOldSize:(struct _NSSize)fp8;

@end

@interface URLFetcher : NSObject
{
    NSURLConnection *_connection;
    NSMutableData *_responseData;
    id _delegate;
    BOOL _useCache;
}

- (void)dealloc;
- (id)initWithDelegate:(id)fp8;
- (void)setDelegate:(id)fp8;
- (id)connection:(id)fp8 willCacheResponse:(id)fp12;
- (void)cancel;
- (void)sendURLRequest:(id)fp8;
- (void)connection:(id)fp8 didReceiveResponse:(id)fp12;
- (void)connection:(id)fp8 didReceiveData:(id)fp12;
- (void)connection:(id)fp8 didFailWithError:(id)fp12;
- (void)connectionDidFinishLoading:(id)fp8;
- (void)setAllowsCachedResults:(BOOL)fp8;

@end

@interface UserSetupController : NSObject
{
    NSButton *_goBackButton;
    NSButton *_continueButton;
    NSPopUpButton *_accountTypeMenu;
    NSWindow *_userSetupWindow;
    NSTabView *_tabView;
    NSTextField *_currentTitle;
    NSTabView *_accountTypeTabView;
    NSTextField *_skipText;
    NSTextField *_aimAccountNameField;
    NSTextField *_aimAccountPassField;
    NSButton *_aimGetAccountButton;
    NSView *_jabberDataView;
    NSTextField *_jabberAccountNameField;
    NSTextField *_jabberAccountPassField;
    NSImageView *_jabberAccountNameValidationLabel;
    NSButton *_jabberServerOptionsReveal;
    NSView *_jabberServerOptionsView;
    NSTextField *_jabberServerName;
    NSTextField *_jabberPortNumber;
    NSButton *_jabberUseSSL;
    NSButton *_jabberUseKerberos;
    NSImageView *_jabberServerNameValidationLabel;
    NSImageView *_jabberPortValidationLabel;
    NSTextField *_macAccountNameField;
    NSTextField *_macAccountPassField;
    NSTextField *_dotMacSuffixField;
    NSButton *_macGetAccountButton;
    NSTextField *_contactingDotmacText;
    NSProgressIndicator *_contactingDotmacSpinner;
    NSTextField *_gmailAccountNameField;
    NSTextField *_gmailAccountPassField;
    NSImageView *_gmailAccountNameValidationLabel;
    NSButton *_useCertCheckbox;
    NSButton *_learnMoreButton;
    NSTextField *_requestSentText;
    NSTextField *_requestSentTitle;
    NSImageView *_requestSentPic;
    NSTextField *_conclusionText;
    NSTextField *_clickDoneText;
    id _delegate;
    BOOL _disableJabber;
    BOOL _disableAIM;
    BOOL _showCertSetup;
    BOOL _showCertReqd;
    BOOL _showNeedCertPassword;
    DotMacCaps *_dotMacCaps;
    AbstractAccount *_accountObject;
    NSMutableArray *_addedAccounts;
    NSWindow *_parentWindow;
    BOOL _hasRun;
    BOOL _runningAsFirstTimeUser;
    BOOL _hasSetupAtLeastOneAccount;
}

+ (id)passwordForAIMAccount:(id)fp8;
+ (id)passwordForJabberAccount:(id)fp8;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (BOOL)_generateAIMAccount;
- (BOOL)_generateMacAccount;
- (BOOL)_generateJabberAccount;
- (BOOL)_generateGmailAccount;
- (void)_setupAccount;
- (BOOL)_saveMeCard;
- (void)_sendMeCardPictureToDaemon;
- (void)aimAccountFieldChanged:(id)fp8;
- (void)macAccountFieldChanged:(id)fp8;
- (void)gmailAccountFieldChanged:(id)fp8;
- (void)jabberAccountFieldChanged:(id)fp8;
- (void)accountTypeChanged:(id)fp8;
- (void)signUpForMacDotCom:(id)fp8;
- (void)addAnotherAccount:(id)fp8;
- (void)_showJabberServerOptions:(BOOL)fp8 animate:(BOOL)fp12 updateControl:(BOOL)fp16;
- (BOOL)_isValidJabberPort:(id)fp8;
- (BOOL)control:(id)fp8 textShouldEndEditing:(id)fp12;
- (void)jabberServerOptionsRevealToggled:(id)fp8;
- (void)jabberUpdateCustomFields:(id)fp8;
- (BOOL)userIsSetup;
- (id)addedAccounts;
- (void)_finishSetup;
- (void)_closeSetup;
- (void)userSetupSheetDidEnd:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)runAccountSetupAttachedToWindow:(id)fp8;
- (void)runFirstTimeUserSetup;
- (void)_forgotPassword:(id)fp8 returnCode:(int)fp12 contextInfo:(void *)fp16;
- (void)_dropInvalidDotMacPassword;
- (void)_setDotmacProgressHidden:(BOOL)fp8;
- (void)_checkForDotMacCertCapability;
- (BOOL)_loadMacSettings;
- (BOOL)_loadAIMSettings;
- (BOOL)_loadGmailSettings;
- (BOOL)_loadJabberSettings;
- (void)_loadDefaults;
- (void)_resetAllFields;
- (void)_updateTitle;
- (void)tabView:(id)fp8 willSelectTabViewItem:(id)fp12;
- (void)tabView:(id)fp8 didSelectTabViewItem:(id)fp12;
- (BOOL)_canMoveOffTabViewItem:(id)fp8;
- (void)_updateContinueDoneButton:(BOOL)fp8;
- (void)_goToDone;
- (void)_goToNextPane:(id)fp8;
- (void)_goToPreviousPane:(id)fp8;
- (void)goBack:(id)fp8;
- (void)done:(id)fp8;
- (void)continueDone:(id)fp8;
- (void)tellMeMore:(id)fp8;
- (void)_finishedGettingDotMacCaps:(id)fp8;
- (id)initWithDelegate:(id)fp8;
- (void)awakeFromNib;
- (void)dealloc;

@end

@interface VCChannelNegotiation : NSObject
{
    AVChatParticipant *_participant;
    Presentity *_localPresentity;
    unsigned int _avChatSessionID;
    BOOL _incoming;
    unsigned int _requestID;
    unsigned int _channelType;
    unsigned int _state;
    BOOL _channelPrepared;
    int _connectionError;
    VCChannel *_channel;
    NSData *_remoteData;
    unsigned int _keyExchangeMode;
    unsigned int _encryptionKeySize;
    NSData *_encryptionKey;
    NSData *_validationKey;
    struct OpaqueSecKeyRef *_keyExchangePublicKey;
    struct OpaqueSecKeyRef *_keyExchangePrivateKey;
    NSOperationQueue *_negotiationQueue;
}

- (id)_decryptDataWithLocalCert:(id)fp8;
- (id)_initWithParticipant:(id)fp8 requestID:(unsigned int)fp12 channelType:(unsigned int)fp16 incoming:(BOOL)fp20 remoteData:(id)fp24 encryptionKeySize:(unsigned long)fp28 keyExchangeMode:(unsigned int)fp32 keyExchangeData:(id)fp36;
- (id)initRequestTo:(id)fp8 channelType:(unsigned int)fp12 encryptionKeySize:(unsigned long)fp16;
- (id)initRequestFrom:(id)fp8 userInfo:(id)fp12;
- (void)dealloc;
- (id)encryptionKey;
- (unsigned int)state;
- (void)_logState;
- (void)setState:(unsigned int)fp8;
- (BOOL)ended;
- (void)_getRequestData:(id *)fp8 forKey:(id *)fp12;
- (int)_sendSharedKey;
- (int)_decryptSharedKey:(id)fp8;
- (void)_receiveSharedKey:(id)fp8;
- (id)userInfoForCompletedOperation:(id)fp8;
- (unsigned int)_messageTypeForState;
- (id)operationForNextMessage;
- (void)_enqueueNextMessage;
- (void)_finishConnection;
- (void)_finishPrepareChannel:(id)fp8;
- (void)_threadedPrepareChannel;
- (void)_prepareChannel;
- (void)_sendMessage:(id)fp8;
- (void)observeValueForKeyPath:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)beginNegotiation;
- (void)_acceptRequest:(BOOL)fp8 remoteData:(id)fp12;
- (void)acceptRequest:(BOOL)fp8;
- (void)cancelRequest;
- (void)handleMessage:(unsigned int)fp8 userInfo:(id)fp12;
- (void)endNegotiation;
- (void)disconnectParticipant;
- (id)extractChannel;
- (unsigned long)encryptionKeySize;
- (unsigned int)keyExchangeMode;
- (int)connectionError;
- (id)channel;
- (BOOL)incoming;
- (unsigned int)channelType;
- (unsigned int)requestID;
- (id)participant;

@end

@interface VCChannelNegotiation (AVChatControllerAdditions)
- (unsigned int)ardRole;
@end

@interface VCChannelNegotiationOp : ExtendedOperation
{
    unsigned int _message;
    _GetVCChannelOp *_channelOp;
    _GetCertificateOp *_certOp;
}

- (void)_createChildOpsWithPresentity:(id)fp8 certOp:(BOOL)fp12;
- (id)initWithNegotiation:(id)fp8 message:(unsigned int)fp12;
- (id)vcChannel;
- (id)connectionData;
- (void)dealloc;
- (unsigned int)message;

@end

@interface VCDropView : NSView
{
    float _opacity;
}

- (void)createRegionsForRecipients:(id)fp8 includeTheater:(BOOL)fp12;
- (void)setOpacity:(float)fp8;
- (float)opacity;
- (id)updateHighlightingForPoint:(struct _NSPoint)fp8;

@end

@interface VCFullScreenScalingInfoController : NSObject
{
    NSMatrix *scalingTypeMatrix;
}

+ (void)initialize;
+ (void)showInfoWindow;
+ (int)fullScreenScalingType;
- (void)awakeFromNib;
- (void)setScalingType:(id)fp8;

@end

@interface VCInfoController : NSWindowController
{
    NSPopUpButton *_tabPopUp;
    NSButton *_helpButton;
    NSTabView *_tabView;
    NSTabViewItem *_statsTab;
    VCInfoTable *_statsTable;
    NSTextField *_noConferenceField;
    NSCell *_statCell;
    NSFormatter *_statFormatter;
    NSTimer *_statsTimer;
    NSMutableArray *_statsList;
    NSTabViewItem *_capsTab;
    NSTableView *_capsTable;
    NSArrayController *_capsList;
    NSAttributedString *_capEnabledSymbol;
    NSAttributedString *_capDisabledSymbol;
    NSTabViewItem *_errorTab;
    NSTextView *_errorLogTextView;
}

+ (void)_createInfoWindow;
+ (void)showInfoWindow;
+ (void)showInfoWindowCapabilities;
+ (void)addErrorLog:(id)fp8;
+ (void)clearErrorLogs;
- (void)awakeFromNib;
- (void)windowWillClose:(id)fp8;
- (float)_errorLogHeight;
- (struct _NSRect)_bestFrameWithStats:(unsigned int)fp8;
- (struct _NSRect)windowWillUseStandardFrame:(id)fp8 defaultFrame:(struct _NSRect)fp12;
- (struct _NSSize)windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12;
- (void)dealloc;
- (void)showTab:(id)fp8;
- (void)showHelp:(id)fp8;
- (void)_updateErrorLogUI;
- (BOOL)validateMenuItem:(id)fp8;
- (id)_descriptionForCapability:(id)fp8 enabled:(BOOL)fp12 reason:(id)fp16;
- (id)_descriptionForCap:(int)fp8 CPUCaps:(int)fp12 netCaps:(int)fp16 device:(BOOL)fp20;
- (void)_updateCaps;
- (void)_setupCapsUpdating;
- (void)refreshStats:(id)fp8;
- (int)numberOfRowsInTableView:(id)fp8;
- (id)tableView:(id)fp8 objectValueForTableColumn:(id)fp12 row:(int)fp16;
- (id)tableView:(id)fp8 statItemForRow:(int)fp12;
- (void)tableView:(id)fp8 willDisplayCell:(id)fp12 forTableColumn:(id)fp16 row:(int)fp20;
- (BOOL)tableView:(id)fp8 shouldSelectRow:(int)fp12;

@end

@interface VCInfoTable : NSTableView
{
}

- (void)_setupColumns;
- (void)awakeFromNib;
- (struct _NSRect)frameOfCellAtColumn:(int)fp8 row:(int)fp12;
- (void)drawRow:(int)fp8 clipRect:(struct _NSRect)fp12;

@end

@interface VCLayoutController : NSObject
{
    VideoConferenceLayerView *_container;
    OpenGLLayerModel *_layerModel;
    BOOL _isPreview;
    BOOL _isFullScreen;
    BOOL _hasPIP;
    BOOL _theatricalLayout;
    BOOL _PIPHiddenByUser;
    NSDate *_transitionStartTime;
    NSDate *_AOLFadeOutStartTime;
    NSTimer *_timer;
    NSTimer *_AOLFadeOutTimer;
    float _PIPScale;
    struct _RectPosition _PIPPosition;
    float _windowStartWidth;
    float _windowEndWidth;
    float _transitionProgress;
    struct _NSRect _startPIPFrame;
    struct _NSRect _endPIPFrame;
    int _trackingRectTag;
    int _mouseInVCLayer;
    BOOL _mouseInCloseButton;
    BOOL _mouseIsHidden;
    OpenGLImageLayer *_recordingDot;
}

+ (void)initialize;
+ (void)_constrainWindow:(id)fp8 frame:(struct _NSRect *)fp12 screen:(id)fp16 andContainerSize:(struct _NSSize *)fp20;
+ (struct _NSRect)constrainedWindow:(id)fp8 frame:(struct _NSRect)fp12 screen:(id)fp28 withContainerSize:(struct _NSSize)fp32;
+ (void)_createTextLabel:(id)fp8 layerName:(id)fp12 inLayer:(id)fp16;
+ (id)_badgeImage:(id)fp8 atSize:(struct _NSSize)fp12 inImageOfSize:(struct _NSSize)fp20 atPoint:(struct _NSPoint)fp28;
+ (void)_showMute:(BOOL)fp8 pause:(BOOL)fp12 off:(BOOL)fp16 stalled:(BOOL)fp20 large:(BOOL)fp24 blackOpacity:(float)fp28 inLayer:(id)fp32;
+ (void)showCameraOff:(BOOL)fp8 inLayer:(id)fp12;
- (void)_syncPositionPrefsRead:(BOOL)fp8;
- (void)_syncScalePrefRead:(BOOL)fp8;
- (id)initWithContainer:(id)fp8 videoOut:(BOOL)fp12 videoIn:(BOOL)fp16;
- (id)layerModel;
- (void)setLayerModel:(id)fp8;
- (void)stopPreviewTransition;
- (void)stopAOLBadgeFadeOut;
- (void)clearContainer;
- (void)dealloc;
- (id)container;
- (float)PIPScale;
- (struct _RectPosition)PIPPosition;
- (float)currentLayerWidth;
- (float)_videoWidthToSnapWithMin:(float)fp8;
- (BOOL)isPreview;
- (float)_transitionProgressReverse:(BOOL)fp8;
- (struct _NSSize)_windowSizeForRemoteLayers:(int)fp8 ofWidth:(float)fp12;
- (void)setPreview:(BOOL)fp8 snapToVideo:(BOOL)fp12;
- (void)setHasPIP;
- (void)_setFullScreen:(BOOL)fp8 layerWidth:(float)fp12;
- (void)setFullScreen;
- (void)setNotFullScreen:(float)fp8;
- (BOOL)isFullScreen;
- (void)freezeFrame;
- (void)fitWindowToLocalBannerHorizOnly:(BOOL)fp8;
- (struct _NSSize)standardWindowSize;
- (struct _NSRect)_PIPFrameForBounds:(struct _NSRect)fp8;
- (struct _NSRect)_theoreticalPIPFrameForLayers:(int)fp8 inBounds:(struct _NSRect)fp12 sideshowMode:(int)fp28;
- (struct _NSRect)_banner:(id)fp8 frameInVCLayer:(id)fp12;
- (void)updateLayout;
- (void)containerDidEndLiveResize;
- (void)_fadeOutAOLBadge;
- (void)_getAspectTransitionForLayers:(int)fp8 ofWidth:(float)fp12 sideshowMode:(int)fp16 containerStart:(struct _NSSize *)fp20 end:(struct _NSSize *)fp24 windowStart:(struct _NSRect *)fp28 end:(struct _NSRect *)fp32;
- (void)_updateCursorTracking;
- (void)_runTheatricalTransition:(unsigned int)fp8 snapToVideo:(BOOL)fp12 sideshowMode:(int)fp16 fullScreenAnimationTime:(double)fp20;
- (void)animateAdditionOfRemoteLayerAtIndex:(unsigned int)fp8 resizeTime:(double)fp12;
- (void)removeRemoteVCLayer:(id)fp8 fullScreenAnimationTime:(double)fp12;
- (id)_createVCLayerNamed:(id)fp8 vcPartyID:(id)fp12 resizes:(BOOL)fp16 appearance:(int)fp20 atIndex:(unsigned int)fp24 isLocal:(BOOL)fp28 isSideshow:(BOOL)fp32 isReplacement:(BOOL)fp36;
- (id)createLayerForParticipant:(id)fp8 appearance:(int)fp12 atIndex:(unsigned int)fp16 isSideshow:(BOOL)fp20 isReplacement:(BOOL)fp24;
- (id)createBannerForParticipant:(id)fp8;
- (id)bannerForParticipant:(id)fp8;
- (void)repositionBannerForParticipant:(id)fp8;
- (void)removeBannerForParticipant:(id)fp8;
- (void)createCloseButtonForParticipant:(id)fp8;
- (void)removeCloseButtonForParticipant:(id)fp8;
- (void)createWhitePreviewLayerForLocalParticipant:(id)fp8;
- (id)createLayerWithLabel:(id)fp8 fontSize:(float)fp12 name:(id)fp16 margin:(float)fp20 bgSize:(struct _NSSize)fp24;
- (void)_createAOLLabel;
- (void)createAOLBadge;
- (void)_changeAOLLabelSize;
- (void)showPreviewLabel:(BOOL)fp8;
- (void)removeAllBanners;
- (void)_showConnectionDoctorLabelInLayer:(id)fp8;
- (void)showLocalConnectionDoctorLabel;
- (void)showRemoteConnectionDoctorLabel:(id)fp8;
- (BOOL)canShowHidePIP;
- (void)setPIPHidden:(BOOL)fp8;
- (BOOL)isPIPHidden;
- (void)showLocalMute:(BOOL)fp8 pause:(BOOL)fp12 off:(BOOL)fp16 stalled:(BOOL)fp20;
- (void)showRemoteParty:(id)fp8 mute:(BOOL)fp12 pause:(BOOL)fp16 stalled:(BOOL)fp20;
- (unsigned int)_autoresizingMask;
- (void)_createResizeIndicatorIn:(id)fp8;
- (void)_showResizeIndicator;
- (void)_hideResizeIndicator;
- (void)_removeResizeIndicator;
- (void)_addResizeTrackingRect;
- (void)_updateResizeTrackingRect;
- (void)resetCursorRects;
- (void)_addPIPBorder;
- (void)_hideOverlay;
- (void)_hideOverlayAndCursor;
- (void)_dontHideOverlay;
- (void)_hideOverlayAndCursorAfterDelay;
- (void)_showOverlay;
- (void)_setMouseInLayer:(int)fp8 inCloseButton:(BOOL)fp12;
- (void)_doBannerHitTest:(struct _NSPoint)fp8;
- (void)_updateBannerHitTesting;
- (void)_resizePIPWithOriginalSize:(struct _NSSize)fp8;
- (void)_animateLayer:(id)fp8 from:(struct _NSRect)fp12 to:(struct _NSRect)fp28;
- (void)_animatePIPFrom:(struct _NSRect)fp8 to:(struct _NSRect)fp24;
- (void)_movePIPWithStartFrame:(struct _NSRect)fp8 baseOffset:(struct _NSSize)fp24 useFistCursor:(BOOL)fp32;
- (BOOL)_trackMouseDown:(id)fp8 inCloseButtonAt:(struct _NSPoint)fp12;
- (void)mouseDown:(id)fp8 at:(struct _NSPoint)fp12;
- (void)mouseUpAt:(struct _NSPoint)fp8;
- (void)mouseMovedAt:(struct _NSPoint)fp8;
- (void)mouseEntered:(id)fp8;
- (void)mouseExited:(id)fp8;
- (void)mouseDraggedAt:(struct _NSPoint)fp8;
- (void)setShowsRecordingDot:(BOOL)fp8 on:(BOOL)fp12;

@end

@interface VCNotifier : Notifier
{
    NSDictionary *_vcProperties;
    AVChatController *_avChatController;
    AVParticipantView *_bannerView;
    BOOL _audioOnly;
    BOOL _oneWay;
    BOOL _ardClient;
    BOOL _ardServer;
}

+ (void)openOnIncomingVC:(id)fp8 properties:(id)fp12;
+ (void)openOnIncomingARDUpgradeRequest:(id)fp8;
+ (void)cleanUpOldNotifiersFrom:(id)fp8;
- (void)dealloc;
- (BOOL)isStale;
- (BOOL)canShowRealWindow;
- (BOOL)canHideRealWindow;
- (BOOL)isActiveNotification;
- (void)floaterBecomingVisible;
- (void)realWindowVisible;
- (void)realWindowHiding;
- (void)updateLockUI;
- (struct CGAffineTransform)_xformForFloaterScale:(float)fp8;
- (void)_makeVCFloaterWindow;
- (BOOL)_makeRealVCNotifierWindow;
- (id)initForPersistentVCWithPresentity:(id)fp8 isVideo:(BOOL)fp12 isOneWay:(BOOL)fp16;
- (id)accessibilityFormat;
- (id)initForVCWith:(id)fp8 properties:(id)fp12;
- (id)_initForARDUpgradeRequest:(id)fp8;
- (void)disconnect;
- (id)menuItemFormat;
- (void)doVCTextReplyWithChat:(id)fp8;
- (id)avChatController;
- (id)bannerView;
- (void)setBannerTitle:(id)fp8;
- (void)showTimeStamp;
- (void)updateBanner;
- (id)callerProperties;

@end

@interface VCStatItem : NSObject
{
    AVChatParticipant *_participant;
    int _type;
    NSAttributedString *_labelValue;
    id _statValue;
}

+ (id)_labelAttributesForType:(int)fp8;
+ (id)statItemsForAVChat:(id)fp8 vcStats:(id)fp12 logFramerate:(BOOL)fp16;
- (id)_initWithParticipant:(id)fp8 type:(int)fp12 label:(id)fp16 stat:(id)fp20;
- (id)_initWithType:(int)fp8 label:(id)fp12 stat:(id)fp16;
- (void)dealloc;
- (id)participant;
- (int)type;
- (id)labelValue;
- (id)statValue;

@end

@interface ValidationObject : BaseThreadedObject
{
    NSArray *_certs;
    NSString *_screenName;
    unsigned short _usage;
    int _result;
}

+ (id)validateCerts:(id)fp8 screenName:(id)fp12 usage:(unsigned short)fp16;
- (id)initWithCerts:(id)fp8 screenName:(id)fp12 usage:(unsigned short)fp16;
- (void)dealloc;
- (void)startThread;
- (void)stopWatchingThread;
- (void)_workerThreadFinished;
- (void)_workerThread;
- (int)result;
- (id)certificates;

@end

@interface VideoBottomOverlayView : NSView
{
}

- (void)drawRect:(struct _NSRect)fp8;

@end

@interface VideoChatController : AVChatController
{
    NSExtendedBox *_vcBox;
    NSButton *_effectsButton;
    NSWindow *_fsOverlayWindow;
    NSExtendedBox *_fsOverlayBox;
    NSButton *_fsEndChatButton;
    ChooseBuddyButton *_fsAddButton;
    ModifierTabView *_fsMutePauseTabView;
    NSButton *_fsMuteButton;
    NSButton *_fsPauseButton;
    NSButton *_fsShowEffectsButton;
    NSButton *_fsEndFullScreenButton;
    BOOL _fsOverlayVisible;
    NSViewAnimation *_fsOverlayAnimation;
    VideoConferenceLayerView *_vcLayerView;
    OpenGLLayerModel *_layerModel;
    OpenGLFullScreenController *_fullScreenController;
    int _restoreTab;
    BOOL _receivedAFrame;
    BOOL _hasSetupVC;
    BOOL _userHasResizedWindow;
    NSString *_participantNames;
    BOOL _recordingUnderNegotiation;
    int _flashingRecordingState;
    NSTimer *_flashingRecordingTimer;
}

- (BOOL)isVideo;
- (void)dealloc;
- (id)vcLayerView;
- (id)layerModel;
- (BOOL)isAddBuddyAllowed;
- (void)_updateNotifierUI;
- (id)_setupBannerFor:(id)fp8 inState:(unsigned int)fp12 layoutController:(id)fp16;
- (void)_setupPreview;
- (void)_createRemoteVCLayers;
- (void)_setupVC;
- (void)endPreview;
- (void)_firstRemoteFrameForParticipantWithID:(id)fp8;
- (void)_firstRemoteFrame:(id)fp8;
- (void)_removeParticipantWithID:(id)fp8 sideshowLayer:(BOOL)fp12;
- (void)removeParticipantWithID:(id)fp8;
- (void)animationDidEnd:(id)fp8;
- (void)animationDidStop:(id)fp8;
- (void)showFullScreenControls:(BOOL)fp8;
- (BOOL)areFullScreenControlsVisible;
- (id)view:(id)fp8 stringForToolTip:(int)fp12 point:(struct _NSPoint)fp16 userData:(void *)fp24;
- (id)windowNibName;
- (void)_setFSButton:(id)fp8 imageTemplateSize:(float)fp12;
- (void)windowDidLoad;
- (void)windowWillClose:(id)fp8;
- (struct _NSSize)windowWillResize:(id)fp8 toSize:(struct _NSSize)fp12;
- (BOOL)windowShouldZoom:(id)fp8 toFrame:(struct _NSRect)fp12;
- (float)_layerWidth;
- (void)_saveWindowFrame;
- (void)_restoreSavedWindowFrame;
- (id)shortWindowTitle;
- (id)longWindowTitle;
- (void)updateAddBuddyButton;
- (void)_updateRemoteVideoStateIndicators:(id)fp8 forcingOff:(BOOL)fp12;
- (void)_updateLocalUI;
- (void)_setupFullScreenOverlay;
- (void)toggleFullScreen:(id)fp8;
- (void)startFullScreen;
- (void)stopFullScreen;
- (void)takeVideoSnapshot:(id)fp8;
- (void)setEffectsButtonHidden:(BOOL)fp8;
- (void)toggleShowVideoSettings:(id)fp8;
- (void)toggleHideLocalVideo:(id)fp8;
- (void)toggleMuteOrPause;
- (void)showEffectsPalette:(id)fp8;
- (id)layerView;
- (BOOL)isFullScreen;
- (void)copy:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (id)_recipientForDropView:(id)fp8 dragSender:(id)fp12;
- (id)_updateDropView:(id)fp8;
- (unsigned int)_operationForDrag:(id)fp8 onPartyID:(id)fp12 isFiles:(char *)fp16;
- (BOOL)_shareFilesWithiChatTheater:(id)fp8;
- (BOOL)_performDragOperation:(id)fp8 onPartyID:(id)fp12 confirmFileSend:(BOOL)fp16;
- (void)logError:(id)fp8 forParticipant:(id)fp12;
- (void)_createCloseButtonForOtherParticipant:(id)fp8;
- (BOOL)_isParticipant:(id)fp8 theOnlyVideoSenderInAVChat:(id)fp12;
- (void)_avChat:(id)fp8 addedParticipant:(id)fp12 isSideshow:(BOOL)fp16;
- (void)avChat:(id)fp8 addedParticipant:(id)fp12;
- (void)avChat:(id)fp8 removedParticipant:(id)fp12;
- (void)avChatParticipantOrderFinalized:(id)fp8;
- (void)avChat:(id)fp8 participant:(id)fp12 changedFromState:(unsigned int)fp16 toState:(unsigned int)fp20;
- (void)avChatIrisStateChanged:(id)fp8;
- (void)avChat:(id)fp8 remoteParticipantMuteOrPausedChanged:(id)fp12;
- (void)avChat:(id)fp8 remoteParticipantNetworkStallChanged:(id)fp12;
- (id)avChat:(id)fp8 bitmapDataForParticipant:(id)fp12;
- (void)avChat:(id)fp8 participantBeganAuxiliaryInput:(id)fp12;
- (void)avChat:(id)fp8 participantEndedAuxiliaryInput:(id)fp12;
- (void)avChat:(id)fp8 participantBeganAuxiliaryReplacement:(id)fp12;
- (void)avChat:(id)fp8 participantEndedAuxiliaryReplacement:(id)fp12;
- (id)_windowForSecurityAlert:(id)fp8;
- (void)showRecordingIndicator:(BOOL)fp8;
- (void)_showRecordingIndicatorOn:(BOOL)fp8;
- (void)requestRecording;
- (void)avChat:(id)fp8 participantGrantedRecording:(id)fp12;
- (void)avChat:(id)fp8 participantDeniedRecording:(id)fp12;
- (void)stopRecording;
- (void)avChat:(id)fp8 participantBeginRecording:(id)fp12;
- (void)avChat:(id)fp8 participantFinishedRecording:(id)fp12;
- (void)windowDidBecomeKeyWindow;
- (void)windowDidResignKeyWindow;

@end

@interface VideoConferenceLayerView : OpenGLLayerView
{
    VideoChatController *_videoChatController;
    VCLayoutController *_layoutController;
}

- (id)initWithFrame:(struct _NSRect)fp8 videoChatController:(id)fp24;
- (void)dealloc;
- (void)setLayerModel:(id)fp8;
- (id)videoChatController;
- (void)resetCursorRects;
- (BOOL)acceptsFirstResponder;
- (void)mouseDown:(id)fp8;
- (void)mouseUp:(id)fp8;
- (void)mouseMoved:(id)fp8;
- (void)mouseDragged:(id)fp8;
- (void)setFrameSize:(struct _NSSize)fp8;
- (void)viewDidEndLiveResize;
- (id)layoutController;
- (unsigned int)draggingSourceOperationMask;
- (BOOL)_isOneWayTo:(id *)fp8;
- (id)_vcPartyIDForDrag:(id)fp8;
- (void)_highlightVCPartyID:(id)fp8;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (void)draggingExited:(id)fp8;
- (BOOL)prepareForDragOperation:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)concludeDragOperation:(id)fp8;

@end

@interface VideoProcessor : NSObject <VCRenderDelegateProtocol>
{
    NSOpenGLContext *_displayContext;
    CIContext *_ciCtx;
    CIContext *_colorCorrectingCtx;
    struct __CVOpenGLBufferPool *_displayBufferPool;
    FrameResizer *_localResizer;
    FrameResizer *_remoteResizer;
    FrameReader *_localReader;
    QCRenderer *_renderer;
    QCRenderer *_gamma;
    NSArray *_keyPaths;
    QCPatchController *_qcController;
    struct _NSPoint _inputXY;
    BOOL _backdropsSupported;
    BOOL _effectsSupported;
    BOOL _cameraLocked;
    unsigned int _auxVideoMode;
    BOOL _dvWorkaround;
    QCBackgroundMoviePlayer *_backPlayer;
    QCBackgroundMoviePlayer *_forePlayer;
    Texture *_spotlightFrame;
    FramerateTracker *_framerateTracker;
    NSRecursiveLock *_renderLock;
    QCComposition *_composition;
    BOOL _backdropsEnabled;
    NSMutableDictionary *_remoteTextures;
    Texture *_auxVideoFrame;
    BOOL _auxVideoNeedsRendering;
    FrameNotifier *_frameNotifier;
    BOOL _showRecordingBadge;
}

+ (id)sharedProcessor;
+ (BOOL)_realCameraConnected;
+ (BOOL)isEffectsAvailable;
+ (BOOL)isBackdropsAvailable;
- (id)init;
- (void)dealloc;
- (void)_applicationWillTerminate:(id)fp8;
- (void)_setMicronCameraAELock:(BOOL)fp8;
- (void)_lockCamera:(BOOL)fp8;
- (void)_startRenderer;
- (void)_stopRenderer;
- (void)frameNotifier:(id)fp8 didAddListener:(id)fp12 forSource:(id)fp16;
- (void)frameNotifier:(id)fp8 didRemoveListener:(id)fp12 forSource:(id)fp16;
- (id)backdropsMessage;
- (void)setBackdropsMessage:(id)fp8;
- (void)setCapture:(BOOL)fp8;
- (BOOL)capture;
- (void)setHasCaptured:(BOOL)fp8;
- (BOOL)hasCaptured;
- (BOOL)finishedCapture;
- (void)setShowBackgroundMotion:(BOOL)fp8;
- (void)_updateCapture;
- (void)startCapture;
- (void)_captureEnded;
- (void)_stopCapture;
- (void)_captureTimedout;
- (void)observeValueForKeyPath:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)observeValueForKeyPathOnMainThread:(id)fp8 ofObject:(id)fp12 change:(id)fp16 context:(void *)fp20;
- (void)setAuxVideoFrame:(struct __CVBuffer *)fp8;
- (id)auxVideoFrame;
- (void)_newBackgroundFrame:(id)fp8;
- (void)setBackPath:(id)fp8 forePath:(id)fp12;
- (void)setComposition:(id)fp8;
- (id)composition;
- (void)setAuxVideoMode:(unsigned int)fp8;
- (unsigned int)auxVideoMode;
- (BOOL)auxVideoModeIsReplacement;
- (void)_correctBufferForDV:(struct __CVBuffer *)fp8 width:(unsigned int *)fp12 height:(unsigned int *)fp16;
- (struct __CVBuffer *)createCVPixelBufferCorrectedForDisplay:(struct __CVBuffer *)fp8;
- (struct __CVBuffer *)_fixDVBuffer:(struct __CVBuffer *)fp8;
- (struct __CVBuffer *)_clipDVBuffer:(struct __CVBuffer *)fp8;
- (struct __CVBuffer *)_gammaCorrectBuffer:(struct __CVBuffer *)fp8;
- (int)_Software_processCVPixelBuffer:(struct __CVBuffer *)fp8 intoCVPixelBuffer:(struct __CVBuffer *)fp12 withHint:(id)fp16 gammaCorrect:(BOOL)fp20;
- (int)_GPU_processCVPixelBuffer:(struct __CVBuffer *)fp8 intoCVPixelBuffer:(struct __CVBuffer *)fp12 withHint:(id)fp16;
- (int)_AuxVideo_processCVPixelBufferIntoCVPixelBuffer:(struct __CVBuffer *)fp8 withHint:(id)fp12;
- (int)processCVPixelBuffer:(struct __CVBuffer *)fp8 intoCVPixelBuffer:(struct __CVBuffer *)fp12 withHint:(id)fp16;
- (void)gammaCorrectBuffer:(struct __CVBuffer *)fp8;
- (void)newRemoteCVPixelBuffer:(struct __CVBuffer *)fp8;
- (int)resizeRemoteVideoForUserID:(id)fp8 outBuffer:(struct __CVBuffer *)fp12;
- (id)frameNotifier;
- (BOOL)backdropsEnabled;
- (struct _NSPoint)inputXY;
- (void)setInputXY:(struct _NSPoint)fp8;

@end

@interface ViewTable : NSView
{
    id _delegate;
    float _rowSpacing;
    int _selectionBehavior;
    BOOL _usesAlternatingRowBackgroundColors;
    float _defaultRowHeight;
    NSColor *_bgColor;
}

- (void)_commonInit;
- (id)initWithFrame:(struct _NSRect)fp8;
- (id)initWithCoder:(id)fp8;
- (void)dealloc;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (void)setRowSpacing:(float)fp8;
- (float)rowSpacing;
- (void)_setHeight:(float)fp8 inClipView:(id)fp12;
- (void)_clipViewFrameChanged:(id)fp8;
- (void)viewDidMoveToSuperview;
- (void)viewWillMoveToSuperview:(id)fp8;
- (void)viewWillMoveToWindow:(id)fp8;
- (void)tile;
- (BOOL)isFlipped;
- (void)setUsesAlternatingRowBackgroundColors:(BOOL)fp8;
- (BOOL)usesAlternatingRowBackgroundColors;
- (void)setDefaultRowHeight:(float)fp8;
- (float)defaultRowHeight;
- (void)setBackgroundColor:(id)fp8;
- (id)backgroundColor;
- (BOOL)isOpaque;
- (void)drawRect:(struct _NSRect)fp8;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (BOOL)resignFirstResponder;
- (void)_windowKeyChanged:(id)fp8;
- (void)setSelectionBehavior:(int)fp8;
- (int)selectionBehavior;
- (void)selectView:(id)fp8;
- (void)selectAll:(id)fp8;
- (void)mouseDown:(id)fp8;
- (id)_nextView:(BOOL)fp8;
- (void)_scrollToVisibleSelectionShowingTop:(BOOL)fp8;
- (void)keyDown:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;

@end

@interface VolumeIndicator : NSView
{
    float _floatValue;
    BOOL _isRemote;
    BOOL _isMute;
    float _opacity;
    NSImage *_onImage;
    NSImage *_offImage;
    NSImage *_muteImage;
    float _numSlices;
    BOOL _proStyle;
}

- (id)_loadScaledImage:(id)fp8;
- (void)_updateNumSlices:(float)fp8;
- (void)_recacheImages;
- (void)setProStyle:(BOOL)fp8;
- (BOOL)proStyle;
- (void)awakeFromNib;
- (void)dealloc;
- (void)setFrameSize:(struct _NSSize)fp8;
- (BOOL)mouseDownCanMoveWindow;
- (void)setFloatValue:(float)fp8;
- (float)floatValue;
- (void)takeFloatValueFrom:(id)fp8;
- (void)setNumberValue:(id)fp8;
- (void)setSamplerLevelValue:(id)fp8;
- (void)setRemote:(BOOL)fp8;
- (BOOL)isRemote;
- (void)setMute:(BOOL)fp8;
- (BOOL)isMute;
- (void)toggleMute:(id)fp8;
- (void)setOpacity:(float)fp8;
- (float)opacity;
- (float)_splicePointFor:(float)fp8;
- (void)_invalidateValue:(float)fp8 to:(float)fp12;
- (void)drawRect:(struct _NSRect)fp8;
- (id)accessibilityAttributeValue:(id)fp8;
- (BOOL)accessibilityIsIgnored;
- (id)accessibilityAttributeNames;
- (id)accessibilityRoleAttribute;
- (BOOL)accessibilityIsAttributeSettable:(id)fp8;
- (id)accessibilityValueAttribute;

@end

@interface WindowDraggingTabView : NSTabView
{
}

- (void)mouseDown:(id)fp8;

@end

@interface XMLStreamer : NSObject
{
    NSMutableArray *_stack;
    NodeHeader *_header;
    unsigned short _separator;
    void *_parser;
    BOOL _parsing;
}

- (void)_createParser;
- (id)initWithRoot:(id)fp8 namespaceSeparatorChar:(unsigned short)fp12;
- (void)dealloc;
- (void)reset;
- (void)_beginNodeNamed:(const char *)fp8 attributes:(const char **)fp12;
- (void)_nodeData:(const char *)fp8 length:(int)fp12;
- (void)_endNode;
- (BOOL)isParsing;
- (BOOL)parse:(id)fp8;
- (void *)getBufferOfSize:(int)fp8;
- (BOOL)parseBufferWithLength:(int)fp8;
- (BOOL)endParse;
- (int)xmlError;

@end

@interface _GetCertificateOp : ExtendedOperation
{
    Presentity *_presentity;
    NSLock *_certLock;
}

- (id)initWithPresentity:(id)fp8;
- (void)dealloc;
- (void)_lockCertRequestMainThread;
- (void)_unlockCertRequest;
- (void)start;
- (void)main;

@end

@interface _GetVCChannelOp : ExtendedOperation
{
    BOOL _findExtIP;
    VCChannel *_channel;
    NSData *_data;
}

- (id)initAndFindExternalIP:(BOOL)fp8;
- (void)main;
- (void)dealloc;
- (id)data;
- (id)channel;

@end

@interface _MoveRecordedTracksOp : ExtendedOperation
{
    NSMutableArray *_filenames;
    NSString *_trackTitle;
}

- (id)initWithFilenames:(id)fp8 trackTitle:(id)fp12;
- (void)dealloc;
- (id)filenames;
- (id)trackTitle;
- (void)main;

@end

@interface _VCDropRegion : NSView
{
    id _recipient;
    BOOL _highlighted;
    float _opacity;
    Animator *_animator;
    BOOL _needsLayout;
    AbbreviatingTextField *_titleField;
    NSBezierPath *_fillPath;
    NSColor *_fillColor;
    NSShadow *_fillGlow;
    NSBezierPath *_borderPath;
}

- (void)_updateMarquee:(float)fp8;
- (void)_updateLayout;
- (void)setFrameSize:(struct _NSSize)fp8;
- (void)_setTitle;
- (void)setOpacity:(float)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (void)animator:(id)fp8 doStep:(float)fp12 lastStep:(BOOL)fp16;
- (void)setHighlighted:(BOOL)fp8;
- (BOOL)isHighlighted;
- (void)setRecipient:(id)fp8;
- (id)recipient;
- (id)initWithFrame:(struct _NSRect)fp8;
- (void)dealloc;

@end

@interface _VCInfoColumn : NSTableColumn
{
    NSLevelIndicatorCell *_levelCell;
}

- (id)initWithIdentifier:(id)fp8;
- (void)dealloc;
- (id)dataCellForRow:(int)fp8;

@end

@interface _iTunesCreatePlaylistOp : ExtendedOperation
{
    NSString *_playlistName;
}

- (id)playlistName;
- (void)main;
- (void)dealloc;

@end

@interface iChatResourceProtocol : FZImageResourceURLProtocol
{
}

+ (id)customProtocolScheme;
- (void)loadOnMainThreadCreatingDataAt:(id)fp8;

@end

@interface iChatStandardImages : NSObject
{
}

+ (id)invalidDataImage;
+ (struct _NSSize)smallBannerCloseBoxSize;
+ (struct _NSSize)defaultBannerCloseBoxSize;
+ (id)bannerCloseImage;
+ (id)bannerCloseImageRollover;
+ (id)bannerCloseImagePressed;

@end

@interface iPhotoBrowser : NSWindowController
{
    ILMediaBrowserView *_browserView;
    NSButton *_okButton;
}

+ (id)sharedBrowser;
- (id)init;
- (void)dealloc;
- (id)browserView;
- (void)_prepareWindow;
- (int)runModal;
- (void)windowDidLoad;
- (void)acceptBrowser:(id)fp8;
- (void)cancelBrowser:(id)fp8;
- (void)mediaBrowserViewSelectionDidChange:(id)fp8;
- (BOOL)mediaBrowserView:(id)fp8 shouldDisplayMediaGroup:(id)fp12;
- (BOOL)mediaBrowserView:(id)fp8 shouldDisplayMediaObject:(id)fp12;
- (BOOL)mediaBrowserView:(id)fp8 shouldSelectMediaObject:(id)fp12;
- (BOOL)mediaBrowserView:(id)fp8 shouldPreviewDoubleClickedItem:(id)fp12;

@end

@interface iTunesAdditionOp : ExtendedOperation
{
    BOOL _didStart;
    ExtendedOperation *_moveOperation;
    ExtendedOperation *_playlistOperation;
}

- (id)initWithFilenames:(id)fp8 trackTitle:(id)fp12;
- (void)dealloc;
- (void)start;
- (void)didChangeValueForKey:(id)fp8;
- (void)main;

@end
